/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/platform","vs/base/common/event","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/nls","vs/nls!vs/server/entry","vs/base/common/types","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","fs","vs/base/common/buffer","vs/base/node/pfs","vs/base/common/strings","vs/base/common/resources","vs/base/common/objects","os","vs/base/common/arrays","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/product","vs/platform/registry/common/platform","vs/base/common/map","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/configuration/common/configuration","vs/base/common/process","vs/base/common/extpath","@coder/logger","vs/base/parts/ipc/common/ipc","path","vs/base/common/errorMessage","child_process","vs/platform/extensions/common/extensions","vs/platform/configuration/common/configurationRegistry","vs/base/common/stream","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryUtils","vs/base/node/zip","vs/base/common/uriIpc","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/node/spdlogLog","vs/platform/request/common/request","vs/server/node/logger","vs/server/node/nls","vs/base/common/functional","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/labels","vs/base/node/decoder","vs/base/parts/ipc/common/ipc.net","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","util","vs/platform/localizations/node/localizations","vs/platform/environment/node/environmentService","vs/platform/configuration/common/configurationService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/server/node/util","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/editor/common/editorService","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/request/node/requestService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/amd","vs/base/common/console","vs/base/common/glob","vs/base/common/marshalling","vs/base/node/languagePacks","vs/base/common/performance","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/proxy_agent","vs/base/node/userDataPath","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/node/terminalProcess","vs/nls!vs/server/node/marketplace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/terminal/common/terminal","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/node/extensionPoints","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/label/common/label","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","crypto","vs/platform/log/common/bufferLog","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/notification/common/notification","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/storage/common/storage","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/browser/errorTelemetry","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/telemetry","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProcess","vs/platform/workspace/common/workspace","vs/server/common/telemetry","vs/server/node/insights","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminal","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionPoints","vs/workbench/services/extensions/node/extensionPoints","vs/server/node/channel","vs/workbench/services/remote/common/remoteAgentFileSystemChannel","vs/workbench/services/remote/common/remoteAgentService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/server/node/marketplace","zlib","vs/code/node/cliProcessMain","vs/server/node/connection","vs/server/node/protocol","vs/server/node/server","string_decoder","proxy-agent","proxy-from-env","https","http","yauzl","yazl","tar-stream","net","graceful-fs","vs/server/entry"],Z=function(H){for(var e=[],h=0,D=H.length;h<D;h++)e[h]=J[H[h]];return e};define(J[88],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function h(D,T){if(!D)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=h}),define(J[89],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function h(u){return(g,I,d)=>{let v=null,m=null;if(typeof d.value=="function"?(v="value",m=d.value):typeof d.get=="function"&&(v="get",m=d.get),!m)throw new Error("not supported");d[v]=u(m,I)}}e.createDecorator=h;let D=0;function T(){const u=`$memoize${D++}`;let g;const I=function(v,m,c){let y=null,b=null;if(typeof c.value=="function"?(y="value",b=c.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(y="get",b=c.get),!b)throw new Error("not supported");const p=`${u}:${m}`;c[y]=function(...w){return g=this,this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!0,enumerable:!1,writable:!0,value:b.apply(this,w)}),this[p]}};return I.clear=()=>{typeof g!="undefined"&&Object.getOwnPropertyNames(g).forEach(d=>{d.indexOf(u)===0&&delete g[d]})},I}e.createMemoizer=T;function _(u,g,I){return T()(u,g,I)}e.memoize=_;function k(u,g,I){return h((d,v)=>{const m=`$debounce$${v}`,c=`$debounce$result$${v}`;return function(...y){this[c]||(this[c]=I?I():void 0),clearTimeout(this[m]),g&&(this[c]=g(this[c],...y),y=[this[c]]),this[m]=setTimeout(()=>{d.apply(this,y),this[c]=I?I():void 0},u)}})}e.debounce=k;function P(u,g,I){return h((d,v)=>{const m=`$throttle$timer$${v}`,c=`$throttle$result$${v}`,y=`$throttle$lastRun$${v}`,b=`$throttle$pending$${v}`;return function(...p){if(this[c]||(this[c]=I?I():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),g&&(this[c]=g(this[c],...p)),!this[b]){const w=this[y]+u;w<=Date.now()?(this[y]=Date.now(),d.apply(this,[this[c]]),this[c]=I?I():void 0):(this[b]=!0,this[m]=setTimeout(()=>{this[b]=!1,this[y]=Date.now(),d.apply(this,[this[c]]),this[c]=I?I():void 0},w-Date.now()))}}})}e.throttle=P}),define(J[14],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class h{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=h,e.errorHandler=new h;function D(i){e.errorHandler.setUnexpectedErrorHandler(i)}e.setUnexpectedErrorHandler=D;function T(i){u(i)||e.errorHandler.onUnexpectedError(i)}e.onUnexpectedError=T;function _(i){u(i)||e.errorHandler.onUnexpectedExternalError(i)}e.onUnexpectedExternalError=_;function k(i){if(i instanceof Error){let{name:t,message:r}=i;const s=i.stacktrace||i.stack;return{$isError:!0,name:t,message:r,stack:s}}return i}e.transformErrorForSerialization=k;const P="Canceled";function u(i){return i instanceof Error&&i.name===P&&i.message===P}e.isPromiseCanceledError=u;class g extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=g;function I(){const i=new Error(P);return i.name=i.message,i}e.canceled=I;function d(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}e.illegalArgument=d;function v(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}e.illegalState=v;function m(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function c(i){const t=new Error(`${i} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function y(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}e.getErrorMessage=y;class b extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=b;class p extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=p;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function l(i){const t=i;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=l;function o(i,t=Object.create(null)){const r=new Error(i);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=o}),define(J[22],Z([0,1,14]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.mergeSort=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function D(L,S=0){return L[L.length-(1+S)]}e.tail=D;function T(L){if(L.length===0)throw new Error("Invalid tail call");return[L.slice(0,L.length-1),L[L.length-1]]}e.tail2=T;function _(L,S,R=(N,U)=>N===U){if(L===S)return!0;if(!L||!S||L.length!==S.length)return!1;for(let N=0,U=L.length;N<U;N++)if(!R(L[N],S[N]))return!1;return!0}e.equals=_;function k(L,S,R){let N=0,U=L.length-1;for(;N<=U;){const $=(N+U)/2|0,K=R(L[$],S);if(K<0)N=$+1;else if(K>0)U=$-1;else return $}return-(N+1)}e.binarySearch=k;function P(L,S){let R=0,N=L.length;if(N===0)return 0;for(;R<N;){const U=Math.floor((R+N)/2);S(L[U])?N=U:R=U+1}return R}e.findFirstInSorted=P;function u(L,S,R){if(L=L|0,L>=S.length)throw new TypeError("invalid index");let N=S[Math.floor(S.length*Math.random())],U=[],$=[],K=[];for(let Y of S){const Q=R(Y,N);Q<0?U.push(Y):Q>0?$.push(Y):K.push(Y)}return L<U.length?u(L,U,R):L<U.length+K.length?K[0]:u(L-(U.length+K.length),$,R)}e.quickSelect=u;function g(L,S){return d(L,S,0,L.length-1,[]),L}e.mergeSort=g;function I(L,S,R,N,U,$){let K=R,Y=N+1;for(let Q=R;Q<=U;Q++)$[Q]=L[Q];for(let Q=R;Q<=U;Q++)K>N?L[Q]=$[Y++]:Y>U?L[Q]=$[K++]:S($[Y],$[K])<0?L[Q]=$[Y++]:L[Q]=$[K++]}function d(L,S,R,N,U){if(!(N<=R)){const $=R+(N-R)/2|0;d(L,S,R,$,U),d(L,S,$+1,N,U),!(S(L[$],L[$+1])<=0)&&I(L,S,R,$,N,U)}}function v(L,S){const R=[];let N;for(const U of g(L.slice(0),S))!N||S(N[0],U)!==0?(N=[U],R.push(N)):N.push(U);return R}e.groupBy=v;function m(L,S,R){const N=[];function U(Y,Q,se){if(!(Q===0&&se.length===0)){const oe=N[N.length-1];oe&&oe.start+oe.deleteCount===Y?(oe.deleteCount+=Q,oe.toInsert.push(...se)):N.push({start:Y,deleteCount:Q,toInsert:se})}}let $=0,K=0;for(;;){if($===L.length){U($,0,S.slice(K));break}if(K===S.length){U($,L.length-$,[]);break}const Y=L[$],Q=S[K],se=R(Y,Q);se===0?($+=1,K+=1):se<0?(U($,1,[]),$+=1):se>0&&(U($,0,[Q]),K+=1)}return N}e.sortedDiff=m;function c(L,S,R){const N=m(L,S,R),U=[],$=[];for(const K of N)U.push(...L.slice(K.start,K.start+K.deleteCount)),$.push(...K.toInsert);return{removed:U,added:$}}e.delta=c;function y(L,S,R){if(R===0)return[];const N=L.slice(0,R).sort(S);return p(L,S,N,R,L.length),N}e.top=y;function b(L,S,R,N,U){return R===0?Promise.resolve([]):new Promise(($,K)=>{(async()=>{const Y=L.length,Q=L.slice(0,R).sort(S);for(let se=R,oe=Math.min(R+N,Y);se<Y;se=oe,oe=Math.min(oe+N,Y)){if(se>R&&await new Promise(ce=>setTimeout(ce)),U&&U.isCancellationRequested)throw h.canceled();p(L,S,Q,se,oe)}return Q})().then($,K)})}e.topAsync=b;function p(L,S,R,N,U){for(const $=R.length;N<U;N++){const K=L[N];if(S(K,R[$-1])<0){R.pop();const Y=P(R,Q=>S(K,Q)<0);R.splice(Y,0,K)}}}function w(L){return L.filter(S=>!!S)}e.coalesce=w;function l(L){let S=0;for(let R=0;R<L.length;R++)L[R]&&(L[S]=L[R],S+=1);L.length=S}e.coalesceInPlace=l;function o(L,S,R){L.splice(R,0,L.splice(S,1)[0])}e.move=o;function i(L){return!Array.isArray(L)||L.length===0}e.isFalsyOrEmpty=i;function t(L){return Array.isArray(L)&&L.length>0}e.isNonEmptyArray=t;function r(L,S){if(!S)return L.filter((N,U)=>L.indexOf(N)===U);const R=Object.create(null);return L.filter(N=>{const U=S(N);return R[U]?!1:(R[U]=!0,!0)})}e.distinct=r;function s(L){const S=new Set;return L.filter(R=>S.has(R)?!1:(S.add(R),!0))}e.distinctES6=s;function a(L){const S=Object.create(null);return R=>{const N=L(R);return S[N]?!1:(S[N]=!0,!0)}}e.uniqueFilter=a;function n(L,S){for(let R=L.length-1;R>=0;R--){const N=L[R];if(S(N))return R}return-1}e.lastIndex=n;function f(L,S){return L.length>0?L[0]:S}e.firstOrDefault=f;function C(L,S,R=(N,U)=>N===U){let N=0;for(let U=0,$=Math.min(L.length,S.length);U<$&&R(L[U],S[U]);U++)N++;return N}e.commonPrefixLength=C;function A(L){return[].concat(...L)}e.flatten=A;function O(L,S){let R=typeof S=="number"?L:0;typeof S=="number"?R=L:(R=0,S=L);const N=[];if(R<=S)for(let U=R;U<S;U++)N.push(U);else for(let U=R;U>S;U--)N.push(U);return N}e.range=O;function E(L,S,R){return L.reduce((N,U)=>(N[S(U)]=R?R(U):U,N),Object.create(null))}e.index=E;function F(L,S){return L.push(S),()=>j(L,S)}e.insert=F;function j(L,S){const R=L.indexOf(S);if(R>-1)return L.splice(R,1),S}e.remove=j;function G(L,S,R){const N=L.slice(0,S),U=L.slice(S);return N.concat(R,U)}e.arrayInsert=G;function z(L,S){let R;if(typeof S=="number"){let N=S;R=()=>{const U=Math.sin(N++)*179426549;return U-Math.floor(U)}}else R=Math.random;for(let N=L.length-1;N>0;N-=1){const U=Math.floor(R()*(N+1)),$=L[N];L[N]=L[U],L[U]=$}}e.shuffle=z;function W(L,S){const R=L.indexOf(S);R>-1&&(L.splice(R,1),L.unshift(S))}e.pushToStart=W;function q(L,S){const R=L.indexOf(S);R>-1&&(L.splice(R,1),L.push(S))}e.pushToEnd=q;function ee(L,S){return Array.isArray(L)?L.map(S):S(L)}e.mapArrayOrNot=ee;function te(L){return Array.isArray(L)?L:[L]}e.asArray=te;function B(L){return L[Math.floor(Math.random()*L.length)]}e.getRandomElement=B;function M(L,S){for(const R of L){const N=S(R);if(N!==void 0)return N}}e.mapFind=M}),define(J[58],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function h(D){const T=this;let _=!1,k;return function(){return _||(_=!0,k=D.apply(T,arguments)),k}}e.once=h}),define(J[59],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var h;(function(D){function T(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}D.is=T;const _=Object.freeze([]);function k(){return _}D.empty=k;function*P(i){yield i}D.single=P;function u(i){return i||_}D.from=u;function g(i){return!i||i[Symbol.iterator]().next().done===!0}D.isEmpty=g;function I(i){return i[Symbol.iterator]().next().value}D.first=I;function d(i,t){for(const r of i)if(t(r))return!0;return!1}D.some=d;function v(i,t){for(const r of i)if(t(r))return r}D.find=v;function*m(i,t){for(const r of i)t(r)&&(yield r)}D.filter=m;function*c(i,t){for(const r of i)yield t(r)}D.map=c;function*y(...i){for(const t of i)for(const r of t)yield r}D.concat=y;function*b(i){for(const t of i)for(const r of t)yield r}D.concatNested=b;function p(i,t,r){let s=r;for(const a of i)s=t(s,a);return s}D.reduce=p;function*w(i,t,r=i.length){for(t<0&&(t+=i.length),r<0?r+=i.length:r>i.length&&(r=i.length);t<r;t++)yield i[t]}D.slice=w;function l(i,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,i];const s=i[Symbol.iterator]();for(let a=0;a<t;a++){const n=s.next();if(n.done)return[r,D.empty()];r.push(n.value)}return[r,{[Symbol.iterator](){return s}}]}D.consume=l;function o(i,t,r=(s,a)=>s===a){const s=i[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const n=s.next(),f=a.next();if(n.done!==f.done)return!1;if(n.done)return!0;if(!r(n.value,f.value))return!1}}D.equals=o})(h=e.Iterable||(e.Iterable={}))}),define(J[60],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var h;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(h=e.ScanError||(e.ScanError={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var _;(function(t){t.DEFAULT={allowTrailingComma:!0}})(_=e.ParseOptions||(e.ParseOptions={}));function k(t,r=!1){let s=0,a=t.length,n="",f=0,C=16,A=0;function O(q){let ee=0,te=0;for(;ee<q;){const B=t.charCodeAt(s);if(B>=48&&B<=57)te=te*16+B-48;else if(B>=65&&B<=70)te=te*16+B-65+10;else if(B>=97&&B<=102)te=te*16+B-97+10;else break;s++,ee++}return ee<q&&(te=-1),te}function E(q){s=q,n="",f=0,C=16,A=0}function F(){const q=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&g(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&g(t.charCodeAt(s)))for(s++;s<t.length&&g(t.charCodeAt(s));)s++;else return A=3,t.substring(q,s);let ee=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&g(t.charCodeAt(s))){for(s++;s<t.length&&g(t.charCodeAt(s));)s++;ee=s}else A=3;return t.substring(q,ee)}function j(){let q="",ee=s;for(;;){if(s>=a){q+=t.substring(ee,s),A=2;break}const te=t.charCodeAt(s);if(te===34){q+=t.substring(ee,s),s++;break}if(te===92){if(q+=t.substring(ee,s),s++,s>=a){A=2;break}switch(t.charCodeAt(s++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:const M=O(4);M>=0?q+=String.fromCharCode(M):A=4;break;default:A=5}ee=s;continue}if(te>=0&&te<=31)if(u(te)){q+=t.substring(ee,s),A=2;break}else A=6;s++}return q}function G(){if(n="",A=0,f=s,s>=a)return f=a,C=17;let q=t.charCodeAt(s);if(P(q)){do s++,n+=String.fromCharCode(q),q=t.charCodeAt(s);while(P(q));return C=15}if(u(q))return s++,n+=String.fromCharCode(q),q===13&&t.charCodeAt(s)===10&&(s++,n+=`
`),C=14;switch(q){case 123:return s++,C=1;case 125:return s++,C=2;case 91:return s++,C=3;case 93:return s++,C=4;case 58:return s++,C=6;case 44:return s++,C=5;case 34:return s++,n=j(),C=10;case 47:const ee=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<a&&!u(t.charCodeAt(s));)s++;return n=t.substring(ee,s),C=12}if(t.charCodeAt(s+1)===42){s+=2;const te=a-1;let B=!1;for(;s<te;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,B=!0;break}s++}return B||(s++,A=1),n=t.substring(ee,s),C=13}return n+=String.fromCharCode(q),s++,C=16;case 45:if(n+=String.fromCharCode(q),s++,s===a||!g(t.charCodeAt(s)))return C=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=F(),C=11;default:for(;s<a&&z(q);)s++,q=t.charCodeAt(s);if(f!==s){switch(n=t.substring(f,s),n){case"true":return C=8;case"false":return C=9;case"null":return C=7}return C=16}return n+=String.fromCharCode(q),s++,C=16}}function z(q){if(P(q)||u(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let q;do q=G();while(q>=12&&q<=15);return q}return{setPosition:E,getPosition:()=>s,scan:r?W:G,getToken:()=>C,getTokenValue:()=>n,getTokenOffset:()=>f,getTokenLength:()=>s-f,getTokenError:()=>A}}e.createScanner=k;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function u(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function d(t,r){const s=[],a=new Object;let n;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let C=!1;function A(O,E,F,j){f.value=O,f.offset=E,f.length=F,f.type=j,f.colonOffset=void 0,n=f}try{l(t,{onObjectBegin:(O,E)=>{if(r<=O)throw a;n=void 0,C=r>O,s.push("")},onObjectProperty:(O,E,F)=>{if(r<E||(A(O,E,F,"property"),s[s.length-1]=O,r<=E+F))throw a},onObjectEnd:(O,E)=>{if(r<=O)throw a;n=void 0,s.pop()},onArrayBegin:(O,E)=>{if(r<=O)throw a;n=void 0,s.push(0)},onArrayEnd:(O,E)=>{if(r<=O)throw a;n=void 0,s.pop()},onLiteralValue:(O,E,F)=>{if(r<E||(A(O,E,F,i(O)),r<=E+F))throw a},onSeparator:(O,E,F)=>{if(r<=E)throw a;if(O===":"&&n&&n.type==="property")n.colonOffset=E,C=!1,n=void 0;else if(O===","){const j=s[s.length-1];typeof j=="number"?s[s.length-1]=j+1:(C=!0,s[s.length-1]=""),n=void 0}}})}catch(O){if(O!==a)throw O}return{path:s,previousNode:n,isAtPropertyKey:C,matches:O=>{let E=0;for(let F=0;E<O.length&&F<s.length;F++)if(O[E]===s[F]||O[E]==="*")E++;else if(O[E]!=="**")return!1;return E===O.length}}}e.getLocation=d;function v(t,r=[],s=_.DEFAULT){let a=null,n=[];const f=[];function C(O){Array.isArray(n)?n.push(O):a!==null&&(n[a]=O)}return l(t,{onObjectBegin:()=>{const O={};C(O),f.push(n),n=O,a=null},onObjectProperty:O=>{a=O},onObjectEnd:()=>{n=f.pop()},onArrayBegin:()=>{const O=[];C(O),f.push(n),n=O,a=null},onArrayEnd:()=>{n=f.pop()},onLiteralValue:C,onError:(O,E,F)=>{r.push({error:O,offset:E,length:F})}},s),n[0]}e.parse=v;function m(t,r=[],s=_.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(O){a.type==="property"&&(a.length=O-a.offset,a=a.parent)}function f(O){return a.children.push(O),O}l(t,{onObjectBegin:O=>{a=f({type:"object",offset:O,length:-1,parent:a,children:[]})},onObjectProperty:(O,E,F)=>{a=f({type:"property",offset:E,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:O,offset:E,length:F,parent:a})},onObjectEnd:(O,E)=>{a.length=O+E-a.offset,a=a.parent,n(O+E)},onArrayBegin:(O,E)=>{a=f({type:"array",offset:O,length:-1,parent:a,children:[]})},onArrayEnd:(O,E)=>{a.length=O+E-a.offset,a=a.parent,n(O+E)},onLiteralValue:(O,E,F)=>{f({type:i(O),offset:E,length:F,parent:a,value:O}),n(E+F)},onSeparator:(O,E,F)=>{a.type==="property"&&(O===":"?a.colonOffset=E:O===","&&n(E))},onError:(O,E,F)=>{r.push({error:O,offset:E,length:F})}},s);const A=a.children[0];return A&&delete A.parent,A}e.parseTree=m;function c(t,r){if(!!t){let s=t;for(let a of r)if(typeof a=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let n=!1;for(const f of s.children)if(Array.isArray(f.children)&&f.children[0].value===a){s=f.children[1],n=!0;break}if(!n)return}else{const n=a;if(s.type!=="array"||n<0||!Array.isArray(s.children)||n>=s.children.length)return;s=s.children[n]}return s}}e.findNodeAtLocation=c;function y(t){if(!t.parent||!t.parent.children)return[];const r=y(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=y;function b(t){switch(t.type){case"array":return t.children.map(b);case"object":const r=Object.create(null);for(let s of t.children){const a=s.children[1];a&&(r[s.children[0].value]=b(a))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=b;function p(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=p;function w(t,r,s=!1){if(p(t,r,s)){const a=t.children;if(Array.isArray(a))for(let n=0;n<a.length&&a[n].offset<=r;n++){const f=w(a[n],r,s);if(f)return f}return t}}e.findNodeAtOffset=w;function l(t,r,s=_.DEFAULT){const a=k(t,!1);function n($){return $?()=>$(a.getTokenOffset(),a.getTokenLength()):()=>!0}function f($){return $?K=>$(K,a.getTokenOffset(),a.getTokenLength()):()=>!0}const C=n(r.onObjectBegin),A=f(r.onObjectProperty),O=n(r.onObjectEnd),E=n(r.onArrayBegin),F=n(r.onArrayEnd),j=f(r.onLiteralValue),G=f(r.onSeparator),z=n(r.onComment),W=f(r.onError),q=s&&s.disallowComments,ee=s&&s.allowTrailingComma;function te(){for(;;){const $=a.scan();switch(a.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:q||B(11);break;case 2:B(12);break;case 6:B(16);break}switch($){case 12:case 13:q?B(10):z();break;case 16:B(1);break;case 15:case 14:break;default:return $}}}function B($,K=[],Y=[]){if(W($),K.length+Y.length>0){let Q=a.getToken();for(;Q!==17;){if(K.indexOf(Q)!==-1){te();break}else if(Y.indexOf(Q)!==-1)break;Q=te()}}}function M($){const K=a.getTokenValue();return $?j(K):A(K),te(),!0}function L(){switch(a.getToken()){case 11:let $=0;try{$=JSON.parse(a.getTokenValue()),typeof $!="number"&&(B(2),$=0)}catch(K){B(2)}j($);break;case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return te(),!0}function S(){return a.getToken()!==10?(B(3,[],[2,5]),!1):(M(!1),a.getToken()===6?(G(":"),te(),U()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function R(){C(),te();let $=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if($||B(4,[],[]),G(","),te(),a.getToken()===2&&ee)break}else $&&B(6,[],[]);S()||B(4,[],[2,5]),$=!0}return O(),a.getToken()!==2?B(7,[2],[]):te(),!0}function N(){E(),te();let $=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if($||B(4,[],[]),G(","),te(),a.getToken()===4&&ee)break}else $&&B(6,[],[]);U()||B(4,[],[4,5]),$=!0}return F(),a.getToken()!==4?B(8,[4],[]):te(),!0}function U(){switch(a.getToken()){case 3:return N();case 1:return R();case 10:return M(!0);default:return L()}}return te(),a.getToken()===17?s.allowEmptyContent?!0:(B(4,[],[]),!1):U()?(a.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=l;function o(t,r){let s=k(t),a=[],n,f=0,C;do switch(C=s.getPosition(),n=s.scan(),n){case 12:case 13:case 17:f!==C&&a.push(t.substring(f,C)),r!==void 0&&a.push(s.getTokenValue().replace(/[^\r\n]/g,r)),f=s.getPosition();break}while(n!==17);return a.join("")}e.stripComments=o;function i(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=i}),define(J[2],Z([0,1,58,59]),function(H,e,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const T=!1;let _=null;function k(l){_=l}if(e.setDisposableTracker=k,T){const l="__is_disposable_tracked__";_=new class{trackDisposable(o){const i=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[l]||console.log(i)},3e3)}markTracked(o){if(o&&o!==y.None)try{o[l]=!0}catch(i){}}}}function P(l){!_||_.markTracked(l)}function u(l){return _&&_.trackDisposable(l),l}e.trackDisposable=u;class g extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=g;function I(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=I;function d(l){if(D.Iterable.is(l)){let o=[];for(const i of l)if(i){P(i);try{i.dispose()}catch(t){o.push(t)}}if(o.length===1)throw o[0];if(o.length>1)throw new g(o);return Array.isArray(l)?[]:l}else if(l)return P(l),l.dispose(),l}e.dispose=d;function v(...l){return l.forEach(P),m(()=>d(l))}e.combinedDisposable=v;function m(l){const o=u({dispose:()=>{P(o),l()}});return o}e.toDisposable=m;class c{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return P(o),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new c,u(this)}dispose(){P(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=y,y.None=Object.freeze({dispose(){}});class b{constructor(){this._isDisposed=!1,u(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){var i;this._isDisposed||o===this._value||((i=this._value)===null||i===void 0||i.dispose(),o&&P(o),this._value=o)}clear(){this.value=void 0}dispose(){var o;this._isDisposed=!0,P(this),(o=this._value)===null||o===void 0||o.dispose(),this._value=void 0}}e.MutableDisposable=b;class p{constructor(){this.references=new Map}acquire(o,...i){let t=this.references.get(o);t||(t={counter:0,object:this.createReferencedObject(o,...i)},this.references.set(o,t));const{object:r}=t,s=h.once(()=>{--t.counter==0&&(this.destroyReferencedObject(o,t.object),this.references.delete(o))});return t.counter++,{object:r,dispose:s}}}e.ReferenceCollection=p;class w{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=w}),define(J[61],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class h{constructor(_){this.element=_,this.next=h.Undefined,this.prev=h.Undefined}}h.Undefined=new h(void 0);class D{constructor(){this._first=h.Undefined,this._last=h.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===h.Undefined}clear(){this._first=h.Undefined,this._last=h.Undefined,this._size=0}unshift(_){return this._insert(_,!1)}push(_){return this._insert(_,!0)}_insert(_,k){const P=new h(_);if(this._first===h.Undefined)this._first=P,this._last=P;else if(k){const g=this._last;this._last=P,P.prev=g,g.next=P}else{const g=this._first;this._first=P,P.next=g,g.prev=P}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(P))}}shift(){if(this._first!==h.Undefined){const _=this._first.element;return this._remove(this._first),_}}pop(){if(this._last!==h.Undefined){const _=this._last.element;return this._remove(this._last),_}}_remove(_){if(_.prev!==h.Undefined&&_.next!==h.Undefined){const k=_.prev;k.next=_.next,_.next.prev=k}else _.prev===h.Undefined&&_.next===h.Undefined?(this._first=h.Undefined,this._last=h.Undefined):_.next===h.Undefined?(this._last=this._last.prev,this._last.next=h.Undefined):_.prev===h.Undefined&&(this._first=this._first.next,this._first.prev=h.Undefined);this._size-=1}*[Symbol.iterator](){let _=this._first;for(;_!==h.Undefined;)yield _.element,_=_.next}}e.LinkedList=D});"use strict";function Ve(H){const e=[];typeof H=="number"&&e.push("code/timeOrigin",H);function h(T){e.push(T,Date.now())}function D(){const T=[];for(let _=0;_<e.length;_+=2)T.push({name:e[_],startTime:e[_+1]});return T}return{mark:h,getMarks:D}}function Xe(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Ve():{mark(H){performance.mark(H)},getMarks(){let H=performance.timeOrigin;typeof H!="number"&&(H=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const e=[{name:"code/timeOrigin",startTime:Math.round(H)}];for(const h of performance.getEntriesByType("mark"))e.push({name:h.name,startTime:Math.round(H+h.startTime)});return e}};if(typeof process=="object"){const H=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Ve(H)}else return console.trace("perf-util loaded in UNKNOWN environment"),Ve()}function $e(H){return H.MonacoPerformanceMarks||(H.MonacoPerformanceMarks=Xe()),H.MonacoPerformanceMarks}var je;typeof global=="object"?je=global:typeof self=="object"?je=self:je={},typeof define=="function"?define("vs/base/common/performance",[],function(){return $e(je)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=$e(je):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),je.perf=$e(je)),define(J[4],Z([0,1]),function(H,e){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.globals=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=void 0;const D="en";let T=!1,_=!1,k=!1,P=!1,u=!1,g=!1,I=!1,d,v=D,m,c;const y=typeof self=="object"?self:typeof global=="object"?global:{};let b;typeof process!="undefined"?b=process:typeof y.vscode!="undefined"&&(b=y.vscode.process);const p=typeof((h=b==null?void 0:b.versions)===null||h===void 0?void 0:h.electron)=="string"&&b.type==="renderer";if(e.isElectronSandboxed=p&&(b==null?void 0:b.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const n=b==null?void 0:b.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof n=="string")return n==="none"||n==="code"||n==="bypassHeatCheck"||n==="bypassHeatCheckAndEagerCompile"?n:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!p){c=navigator.userAgent,T=c.indexOf("Windows")>=0,_=c.indexOf("Macintosh")>=0,I=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=c.indexOf("Linux")>=0,g=!0,d=navigator.language,v=d;const n=typeof document!="undefined"&&document.getElementById("vscode-remote-nls-configuration"),f=n&&n.getAttribute("data-settings");if(f)try{const C=JSON.parse(f);d=C.locale,m=C._translationsConfigFile,v=C.availableLanguages["*"]||D}catch(C){}}else if(typeof b=="object"){T=b.platform==="win32",_=b.platform==="darwin",k=b.platform==="linux",P=k&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,d=D,v=D;const n=b.env.VSCODE_NLS_CONFIG;if(n)try{const f=JSON.parse(n),C=f.availableLanguages["*"];d=f.locale,v=C||D,m=f._translationsConfigFile}catch(f){}u=!0}else console.error("Unable to resolve platform.");var w;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function l(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let o=0;_?o=1:T?o=3:k&&(o=2),e.isWindows=T,e.isMacintosh=_,e.isLinux=k,e.isLinuxSnap=P,e.isNative=u,e.isWeb=g,e.isIOS=I,e.platform=o,e.userAgent=c,e.language=v;var i;(function(n){function f(){return e.language}n.value=f;function C(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=C;function A(){return e.language==="en"}n.isDefault=A})(i=e.Language||(e.Language={})),e.locale=d,e.translationsConfigFile=m,e.globals=y,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let C=[];e.globals.addEventListener("message",O=>{if(O.data&&O.data.vscodeSetImmediateId)for(let E=0,F=C.length;E<F;E++){const j=C[E];if(j.id===O.data.vscodeSetImmediateId){C.splice(E,1),j.callback();return}}});let A=0;return O=>{const E=++A;C.push({id:E,callback:O}),e.globals.postMessage({vscodeSetImmediateId:E},"*")}}if(b&&typeof b.nextTick=="function")return b.nextTick.bind(b);const f=Promise.resolve();return C=>f.then(C)}();var t;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=_||I?2:T?1:3;let r=!0,s=!1;function a(){if(!s){s=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,r=new Uint16Array(n.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=a}),define(J[33],Z([0,1,4]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let D;typeof process!="undefined"?D=process:typeof h.globals.vscode!="undefined"?D={get platform(){return h.globals.vscode.process.platform},get env(){return h.globals.vscode.process.env},nextTick(T){return h.setImmediate(T)},cwd(){return h.globals.vscode.process.env.VSCODE_CWD||h.globals.vscode.process.execPath.substr(0,h.globals.vscode.process.execPath.lastIndexOf(h.globals.vscode.process.platform==="win32"?"\\":"/"))}}:D={get platform(){return h.isWindows?"win32":h.isMacintosh?"darwin":"linux"},nextTick(T){return h.setImmediate(T)},get env(){return Object.create(null)},cwd(){return"/"}},e.cwd=D.cwd,e.env=D.env,e.platform=D.platform,e.nextTick=D.nextTick}),define(J[3],Z([0,1,33]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const D=65,T=97,_=90,k=122,P=46,u=47,g=92,I=58,d=63;class v extends Error{constructor(o,i,t){let r;typeof i=="string"&&i.indexOf("not ")===0?(r="must not be",i=i.replace(/^not /,"")):r="must be";const s=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${s} ${r} of type ${i}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function m(l,o){if(typeof l!="string")throw new v(o,"string",l)}function c(l){return l===u||l===g}function y(l){return l===u}function b(l){return l>=D&&l<=_||l>=T&&l<=k}function p(l,o,i,t){let r="",s=0,a=-1,n=0,f=0;for(let C=0;C<=l.length;++C){if(C<l.length)f=l.charCodeAt(C);else{if(t(f))break;f=u}if(t(f)){if(!(a===C-1||n===1))if(n===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const A=r.lastIndexOf(i);A===-1?(r="",s=0):(r=r.slice(0,A),s=r.length-1-r.lastIndexOf(i)),a=C,n=0;continue}else if(r.length!==0){r="",s=0,a=C,n=0;continue}}o&&(r+=r.length>0?`${i}..`:"..",s=2)}else r.length>0?r+=`${i}${l.slice(a+1,C)}`:r=l.slice(a+1,C),s=C-a-1;a=C,n=0}else f===P&&n!==-1?++n:n=-1}return r}function w(l,o){if(o===null||typeof o!="object")throw new v("pathObject","Object",o);const i=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return i?i===o.root?`${i}${t}`:`${i}${l}${t}`:t}e.win32={resolve(...l){let o="",i="",t=!1;for(let r=l.length-1;r>=-1;r--){let s;if(r>=0){if(s=l[r],m(s,"path"),s.length===0)continue}else o.length===0?s=h.cwd():(s=h.env[`=${o}`]||h.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==o.toLowerCase()&&s.charCodeAt(2)===g)&&(s=`${o}\\`));const a=s.length;let n=0,f="",C=!1;const A=s.charCodeAt(0);if(a===1)c(A)&&(n=1,C=!0);else if(c(A))if(C=!0,c(s.charCodeAt(1))){let O=2,E=O;for(;O<a&&!c(s.charCodeAt(O));)O++;if(O<a&&O!==E){const F=s.slice(E,O);for(E=O;O<a&&c(s.charCodeAt(O));)O++;if(O<a&&O!==E){for(E=O;O<a&&!c(s.charCodeAt(O));)O++;(O===a||O!==E)&&(f=`\\\\${F}\\${s.slice(E,O)}`,n=O)}}}else n=1;else b(A)&&s.charCodeAt(1)===I&&(f=s.slice(0,2),n=2,a>2&&c(s.charCodeAt(2))&&(C=!0,n=3));if(f.length>0)if(o.length>0){if(f.toLowerCase()!==o.toLowerCase())continue}else o=f;if(t){if(o.length>0)break}else if(i=`${s.slice(n)}\\${i}`,t=C,C&&o.length>0)break}return i=p(i,!t,"\\",c),t?`${o}\\${i}`:`${o}${i}`||"."},normalize(l){m(l,"path");const o=l.length;if(o===0)return".";let i=0,t,r=!1;const s=l.charCodeAt(0);if(o===1)return y(s)?"\\":l;if(c(s))if(r=!0,c(l.charCodeAt(1))){let n=2,f=n;for(;n<o&&!c(l.charCodeAt(n));)n++;if(n<o&&n!==f){const C=l.slice(f,n);for(f=n;n<o&&c(l.charCodeAt(n));)n++;if(n<o&&n!==f){for(f=n;n<o&&!c(l.charCodeAt(n));)n++;if(n===o)return`\\\\${C}\\${l.slice(f)}\\`;n!==f&&(t=`\\\\${C}\\${l.slice(f,n)}`,i=n)}}}else i=1;else b(s)&&l.charCodeAt(1)===I&&(t=l.slice(0,2),i=2,o>2&&c(l.charCodeAt(2))&&(r=!0,i=3));let a=i<o?p(l.slice(i),!r,"\\",c):"";return a.length===0&&!r&&(a="."),a.length>0&&c(l.charCodeAt(o-1))&&(a+="\\"),t===void 0?r?`\\${a}`:a:r?`${t}\\${a}`:`${t}${a}`},isAbsolute(l){m(l,"path");const o=l.length;if(o===0)return!1;const i=l.charCodeAt(0);return c(i)||o>2&&b(i)&&l.charCodeAt(1)===I&&c(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let o,i;for(let s=0;s<l.length;++s){const a=l[s];m(a,"path"),a.length>0&&(o===void 0?o=i=a:o+=`\\${a}`)}if(o===void 0)return".";let t=!0,r=0;if(typeof i=="string"&&c(i.charCodeAt(0))){++r;const s=i.length;s>1&&c(i.charCodeAt(1))&&(++r,s>2&&(c(i.charCodeAt(2))?++r:t=!1))}if(t){for(;r<o.length&&c(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(l,o){if(m(l,"from"),m(o,"to"),l===o)return"";const i=e.win32.resolve(l),t=e.win32.resolve(o);if(i===t||(l=i.toLowerCase(),o=t.toLowerCase(),l===o))return"";let r=0;for(;r<l.length&&l.charCodeAt(r)===g;)r++;let s=l.length;for(;s-1>r&&l.charCodeAt(s-1)===g;)s--;const a=s-r;let n=0;for(;n<o.length&&o.charCodeAt(n)===g;)n++;let f=o.length;for(;f-1>n&&o.charCodeAt(f-1)===g;)f--;const C=f-n,A=a<C?a:C;let O=-1,E=0;for(;E<A;E++){const j=l.charCodeAt(r+E);if(j!==o.charCodeAt(n+E))break;j===g&&(O=E)}if(E!==A){if(O===-1)return t}else{if(C>A){if(o.charCodeAt(n+E)===g)return t.slice(n+E+1);if(E===2)return t.slice(n+E)}a>A&&(l.charCodeAt(r+E)===g?O=E:E===2&&(O=3)),O===-1&&(O=0)}let F="";for(E=r+O+1;E<=s;++E)(E===s||l.charCodeAt(E)===g)&&(F+=F.length===0?"..":"\\..");return n+=O,F.length>0?`${F}${t.slice(n,f)}`:(t.charCodeAt(n)===g&&++n,t.slice(n,f))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const o=e.win32.resolve(l);if(o.length<=2)return l;if(o.charCodeAt(0)===g){if(o.charCodeAt(1)===g){const i=o.charCodeAt(2);if(i!==d&&i!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(b(o.charCodeAt(0))&&o.charCodeAt(1)===I&&o.charCodeAt(2)===g)return`\\\\?\\${o}`;return l},dirname(l){m(l,"path");const o=l.length;if(o===0)return".";let i=-1,t=0;const r=l.charCodeAt(0);if(o===1)return c(r)?l:".";if(c(r)){if(i=t=1,c(l.charCodeAt(1))){let n=2,f=n;for(;n<o&&!c(l.charCodeAt(n));)n++;if(n<o&&n!==f){for(f=n;n<o&&c(l.charCodeAt(n));)n++;if(n<o&&n!==f){for(f=n;n<o&&!c(l.charCodeAt(n));)n++;if(n===o)return l;n!==f&&(i=t=n+1)}}}}else b(r)&&l.charCodeAt(1)===I&&(i=o>2&&c(l.charCodeAt(2))?3:2,t=i);let s=-1,a=!0;for(let n=o-1;n>=t;--n)if(c(l.charCodeAt(n))){if(!a){s=n;break}}else a=!1;if(s===-1){if(i===-1)return".";s=i}return l.slice(0,s)},basename(l,o){o!==void 0&&m(o,"ext"),m(l,"path");let i=0,t=-1,r=!0,s;if(l.length>=2&&b(l.charCodeAt(0))&&l.charCodeAt(1)===I&&(i=2),o!==void 0&&o.length>0&&o.length<=l.length){if(o===l)return"";let a=o.length-1,n=-1;for(s=l.length-1;s>=i;--s){const f=l.charCodeAt(s);if(c(f)){if(!r){i=s+1;break}}else n===-1&&(r=!1,n=s+1),a>=0&&(f===o.charCodeAt(a)?--a==-1&&(t=s):(a=-1,t=n))}return i===t?t=n:t===-1&&(t=l.length),l.slice(i,t)}for(s=l.length-1;s>=i;--s)if(c(l.charCodeAt(s))){if(!r){i=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":l.slice(i,t)},extname(l){m(l,"path");let o=0,i=-1,t=0,r=-1,s=!0,a=0;l.length>=2&&l.charCodeAt(1)===I&&b(l.charCodeAt(0))&&(o=t=2);for(let n=l.length-1;n>=o;--n){const f=l.charCodeAt(n);if(c(f)){if(!s){t=n+1;break}continue}r===-1&&(s=!1,r=n+1),f===P?i===-1?i=n:a!==1&&(a=1):i!==-1&&(a=-1)}return i===-1||r===-1||a===0||a===1&&i===r-1&&i===t+1?"":l.slice(i,r)},format:w.bind(null,"\\"),parse(l){m(l,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return o;const i=l.length;let t=0,r=l.charCodeAt(0);if(i===1)return c(r)?(o.root=o.dir=l,o):(o.base=o.name=l,o);if(c(r)){if(t=1,c(l.charCodeAt(1))){let O=2,E=O;for(;O<i&&!c(l.charCodeAt(O));)O++;if(O<i&&O!==E){for(E=O;O<i&&c(l.charCodeAt(O));)O++;if(O<i&&O!==E){for(E=O;O<i&&!c(l.charCodeAt(O));)O++;O===i?t=O:O!==E&&(t=O+1)}}}}else if(b(r)&&l.charCodeAt(1)===I){if(i<=2)return o.root=o.dir=l,o;if(t=2,c(l.charCodeAt(2))){if(i===3)return o.root=o.dir=l,o;t=3}}t>0&&(o.root=l.slice(0,t));let s=-1,a=t,n=-1,f=!0,C=l.length-1,A=0;for(;C>=t;--C){if(r=l.charCodeAt(C),c(r)){if(!f){a=C+1;break}continue}n===-1&&(f=!1,n=C+1),r===P?s===-1?s=C:A!==1&&(A=1):s!==-1&&(A=-1)}return n!==-1&&(s===-1||A===0||A===1&&s===n-1&&s===a+1?o.base=o.name=l.slice(a,n):(o.name=l.slice(a,s),o.base=l.slice(a,n),o.ext=l.slice(s,n))),a>0&&a!==t?o.dir=l.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let o="",i=!1;for(let t=l.length-1;t>=-1&&!i;t--){const r=t>=0?l[t]:h.cwd();m(r,"path"),r.length!==0&&(o=`${r}/${o}`,i=r.charCodeAt(0)===u)}return o=p(o,!i,"/",y),i?`/${o}`:o.length>0?o:"."},normalize(l){if(m(l,"path"),l.length===0)return".";const o=l.charCodeAt(0)===u,i=l.charCodeAt(l.length-1)===u;return l=p(l,!o,"/",y),l.length===0?o?"/":i?"./":".":(i&&(l+="/"),o?`/${l}`:l)},isAbsolute(l){return m(l,"path"),l.length>0&&l.charCodeAt(0)===u},join(...l){if(l.length===0)return".";let o;for(let i=0;i<l.length;++i){const t=l[i];m(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(l,o){if(m(l,"from"),m(o,"to"),l===o||(l=e.posix.resolve(l),o=e.posix.resolve(o),l===o))return"";const i=1,t=l.length,r=t-i,s=1,a=o.length-s,n=r<a?r:a;let f=-1,C=0;for(;C<n;C++){const O=l.charCodeAt(i+C);if(O!==o.charCodeAt(s+C))break;O===u&&(f=C)}if(C===n)if(a>n){if(o.charCodeAt(s+C)===u)return o.slice(s+C+1);if(C===0)return o.slice(s+C)}else r>n&&(l.charCodeAt(i+C)===u?f=C:C===0&&(f=0));let A="";for(C=i+f+1;C<=t;++C)(C===t||l.charCodeAt(C)===u)&&(A+=A.length===0?"..":"/..");return`${A}${o.slice(s+f)}`},toNamespacedPath(l){return l},dirname(l){if(m(l,"path"),l.length===0)return".";const o=l.charCodeAt(0)===u;let i=-1,t=!0;for(let r=l.length-1;r>=1;--r)if(l.charCodeAt(r)===u){if(!t){i=r;break}}else t=!1;return i===-1?o?"/":".":o&&i===1?"//":l.slice(0,i)},basename(l,o){o!==void 0&&m(o,"ext"),m(l,"path");let i=0,t=-1,r=!0,s;if(o!==void 0&&o.length>0&&o.length<=l.length){if(o===l)return"";let a=o.length-1,n=-1;for(s=l.length-1;s>=0;--s){const f=l.charCodeAt(s);if(f===u){if(!r){i=s+1;break}}else n===-1&&(r=!1,n=s+1),a>=0&&(f===o.charCodeAt(a)?--a==-1&&(t=s):(a=-1,t=n))}return i===t?t=n:t===-1&&(t=l.length),l.slice(i,t)}for(s=l.length-1;s>=0;--s)if(l.charCodeAt(s)===u){if(!r){i=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":l.slice(i,t)},extname(l){m(l,"path");let o=-1,i=0,t=-1,r=!0,s=0;for(let a=l.length-1;a>=0;--a){const n=l.charCodeAt(a);if(n===u){if(!r){i=a+1;break}continue}t===-1&&(r=!1,t=a+1),n===P?o===-1?o=a:s!==1&&(s=1):o!==-1&&(s=-1)}return o===-1||t===-1||s===0||s===1&&o===t-1&&o===i+1?"":l.slice(o,t)},format:w.bind(null,"/"),parse(l){m(l,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return o;const i=l.charCodeAt(0)===u;let t;i?(o.root="/",t=1):t=0;let r=-1,s=0,a=-1,n=!0,f=l.length-1,C=0;for(;f>=t;--f){const A=l.charCodeAt(f);if(A===u){if(!n){s=f+1;break}continue}a===-1&&(n=!1,a=f+1),A===P?r===-1?r=f:C!==1&&(C=1):r!==-1&&(C=-1)}if(a!==-1){const A=s===0&&i?1:s;r===-1||C===0||C===1&&r===a-1&&r===s+1?o.base=o.name=l.slice(A,a):(o.name=l.slice(A,r),o.base=l.slice(A,a),o.ext=l.slice(r,a))}return s>0?o.dir=l.slice(0,s-1):i&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=h.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=h.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=h.platform==="win32"?e.win32.join:e.posix.join,e.resolve=h.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=h.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=h.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=h.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=h.platform==="win32"?e.win32.extname:e.posix.extname,e.format=h.platform==="win32"?e.win32.format:e.posix.format,e.parse=h.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=h.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=h.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=h.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[90],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var h;(function(_){_[_.stdout=0]="stdout",_[_.stderr=1]="stderr"})(h=e.Source||(e.Source={}));var D;(function(_){_[_.Success=0]="Success",_[_.Unknown=1]="Unknown",_[_.AccessDenied=2]="AccessDenied",_[_.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(_,...k){const P=k.reduce((I,d)=>(I[d]=!0,I),{}),u=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/];Object.keys(_).filter(I=>!P[I]).forEach(I=>{for(let d=0;d<u.length;d++)if(I.search(u[d])!==-1){delete _[I];break}})}e.sanitizeProcessEnvironment=T}),function(H,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var h=e();for(var D in h)(typeof exports=="object"?exports:H)[D]=h[D]}}(typeof self!="undefined"?self:this,function(){return function(H){var e={};function h(D){if(e[D])return e[D].exports;var T=e[D]={i:D,l:!1,exports:{}};return H[D].call(T.exports,T,T.exports,h),T.l=!0,T.exports}return h.m=H,h.c=e,h.d=function(D,T,_){h.o(D,T)||Object.defineProperty(D,T,{enumerable:!0,get:_})},h.r=function(D){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},h.t=function(D,T){if(1&T&&(D=h(D)),8&T||4&T&&typeof D=="object"&&D&&D.__esModule)return D;var _=Object.create(null);if(h.r(_),Object.defineProperty(_,"default",{enumerable:!0,value:D}),2&T&&typeof D!="string")for(var k in D)h.d(_,k,function(P){return D[P]}.bind(null,k));return _},h.n=function(D){var T=D&&D.__esModule?function(){return D.default}:function(){return D};return h.d(T,"a",T),T},h.o=function(D,T){return Object.prototype.hasOwnProperty.call(D,T)},h.p="",h(h.s=0)}([function(H,e,h){(function(D){var T;e=H.exports=Y,T=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var _=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],u=e.src=[],g=0,I=g++;u[I]="0|[1-9]\\d*";var d=g++;u[d]="[0-9]+";var v=g++;u[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=g++;u[m]="("+u[I]+")\\.("+u[I]+")\\.("+u[I]+")";var c=g++;u[c]="("+u[d]+")\\.("+u[d]+")\\.("+u[d]+")";var y=g++;u[y]="(?:"+u[I]+"|"+u[v]+")";var b=g++;u[b]="(?:"+u[d]+"|"+u[v]+")";var p=g++;u[p]="(?:-("+u[y]+"(?:\\."+u[y]+")*))";var w=g++;u[w]="(?:-?("+u[b]+"(?:\\."+u[b]+")*))";var l=g++;u[l]="[0-9A-Za-z-]+";var o=g++;u[o]="(?:\\+("+u[l]+"(?:\\."+u[l]+")*))";var i=g++,t="v?"+u[m]+u[p]+"?"+u[o]+"?";u[i]="^"+t+"$";var r="[v=\\s]*"+u[c]+u[w]+"?"+u[o]+"?",s=g++;u[s]="^"+r+"$";var a=g++;u[a]="((?:<|>)?=?)";var n=g++;u[n]=u[d]+"|x|X|\\*";var f=g++;u[f]=u[I]+"|x|X|\\*";var C=g++;u[C]="[v=\\s]*("+u[f]+")(?:\\.("+u[f]+")(?:\\.("+u[f]+")(?:"+u[p]+")?"+u[o]+"?)?)?";var A=g++;u[A]="[v=\\s]*("+u[n]+")(?:\\.("+u[n]+")(?:\\.("+u[n]+")(?:"+u[w]+")?"+u[o]+"?)?)?";var O=g++;u[O]="^"+u[a]+"\\s*"+u[C]+"$";var E=g++;u[E]="^"+u[a]+"\\s*"+u[A]+"$";var F=g++;u[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=g++;u[j]="(?:~>?)";var G=g++;u[G]="(\\s*)"+u[j]+"\\s+",P[G]=new RegExp(u[G],"g");var z=g++;u[z]="^"+u[j]+u[C]+"$";var W=g++;u[W]="^"+u[j]+u[A]+"$";var q=g++;u[q]="(?:\\^)";var ee=g++;u[ee]="(\\s*)"+u[q]+"\\s+",P[ee]=new RegExp(u[ee],"g");var te=g++;u[te]="^"+u[q]+u[C]+"$";var B=g++;u[B]="^"+u[q]+u[A]+"$";var M=g++;u[M]="^"+u[a]+"\\s*("+r+")$|^$";var L=g++;u[L]="^"+u[a]+"\\s*("+t+")$|^$";var S=g++;u[S]="(\\s*)"+u[a]+"\\s*("+r+"|"+u[C]+")",P[S]=new RegExp(u[S],"g");var R=g++;u[R]="^\\s*("+u[C]+")\\s+-\\s+("+u[C]+")\\s*$";var N=g++;u[N]="^\\s*("+u[A]+")\\s+-\\s+("+u[A]+")\\s*$";var U=g++;u[U]="(<|>)?=?\\s*\\*";for(var $=0;$<35;$++)T($,u[$]),P[$]||(P[$]=new RegExp(u[$]));function K(X,ie){if(X instanceof Y)return X;if(typeof X!="string"||X.length>_||!(ie?P[s]:P[i]).test(X))return null;try{return new Y(X,ie)}catch(ne){return null}}function Y(X,ie){if(X instanceof Y){if(X.loose===ie)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>_)throw new TypeError("version is longer than "+_+" characters");if(!(this instanceof Y))return new Y(X,ie);T("SemVer",X,ie),this.loose=ie;var ne=X.trim().match(ie?P[s]:P[i]);if(!ne)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+ne[1],this.minor=+ne[2],this.patch=+ne[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");ne[4]?this.prerelease=ne[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var V=+fe;if(V>=0&&V<k)return V}return fe}):this.prerelease=[],this.build=ne[5]?ne[5].split("."):[],this.format()}e.parse=K,e.valid=function(X,ie){var ne=K(X,ie);return ne?ne.version:null},e.clean=function(X,ie){var ne=K(X.trim().replace(/^[=v]+/,""),ie);return ne?ne.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(X){return T("SemVer.compare",this.version,this.loose,X),X instanceof Y||(X=new Y(X,this.loose)),this.compareMain(X)||this.comparePre(X)},Y.prototype.compareMain=function(X){return X instanceof Y||(X=new Y(X,this.loose)),se(this.major,X.major)||se(this.minor,X.minor)||se(this.patch,X.patch)},Y.prototype.comparePre=function(X){if(X instanceof Y||(X=new Y(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var ie=0;do{var ne=this.prerelease[ie],fe=X.prerelease[ie];if(T("prerelease compare",ie,ne,fe),ne===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(ne===void 0)return-1;if(ne!==fe)return se(ne,fe)}while(++ie)},Y.prototype.inc=function(X,ie){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ie);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ie);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ie),this.inc("pre",ie);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ie),this.inc("pre",ie);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ne=this.prerelease.length;--ne>=0;)typeof this.prerelease[ne]=="number"&&(this.prerelease[ne]++,ne=-2);ne===-1&&this.prerelease.push(0)}ie&&(this.prerelease[0]===ie?isNaN(this.prerelease[1])&&(this.prerelease=[ie,0]):this.prerelease=[ie,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,ie,ne,fe){typeof ne=="string"&&(fe=ne,ne=void 0);try{return new Y(X,ne).inc(ie,fe).version}catch(V){return null}},e.diff=function(X,ie){if(_e(X,ie))return null;var ne=K(X),fe=K(ie);if(ne.prerelease.length||fe.prerelease.length){for(var V in ne)if((V==="major"||V==="minor"||V==="patch")&&ne[V]!==fe[V])return"pre"+V;return"prerelease"}for(var V in ne)if((V==="major"||V==="minor"||V==="patch")&&ne[V]!==fe[V])return V},e.compareIdentifiers=se;var Q=/^[0-9]+$/;function se(X,ie){var ne=Q.test(X),fe=Q.test(ie);return ne&&fe&&(X=+X,ie=+ie),ne&&!fe?-1:fe&&!ne?1:X<ie?-1:X>ie?1:0}function oe(X,ie,ne){return new Y(X,ne).compare(new Y(ie,ne))}function ce(X,ie,ne){return oe(X,ie,ne)>0}function he(X,ie,ne){return oe(X,ie,ne)<0}function _e(X,ie,ne){return oe(X,ie,ne)===0}function Pe(X,ie,ne){return oe(X,ie,ne)!==0}function Re(X,ie,ne){return oe(X,ie,ne)>=0}function Ae(X,ie,ne){return oe(X,ie,ne)<=0}function Se(X,ie,ne,fe){var V;switch(ie){case"===":typeof X=="object"&&(X=X.version),typeof ne=="object"&&(ne=ne.version),V=X===ne;break;case"!==":typeof X=="object"&&(X=X.version),typeof ne=="object"&&(ne=ne.version),V=X!==ne;break;case"":case"=":case"==":V=_e(X,ne,fe);break;case"!=":V=Pe(X,ne,fe);break;case">":V=ce(X,ne,fe);break;case">=":V=Re(X,ne,fe);break;case"<":V=he(X,ne,fe);break;case"<=":V=Ae(X,ne,fe);break;default:throw new TypeError("Invalid operator: "+ie)}return V}function de(X,ie){if(X instanceof de){if(X.loose===ie)return X;X=X.value}if(!(this instanceof de))return new de(X,ie);T("comparator",X,ie),this.loose=ie,this.parse(X),this.semver===we?this.value="":this.value=this.operator+this.semver.version,T("comp",this)}e.rcompareIdentifiers=function(X,ie){return se(ie,X)},e.major=function(X,ie){return new Y(X,ie).major},e.minor=function(X,ie){return new Y(X,ie).minor},e.patch=function(X,ie){return new Y(X,ie).patch},e.compare=oe,e.compareLoose=function(X,ie){return oe(X,ie,!0)},e.rcompare=function(X,ie,ne){return oe(ie,X,ne)},e.sort=function(X,ie){return X.sort(function(ne,fe){return e.compare(ne,fe,ie)})},e.rsort=function(X,ie){return X.sort(function(ne,fe){return e.rcompare(ne,fe,ie)})},e.gt=ce,e.lt=he,e.eq=_e,e.neq=Pe,e.gte=Re,e.lte=Ae,e.cmp=Se,e.Comparator=de;var we={};function Ee(X,ie){if(X instanceof Ee)return X.loose===ie?X:new Ee(X.raw,ie);if(X instanceof de)return new Ee(X.value,ie);if(!(this instanceof Ee))return new Ee(X,ie);if(this.loose=ie,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(ne){return this.parseRange(ne.trim())},this).filter(function(ne){return ne.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Ie(X){return!X||X.toLowerCase()==="x"||X==="*"}function Ne(X,ie,ne,fe,V,x,re,ae,le,ue,me,pe,Ce){return((ie=Ie(ne)?"":Ie(fe)?">="+ne+".0.0":Ie(V)?">="+ne+"."+fe+".0":">="+ie)+" "+(ae=Ie(le)?"":Ie(ue)?"<"+(+le+1)+".0.0":Ie(me)?"<"+le+"."+(+ue+1)+".0":pe?"<="+le+"."+ue+"."+me+"-"+pe:"<="+ae)).trim()}function Me(X,ie){for(var ne=0;ne<X.length;ne++)if(!X[ne].test(ie))return!1;if(ie.prerelease.length){for(ne=0;ne<X.length;ne++)if(T(X[ne].semver),X[ne].semver!==we&&X[ne].semver.prerelease.length>0){var fe=X[ne].semver;if(fe.major===ie.major&&fe.minor===ie.minor&&fe.patch===ie.patch)return!0}return!1}return!0}function Ue(X,ie,ne){try{ie=new Ee(ie,ne)}catch(fe){return!1}return ie.test(X)}function ze(X,ie,ne,fe){var V,x,re,ae,le;switch(X=new Y(X,fe),ie=new Ee(ie,fe),ne){case">":V=ce,x=Ae,re=he,ae=">",le=">=";break;case"<":V=he,x=Re,re=ce,ae="<",le="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(X,ie,fe))return!1;for(var ue=0;ue<ie.set.length;++ue){var me=ie.set[ue],pe=null,Ce=null;if(me.forEach(function(Le){Le.semver===we&&(Le=new de(">=0.0.0")),pe=pe||Le,Ce=Ce||Le,V(Le.semver,pe.semver,fe)?pe=Le:re(Le.semver,Ce.semver,fe)&&(Ce=Le)}),pe.operator===ae||pe.operator===le||(!Ce.operator||Ce.operator===ae)&&x(X,Ce.semver)||Ce.operator===le&&re(X,Ce.semver))return!1}return!0}de.prototype.parse=function(X){var ie=this.loose?P[M]:P[L],ne=X.match(ie);if(!ne)throw new TypeError("Invalid comparator: "+X);this.operator=ne[1],this.operator==="="&&(this.operator=""),ne[2]?this.semver=new Y(ne[2],this.loose):this.semver=we},de.prototype.toString=function(){return this.value},de.prototype.test=function(X){return T("Comparator.test",X,this.loose),this.semver===we||(typeof X=="string"&&(X=new Y(X,this.loose)),Se(X,this.operator,this.semver,this.loose))},de.prototype.intersects=function(X,ie){if(!(X instanceof de))throw new TypeError("a Comparator is required");var ne;if(this.operator==="")return ne=new Ee(X.value,ie),Ue(this.value,ne,ie);if(X.operator==="")return ne=new Ee(this.value,ie),Ue(X.semver,ne,ie);var fe=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),V=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),x=this.semver.version===X.semver.version,re=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),ae=Se(this.semver,"<",X.semver,ie)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),le=Se(this.semver,">",X.semver,ie)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return fe||V||x&&re||ae||le},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(X){var ie=this.loose;X=X.trim(),T("range",X,ie);var ne=ie?P[N]:P[R];X=X.replace(ne,Ne),T("hyphen replace",X),X=X.replace(P[S],"$1$2$3"),T("comparator trim",X,P[S]),X=(X=(X=X.replace(P[G],"$1~")).replace(P[ee],"$1^")).split(/\s+/).join(" ");var fe=ie?P[M]:P[L],V=X.split(" ").map(function(x){return function(re,ae){return T("comp",re),re=function(le,ue){return le.trim().split(/\s+/).map(function(me){return function(pe,Ce){T("caret",pe,Ce);var Le=Ce?P[B]:P[te];return pe.replace(Le,function(Oe,ye,be,Te,De){var Fe;return T("caret",pe,Oe,ye,be,Te,De),Ie(ye)?Fe="":Ie(be)?Fe=">="+ye+".0.0 <"+(+ye+1)+".0.0":Ie(Te)?Fe=ye==="0"?">="+ye+"."+be+".0 <"+ye+"."+(+be+1)+".0":">="+ye+"."+be+".0 <"+(+ye+1)+".0.0":De?(T("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),Fe=ye==="0"?be==="0"?">="+ye+"."+be+"."+Te+De+" <"+ye+"."+be+"."+(+Te+1):">="+ye+"."+be+"."+Te+De+" <"+ye+"."+(+be+1)+".0":">="+ye+"."+be+"."+Te+De+" <"+(+ye+1)+".0.0"):(T("no pr"),Fe=ye==="0"?be==="0"?">="+ye+"."+be+"."+Te+" <"+ye+"."+be+"."+(+Te+1):">="+ye+"."+be+"."+Te+" <"+ye+"."+(+be+1)+".0":">="+ye+"."+be+"."+Te+" <"+(+ye+1)+".0.0"),T("caret return",Fe),Fe})}(me,ue)}).join(" ")}(re,ae),T("caret",re),re=function(le,ue){return le.trim().split(/\s+/).map(function(me){return function(pe,Ce){var Le=Ce?P[W]:P[z];return pe.replace(Le,function(Oe,ye,be,Te,De){var Fe;return T("tilde",pe,Oe,ye,be,Te,De),Ie(ye)?Fe="":Ie(be)?Fe=">="+ye+".0.0 <"+(+ye+1)+".0.0":Ie(Te)?Fe=">="+ye+"."+be+".0 <"+ye+"."+(+be+1)+".0":De?(T("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),Fe=">="+ye+"."+be+"."+Te+De+" <"+ye+"."+(+be+1)+".0"):Fe=">="+ye+"."+be+"."+Te+" <"+ye+"."+(+be+1)+".0",T("tilde return",Fe),Fe})}(me,ue)}).join(" ")}(re,ae),T("tildes",re),re=function(le,ue){return T("replaceXRanges",le,ue),le.split(/\s+/).map(function(me){return function(pe,Ce){pe=pe.trim();var Le=Ce?P[E]:P[O];return pe.replace(Le,function(Oe,ye,be,Te,De,Fe){T("xRange",pe,Oe,ye,be,Te,De,Fe);var He=Ie(be),Be=He||Ie(Te),We=Be||Ie(De);return ye==="="&&We&&(ye=""),He?Oe=ye===">"||ye==="<"?"<0.0.0":"*":ye&&We?(Be&&(Te=0),We&&(De=0),ye===">"?(ye=">=",Be?(be=+be+1,Te=0,De=0):We&&(Te=+Te+1,De=0)):ye==="<="&&(ye="<",Be?be=+be+1:Te=+Te+1),Oe=ye+be+"."+Te+"."+De):Be?Oe=">="+be+".0.0 <"+(+be+1)+".0.0":We&&(Oe=">="+be+"."+Te+".0 <"+be+"."+(+Te+1)+".0"),T("xRange return",Oe),Oe})}(me,ue)}).join(" ")}(re,ae),T("xrange",re),re=function(le,ue){return T("replaceStars",le,ue),le.trim().replace(P[U],"")}(re,ae),T("stars",re),re}(x,ie)}).join(" ").split(/\s+/);return this.loose&&(V=V.filter(function(x){return!!x.match(fe)})),V=V.map(function(x){return new de(x,ie)})},Ee.prototype.intersects=function(X,ie){if(!(X instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ne){return ne.every(function(fe){return X.set.some(function(V){return V.every(function(x){return fe.intersects(x,ie)})})})})},e.toComparators=function(X,ie){return new Ee(X,ie).set.map(function(ne){return ne.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new Y(X,this.loose));for(var ie=0;ie<this.set.length;ie++)if(Me(this.set[ie],X))return!0;return!1},e.satisfies=Ue,e.maxSatisfying=function(X,ie,ne){var fe=null,V=null;try{var x=new Ee(ie,ne)}catch(re){return null}return X.forEach(function(re){x.test(re)&&(fe&&V.compare(re)!==-1||(V=new Y(fe=re,ne)))}),fe},e.minSatisfying=function(X,ie,ne){var fe=null,V=null;try{var x=new Ee(ie,ne)}catch(re){return null}return X.forEach(function(re){x.test(re)&&(fe&&V.compare(re)!==1||(V=new Y(fe=re,ne)))}),fe},e.validRange=function(X,ie){try{return new Ee(X,ie).range||"*"}catch(ne){return null}},e.ltr=function(X,ie,ne){return ze(X,ie,"<",ne)},e.gtr=function(X,ie,ne){return ze(X,ie,">",ne)},e.outside=ze,e.prerelease=function(X,ie){var ne=K(X,ie);return ne&&ne.prerelease.length?ne.prerelease:null},e.intersects=function(X,ie,ne){return X=new Ee(X,ne),ie=new Ee(ie,ne),X.intersects(ie)},e.coerce=function(X){if(X instanceof Y)return X;if(typeof X!="string")return null;var ie=X.match(P[F]);return ie==null?null:K((ie[1]||"0")+"."+(ie[2]||"0")+"."+(ie[3]||"0"))}}).call(this,h(1))},function(H,e){var h,D,T=H.exports={};function _(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function P(b){if(h===setTimeout)return setTimeout(b,0);if((h===_||!h)&&setTimeout)return h=setTimeout,setTimeout(b,0);try{return h(b,0)}catch(p){try{return h.call(null,b,0)}catch(w){return h.call(this,b,0)}}}(function(){try{h=typeof setTimeout=="function"?setTimeout:_}catch(b){h=_}try{D=typeof clearTimeout=="function"?clearTimeout:k}catch(b){D=k}})();var u,g=[],I=!1,d=-1;function v(){I&&u&&(I=!1,u.length?g=u.concat(g):d=-1,g.length&&m())}function m(){if(!I){var b=P(v);I=!0;for(var p=g.length;p;){for(u=g,g=[];++d<p;)u&&u[d].run();d=-1,p=g.length}u=null,I=!1,function(w){if(D===clearTimeout)return clearTimeout(w);if((D===k||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(w);try{D(w)}catch(l){try{return D.call(null,w)}catch(o){return D.call(this,w)}}}(b)}}function c(b,p){this.fun=b,this.array=p}function y(){}T.nextTick=function(b){var p=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)p[w-1]=arguments[w];g.push(new c(b,p)),g.length!==1||I||P(m)},c.prototype.run=function(){this.fun.apply(null,this.array)},T.title="browser",T.browser=!0,T.env={},T.argv=[],T.version="",T.versions={},T.on=y,T.addListener=y,T.once=y,T.off=y,T.removeListener=y,T.removeAllListeners=y,T.emit=y,T.prependListener=y,T.prependOnceListener=y,T.listeners=function(b){return[]},T.binding=function(b){throw new Error("process.binding is not supported")},T.cwd=function(){return"/"},T.chdir=function(b){throw new Error("process.chdir is not supported")},T.umask=function(){return 0}}])}),define(J[91],Z([0,1,4]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const D=h.globals.performance&&typeof h.globals.performance.now=="function";class T{constructor(k){this._highResolution=D&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new T(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?h.globals.performance.now():Date.now()}}e.StopWatch=T}),define(J[5],Z([0,1,14,58,2,61,91]),function(H,e,h,D,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(p){p.None=()=>T.Disposable.None;function w(W){return(q,ee=null,te)=>{let B=!1,M;return M=W(L=>{if(!B)return M?M.dispose():B=!0,q.call(ee,L)},null,te),B&&M.dispose(),M}}p.once=w;function l(W,q){return a((ee,te=null,B)=>W(M=>ee.call(te,q(M)),null,B))}p.map=l;function o(W,q){return a((ee,te=null,B)=>W(M=>{q(M),ee.call(te,M)},null,B))}p.forEach=o;function i(W,q){return a((ee,te=null,B)=>W(M=>q(M)&&ee.call(te,M),null,B))}p.filter=i;function t(W){return W}p.signal=t;function r(...W){return(q,ee=null,te)=>T.combinedDisposable(...W.map(B=>B(M=>q.call(ee,M),null,te)))}p.any=r;function s(W,q,ee){let te=ee;return l(W,B=>(te=q(te,B),te))}p.reduce=s;function a(W){let q;const ee=new v({onFirstListenerAdd(){q=W(ee.fire,ee)},onLastListenerRemove(){q.dispose()}});return ee.event}p.snapshot=a;function n(W,q,ee=100,te=!1,B){let M,L,S,R=0;const N=new v({leakWarningThreshold:B,onFirstListenerAdd(){M=W(U=>{R++,L=q(L,U),te&&!S&&(N.fire(L),L=void 0),clearTimeout(S),S=setTimeout(()=>{const $=L;L=void 0,S=void 0,(!te||R>1)&&N.fire($),R=0},ee)})},onLastListenerRemove(){M.dispose()}});return N.event}p.debounce=n;function f(W){const q=new Date().getTime();return l(w(W),ee=>new Date().getTime()-q)}p.stopwatch=f;function C(W){let q=!0,ee;return i(W,te=>{const B=q||te!==ee;return q=!1,ee=te,B})}p.latch=C;function A(W,q=!1,ee=[]){let te=ee.slice(),B=W(S=>{te?te.push(S):L.fire(S)});const M=()=>{te&&te.forEach(S=>L.fire(S)),te=null},L=new v({onFirstListenerAdd(){B||(B=W(S=>L.fire(S)))},onFirstListenerDidAdd(){te&&(q?setTimeout(M):M())},onLastListenerRemove(){B&&B.dispose(),B=null}});return L.event}p.buffer=A;class O{constructor(q){this.event=q}map(q){return new O(l(this.event,q))}forEach(q){return new O(o(this.event,q))}filter(q){return new O(i(this.event,q))}reduce(q,ee){return new O(s(this.event,q,ee))}latch(){return new O(C(this.event))}debounce(q,ee=100,te=!1,B){return new O(n(this.event,q,ee,te,B))}on(q,ee,te){return this.event(q,ee,te)}once(q,ee,te){return w(this.event)(q,ee,te)}}function E(W){return new O(W)}p.chain=E;function F(W,q,ee=te=>te){const te=(...S)=>L.fire(ee(...S)),B=()=>W.on(q,te),M=()=>W.removeListener(q,te),L=new v({onFirstListenerAdd:B,onLastListenerRemove:M});return L.event}p.fromNodeEventEmitter=F;function j(W,q,ee=te=>te){const te=(...S)=>L.fire(ee(...S)),B=()=>W.addEventListener(q,te),M=()=>W.removeEventListener(q,te),L=new v({onFirstListenerAdd:B,onLastListenerRemove:M});return L.event}p.fromDOMEventEmitter=j;function G(W){const q=new v;let ee=!1;return W.then(void 0,()=>null).then(()=>{ee?q.fire(void 0):setTimeout(()=>q.fire(void 0),0)}),ee=!0,q.event}p.fromPromise=G;function z(W){return new Promise(q=>w(W)(q))}p.toPromise=z})(P=e.Event||(e.Event={}));class u{constructor(w){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${w}_${u._idPool++}`}start(w){this._stopWatch=new k.StopWatch(!0),this._listenerCount=w}stop(){if(this._stopWatch){const w=this._stopWatch.elapsed();this._elapsedOverall+=w,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${w.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}u._idPool=0;let g=-1;function I(p){const w=g;return g=p,{dispose(){g=w}}}e.setGlobalLeakWarningThreshold=I;class d{constructor(w,l=Math.random().toString(18).slice(2,5)){this.customThreshold=w,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(w){let l=g;if(typeof this.customThreshold=="number"&&(l=this.customThreshold),!(l<=0||w<l)){this._stacks||(this._stacks=new Map);const o=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(o)||0;if(this._stacks.set(o,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=l*.5;let t,r=0;for(const[s,a]of this._stacks)(!t||r<a)&&(t=s,r=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${w} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(o)||0;this._stacks.set(o,t-1)}}}}class v{constructor(w){var l;this._disposed=!1,this._options=w,this._leakageMon=g>0?new d(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((l=this._options)===null||l===void 0?void 0:l._profName)?new u(this._options._profName):void 0}get event(){return this._event||(this._event=(w,l,o)=>{var i;this._listeners||(this._listeners=new _.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(l?[w,l]:w);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,w,l);const s=(i=this._leakageMon)===null||i===void 0?void 0:i.check(this._listeners.size);let a;return a={dispose:()=>{s&&s(),a.dispose=v._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},o instanceof T.DisposableStore?o.add(a):Array.isArray(o)&&o.push(a),a}),this._event}fire(w){var l,o;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new _.LinkedList);for(let i of this._listeners)this._deliveryQueue.push([i,w]);for((l=this._perfMon)===null||l===void 0||l.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[i,t]=this._deliveryQueue.shift();try{typeof i=="function"?i.call(void 0,t):i[0].call(i[1],t)}catch(r){h.onUnexpectedError(r)}}(o=this._perfMon)===null||o===void 0||o.stop()}}dispose(){var w,l,o;(w=this._listeners)===null||w===void 0||w.clear(),(l=this._deliveryQueue)===null||l===void 0||l.clear(),(o=this._leakageMon)===null||o===void 0||o.dispose(),this._disposed=!0}}e.Emitter=v,v._noop=function(){};class m extends v{constructor(w){super(w);this._isPaused=0,this._eventQueue=new _.LinkedList,this._mergeFn=w==null?void 0:w.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const w=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(w))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(w){this._listeners&&(this._isPaused!==0?this._eventQueue.push(w):super.fire(w))}}e.PauseableEmitter=m;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(w){const l={event:w,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const o=()=>{this.hasListeners&&this.unhook(l);const i=this.events.indexOf(l);this.events.splice(i,1)};return T.toDisposable(D.once(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(w=>this.hook(w))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(w=>this.unhook(w))}hook(w){w.listener=w.event(l=>this.emitter.fire(l))}unhook(w){w.listener&&w.listener.dispose(),w.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=c;class y{constructor(){this.buffers=[]}wrapEvent(w){return(l,o,i)=>w(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>l.call(o,t)):l.call(o,t)},void 0,i)}bufferEvents(w){const l=[];this.buffers.push(l);const o=w();return this.buffers.pop(),l.forEach(i=>i()),o}}e.EventBufferer=y;class b{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=T.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(w){this.inputEvent=w,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=w(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=b}),define(J[25],Z([0,1,5]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const D=Object.freeze(function(P,u){const g=setTimeout(P.bind(u),0);return{dispose(){clearTimeout(g)}}});var T;(function(P){function u(g){return g===P.None||g===P.Cancelled||g instanceof _?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}P.isCancellationToken=u,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:h.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(T=e.CancellationToken||(e.CancellationToken={}));class _{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new h.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new _),this._token}cancel(){this._token?this._token instanceof _&&this._token.cancel():this._token=T.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof _&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=k}),define(J[12],Z([0,1,25,14,5,2,61]),function(H,e,h,D,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(B){return!!B&&typeof B.then=="function"}e.isThenable=P;function u(B){const M=new h.CancellationTokenSource,L=B(M.token),S=new Promise((R,N)=>{M.token.onCancellationRequested(()=>{N(D.canceled())}),Promise.resolve(L).then(U=>{M.dispose(),R(U)},U=>{M.dispose(),N(U)})});return new class{cancel(){M.cancel()}then(R,N){return S.then(R,N)}catch(R){return this.then(void 0,R)}finally(R){return S.finally(R)}}}e.createCancelablePromise=u;function g(B,M,L){return Promise.race([B,new Promise(S=>M.onCancellationRequested(()=>S(L)))])}e.raceCancellation=g;async function I(B){let M=-1;const L=B.map((R,N)=>R.then(U=>(M=N,U))),S=await Promise.race(L);return B.forEach((R,N)=>{N!==M&&R.cancel()}),S}e.raceCancellablePromises=I;function d(B,M,L){let S;const R=setTimeout(()=>{S==null||S(void 0),L==null||L()},M);return Promise.race([B.finally(()=>clearTimeout(R)),new Promise(N=>S=N)])}e.raceTimeout=d;function v(B){return new Promise((M,L)=>{const S=B();P(S)?S.then(M,L):M(S)})}e.asPromise=v;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const L=()=>{this.queuedPromise=null;const S=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,S};this.queuedPromise=new Promise(S=>{this.activePromise.then(L,L).then(S)})}return new Promise((L,S)=>{this.queuedPromise.then(L,S)})}return this.activePromise=M(),new Promise((L,S)=>{this.activePromise.then(R=>{this.activePromise=null,L(R)},R=>{this.activePromise=null,S(R)})})}}e.Throttler=m;class c{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=c;class y{constructor(){this.promiseMap=new Map}queue(M,L){var S;const N=((S=this.promiseMap.get(M))!==null&&S!==void 0?S:Promise.resolve()).catch(()=>{}).then(L).finally(()=>{this.promiseMap.get(M)===N&&this.promiseMap.delete(M)});return this.promiseMap.set(M,N),N}}e.SequencerByKey=y;class b{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,L=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((S,R)=>{this.doResolve=S,this.doReject=R}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const S=this.task;return this.task=null,S()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},L),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(D.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=b;class p{constructor(M){this.delayer=new b(M),this.throttler=new m}trigger(M,L){return this.delayer.trigger(()=>this.throttler.queue(M),L)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=p;class w{constructor(){this._isOpen=!1,this._promise=new Promise((M,L)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=w;class l extends w{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function o(B,M){return M?new Promise((L,S)=>{const R=setTimeout(L,B);M.onCancellationRequested(()=>{clearTimeout(R),S(D.canceled())})}):u(L=>o(B,L))}e.timeout=o;function i(B,M=0){const L=setTimeout(B,M);return _.toDisposable(()=>clearTimeout(L))}e.disposableTimeout=i;function t(B){return B.then(void 0,M=>{})}e.ignoreErrors=t;function r(B){const M=[];let L=0;const S=B.length;function R(){return L<S?B[L++]():null}function N(U){U!=null&&M.push(U);const $=R();return $?$.then(N):Promise.resolve(M)}return Promise.resolve(null).then(N)}e.sequence=r;function s(B,M=S=>!!S,L=null){let S=0;const R=B.length,N=()=>{if(S>=R)return Promise.resolve(L);const U=B[S++];return Promise.resolve(U()).then(K=>M(K)?Promise.resolve(K):N())};return N()}e.first=s;function a(B,M=S=>!!S,L=null){if(B.length===0)return Promise.resolve(L);let S=B.length;const R=()=>{var N,U;S=-1;for(const $ of B)(U=(N=$).cancel)===null||U===void 0||U.call(N)};return new Promise((N,U)=>{for(const $ of B)$.then(K=>{--S>=0&&M(K)?(R(),N(K)):S===0&&N(L)}).catch(K=>{--S>=0&&(R(),U(K))})})}e.firstParallel=a;class n{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new T.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((L,S)=>{this.outstandingPromises.push({factory:M,c:L,e:S}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const L=M.factory();L.then(M.c,M.e),L.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=n;class f extends n{constructor(){super(1)}}e.Queue=f;class C{constructor(){this.queues=new Map}queueFor(M){const L=M.toString();if(!this.queues.has(L)){const S=new f;S.onFinished(()=>{S.dispose(),this.queues.delete(L)}),this.queues.set(L,S)}return this.queues.get(L)}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=C;class A{constructor(M,L){this._token=-1,typeof M=="function"&&typeof L=="number"&&this.setIfNotSet(M,L)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,L){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},L)}setIfNotSet(M,L){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},L))}}e.TimeoutTimer=A;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,L){this.cancel(),this._token=setInterval(()=>{M()},L)}}e.IntervalTimer=O;class E{constructor(M,L){this.timeoutToken=-1,this.runner=M,this.timeout=L,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=E;class F extends E{constructor(M,L){super(M,L);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const B=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const L=setTimeout(()=>M(B));let S=!1;return{dispose(){S||(S=!0,clearTimeout(L))}}}}else e.runWhenIdle=(B,M)=>{const L=requestIdleCallback(B,typeof M=="number"?{timeout:M}:void 0);let S=!1;return{dispose(){S||(S=!0,cancelIdleCallback(L))}}}}();class j{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(L){this._error=L}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=j;async function G(B,M,L){let S;for(let R=0;R<L;R++)try{return await B()}catch(N){S=N,await o(M)}throw S}e.retry=G;class z{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var M;(M=this._pending)===null||M===void 0||M.cancel()}setPending(M,L,S){return this._pending={taskId:M,cancel:()=>S==null?void 0:S(),promise:L},L.then(()=>this.donePending(M),()=>this.donePending(M)),L}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let L,S;const R=new Promise((N,U)=>{L=N,S=U});this._next={run:M,promise:R,promiseResolve:L,promiseReject:S}}return this._next.promise}}e.TaskSequentializer=z;class W{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=W;class q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,L)=>{this.completeCallback=M,this.errorCallback=L})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(L=>{this.completeCallback(M),this.resolved=!0,L()})}error(M){return new Promise(L=>{this.errorCallback(M),this.rejected=!0,L()})}cancel(){new Promise(M=>{this.errorCallback(D.canceled()),this.rejected=!0,M()})}}e.DeferredPromise=q;class ee extends T.Emitter{async fireAsync(M,L,S){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const R of this._listeners)this._asyncDeliveryQueue.push([R,M]);for(;this._asyncDeliveryQueue.size>0&&!L.isCancellationRequested;){const[R,N]=this._asyncDeliveryQueue.shift(),U=[],$=Object.assign(Object.assign({},N),{waitUntil:K=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");S&&(K=S(K,typeof R=="function"?R:R[0])),U.push(K)}});try{typeof R=="function"?R.call(void 0,$):R[0].call(R[1],$)}catch(K){D.onUnexpectedError(K);continue}Object.freeze(U),await te.settled(U).catch(K=>D.onUnexpectedError(K))}}}}e.AsyncEmitter=ee;var te;(function(B){async function M(N){return typeof Promise.allSettled=="function"?L(N):S(N)}B.allSettled=M;async function L(N){return Promise.allSettled(N)}async function S(N){return Promise.all(N.map(U=>U.then($=>({status:"fulfilled",value:$}),$=>({status:"rejected",reason:$}))))}async function R(N){let U;const $=await Promise.all(N.map(K=>K.then(Y=>Y,Y=>{U||(U=Y)})));if(typeof U!="undefined")throw U;return $}B.settled=R})(te=e.Promises||(e.Promises={}))}),define(J[42],Z([0,1,14,2]),function(H,e,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function T(b){const p=b;return p&&[p.on,p.pause,p.resume,p.destroy].every(w=>typeof w=="function")}e.isReadableStream=T;function _(b){const p=b;return p&&T(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean"}e.isReadableBufferedStream=_;function k(b,p){return new P(b,p)}e.newWriteableStream=k;class P{constructor(p,w){this.reducer=p,this.options=w,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){var w;if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof((w=this.options)===null||w===void 0?void 0:w.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(p instanceof Error?this.error(p):typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(w=>w(p))}emitError(p){this.listeners.error.length===0?h.onUnexpectedError(p):this.listeners.error.slice(0).forEach(w=>w(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,w){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(w),this.resume();break;case"end":this.listeners.end.push(w),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(w),this.state.flowing&&this.flowErrors();break}}removeListener(p,w){if(!this.state.destroyed){let l;switch(p){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const o=l.indexOf(w);o>=0&&l.splice(o,1)}}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const w=[...this.pendingWritePromises];this.pendingWritePromises.length=0,w.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function u(b,p){const w=[];let l;for(;(l=b.read())!==null;)w.push(l);return p(w)}e.consumeReadable=u;function g(b,p,w){const l=[];let o;for(;(o=b.read())!==null&&l.length<w;)l.push(o);return o===null&&l.length>0?p(l):{read:()=>{if(l.length>0)return l.shift();if(typeof o!="undefined"){const i=o;return o=void 0,i}return b.read()}}}e.peekReadable=g;function I(b,p){return new Promise((w,l)=>{const o=[];d(b,{onData:i=>{p&&o.push(i)},onError:i=>{p?l(i):w(void 0)},onEnd:()=>{w(p?p(o):void 0)}})})}e.consumeStream=I;function d(b,p){b.on("error",w=>p.onError(w)),b.on("end",()=>p.onEnd()),b.on("data",w=>p.onData(w))}e.listenStream=d;function v(b,p){return new Promise((w,l)=>{const o=new D.DisposableStore,i=[],t=a=>{if(i.push(a),i.length>p)return o.dispose(),b.pause(),w({stream:b,buffer:i,ended:!1})},r=a=>l(a),s=()=>w({stream:b,buffer:i,ended:!0});o.add(D.toDisposable(()=>b.removeListener("error",r))),b.on("error",r),o.add(D.toDisposable(()=>b.removeListener("end",s))),b.on("end",s),o.add(D.toDisposable(()=>b.removeListener("data",t))),b.on("data",t)})}e.peekStream=v;function m(b,p){const w=k(p);return w.end(b),w}e.toStream=m;function c(b){let p=!1;return{read:()=>p?null:(p=!0,b)}}e.toReadable=c;function y(b,p,w){const l=k(w);return d(b,{onData:o=>l.write(p.data(o)),onError:o=>l.error(p.error?p.error(o):o),onEnd:()=>l.end()}),l}e.transform=y}),define(J[18],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function h(V){return!V||typeof V!="string"?!0:V.trim().length===0}e.isFalsyOrWhitespace=h;const D=/{(\d+)}/g;function T(V,...x){return x.length===0?V:V.replace(D,function(re,ae){const le=parseInt(ae,10);return isNaN(le)||le<0||le>=x.length?re:x[le]})}e.format=T;function _(V){return V.replace(/[<>&]/g,function(x){switch(x){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return x}})}e.escape=_;function k(V){return V.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function P(V,x){let re=0;const ae=x.charCodeAt(0);for(let le=V.length-1;le>=0;le--)V.charCodeAt(le)===ae&&re++;return re}e.count=P;function u(V,x,re="\u2026"){return V.length<=x?V:`${V.substr(0,x)}${re}`}e.truncate=u;function g(V,x=" "){const re=I(V,x);return d(re,x)}e.trim=g;function I(V,x){if(!V||!x)return V;const re=x.length;if(re===0||V.length===0)return V;let ae=0;for(;V.indexOf(x,ae)===ae;)ae=ae+re;return V.substring(ae)}e.ltrim=I;function d(V,x){if(!V||!x)return V;const re=x.length,ae=V.length;if(re===0||ae===0)return V;let le=ae,ue=-1;for(;ue=V.lastIndexOf(x,le-1),!(ue===-1||ue+re!==le);){if(ue===0)return"";le=ue}return V.substring(0,le)}e.rtrim=d;function v(V){return V.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function m(V){return V.replace(/\*/g,"")}e.stripWildcards=m;function c(V,x,re={}){if(!V)throw new Error("Cannot create regex from empty string");x||(V=k(V)),re.wholeWord&&(/\B/.test(V.charAt(0))||(V="\\b"+V),/\B/.test(V.charAt(V.length-1))||(V=V+"\\b"));let ae="";return re.global&&(ae+="g"),re.matchCase||(ae+="i"),re.multiline&&(ae+="m"),re.unicode&&(ae+="u"),new RegExp(V,ae)}e.createRegExp=c;function y(V){return V.source==="^"||V.source==="^$"||V.source==="$"||V.source==="^\\s*$"?!1:!!(V.exec("")&&V.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function b(V){return!!V.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function p(V){return(V.global?"g":"")+(V.ignoreCase?"i":"")+(V.multiline?"m":"")+(V.unicode?"u":"")}e.regExpFlags=p;function w(V){return V.split(/\r\n|\r|\n/)}e.splitLines=w;function l(V){for(let x=0,re=V.length;x<re;x++){const ae=V.charCodeAt(x);if(ae!==32&&ae!==9)return x}return-1}e.firstNonWhitespaceIndex=l;function o(V,x=0,re=V.length){for(let ae=x;ae<re;ae++){const le=V.charCodeAt(ae);if(le!==32&&le!==9)return V.substring(x,ae)}return V.substring(x,re)}e.getLeadingWhitespace=o;function i(V,x=V.length-1){for(let re=x;re>=0;re--){const ae=V.charCodeAt(re);if(ae!==32&&ae!==9)return re}return-1}e.lastNonWhitespaceIndex=i;function t(V,x){return V<x?-1:V>x?1:0}e.compare=t;function r(V,x,re=0,ae=V.length,le=0,ue=x.length){for(;re<ae&&le<ue;re++,le++){let Ce=V.charCodeAt(re),Le=x.charCodeAt(le);if(Ce<Le)return-1;if(Ce>Le)return 1}const me=ae-re,pe=ue-le;return me<pe?-1:me>pe?1:0}e.compareSubstring=r;function s(V,x){return a(V,x,0,V.length,0,x.length)}e.compareIgnoreCase=s;function a(V,x,re=0,ae=V.length,le=0,ue=x.length){for(;re<ae&&le<ue;re++,le++){let Ce=V.charCodeAt(re),Le=x.charCodeAt(le);if(Ce!==Le){const Oe=Ce-Le;if(!(Oe===32&&f(Le))&&!(Oe===-32&&f(Ce)))return n(Ce)&&n(Le)?Oe:r(V.toLowerCase(),x.toLowerCase(),re,ae,le,ue)}}const me=ae-re,pe=ue-le;return me<pe?-1:me>pe?1:0}e.compareSubstringIgnoreCase=a;function n(V){return V>=97&&V<=122}e.isLowerAsciiLetter=n;function f(V){return V>=65&&V<=90}e.isUpperAsciiLetter=f;function C(V){return n(V)||f(V)}function A(V,x){return V.length===x.length&&O(V,x)}e.equalsIgnoreCase=A;function O(V,x,re=V.length){for(let ae=0;ae<re;ae++){const le=V.charCodeAt(ae),ue=x.charCodeAt(ae);if(le!==ue){if(C(le)&&C(ue)){const me=Math.abs(le-ue);if(me!==0&&me!==32)return!1}else if(String.fromCharCode(le).toLowerCase()!==String.fromCharCode(ue).toLowerCase())return!1}}return!0}function E(V,x){const re=x.length;return x.length>V.length?!1:O(V,x,re)}e.startsWithIgnoreCase=E;function F(V,x){let re,ae=Math.min(V.length,x.length);for(re=0;re<ae;re++)if(V.charCodeAt(re)!==x.charCodeAt(re))return re;return ae}e.commonPrefixLength=F;function j(V,x){let re,ae=Math.min(V.length,x.length);const le=V.length-1,ue=x.length-1;for(re=0;re<ae;re++)if(V.charCodeAt(le-re)!==x.charCodeAt(ue-re))return re;return ae}e.commonSuffixLength=j;function G(V){return 55296<=V&&V<=56319}e.isHighSurrogate=G;function z(V){return 56320<=V&&V<=57343}e.isLowSurrogate=z;function W(V,x){return(V-55296<<10)+(x-56320)+65536}e.computeCodePoint=W;function q(V,x,re){const ae=V.charCodeAt(re);if(G(ae)&&re+1<x){const le=V.charCodeAt(re+1);if(z(le))return W(ae,le)}return ae}e.getNextCodePoint=q;function ee(V,x){const re=V.charCodeAt(x-1);if(z(re)&&x>1){const ae=V.charCodeAt(x-2);if(G(ae))return W(ae,re)}return re}function te(V,x){const re=ne.getInstance(),ae=x,le=V.length,ue=q(V,le,x);x+=ue>=65536?2:1;let me=re.getGraphemeBreakType(ue);for(;x<le;){const pe=q(V,le,x),Ce=re.getGraphemeBreakType(pe);if(X(me,Ce))break;x+=pe>=65536?2:1,me=Ce}return x-ae}e.nextCharLength=te;function B(V,x){const re=ne.getInstance(),ae=x,le=ee(V,x);x-=le>=65536?2:1;let ue=re.getGraphemeBreakType(le);for(;x>0;){const me=ee(V,x),pe=re.getGraphemeBreakType(me);if(X(pe,ue))break;x-=me>=65536?2:1,ue=pe}return ae-x}e.prevCharLength=B;function M(V,x){const re=ne.getInstance(),ae=V.length,le=x,ue=q(V,ae,x),me=re.getGraphemeBreakType(ue);x+=ue>=65536?2:1;let pe=me;for(;x<ae;){const Le=q(V,ae,x),Oe=re.getGraphemeBreakType(Le);if(X(pe,Oe))break;x+=Le>=65536?2:1,pe=Oe}const Ce=x;for(x=le,pe=me;x>0;){const Le=ee(V,x),Oe=re.getGraphemeBreakType(Le);if(X(Oe,pe))break;x-=Le>=65536?2:1,pe=Oe}return[x,Ce]}function L(V,x){return x>0&&z(V.charCodeAt(x))?M(V,x-1):M(V,x)}e.getCharContainingOffset=L;function S(V){const x=V.length;let re=0,ae=0;for(;ae<x;){const me=q(V,x,ae);ae+=me>=65536?2:1,me<128?re+=1:me<2048?re+=2:me<65536?re+=3:re+=4}const le=new Uint8Array(re);ae=0;let ue=0;for(;ae<x;){const me=q(V,x,ae);ae+=me>=65536?2:1,me<128?le[ue++]=me:me<2048?(le[ue++]=192|(me&1984)>>>6,le[ue++]=128|(me&63)>>>0):me<65536?(le[ue++]=224|(me&61440)>>>12,le[ue++]=128|(me&4032)>>>6,le[ue++]=128|(me&63)>>>0):(le[ue++]=240|(me&1835008)>>>18,le[ue++]=128|(me&258048)>>>12,le[ue++]=128|(me&4032)>>>6,le[ue++]=128|(me&63)>>>0)}return le}e.encodeUTF8=S;function R(V){const x=V.byteLength,re=[];let ae=0;for(;ae<x;){const le=V[ae];let ue;if(le>=240&&ae+3<x?ue=(V[ae++]&7)<<18>>>0|(V[ae++]&63)<<12>>>0|(V[ae++]&63)<<6>>>0|(V[ae++]&63)<<0>>>0:le>=224&&ae+2<x?ue=(V[ae++]&15)<<12>>>0|(V[ae++]&63)<<6>>>0|(V[ae++]&63)<<0>>>0:le>=192&&ae+1<x?ue=(V[ae++]&31)<<6>>>0|(V[ae++]&63)<<0>>>0:ue=V[ae++],ue>=0&&ue<=55295||ue>=57344&&ue<=65535)re.push(String.fromCharCode(ue));else if(ue>=65536&&ue<=1114111){const me=ue-65536,pe=55296+((me&1047552)>>>10),Ce=56320+((me&1023)>>>0);re.push(String.fromCharCode(pe)),re.push(String.fromCharCode(Ce))}else re.push(String.fromCharCode(65533))}return re.join("")}e.decodeUTF8=R;const N=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function U(V){return N.test(V)}e.containsRTL=U;const $=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function K(V){return $.test(V)}e.containsEmoji=K;const Y=/^[\t\n\r\x20-\x7E]*$/;function Q(V){return Y.test(V)}e.isBasicASCII=Q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se(V){return e.UNUSUAL_LINE_TERMINATORS.test(V)}e.containsUnusualLineTerminators=se;function oe(V){for(let x=0,re=V.length;x<re;x++)if(ce(V.charCodeAt(x)))return!0;return!1}e.containsFullWidthCharacter=oe;function ce(V){return V=+V,V>=11904&&V<=55215||V>=63744&&V<=64255||V>=65281&&V<=65374}e.isFullWidthCharacter=ce;function he(V){return V>=127462&&V<=127487||V===8986||V===8987||V===9200||V===9203||V>=9728&&V<=10175||V===11088||V===11093||V>=127744&&V<=128591||V>=128640&&V<=128764||V>=128992&&V<=129003||V>=129280&&V<=129535||V>=129648&&V<=129750}e.isEmojiImprecise=he;function _e(V,x){if(V.length<x)return V;const re=/\b/g;let ae=0;for(;re.test(V)&&!(V.length-re.lastIndex<x);)ae=re.lastIndex,re.lastIndex+=1;return V.substring(ae).replace(/^\s/,"")}e.lcut=_e;const Pe=/\x1B\x5B[12]?K/g,Re=/\x1b\[\d+m/g,Ae=/\x1b\[0?m/g;function Se(V){return V&&(V=V.replace(Pe,""),V=V.replace(Re,""),V=V.replace(Ae,"")),V}e.removeAnsiEscapeCodes=Se,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function de(V){return!!(V&&V.length>0&&V.charCodeAt(0)===65279)}e.startsWithUTF8BOM=de;function we(V){return de(V)?V.substr(1):V}e.stripUTF8BOM=we;function Ee(V,x){if(!V||!x||V.length<x.length)return!1;const re=x.length,ae=V.toLowerCase();let le=0,ue=-1;for(;le<re;){const me=ae.indexOf(x[le],ue+1);if(me<0)return!1;ue=me,le++}return!0}e.fuzzyContains=Ee;function Ie(V,x=!1){return V?(x&&(V=V.replace(/\\./g,"")),V.toLowerCase()!==V):!1}e.containsUppercaseCharacter=Ie;function Ne(V){return V.charAt(0).toUpperCase()+V.slice(1)}e.uppercaseFirstLetter=Ne;function Me(V,x=1){if(x===0)return"";let re=-1;do re=V.indexOf(`
`,re+1),x--;while(x>0&&re>=0);return re===-1?V:(V[re-1]==="\r"&&re--,V.substr(0,re))}e.getNLines=Me;function Ue(V){const x=90-65+1;return V=V%(2*x),V<x?String.fromCharCode(97+V):String.fromCharCode(65+V-x)}e.singleLetterHash=Ue;function ze(V){return ne.getInstance().getGraphemeBreakType(V)}e.getGraphemeBreakType=ze;function X(V,x){return V===0?x!==5&&x!==7:V===2&&x===3?!1:V===4||V===2||V===3||x===4||x===2||x===3?!0:!(V===8&&(x===8||x===9||x===11||x===12)||(V===11||V===9)&&(x===9||x===10)||(V===12||V===10)&&x===10||x===5||x===13||x===7||V===1||V===13&&x===14||V===6&&x===6)}e.breakBetweenGraphemeBreakType=X;var ie;(function(V){V[V.Other=0]="Other",V[V.Prepend=1]="Prepend",V[V.CR=2]="CR",V[V.LF=3]="LF",V[V.Control=4]="Control",V[V.Extend=5]="Extend",V[V.Regional_Indicator=6]="Regional_Indicator",V[V.SpacingMark=7]="SpacingMark",V[V.L=8]="L",V[V.V=9]="V",V[V.T=10]="T",V[V.LV=11]="LV",V[V.LVT=12]="LVT",V[V.ZWJ=13]="ZWJ",V[V.Extended_Pictographic=14]="Extended_Pictographic"})(ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ne{constructor(){this._data=fe()}static getInstance(){return ne._INSTANCE||(ne._INSTANCE=new ne),ne._INSTANCE}getGraphemeBreakType(x){if(x<32)return x===10?3:x===13?2:4;if(x<127)return 0;const re=this._data,ae=re.length/3;let le=1;for(;le<=ae;)if(x<re[3*le])le=2*le;else if(x>re[3*le+1])le=2*le+1;else return re[3*le+2];return 0}}ne._INSTANCE=null;function fe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(J[16],Z([0,1,18,42]),function(H,e,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined",_=typeof TextEncoder!="undefined",k=typeof TextDecoder!="undefined";let P,u;class g{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return T?new g(Buffer.allocUnsafe(n)):new g(new Uint8Array(n))}static wrap(n){return T&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new g(n)}static fromString(n,f){return!((f==null?void 0:f.dontUseNodeBuffer)||!1)&&T?new g(Buffer.from(n)):_?(P||(P=new TextEncoder),new g(P.encode(n))):new g(h.encodeUTF8(n))}static concat(n,f){if(typeof f=="undefined"){f=0;for(let O=0,E=n.length;O<E;O++)f+=n[O].byteLength}const C=g.alloc(f);let A=0;for(let O=0,E=n.length;O<E;O++){const F=n[O];C.set(F,A),A+=F.byteLength}return C}toString(){return T?this.buffer.toString():k?(u||(u=new TextDecoder),u.decode(this.buffer)):h.decodeUTF8(this.buffer)}slice(n,f){return new g(this.buffer.subarray(n,f))}set(n,f){n instanceof g?this.buffer.set(n.buffer,f):this.buffer.set(n,f)}readUInt32BE(n){return v(this.buffer,n)}writeUInt32BE(n,f){m(this.buffer,n,f)}readUInt32LE(n){return c(this.buffer,n)}writeUInt32LE(n,f){y(this.buffer,n,f)}readUInt8(n){return b(this.buffer,n)}writeUInt8(n,f){p(this.buffer,n,f)}}e.VSBuffer=g;function I(a,n){return a[n+0]<<0>>>0|a[n+1]<<8>>>0}e.readUInt16LE=I;function d(a,n,f){a[f+0]=n&255,n=n>>>8,a[f+1]=n&255}e.writeUInt16LE=d;function v(a,n){return a[n]*2**24+a[n+1]*2**16+a[n+2]*2**8+a[n+3]}e.readUInt32BE=v;function m(a,n,f){a[f+3]=n,n=n>>>8,a[f+2]=n,n=n>>>8,a[f+1]=n,n=n>>>8,a[f]=n}e.writeUInt32BE=m;function c(a,n){return a[n+0]<<0>>>0|a[n+1]<<8>>>0|a[n+2]<<16>>>0|a[n+3]<<24>>>0}e.readUInt32LE=c;function y(a,n,f){a[f+0]=n&255,n=n>>>8,a[f+1]=n&255,n=n>>>8,a[f+2]=n&255,n=n>>>8,a[f+3]=n&255}e.writeUInt32LE=y;function b(a,n){return a[n]}e.readUInt8=b;function p(a,n,f){a[f]=n}e.writeUInt8=p;function w(a){return D.consumeReadable(a,n=>g.concat(n))}e.readableToBuffer=w;function l(a){return D.toReadable(a)}e.bufferToReadable=l;function o(a){return D.consumeStream(a,n=>g.concat(n))}e.streamToBuffer=o;async function i(a){return a.ended?g.concat(a.buffer):g.concat([...a.buffer,await o(a.stream)])}e.bufferedStreamToBuffer=i;function t(a){return D.toStream(a,n=>g.concat(n))}e.bufferToStream=t;function r(a){return D.transform(a,{data:n=>typeof n=="string"?g.fromString(n):g.wrap(n)},n=>g.concat(n))}e.streamToBufferReadableStream=r;function s(a){return D.newWriteableStream(n=>g.concat(n),a)}e.newWriteableBufferStream=s}),define(J[92],Z([0,1,18]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(D||(D={})),function(T){const _="error",k="warning",P="warn",u="info";function g(I){return I?h.equalsIgnoreCase(_,I)?T.Error:h.equalsIgnoreCase(k,I)||h.equalsIgnoreCase(P,I)?T.Warning:h.equalsIgnoreCase(u,I)?T.Info:T.Ignore:T.Ignore}T.fromValue=g}(D||(D={})),e.default=D}),define(J[10],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function h(n){return Array.isArray(n)}e.isArray=h;function D(n){return typeof n=="string"}e.isString=D;function T(n){return Array.isArray(n)&&n.every(f=>D(f))}e.isStringArray=T;function _(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}e.isObject=_;function k(n){return typeof n=="number"&&!isNaN(n)}e.isNumber=k;function P(n){return n===!0||n===!1}e.isBoolean=P;function u(n){return typeof n=="undefined"}e.isUndefined=u;function g(n){return!I(n)}e.isDefined=g;function I(n){return u(n)||n===null}e.isUndefinedOrNull=I;function d(n,f){if(!n)throw new Error(f?`Unexpected type, expected '${f}'`:"Unexpected type")}e.assertType=d;function v(n){if(I(n))throw new Error("Assertion Failed: argument is undefined or null");return n}e.assertIsDefined=v;function m(...n){const f=[];for(let C=0;C<n.length;C++){const A=n[C];if(I(A))throw new Error(`Assertion Failed: argument at index ${C} is undefined or null`);f.push(A)}return f}e.assertAllDefined=m;const c=Object.prototype.hasOwnProperty;function y(n){if(!_(n))return!1;for(let f in n)if(c.call(n,f))return!1;return!0}e.isEmptyObject=y;function b(n){return typeof n=="function"}e.isFunction=b;function p(...n){return n.length>0&&n.every(b)}e.areFunctions=p;function w(n,f){const C=Math.min(n.length,f.length);for(let A=0;A<C;A++)l(n[A],f[A])}e.validateConstraints=w;function l(n,f){if(D(f)){if(typeof n!==f)throw new Error(`argument does not match constraint: typeof ${f}`)}else if(b(f)){try{if(n instanceof f)return}catch(C){}if(!I(n)&&n.constructor===f||f.length===1&&f.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function o(n){let f=[],C=Object.getPrototypeOf(n);for(;Object.prototype!==C;)f=f.concat(Object.getOwnPropertyNames(C)),C=Object.getPrototypeOf(C);return f}e.getAllPropertyNames=o;function i(n){const f=[];for(const C of o(n))typeof n[C]=="function"&&f.push(C);return f}e.getAllMethodNames=i;function t(n,f){const C=O=>function(){const E=Array.prototype.slice.call(arguments,0);return f(O,E)};let A={};for(const O of n)A[O]=C(O);return A}e.createProxyObject=t;function r(n){return n===null?void 0:n}e.withNullAsUndefined=r;function s(n){return typeof n=="undefined"?null:n}e.withUndefinedAsNull=s;function a(n){return class{constructor(){return new Proxy({},{get(f,C){if(f[C])return f[C];throw new Error(`Not Implemented: ${n}->${String(C)}`)}})}}}e.NotImplementedProxy=a}),define(J[34],Z([0,1,4,18,3,10]),function(H,e,h,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function k(r){return r===47||r===92}e.isPathSeparator=k;function P(r){return r.replace(/[\\/]/g,T.posix.sep)}e.toSlashes=P;function u(r,s=T.posix.sep){if(!r)return"";const a=r.length,n=r.charCodeAt(0);if(k(n)){if(k(r.charCodeAt(1))&&!k(r.charCodeAt(2))){let C=3;const A=C;for(;C<a&&!k(r.charCodeAt(C));C++);if(A!==C&&!k(r.charCodeAt(C+1))){for(C+=1;C<a;C++)if(k(r.charCodeAt(C)))return r.slice(0,C+1).replace(/[\\/]/g,s)}}return s}else if(b(n)&&r.charCodeAt(1)===58)return k(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<a;f++)if(k(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.getRoot=u;function g(r){if(!h.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let a=2;const n=a;for(;a<r.length&&(s=r.charCodeAt(a),s!==92);a++);return!(n===a||(s=r.charCodeAt(a+1),isNaN(s)||s===92))}e.isUNC=g;const I=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(r,s=h.isWindows){const a=s?I:d;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||s&&v.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=m;function c(r,s,a){const n=r===s;return!a||n?n:!r||!s?!1:D.equalsIgnoreCase(r,s)}e.isEqual=c;function y(r,s,a,n=T.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(a){if(!D.startsWithIgnoreCase(r,s))return!1;if(s.length===r.length)return!0;let C=s.length;return s.charAt(s.length-1)===n&&C--,r.charAt(C)===n}return s.charAt(s.length-1)!==n&&(s+=n),r.indexOf(s)===0}e.isEqualOrParent=y;function b(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=b;function p(r,s){return h.isWindows&&r.endsWith(":")&&(r+=T.sep),T.isAbsolute(r)||(r=T.join(s,r)),r=T.normalize(r),h.isWindows?(r=D.rtrim(r,T.sep),r.endsWith(":")&&(r+=T.sep)):(r=D.rtrim(r,T.sep),r||(r=T.sep)),r}e.sanitizeFilePath=p;function w(r){const s=T.normalize(r);return h.isWindows?r.length>3?!1:l(s)&&(r.length===2||s.charCodeAt(2)===92):s===T.posix.sep}e.isRootOrDriveLetter=w;function l(r){return h.isWindows?b(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function o(r){return l(r)?r[0]:void 0}e.getDriveLetter=o;function i(r,s,a){return s.length>r.length?-1:r===s?0:(a&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=i;function t(r){const s=r.split(":");let a,n,f;if(s.forEach(C=>{const A=Number(C);_.isNumber(A)?n===void 0?n=A:f===void 0&&(f=A):a=a?[a,C].join(":"):C}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:n!==void 0?n:void 0,column:f!==void 0?f:n!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(J[20],Z([0,1,10]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function D(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const y=Array.isArray(c)?[]:{};return Object.keys(c).forEach(b=>{c[b]&&typeof c[b]=="object"?y[b]=D(c[b]):y[b]=c[b]}),y}e.deepClone=D;function T(c){if(!c||typeof c!="object")return c;const y=[c];for(;y.length>0;){const b=y.shift();Object.freeze(b);for(const p in b)if(_.call(b,p)){const w=b[p];typeof w=="object"&&!Object.isFrozen(w)&&y.push(w)}}return c}e.deepFreeze=T;const _=Object.prototype.hasOwnProperty;function k(c,y){return P(c,y,new Set)}e.cloneAndChange=k;function P(c,y,b){if(h.isUndefinedOrNull(c))return c;const p=y(c);if(typeof p!="undefined")return p;if(h.isArray(c)){const w=[];for(const l of c)w.push(P(l,y,b));return w}if(h.isObject(c)){if(b.has(c))throw new Error("Cannot clone recursive data-structure");b.add(c);const w={};for(let l in c)_.call(c,l)&&(w[l]=P(c[l],y,b));return b.delete(c),w}return c}function u(c,y,b=!0){return h.isObject(c)?(h.isObject(y)&&Object.keys(y).forEach(p=>{p in c?b&&(h.isObject(c[p])&&h.isObject(y[p])?u(c[p],y[p],b):c[p]=y[p]):c[p]=y[p]}),c):y}e.mixin=u;function g(c,y){if(c===y)return!0;if(c==null||y===null||y===void 0||typeof c!=typeof y||typeof c!="object"||Array.isArray(c)!==Array.isArray(y))return!1;let b,p;if(Array.isArray(c)){if(c.length!==y.length)return!1;for(b=0;b<c.length;b++)if(!g(c[b],y[b]))return!1}else{const w=[];for(p in c)w.push(p);w.sort();const l=[];for(p in y)l.push(p);if(l.sort(),!g(w,l))return!1;for(b=0;b<w.length;b++)if(!g(c[w[b]],y[w[b]]))return!1}return!0}e.equals=g;function I(c){const y=new Set;return JSON.stringify(c,(b,p)=>{if(h.isObject(p)||Array.isArray(p)){if(y.has(p))return"[Circular]";y.add(p)}return p})}e.safeStringify=I;function d(c,y,b){const p=y(c);return typeof p=="undefined"?b:p}e.getOrDefault=d;function v(c,y){const b=Object.create(null);return!c||!y||Object.keys(y).forEach(w=>{const l=c[w],o=y[w];g(l,o)||(b[w]=o)}),b}e.distinct=v;function m(c,y){const b=y.toLowerCase(),p=Object.keys(c).find(w=>w.toLowerCase()===b);return p?c[p]:c[y]}e.getCaseInsensitive=m}),define(J[6],Z([0,1,4,3]),function(H,e,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,_=/^\//,k=/^\/\//;function P(s,a){if(!s.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!T.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!_.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(s,a){return!s&&!a?"file":s}function g(s,a){switch(s){case"https":case"http":case"file":a?a[0]!==d&&(a=d+a):a=d;break}return a}const I="",d="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(a,n,f,C,A,O=!1){typeof a=="object"?(this.scheme=a.scheme||I,this.authority=a.authority||I,this.path=a.path||I,this.query=a.query||I,this.fragment=a.fragment||I):(this.scheme=u(a,O),this.authority=n||I,this.path=g(this.scheme,f||I),this.query=C||I,this.fragment=A||I,P(this,O))}static isUri(a){return a instanceof m?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return l(this,!1)}with(a){if(!a)return this;let{scheme:n,authority:f,path:C,query:A,fragment:O}=a;return n===void 0?n=this.scheme:n===null&&(n=I),f===void 0?f=this.authority:f===null&&(f=I),C===void 0?C=this.path:C===null&&(C=I),A===void 0?A=this.query:A===null&&(A=I),O===void 0?O=this.fragment:O===null&&(O=I),n===this.scheme&&f===this.authority&&C===this.path&&A===this.query&&O===this.fragment?this:new y(n,f,C,A,O)}static parse(a,n=!1){const f=v.exec(a);return f?new y(f[2]||I,r(f[4]||I),r(f[5]||I),r(f[7]||I),r(f[9]||I),n):new y(I,I,I,I,I)}static file(a){let n=I;if(h.isWindows&&(a=a.replace(/\\/g,d)),a[0]===d&&a[1]===d){const f=a.indexOf(d,2);f===-1?(n=a.substring(2),a=d):(n=a.substring(2,f),a=a.substring(f)||d)}return new y("file",n,a,I,I)}static from(a){return new y(a.scheme,a.authority,a.path,a.query,a.fragment)}static joinPath(a,...n){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return h.isWindows&&a.scheme==="file"?f=m.file(D.win32.join(l(a,!0),...n)).path:f=D.posix.join(a.path,...n),a.with({path:f})}toString(a=!1){return o(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof m)return a;{const n=new y(a);return n._formatted=a.external,n._fsPath=a._sep===c?a.fsPath:null,n}}else return a}}e.URI=m;const c=h.isWindows?1:void 0;class y extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(a=!1){return a?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=c),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(s,a){let n,f=-1;for(let C=0;C<s.length;C++){const A=s.charCodeAt(C);if(A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57||A===45||A===46||A===95||A===126||a&&A===47)f!==-1&&(n+=encodeURIComponent(s.substring(f,C)),f=-1),n!==void 0&&(n+=s.charAt(C));else{n===void 0&&(n=s.substr(0,C));const O=b[A];O!==void 0?(f!==-1&&(n+=encodeURIComponent(s.substring(f,C)),f=-1),n+=O):f===-1&&(f=C)}}return f!==-1&&(n+=encodeURIComponent(s.substring(f))),n!==void 0?n:s}function w(s){let a;for(let n=0;n<s.length;n++){const f=s.charCodeAt(n);f===35||f===63?(a===void 0&&(a=s.substr(0,n)),a+=b[f]):a!==void 0&&(a+=s[n])}return a!==void 0?a:s}function l(s,a){let n;return s.authority&&s.path.length>1&&s.scheme==="file"?n=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?a?n=s.path.substr(1):n=s.path[1].toLowerCase()+s.path.substr(2):n=s.path,h.isWindows&&(n=n.replace(/\//g,"\\")),n}e.uriToFsPath=l;function o(s,a){const n=a?w:p;let f="",{scheme:C,authority:A,path:O,query:E,fragment:F}=s;if(C&&(f+=C,f+=":"),(A||C==="file")&&(f+=d,f+=d),A){let j=A.indexOf("@");if(j!==-1){const G=A.substr(0,j);A=A.substr(j+1),j=G.indexOf(":"),j===-1?f+=n(G,!1):(f+=n(G.substr(0,j),!1),f+=":",f+=n(G.substr(j+1),!1)),f+="@"}A=A.toLowerCase(),j=A.indexOf(":"),j===-1?f+=n(A,!1):(f+=n(A.substr(0,j),!1),f+=A.substr(j))}if(O){if(O.length>=3&&O.charCodeAt(0)===47&&O.charCodeAt(2)===58){const j=O.charCodeAt(1);j>=65&&j<=90&&(O=`/${String.fromCharCode(j+32)}:${O.substr(3)}`)}else if(O.length>=2&&O.charCodeAt(1)===58){const j=O.charCodeAt(0);j>=65&&j<=90&&(O=`${String.fromCharCode(j+32)}:${O.substr(2)}`)}f+=n(O,!0)}return E&&(f+="?",f+=n(E,!1)),F&&(f+="#",f+=a?F:p(F,!1)),f}function i(s){try{return decodeURIComponent(s)}catch(a){return s.length>3?s.substr(0,3)+i(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,a=>i(a)):s}}),define(J[93],Z([0,1,22,6]),function(H,e,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.getUriFromAmdModule=e.getPathFromAmdModule=void 0;function T(P,u){return _(P,u).fsPath}e.getPathFromAmdModule=T;function _(P,u){return D.URI.parse(P.toUrl(u))}e.getUriFromAmdModule=_;class k{static get(){const u=new Map,g=new Map,I=new Map,d=new Map;function v(p,w){p.has(w.detail)||p.set(w.detail,-w.timestamp)}function m(p,w){let l=p.get(w.detail);!l||l>=0||p.set(w.detail,l+w.timestamp)}const c=h.mergeSort(H.getStats().slice(0),(p,w)=>p.timestamp-w.timestamp);for(const p of c)switch(p.type){case 10:v(u,p);break;case 11:case 12:m(u,p);break;case 21:v(g,p);break;case 22:m(g,p);break;case 33:v(I,p);break;case 34:m(I,p);break;case 31:v(d,p);break;case 32:m(d,p);break}let y=0;I.forEach(p=>y+=p);function b(p){let w=[];return p.forEach((l,o)=>w.push([o,l])),w}return{amdLoad:b(u),amdInvoke:b(g),nodeRequire:b(I),nodeEval:b(d),nodeRequireTotal:y}}static toMarkdownTable(u,g){let I="",d=[];return u.forEach((v,m)=>{d[m]=v.length}),g.forEach(v=>{v.forEach((m,c)=>{typeof m=="undefined"&&(m=v[c]="-");const y=m.toString().length;d[c]=Math.max(y,d[c])})}),u.forEach((v,m)=>{I+=`| ${v+" ".repeat(d[m]-v.toString().length)} `}),I+=`|
`,u.forEach((v,m)=>{I+=`| ${"-".repeat(d[m])} `}),I+=`|
`,g.forEach(v=>{v.forEach((m,c)=>{typeof m!="undefined"&&(I+=`| ${m+" ".repeat(d[c]-m.toString().length)} `)}),I+=`|
`}),I}}e.LoaderStats=k}),define(J[94],Z([0,1,6]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function D(g){const I=g;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=D;function T(g){const I=[];let d;try{const v=JSON.parse(g.arguments),m=v[v.length-1];m&&m.__$stack&&(v.pop(),d=m.__$stack),I.push(...v)}catch(v){I.push("Unable to log remote console arguments",g.arguments)}return{args:I,stack:d}}e.parse=T;function _(g){if(typeof g!="string")return _(T(g).stack);const I=g;if(I){const d=k(I),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(d||"");if(v&&v.length===4)return{uri:h.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=_;function k(g){if(!g)return g;const I=g.indexOf(`
`);return I===-1?g:g.substring(0,I)}function P(g,I){const{args:d,stack:v}=T(g),m=typeof d[0]=="string"&&d.length===1;let c=k(v);c&&(c=`(${c.trim()})`);let y=[];if(typeof d[0]=="string"?c&&m?y=[`%c[${I}] %c${d[0]} %c${c}`,u("blue"),u(""),u("grey")]:y=[`%c[${I}] %c${d[0]}`,u("blue"),u(""),...d.slice(1)]:y=[`%c[${I}]%`,u("blue"),...d],c&&!m&&y.push(c),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,y)}e.log=P;function u(g){return`color: ${g}`}}),define(J[30],Z([0,1,6,18]),function(H,e,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function T(w,l,o){let i=w.get(l);return i===void 0&&(i=o,w.set(l,i)),i}e.getOrSet=T;function _(w){const l=[];return w.forEach((o,i)=>{l.push(`${i} => ${o}`)}),`Map(${w.size}) {${l.join(", ")}}`}e.mapToString=_;function k(w){const l=[];return w.forEach(o=>{l.push(o)}),`Set(${w.size}) {${l.join(", ")}}`}e.setToString=k;class P{constructor(){this._value="",this._pos=0}reset(l){return this._value=l,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(l){const o=l.charCodeAt(0),i=this._value.charCodeAt(this._pos);return o-i}value(){return this._value[this._pos]}}e.StringIterator=P;class u{constructor(l=!0){this._caseSensitive=l}reset(l){return this._value=l,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(l)this._from++;else break;else l=!1;return this}cmp(l){return this._caseSensitive?D.compareSubstring(l,this._value,0,l.length,this._from,this._to):D.compareSubstringIgnoreCase(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=u;class g{constructor(l=!0,o=!0){this._splitOnBackslash=l,this._caseSensitive=o}reset(l){return this._value=l.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(l)this._from++;else break;else l=!1}return this}cmp(l){return this._caseSensitive?D.compareSubstring(l,this._value,0,l.length,this._from,this._to):D.compareSubstringIgnoreCase(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=g;var I;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(I||(I={}));class d{constructor(l){this._ignorePathCasing=l,this._states=[],this._stateIdx=0}reset(l){return this._value=l,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new g(!1,!this._ignorePathCasing(l)),this._pathIterator.reset(l.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(l){if(this._states[this._stateIdx]===1)return D.compareIgnoreCase(l,this._value.scheme);if(this._states[this._stateIdx]===2)return D.compareIgnoreCase(l,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(l);if(this._states[this._stateIdx]===4)return D.compare(l,this._value.query);if(this._states[this._stateIdx]===5)return D.compare(l,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class v{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class m{constructor(l){this._iter=l}static forUris(l=()=>!1){return new m(new d(l))}static forPaths(){return new m(new g)}static forStrings(){return new m(new P)}static forConfigKeys(){return new m(new u)}clear(){this._root=void 0}set(l,o){const i=this._iter.reset(l);let t;for(this._root||(this._root=new v,this._root.segment=i.value()),t=this._root;;){const s=i.cmp(t.segment);if(s>0)t.left||(t.left=new v,t.left.segment=i.value()),t=t.left;else if(s<0)t.right||(t.right=new v,t.right.segment=i.value()),t=t.right;else if(i.hasNext())i.next(),t.mid||(t.mid=new v,t.mid.segment=i.value()),t=t.mid;else break}const r=t.value;return t.value=o,t.key=l,r}get(l){var o;return(o=this._getNode(l))===null||o===void 0?void 0:o.value}_getNode(l){const o=this._iter.reset(l);let i=this._root;for(;i;){const t=o.cmp(i.segment);if(t>0)i=i.left;else if(t<0)i=i.right;else if(o.hasNext())o.next(),i=i.mid;else break}return i}has(l){const o=this._getNode(l);return!((o==null?void 0:o.value)===void 0&&(o==null?void 0:o.mid)===void 0)}delete(l){return this._delete(l,!1)}deleteSuperstr(l){return this._delete(l,!0)}_delete(l,o){const i=this._iter.reset(l),t=[];let r=this._root;for(;r;){const s=i.cmp(r.segment);if(s>0)t.push([1,r]),r=r.left;else if(s<0)t.push([-1,r]),r=r.right;else if(i.hasNext())i.next(),t.push([0,r]),r=r.mid;else{for(o?(r.left=void 0,r.mid=void 0,r.right=void 0):r.value=void 0;t.length>0&&r.isEmpty();){let[a,n]=t.pop();switch(a){case 1:n.left=void 0;break;case 0:n.mid=void 0;break;case-1:n.right=void 0;break}r=n}break}}}findSubstr(l){const o=this._iter.reset(l);let i=this._root,t;for(;i;){const r=o.cmp(i.segment);if(r>0)i=i.left;else if(r<0)i=i.right;else if(o.hasNext())o.next(),t=i.value||t,i=i.mid;else break}return i&&i.value||t}findSuperstr(l){const o=this._iter.reset(l);let i=this._root;for(;i;){const t=o.cmp(i.segment);if(t>0)i=i.left;else if(t<0)i=i.right;else if(o.hasNext())o.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(l){for(const[o,i]of this)l(i,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(l){l&&(yield*this._entries(l.left),l.value&&(yield[l.key,l.value]),yield*this._entries(l.mid),yield*this._entries(l.right))}}e.TernarySearchTree=m;class c{constructor(l,o){this[Symbol.toStringTag]="ResourceMap",l instanceof c?(this.map=new Map(l.map),this.toKey=o!=null?o:c.defaultToKey):(this.map=new Map,this.toKey=l!=null?l:c.defaultToKey)}set(l,o){return this.map.set(this.toKey(l),o),this}get(l){return this.map.get(this.toKey(l))}has(l){return this.map.has(this.toKey(l))}get size(){return this.map.size}clear(){this.map.clear()}delete(l){return this.map.delete(this.toKey(l))}forEach(l,o){typeof o!="undefined"&&(l=l.bind(o));for(let[i,t]of this.map)l(t,h.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let l of this.map.keys())yield h.URI.parse(l)}*entries(){for(let l of this.map.entries())yield[h.URI.parse(l[0]),l[1]]}*[Symbol.iterator](){for(let l of this.map)yield[h.URI.parse(l[0]),l[1]]}}e.ResourceMap=c,c.defaultToKey=w=>w.toString();var y;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(y=e.Touch||(e.Touch={}));class b{constructor(){this[Symbol.toStringTag]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var l;return(l=this._head)===null||l===void 0?void 0:l.value}get last(){var l;return(l=this._tail)===null||l===void 0?void 0:l.value}has(l){return this._map.has(l)}get(l,o=0){const i=this._map.get(l);if(!!i)return o!==0&&this.touch(i,o),i.value}set(l,o,i=0){let t=this._map.get(l);if(t)t.value=o,i!==0&&this.touch(t,i);else{switch(t={key:l,value:o,next:void 0,previous:void 0},i){case 0:this.addItemLast(t);break;case 1:this.addItemFirst(t);break;case 2:this.addItemLast(t);break;default:this.addItemLast(t);break}this._map.set(l,t),this._size++}return this}delete(l){return!!this.remove(l)}remove(l){const o=this._map.get(l);if(!!o)return this._map.delete(l),this.removeItem(o),this._size--,o.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const l=this._head;return this._map.delete(l.key),this.removeItem(l),this._size--,l.value}}forEach(l,o){const i=this._state;let t=this._head;for(;t;){if(o?l.bind(o)(t.value,t.key,this):l(t.value,t.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const l=this,o=this._state;let i=this._head;const t={[Symbol.iterator](){return t},next(){if(l._state!==o)throw new Error("LinkedMap got modified during iteration.");if(i){const r={value:i.key,done:!1};return i=i.next,r}else return{value:void 0,done:!0}}};return t}values(){const l=this,o=this._state;let i=this._head;const t={[Symbol.iterator](){return t},next(){if(l._state!==o)throw new Error("LinkedMap got modified during iteration.");if(i){const r={value:i.value,done:!1};return i=i.next,r}else return{value:void 0,done:!0}}};return t}entries(){const l=this,o=this._state;let i=this._head;const t={[Symbol.iterator](){return t},next(){if(l._state!==o)throw new Error("LinkedMap got modified during iteration.");if(i){const r={value:[i.key,i.value],done:!1};return i=i.next,r}else return{value:void 0,done:!0}}};return t}[Symbol.iterator](){return this.entries()}trimOld(l){if(!(l>=this.size)){if(l===0){this.clear();return}let o=this._head,i=this.size;for(;o&&i>l;)this._map.delete(o.key),o=o.next,i--;this._head=o,this._size=i,o&&(o.previous=void 0),this._state++}}addItemFirst(l){if(!this._head&&!this._tail)this._tail=l;else if(this._head)l.next=this._head,this._head.previous=l;else throw new Error("Invalid list");this._head=l,this._state++}addItemLast(l){if(!this._head&&!this._tail)this._head=l;else if(this._tail)l.previous=this._tail,this._tail.next=l;else throw new Error("Invalid list");this._tail=l,this._state++}removeItem(l){if(l===this._head&&l===this._tail)this._head=void 0,this._tail=void 0;else if(l===this._head){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this._head=l.next}else if(l===this._tail){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this._tail=l.previous}else{const o=l.next,i=l.previous;if(!o||!i)throw new Error("Invalid list");o.previous=i,i.next=o}l.next=void 0,l.previous=void 0,this._state++}touch(l,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(l===this._head)return;const i=l.next,t=l.previous;l===this._tail?(t.next=void 0,this._tail=t):(i.previous=t,t.next=i),l.previous=void 0,l.next=this._head,this._head.previous=l,this._head=l,this._state++}else if(o===2){if(l===this._tail)return;const i=l.next,t=l.previous;l===this._head?(i.previous=void 0,this._head=i):(i.previous=t,t.next=i),l.next=void 0,l.previous=this._tail,this._tail.next=l,this._tail=l,this._state++}}}toJSON(){const l=[];return this.forEach((o,i)=>{l.push([i,o])}),l}fromJSON(l){this.clear();for(const[o,i]of l)this.set(o,i)}}e.LinkedMap=b;class p extends b{constructor(l,o=1){super();this._limit=l,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(l){this._limit=l,this.checkTrim()}get ratio(){return this._ratio}set ratio(l){this._ratio=Math.min(Math.max(0,l),1),this.checkTrim()}get(l,o=2){return super.get(l,o)}peek(l){return super.get(l,0)}set(l,o){return super.set(l,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=p}),define(J[95],Z([0,1,18,34,3,30,12]),function(H,e,h,D,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const u="**",g="/",I="[/\\\\]",d="[^/\\\\]",v=/\//g;function m(S){switch(S){case 0:return"";case 1:return`${d}*?`;default:return`(?:${I}|${d}+${I}|${I}${d}+)*?`}}function c(S,R){if(!S)return[];const N=[];let U=!1,$=!1,K="";for(const Y of S){switch(Y){case R:if(!U&&!$){N.push(K),K="";continue}break;case"{":U=!0;break;case"}":U=!1;break;case"[":$=!0;break;case"]":$=!1;break}K+=Y}return K&&N.push(K),N}e.splitGlobAware=c;function y(S){if(!S)return"";let R="";const N=c(S,g);if(N.every(U=>U===u))R=".*";else{let U=!1;N.forEach(($,K)=>{if($===u){U||(R+=m(2),U=!0);return}let Y=!1,Q="",se=!1,oe="";for(const ce of $){if(ce!=="}"&&Y){Q+=ce;continue}if(se&&(ce!=="]"||!oe)){let he;ce==="-"?he=ce:(ce==="^"||ce==="!")&&!oe?he="^":ce===g?he="":he=h.escapeRegExpCharacters(ce),oe+=he;continue}switch(ce){case"{":Y=!0;continue;case"[":se=!0;continue;case"}":R+=`(?:${c(Q,",").map(Pe=>y(Pe)).join("|")})`,Y=!1,Q="";break;case"]":R+="["+oe+"]",se=!1,oe="";break;case"?":R+=d;continue;case"*":R+=m(1);continue;default:R+=h.escapeRegExpCharacters(ce)}}K<N.length-1&&(N[K+1]!==u||K+2<N.length)&&(R+=I),U=!1})}return R}const b=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new _.LRUCache(1e4),r=function(){return!1},s=function(){return null};function a(S,R){if(!S)return s;let N;typeof S!="string"?N=S.pattern:N=S,N=N.trim();const U=`${N}_${!!R.trimForExclusions}`;let $=t.get(U);if($)return n($,S);let K;if(b.test(N)){const Y=N.substr(4);$=function(Q,se){return typeof Q=="string"&&Q.endsWith(Y)?N:null}}else(K=p.exec(f(N,R)))?$=C(K[1],N):(R.trimForExclusions?l:w).test(N)?$=A(N,R):(K=o.exec(f(N,R)))?$=O(K[1].substr(1),N,!0):(K=i.exec(f(N,R)))?$=O(K[1],N,!1):$=E(N);return t.set(U,$),n($,S)}function n(S,R){return typeof R=="string"?S:function(N,U){return D.isEqualOrParent(N,R.base)?S(T.relative(R.base,N),U):null}}function f(S,R){return R.trimForExclusions&&S.endsWith("/**")?S.substr(0,S.length-2):S}function C(S,R){const N=`/${S}`,U=`\\${S}`,$=function(Y,Q){return typeof Y!="string"?null:Q?Q===S?R:null:Y===S||Y.endsWith(N)||Y.endsWith(U)?R:null},K=[S];return $.basenames=K,$.patterns=[R],$.allBasenames=K,$}function A(S,R){const N=L(S.slice(1,-1).split(",").map(Q=>a(Q,R)).filter(Q=>Q!==s),S),U=N.length;if(!U)return s;if(U===1)return N[0];const $=function(Q,se){for(let oe=0,ce=N.length;oe<ce;oe++)if(N[oe](Q,se))return S;return null},K=N.find(Q=>!!Q.allBasenames);K&&($.allBasenames=K.allBasenames);const Y=N.reduce((Q,se)=>se.allPaths?Q.concat(se.allPaths):Q,[]);return Y.length&&($.allPaths=Y),$}function O(S,R,N){const U=T.sep===T.posix.sep,$=U?S:S.replace(v,T.sep),K=T.sep+$,Y=T.posix.sep+S,Q=N?function(se,oe){return typeof se=="string"&&(se===$||se.endsWith(K)||!U&&(se===S||se.endsWith(Y)))?R:null}:function(se,oe){return typeof se=="string"&&(se===$||!U&&se===S)?R:null};return Q.allPaths=[(N?"*/":"./")+S],Q}function E(S){try{const R=new RegExp(`^${y(S)}$`);return function(N){return R.lastIndex=0,typeof N=="string"&&R.test(N)?S:null}}catch(R){return s}}function F(S,R,N){return!S||typeof R!="string"?!1:j(S)(R,void 0,N)}e.match=F;function j(S,R={}){if(!S)return r;if(typeof S=="string"||q(S)){const N=a(S,R);if(N===s)return r;const U=function($,K){return!!N($,K)};return N.allBasenames&&(U.allBasenames=N.allBasenames),N.allPaths&&(U.allPaths=N.allPaths),U}return B(S,R)}e.parse=j;function G(S){if(!!S){let R;return N=>(R||(R=(S()||Promise.resolve([])).then(U=>U?W(U):{})),R.then(U=>!!U[N]))}}e.hasSiblingPromiseFn=G;function z(S){if(!!S){let R;return N=>{if(!R){const U=S();R=U?W(U):{}}return!!R[N]}}}e.hasSiblingFn=z;function W(S){const R={};for(const N of S)R[N]=!0;return R}function q(S){const R=S;return R&&typeof R.base=="string"&&typeof R.pattern=="string"}e.isRelativePattern=q;function ee(S){return S.allBasenames||[]}e.getBasenameTerms=ee;function te(S){return S.allPaths||[]}e.getPathTerms=te;function B(S,R){const N=L(Object.getOwnPropertyNames(S).map(Q=>M(Q,S[Q],R)).filter(Q=>Q!==s)),U=N.length;if(!U)return s;if(!N.some(Q=>!!Q.requiresSiblings)){if(U===1)return N[0];const Q=function(ce,he){for(let _e=0,Pe=N.length;_e<Pe;_e++){const Re=N[_e](ce,he);if(Re)return Re}return null},se=N.find(ce=>!!ce.allBasenames);se&&(Q.allBasenames=se.allBasenames);const oe=N.reduce((ce,he)=>he.allPaths?ce.concat(he.allPaths):ce,[]);return oe.length&&(Q.allPaths=oe),Q}const $=function(Q,se,oe){let ce;for(let he=0,_e=N.length;he<_e;he++){const Pe=N[he];Pe.requiresSiblings&&oe&&(se||(se=T.basename(Q)),ce||(ce=se.substr(0,se.length-T.extname(Q).length)));const Re=Pe(Q,se,ce,oe);if(Re)return Re}return null},K=N.find(Q=>!!Q.allBasenames);K&&($.allBasenames=K.allBasenames);const Y=N.reduce((Q,se)=>se.allPaths?Q.concat(se.allPaths):Q,[]);return Y.length&&($.allPaths=Y),$}function M(S,R,N){if(R===!1)return s;const U=a(S,N);if(U===s)return s;if(typeof R=="boolean")return U;if(R){const $=R.when;if(typeof $=="string"){const K=(Y,Q,se,oe)=>{if(!oe||!U(Y,Q))return null;const ce=$.replace("$(basename)",se),he=oe(ce);return k.isThenable(he)?he.then(_e=>_e?S:null):he?S:null};return K.requiresSiblings=!0,K}}return U}function L(S,R){const N=S.filter(Q=>!!Q.basenames);if(N.length<2)return S;const U=N.reduce((Q,se)=>{const oe=se.basenames;return oe?Q.concat(oe):Q},[]);let $;if(R){$=[];for(let Q=0,se=U.length;Q<se;Q++)$.push(R)}else $=N.reduce((Q,se)=>{const oe=se.patterns;return oe?Q.concat(oe):Q},[]);const K=function(Q,se){if(typeof Q!="string")return null;if(!se){let ce;for(ce=Q.length;ce>0;ce--){const he=Q.charCodeAt(ce-1);if(he===47||he===92)break}se=Q.substr(ce)}const oe=U.indexOf(se);return oe!==-1?$[oe]:null};K.basenames=U,K.patterns=$,K.allBasenames=U;const Y=S.filter(Q=>!Q.basenames);return Y.push(K),Y}}),define(J[96],Z([0,1,16,18,6]),function(H,e,h,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function _(g){return JSON.stringify(g,P)}e.stringify=_;function k(g){let I=JSON.parse(g);return I=u(I),I}e.parse=k;function P(g,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:D.regExpFlags(I)}:I}function u(g,I=0){if(!g||I>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return T.URI.revive(g);case 2:return new RegExp(g.source,g.flags)}if(g instanceof h.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let d=0;d<g.length;++d)g[d]=u(g[d],I+1);else for(const d in g)Object.hasOwnProperty.call(g,d)&&(g[d]=u(g[d],I+1))}return g}e.revive=u}),define(J[11],Z([0,1,6,4]),function(H,e,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var T;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.vscodeWebviewResource="vscode-webview-resource",P.extension="extension",P.vscodeFileResource="vscode-file"})(T=e.Schemas||(e.Schemas={}));class _{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(u){this._preferredWebSchema=u}setDelegate(u){this._delegate=u}set(u,g,I){this._hosts[u]=g,this._ports[u]=I}setConnectionToken(u,g){this._connectionTokens[u]=g}rewrite(u){if(this._delegate)return this._delegate(u);const g=u.authority;let I=this._hosts[g];I&&I.indexOf(":")!==-1&&(I=`[${I}]`);const d=this._connectionTokens[g];let v=`path=${encodeURIComponent(u.path)}`;return typeof d=="string"&&(v+=`&tkn=${encodeURIComponent(d)}`),h.URI.from({scheme:D.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:window.location.host,path:`${window.location.pathname.replace(/\/+$/,"")}/vscode-remote-resource`,query:v})}}e.RemoteAuthorities=new _;class k{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(u,g,I){const d=this.toUri(u,g);return d.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(d):D.isNative&&(I||D.isPreferringBrowserCodeLoad)&&d.scheme===T.file?d.with({scheme:T.vscodeFileResource,authority:d.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):d}asFileUri(u,g){const I=this.toUri(u,g);return I.scheme===T.vscodeFileResource?I.with({scheme:T.file,authority:I.authority!==this.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(u,g){return h.URI.isUri(u)?u:h.URI.parse(g.toUrl(u))}}e.FileAccess=new k}),define(J[62],Z([0,1,30]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const D=new h.LRUCache(1e4);function T(g){return u(g,"NFC",D)}e.normalizeNFC=T;const _=new h.LRUCache(1e4);function k(g){return u(g,"NFD",_)}e.normalizeNFD=k;const P=/[^\u0000-\u0080]/;function u(g,I,d){if(!e.canNormalize||!g)return g;const v=d.get(g);if(v)return v;let m;return P.test(g)?m=g.normalize(I):m=g,d.set(g,m),m}e.removeAccents=function(){if(e.canNormalize){const g=/[\u0300-\u036f]/g;return function(I){return k(I).replace(g,"")}}else return function(g){return g}}()}),define(J[19],Z([0,1,34,3,6,18,11,4]),function(H,e,h,D,T,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function u(m){return T.uriToFsPath(m,!0)}e.originalFSPath=u;class g{constructor(c){this._ignorePathCasing=c}compare(c,y,b=!1){return c===y?0:_.compare(this.getComparisonKey(c,b),this.getComparisonKey(y,b))}isEqual(c,y,b=!1){return c===y?!0:!c||!y?!1:this.getComparisonKey(c,b)===this.getComparisonKey(y,b)}getComparisonKey(c,y=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,y,b=!1){if(c.scheme===y.scheme){if(c.scheme===k.Schemas.file)return h.isEqualOrParent(u(c),u(y),this._ignorePathCasing(c))&&c.query===y.query&&(b||c.fragment===y.fragment);if(e.isEqualAuthority(c.authority,y.authority))return h.isEqualOrParent(c.path,y.path,this._ignorePathCasing(c),"/")&&c.query===y.query&&(b||c.fragment===y.fragment)}return!1}joinPath(c,...y){return T.URI.joinPath(c,...y)}basenameOrAuthority(c){return e.basename(c)||c.authority}basename(c){return D.posix.basename(c.path)}extname(c){return D.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let y;return c.scheme===k.Schemas.file?y=T.URI.file(D.dirname(u(c))).path:(y=D.posix.dirname(c.path),c.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),y="/")),c.with({path:y})}normalizePath(c){if(!c.path.length)return c;let y;return c.scheme===k.Schemas.file?y=T.URI.file(D.normalize(u(c))).path:y=D.posix.normalize(c.path),c.with({path:y})}relativePath(c,y){if(!(c.scheme!==y.scheme||!e.isEqualAuthority(c.authority,y.authority))){if(c.scheme===k.Schemas.file){const w=D.relative(u(c),u(y));return P.isWindows?h.toSlashes(w):w}let b=c.path||"/",p=y.path||"/";if(this._ignorePathCasing(c)){let w=0;for(const l=Math.min(b.length,p.length);w<l&&!(b.charCodeAt(w)!==p.charCodeAt(w)&&b.charAt(w).toLowerCase()!==p.charAt(w).toLowerCase());w++);b=p.substr(0,w)+b.substr(w)}return D.posix.relative(b,p)}}resolvePath(c,y){if(c.scheme===k.Schemas.file){const b=T.URI.file(D.resolve(u(c),y));return c.with({authority:b.authority,path:b.path})}return y.indexOf("/")===-1&&(y=h.toSlashes(y),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y)),c.with({path:D.posix.resolve(c.path,y)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,y){return c===y||_.equalsIgnoreCase(c,y)}hasTrailingPathSeparator(c,y=D.sep){if(c.scheme===k.Schemas.file){const b=u(c);return b.length>h.getRoot(b).length&&b[b.length-1]===y}else{const b=c.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,y=D.sep){return e.hasTrailingPathSeparator(c,y)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,y=D.sep){let b=!1;if(c.scheme===k.Schemas.file){const p=u(c);b=p!==void 0&&p.length===h.getRoot(p).length&&p[p.length-1]===y}else{y="/";const p=c.path;b=p.length===1&&p.charCodeAt(p.length-1)===47}return!b&&!e.hasTrailingPathSeparator(c,y)?c.with({path:c.path+"/"}):c}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(m=>m.scheme===k.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new g(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(m,c){const y=[];for(let b=0;b<m.length;b++){const p=c(m[b]);m.some((w,l)=>l===b?!1:e.isEqualOrParent(p,c(w)))||y.push(m[b])}return y}e.distinctParents=I;var d;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function c(y){const b=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(l=>{const[o,i]=l.split(":");o&&i&&b.set(o,i)});const w=y.path.substring(0,y.path.indexOf(";"));return w&&b.set(m.META_DATA_MIME,w),b}m.parseMetaData=c})(d=e.DataUri||(e.DataUri={}));function v(m,c,y){if(c){let b=m.path;return b&&b[0]!==D.posix.sep&&(b=D.posix.sep+b),m.with({scheme:y,authority:c,path:b})}return m.with({scheme:y})}e.toLocalResource=v}),define(J[63],Z([0,1,6,3,18,11,4,19,34]),function(H,e,h,D,T,_,k,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function g(a,n,f){if(typeof a=="string"&&(a=h.URI.file(a)),f){const A=f.getWorkspaceFolder(a);if(A){const O=f.getWorkspace().folders.length>1;let E;if(P.isEqual(A.uri,a)?E="":E=P.relativePath(A.uri,a),O){const F=A.name?A.name:P.basename(A.uri);E=E?F+" \u2022 "+E:F}return E}}if(a.scheme!==_.Schemas.file&&a.scheme!==_.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if(u.hasDriveLetter(a.fsPath))return D.normalize(d(a.fsPath));let C=D.normalize(a.fsPath);return!k.isWindows&&(n==null?void 0:n.userHome)&&(C=m(C,n.userHome.fsPath)),C}e.getPathLabel=g;function I(a){if(!!a){typeof a=="string"&&(a=h.URI.file(a));const n=P.basename(a)||(a.scheme===_.Schemas.file?a.fsPath:a.path);return k.isWindows&&u.isRootOrDriveLetter(n)?d(n):n}}e.getBaseLabel=I;function d(a){return u.hasDriveLetter(a)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=d;let v=Object.create(null);function m(a,n){if(k.isWindows||!a||!n)return a;let f=v.original===n?v.normalized:void 0;return f||(f=`${T.rtrim(n,D.posix.sep)}${D.posix.sep}`,v={original:n,normalized:f}),(k.isLinux?a.startsWith(f):T.startsWithIgnoreCase(a,f))&&(a=`~/${a.substr(f.length)}`),a}e.tildify=m;function c(a,n){return a.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=c;const y="\u2026",b="\\\\",p="~";function w(a,n=D.sep){const f=new Array(a.length);let C=!1;for(let A=0;A<a.length;A++){let O=a[A];if(O===""){f[A]=`.${n}`;continue}if(!O){f[A]=O;continue}C=!0;let E="";O.indexOf(b)===0?(E=O.substr(0,O.indexOf(b)+b.length),O=O.substr(O.indexOf(b)+b.length)):O.indexOf(n)===0?(E=O.substr(0,O.indexOf(n)+n.length),O=O.substr(O.indexOf(n)+n.length)):O.indexOf(p)===0&&(E=O.substr(0,O.indexOf(p)+p.length),O=O.substr(O.indexOf(p)+p.length));const F=O.split(n);for(let j=1;C&&j<=F.length;j++)for(let G=F.length-j;C&&G>=0;G--){C=!1;let z=F.slice(G,G+j).join(n);for(let W=0;!C&&W<a.length;W++)if(W!==A&&a[W]&&a[W].indexOf(z)>-1){const q=G+j===F.length,ee=G>0&&a[W].indexOf(n)>-1?n+z:z,te=a[W].endsWith(ee);C=!q||te}if(!C){let W="";(F[0].endsWith(":")||E!=="")&&(G===1&&(G=0,j++,z=F[0]+n+z),G>0&&(W=F[0]+n),W=E+W),G>0&&(W=W+y+n),W=W+z,G+j<F.length&&(W=W+n+y),f[A]=W}}C&&(f[A]=O)}return f}e.shorten=w;var l;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function o(a,n=Object.create(null)){const f=[];let C=!1,A="";for(const O of a)if(O==="$"||C&&O==="{")A&&f.push({value:A,type:l.TEXT}),A="",C=!0;else if(O==="}"&&C){const E=n[A];if(typeof E=="string")E.length&&f.push({value:E,type:l.VARIABLE});else if(E){const F=f[f.length-1];(!F||F.type!==l.SEPARATOR)&&f.push({value:E.label,type:l.SEPARATOR})}A="",C=!1}else A+=O;return A&&!C&&f.push({value:A,type:l.TEXT}),f.filter((O,E)=>{if(O.type===l.SEPARATOR){const F=f[E-1],j=f[E+1];return[F,j].every(G=>G&&(G.type===l.VARIABLE||G.type===l.TEXT)&&G.value.length>0)}return!0}).map(O=>O.value).join("")}e.template=o;function i(a,n){return k.isMacintosh||n?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):a.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=i;function t(a,n){return k.isMacintosh||n?a.replace(/\(&&\w\)|&&/g,""):k.isWindows?a.replace(/&&|&/g,f=>f==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(a){const n=a.indexOf("/")!==-1?D.posix:D.win32,f=n.basename(a),C=n.dirname(a);return f.length?{name:f,parentPath:C}:{name:C,parentPath:""}}e.splitName=s}),define(J[49],Z([0,1,6,11]),function(H,e,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(d){return d.toJSON()}class _{constructor(v){this.remoteAuthority=v}transformIncoming(v){return v.scheme===D.Schemas.vscodeRemote?T(h.URI.file(v.path)):v}transformOutgoing(v){return v.scheme===D.Schemas.file?T(h.URI.from({authority:this.remoteAuthority,scheme:D.Schemas.vscodeRemote,path:v.path})):v}transformOutgoingURI(v){return v.scheme===D.Schemas.file?h.URI.from({authority:this.remoteAuthority,scheme:D.Schemas.vscodeRemote,path:v.path}):v}transformOutgoingScheme(v){return v===D.Schemas.file?D.Schemas.vscodeRemote:v}}e.URITransformer=_,e.DefaultURITransformer=new class{transformIncoming(d){return d}transformOutgoing(d){return d}transformOutgoingURI(d){return d}transformOutgoingScheme(d){return d}};function k(d,v,m){if(!d||m>200)return null;if(typeof d=="object"){if(d instanceof h.URI)return v.transformOutgoing(d);for(let c in d)if(Object.hasOwnProperty.call(d,c)){const y=k(d[c],v,m+1);y!==null&&(d[c]=y)}}return null}function P(d,v){const m=k(d,v,0);return m===null?d:m}e.transformOutgoingURIs=P;function u(d,v,m,c){if(!d||c>200)return null;if(typeof d=="object"){if(d.$mid===1)return m?h.URI.revive(v.transformIncoming(d)):v.transformIncoming(d);for(let y in d)if(Object.hasOwnProperty.call(d,y)){const b=u(d[y],v,m,c+1);b!==null&&(d[y]=b)}}return null}function g(d,v){const m=u(d,v,!1,0);return m===null?d:m}e.transformIncomingURIs=g;function I(d,v){const m=u(d,v,!0,0);return m===null?d:m}e.transformAndReviveIncomingURIs=I}),define(J[26],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const h=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(u){return h.test(u)}e.isUUID=D;const T=new Uint8Array(16),_=[];for(let u=0;u<256;u++)_.push(u.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(u){for(let g=0;g<u.length;g++)u[g]=Math.floor(Math.random()*256);return u};function P(){k(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let u=0,g="";return g+=_[T[u++]],g+=_[T[u++]],g+=_[T[u++]],g+=_[T[u++]],g+="-",g+=_[T[u++]],g+=_[T[u++]],g+="-",g+=_[T[u++]],g+=_[T[u++]],g+="-",g+=_[T[u++]],g+=_[T[u++]],g+="-",g+=_[T[u++]],g+=_[T[u++]],g+=_[T[u++]],g+=_[T[u++]],g+=_[T[u++]],g+=_[T[u++]],g}e.generateUuid=P}),define(J[64],Z([0,1,200]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class D{constructor(_="utf8"){this.stringDecoder=new h.StringDecoder(_),this.remaining=null}write(_){const k=[],P=this.remaining?this.remaining+this.stringDecoder.write(_):this.stringDecoder.write(_);if(P.length<1)return k;let u=0,g,I=u;for(;I<P.length;)if(g=P.charCodeAt(I),g===13||g===10){if(k.push(P.substring(u,I)),I++,I<P.length){const d=g;g=P.charCodeAt(I),(d===13&&g===10||d===10&&g===13)&&I++}u=I}else I++;return this.remaining=u<P.length?P.substr(u):null,k}end(){return this.remaining}}e.LineDecoder=D}),function(){"use strict";function H(e,h,D,T){function _(c){return new Promise(y=>D.exists(c,y))}function k(c){return new Promise((y,b)=>{const p=new Date;D.utimes(c,p,p,w=>w?b(w):y())})}function P(c){return new Promise((y,b)=>D.mkdir(c,{recursive:!0},p=>p&&p.code!=="EEXIST"?b(p):y(c)))}function u(c){return new Promise((y,b)=>D.rmdir(c,{recursive:!0},p=>p&&p.code!=="ENOENT"?b(p):y()))}function g(c){return new Promise((y,b)=>D.readFile(c,"utf8",(p,w)=>p?b(p):y(w)))}function I(c,y){return new Promise((b,p)=>D.writeFile(c,y,"utf8",w=>w?p(w):b()))}function d(c){const y=h.join(c,"languagepacks.json");try{return JSON.parse(D.readFileSync(y,"utf8"))}catch(b){}}function v(c,y){try{for(;y;){if(c[y])return y;{const b=y.lastIndexOf("-");if(b>0)y=y.substring(0,b);else return}}}catch(b){console.error("Resolving language pack configuration failed.",b)}}function m(c,y,b,p){if(p==="pseudo")return Promise.resolve({locale:p,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:p,availableLanguages:{}});if(p&&(p==="en"||p==="en-us"))return Promise.resolve({locale:p,availableLanguages:{}});const w=p;T.mark("code/willGenerateNls");const l=function(o){return T.mark("code/didGenerateNls"),Promise.resolve({locale:o,availableLanguages:{}})};try{if(!c)return l(w);const o=d(y);if(!o||(p=v(o,p),!p))return l(w);const i=o[p];let t;return!i||typeof i.hash!="string"||!i.translations||typeof(t=i.translations.vscode)!="string"?l(w):_(t).then(r=>{if(!r)return l(w);const s=i.hash+"."+p,a=h.join(y,"clp",s),n=h.join(a,c),f=h.join(a,"tcf.json"),C=h.join(a,"corrupted.info"),A={locale:w,availableLanguages:{"*":p},_languagePackId:s,_translationsConfigFile:f,_cacheRoot:a,_resolvedLanguagePackCoreLocation:n,_corruptedFile:C};return _(C).then(O=>{let E;return O?E=u(a):E=Promise.resolve(void 0),E.then(()=>_(n).then(F=>F?(k(n).catch(()=>{}),T.mark("code/didGenerateNls"),A):P(n).then(()=>Promise.all([g(b),g(t)])).then(j=>{const G=JSON.parse(j[0]),z=JSON.parse(j[1]).contents,W=Object.keys(G.bundles),q=[];for(const ee of W){const te=G.bundles[ee],B=Object.create(null);for(const M of te){const L=G.keys[M],S=G.messages[M],R=z[M];let N;if(R){N=[];for(let U=0;U<L.length;U++){const $=L[U],K=typeof $=="string"?$:$.key;let Y=R[K];Y===void 0&&(Y=S[U]),N.push(Y)}}else N=S;B[M]=N}q.push(I(h.join(n,ee.replace(/\//g,"!")+".nls.json"),JSON.stringify(B)))}return q.push(I(f,JSON.stringify(i.translations))),Promise.all(q)}).then(()=>(T.mark("code/didGenerateNls"),A)).catch(j=>(console.error("Generating translation files failed.",j),l(p)))))})})}catch(o){return console.error("Generating translation files failed.",o),l(p)}}return{getNLSConfiguration:m}}if(typeof define=="function")define(J[97],Z([0,37,15,98]),function(e,h,D,T){return H(e.__$__nodeRequire,h,D,T)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),h=require("fs"),D=require("../common/performance");module.exports=H(require,e,h,D)}else throw new Error("Unknown context")}(),define(J[99],Z([0,1,21]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function T(P){const u=P.replace(/\-/g,":").toLowerCase();return!D.has(u)}function _(){return new Promise(async(P,u)=>{const g=setTimeout(()=>u("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await k())}catch(I){u(I)}finally{clearTimeout(g)}})}e.getMac=_;function k(){return new Promise((P,u)=>{try{const g=h.networkInterfaces();for(const[,I]of Object.entries(g))for(const d of I)if(T(d.mac))return P(d.mac);u("Unable to retrieve mac address (unexpected format)")}catch(g){u(g)}})}}),define(J[100],Z([0,1,14,26,21,30,99]),function(H,e,h,D,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=_.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,d=0;const v=T.networkInterfaces();for(let m in v)if(Object.prototype.hasOwnProperty.call(v,m))for(const{mac:c,internal:y}of v[m])y||(d+=1,this._isVirtualMachineMacAdress(c.toUpperCase())&&(I+=1));this._value=d>0?I/d:0}return this._value}};let P;async function u(){return P||(P=(async()=>await g()||D.generateUuid())()),P}e.getMachineId=u;async function g(){try{const I=await new Promise((v,m)=>{H(["crypto"],v,m)}),d=await k.getMac();return I.createHash("sha256").update(d,"utf8").digest("hex")}catch(I){h.onUnexpectedError(I);return}}}),define(J[17],Z([0,1,15,21,3,12,4,5,34,26,62]),function(H,e,h,D,T,_,k,P,u,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=e.MAX_HEAP_SIZE=e.MAX_FILE_SIZE=void 0;const d=300*1024*1024,v=16*1024*1024*1024,m=700*1024*1024,c=700*2*1024*1024;e.MAX_FILE_SIZE=process.arch==="ia32"?d:v,e.MAX_HEAP_SIZE=process.arch==="ia32"?m:c;var y;(function(S){S[S.UNLINK=0]="UNLINK",S[S.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function b(S,R=y.UNLINK){if(u.isRootOrDriveLetter(S))throw new Error("rimraf - will refuse to recursively delete root");return R===y.UNLINK?w(S):p(S)}e.rimraf=b;async function p(S){try{const R=T.join(D.tmpdir(),g.generateUuid());try{await h.promises.rename(S,R)}catch(N){return w(S)}w(R).catch(N=>{})}catch(R){if(R.code!=="ENOENT")throw R}}async function w(S){return h.promises.rmdir(S,{recursive:!0,maxRetries:3})}function l(S){if(u.isRootOrDriveLetter(S))throw new Error("rimraf - will refuse to recursively delete root");h.rmdirSync(S,{recursive:!0})}e.rimrafSync=l;async function o(S,R){return r(await(R?i(S):h.promises.readdir(S)))}e.readdir=o;async function i(S){try{return await h.promises.readdir(S,{withFileTypes:!0})}catch(U){console.warn("[node.js fs] readdir with filetypes failed with error: ",U)}const R=[],N=await o(S);for(const U of N){let $=!1,K=!1,Y=!1;try{const Q=await h.promises.lstat(T.join(S,U));$=Q.isFile(),K=Q.isDirectory(),Y=Q.isSymbolicLink()}catch(Q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Q)}R.push({name:U,isFile:()=>$,isDirectory:()=>K,isSymbolicLink:()=>Y})}return R}function t(S){return r(h.readdirSync(S))}e.readdirSync=t;function r(S){return S.map(R=>typeof R=="string"?k.isMacintosh?I.normalizeNFC(R):R:(R.name=k.isMacintosh?I.normalizeNFC(R.name):R.name,R))}async function s(S){const R=await o(S),N=[];for(const U of R)await n.existsDirectory(T.join(S,U))&&N.push(U);return N}e.readDirsInDir=s;function a(S,R=1e3){return new Promise(N=>{let U=!1;const $=setInterval(()=>{U||(U=!0,h.access(S,K=>{U=!1,K&&(clearInterval($),N(void 0))}))},R)})}e.whenDeleted=a;var n;(function(S){async function R($){let K;try{if(K=await h.promises.lstat($),!K.isSymbolicLink())return{stat:K}}catch(Y){}try{return{stat:await h.promises.stat($),symbolicLink:(K==null?void 0:K.isSymbolicLink())?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};if(k.isWindows&&Y.code==="EACCES")try{return{stat:await h.promises.stat(await h.promises.readlink($)),symbolicLink:{dangling:!1}}}catch(Q){if(Q.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};throw Q}throw Y}}S.stat=R;async function N($){try{const{stat:K,symbolicLink:Y}=await S.stat($);return K.isFile()&&(Y==null?void 0:Y.dangling)!==!0}catch(K){}return!1}S.existsFile=N;async function U($){try{const{stat:K,symbolicLink:Y}=await S.stat($);return K.isDirectory()&&(Y==null?void 0:Y.dangling)!==!0}catch(K){}return!1}S.existsDirectory=U})(n=e.SymlinkSupport||(e.SymlinkSupport={}));function f(S,R,N){const U=A(S);return O(U).queue(()=>{const $=G(N);return new Promise((K,Y)=>F(S,R,$,Q=>Q?Y(Q):K()))})}e.writeFile=f;const C=new Map;function A(S){let R=S;return(k.isWindows||k.isMacintosh)&&(R=R.toLowerCase()),R}function O(S){const R=C.get(S);if(R)return R;const N=new _.Queue;return C.set(S,N),P.Event.once(N.onFinished)(()=>{C.delete(S),N.dispose()}),N}let E=!0;function F(S,R,N,U){if(!E)return h.writeFile(S,R,{mode:N.mode,flag:N.flag},U);h.open(S,N.flag,N.mode,($,K)=>{if($)return U($);h.writeFile(K,R,Y=>{if(Y)return h.close(K,()=>U(Y));h.fdatasync(K,Q=>(Q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Q),E=!1),h.close(K,se=>U(se))))})})}function j(S,R,N){const U=G(N);if(!E)return h.writeFileSync(S,R,{mode:U.mode,flag:U.flag});const $=h.openSync(S,U.flag,U.mode);try{h.writeFileSync($,R);try{h.fdatasyncSync($)}catch(K){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",K),E=!1}}finally{h.closeSync($)}}e.writeFileSync=j;function G(S){return S?{mode:typeof S.mode=="number"?S.mode:438,flag:typeof S.flag=="string"?S.flag:"w"}:{mode:438,flag:"w"}}async function z(S,R){if(S!==R){async function N(U){try{const $=await h.promises.lstat(U);if($.isDirectory()||$.isSymbolicLink())return;const K=await h.promises.open(U,"a");try{await K.utimes($.atime,new Date)}finally{await K.close()}}catch($){}}try{await h.promises.rename(S,R),await N(R)}catch(U){if(S.toLowerCase()!==R.toLowerCase()&&U.code==="EXDEV"||S.endsWith("."))await W(S,R,{preserveSymlinks:!1}),await b(S,y.MOVE),await N(R);else throw U}}}e.move=z;async function W(S,R,N){return ee(S,R,{root:{source:S,target:R},options:N,handledSourcePaths:new Set})}e.copy=W;const q=511;async function ee(S,R,N){if(!N.handledSourcePaths.has(S)){N.handledSourcePaths.add(S);const{stat:U,symbolicLink:$}=await n.stat(S);if($){if($.dangling)return;if(N.options.preserveSymlinks)try{return await M(S,R,N)}catch(K){console.warn("[node.js fs] copy of symlink failed: ",K)}}return U.isDirectory()?te(S,R,U.mode&q,N):B(S,R,U.mode&q)}}async function te(S,R,N,U){await h.promises.mkdir(R,{recursive:!0,mode:N});const $=await o(S);for(const K of $)await ee(T.join(S,K),T.join(R,K),U)}async function B(S,R,N){await h.promises.copyFile(S,R),await h.promises.chmod(R,N)}async function M(S,R,N){let U=await h.promises.readlink(S);u.isEqualOrParent(U,N.root.source,!k.isLinux)&&(U=T.join(N.root.target,U.substr(N.root.source.length+1))),await h.promises.symlink(U,R)}async function L(S){try{return await h.promises.access(S),!0}catch(R){return!1}}e.exists=L}),define(J[101],Z([0,1,15,18,3,17]),function(H,e,h,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function k(I){const d=T.dirname(I);if(I===d)return I;const v=(T.basename(I)||I).toLowerCase();try{const c=_.readdirSync(d).filter(y=>y.toLowerCase()===v);if(c.length===1){const y=k(d);if(y)return T.join(y,c[0])}else if(c.length>1){const y=c.indexOf(v);if(y>=0){const b=k(d);if(b)return T.join(b,c[y])}}}catch(m){}return null}e.realcaseSync=k;async function P(I){try{return await h.promises.realpath(I)}catch(d){const v=g(I);return await h.promises.access(v,h.constants.R_OK),v}}e.realpath=P;function u(I){try{return h.realpathSync(I)}catch(d){const v=g(I);return h.accessSync(v,h.constants.R_OK),v}}e.realpathSync=u;function g(I){return D.rtrim(T.normalize(I),T.sep)}});var ke=this&&this.__await||function(H){return this instanceof ke?(this.v=H,this):new ke(H)},qe=this&&this.__asyncGenerator||function(H,e,h){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var D=h.apply(H,e||[]),T,_=[];return T={},k("next"),k("throw"),k("return"),T[Symbol.asyncIterator]=function(){return this},T;function k(v){D[v]&&(T[v]=function(m){return new Promise(function(c,y){_.push([v,m,c,y])>1||P(v,m)})})}function P(v,m){try{u(D[v](m))}catch(c){d(_[0][3],c)}}function u(v){v.value instanceof ke?Promise.resolve(v.value.v).then(g,I):d(_[0][2],v)}function g(v){P("next",v)}function I(v){P("throw",v)}function d(v,m){v(m),_.shift(),_.length&&P(_[0][0],_[0][1])}},Ge=this&&this.__asyncValues||function(H){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=H[Symbol.asyncIterator],h;return e?e.call(H):(H=typeof __values=="function"?__values(H):H[Symbol.iterator](),h={},D("next"),D("throw"),D("return"),h[Symbol.asyncIterator]=function(){return this},h);function D(_){h[_]=H[_]&&function(k){return new Promise(function(P,u){k=H[_](k),T(P,u,k.done,k.value)})}}function T(_,k,P,u){Promise.resolve(u).then(function(g){_({value:g,done:P})},k)}};define(J[102],Z([0,1,17,21,3,33]),function(H,e,h,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,P=/^Microsoft.PowerShell_.*/,u=/^Microsoft.PowerShellPreview_.*/;var g;(function(i){i[i.x64=0]="x64",i[i.x86=1]="x86",i[i.ARM=2]="ARM"})(g||(g={}));let I;switch(process.arch){case"ia32":case"x32":I=1;break;case"arm":case"arm64":I=2;break;default:I=0;break}let d;process.env.PROCESSOR_ARCHITEW6432?d=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?d=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?d=1:d=0;class v{constructor(t,r,s){this.exePath=t,this.displayName=r,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await h.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:i=!1}={}){return i?I===0?_.env["ProgramFiles(x86)"]||null:d===0&&_.env.ProgramW6432||null:_.env.ProgramFiles||null}async function c({useAlternateBitness:i=!1,findPreview:t=!1}={}){const r=m({useAlternateBitness:i});if(!r)return null;const s=T.join(r,"PowerShell");if(!await h.SymlinkSupport.existsDirectory(s))return null;let a=-1,n=null;for(const A of await h.readdir(s)){let O=-1;if(t){const F=A.indexOf("-");if(F<0)continue;const j=A.substring(0,F);if(!k.test(j)||A.substring(F+1)!=="preview")continue;O=parseInt(j,10)}else{if(!k.test(A))continue;O=parseInt(A,10)}if(!(O<=a)){const E=T.join(s,A,"pwsh.exe");!await h.SymlinkSupport.existsFile(E)||(n=E,a=O)}}if(!n)return null;const f=r.includes("x86")?" (x86)":"",C=t?" Preview":"";return new v(n,`PowerShell${C}${f}`,!0)}async function y({findPreview:i}={}){if(!_.env.LOCALAPPDATA)return null;const t=T.join(_.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await h.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:r,pwshMsixName:s}=i?{pwshMsixDirRegex:u,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:P,pwshMsixName:"PowerShell (Store)"};try{for(const a of await h.readdir(t))if(r.test(a)){const n=T.join(t,a,"pwsh.exe");return new v(n,s)}}catch(a){console.warn(`Unable to read MSIX directory (${t}) because of the following error: ${a}`)}return null}function b(){const i=T.join(D.homedir(),".dotnet","tools","pwsh.exe");return new v(i,".NET Core PowerShell Global Tool")}function p(){const i=T.join(_.env.windir,I===1&&d!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(i,"Windows PowerShell",!0)}function w(){return qe(this,arguments,function*(){let t=yield ke(c());t&&(yield yield ke(t)),t=yield ke(c({useAlternateBitness:!0})),t&&(yield yield ke(t)),t=yield ke(y()),t&&(yield yield ke(t)),t=b(),t&&(yield yield ke(t)),t=yield ke(c({findPreview:!0})),t&&(yield yield ke(t)),t=yield ke(y({findPreview:!0})),t&&(yield yield ke(t)),t=yield ke(c({useAlternateBitness:!0,findPreview:!0})),t&&(yield yield ke(t)),t=p(),t&&(yield yield ke(t))})}function l(){return qe(this,arguments,function*(){var t,r;try{for(var s=Ge(w()),a;a=yield ke(s.next()),!a.done;){const n=a.value;(yield ke(n.exists()))&&(yield yield ke(n))}}catch(n){t={error:n}}finally{try{a&&!a.done&&(r=s.return)&&(yield ke(r.call(s)))}finally{if(t)throw t.error}}})}e.enumeratePowerShellInstallations=l;async function o(){var i,t;try{for(var r=Ge(l()),s;s=await r.next(),!s.done;)return s.value}catch(a){i={error:a}}finally{try{s&&!s.done&&(t=r.return)&&await t.call(r)}finally{if(i)throw i.error}}return null}e.getFirstAvailablePowerShellInstallation=o}),define(J[103],Z([0,1,35,201,202]),function(H,e,h,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.monkeyPatch=void 0;function _(u){if(P()){const g=H("http"),I=H("https"),d=k(u);g.globalAgent=d,I.globalAgent=d}}e.monkeyPatch=_;function k(u){return u?new D:new D.default}function P(){let u=!1;const g=T.getProxyForUrl("http://example.com");g&&(u=!0,h.logger.debug(`using $HTTP_PROXY ${g}`));const I=T.getProxyForUrl("https://example.com");return I&&(u=!0,h.logger.debug(`using $HTTPS_PROXY ${I}`)),u}}),function(){"use strict";function H(e,h,D){function T(){let _=process.env.VSCODE_APPDATA;if(!_)switch(process.platform){case"win32":if(_=process.env.APPDATA,!_){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");_=e.join(k,"AppData","Roaming")}break;case"darwin":_=e.join(h.homedir(),"Library","Application Support");break;case"linux":_=process.env.XDG_CONFIG_HOME||e.join(h.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(_,D)}return{getDefaultUserDataPath:T}}if(typeof define=="function")define(J[104],Z([0,37,21,11,19]),function(e,h,D,T,_){const k=_.dirname(T.FileAccess.asFileUri("",e)),P=e.__$__nodeRequire(_.joinPath(k,"package.json").fsPath);return H(h,D,P.name)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../package.json"),h=require("path"),D=require("os");module.exports=H(h,D,e.name)}else throw new Error("Unknown context")}(),define(J[105],Z([0,1,3,15,4,62,2,17]),function(H,e,h,D,T,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function u(d,v,m){return I({path:d,isDirectory:!1},v,m)}e.watchFile=u;function g(d,v,m){return I({path:d,isDirectory:!0},v,m)}e.watchFolder=g,e.CHANGE_BUFFER_DELAY=100;function I(d,v,m){const c=h.basename(d.path),y=new Map;let b=!1,p=[k.toDisposable(()=>{y.forEach(w=>k.dispose(w)),y.clear()})];try{const w=D.watch(d.path);p.push(k.toDisposable(()=>{w.removeAllListeners(),w.close()}));const l=new Set;d.isDirectory&&P.readdir(d.path).then(o=>o.forEach(i=>l.add(i))),w.on("error",(o,i)=>{b||m(`Failed to watch ${d.path} for changes using fs.watch() (${o}, ${i})`)}),w.on("change",(o,i)=>{if(!b){let t="";if(i&&(t=i.toString(),T.isMacintosh&&(t=_.normalizeNFC(t))),!(!t||o!=="change"&&o!=="rename")){const r=d.isDirectory?h.join(d.path,t):d.path;if(d.isDirectory)if(o==="rename"){const s=y.get(r);s&&k.dispose(s);const a=setTimeout(async()=>{y.delete(r);const n=await P.exists(r);if(!b){let f;n?l.has(t)?f="changed":(f="added",l.add(t)):(l.delete(t),f="deleted"),v(f,r)}},e.CHANGE_BUFFER_DELAY);y.set(r,k.toDisposable(()=>clearTimeout(a)))}else{let s;l.has(t)?s="changed":(s="added",l.add(t)),v(s,r)}else if(o==="rename"||t!==c){const s=setTimeout(async()=>{const a=await P.exists(r);b||(a?(v("changed",r),p=[I(d,v,m)]):v("deleted",r))},e.CHANGE_BUFFER_DELAY);k.dispose(p),p=[k.toDisposable(()=>clearTimeout(s))]}else v("changed",r)}}})}catch(w){P.exists(d.path).then(l=>{l&&!b&&m(`Failed to watch ${d.path} for changes using fs.watch() (${w.toString()})`)})}return k.toDisposable(()=>{b=!0,p=k.dispose(p)})}}),define(J[36],Z([0,1,5,2,12,25,14,16,22,10,96,18]),function(H,e,h,D,T,_,k,P,u,g,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function m(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(c=e.ResponseType||(e.ResponseType={}));function y(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(b||(b={}));class p{constructor(L){this.buffer=L,this.pos=0}read(L){const S=this.buffer.slice(this.pos,this.pos+L);return this.pos+=S.byteLength,S}}class w{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(L){this.buffers.push(L)}}var l;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(l||(l={}));function o(M){const L=P.VSBuffer.alloc(4);return L.writeUInt32BE(M,0),L}function i(M){return M.read(4).readUInt32BE(0)}function t(M){const L=P.VSBuffer.alloc(1);return L.writeUInt8(M,0),L}const r={Undefined:t(l.Undefined),String:t(l.String),Buffer:t(l.Buffer),VSBuffer:t(l.VSBuffer),Array:t(l.Array),Object:t(l.Object)},s=typeof Buffer!="undefined";function a(M,L){if(typeof L=="undefined")M.write(r.Undefined);else if(typeof L=="string"){const S=P.VSBuffer.fromString(L);M.write(r.String),M.write(o(S.byteLength)),M.write(S)}else if(s&&Buffer.isBuffer(L)){const S=P.VSBuffer.wrap(L);M.write(r.Buffer),M.write(o(S.byteLength)),M.write(S)}else if(L instanceof P.VSBuffer)M.write(r.VSBuffer),M.write(o(L.byteLength)),M.write(L);else if(Array.isArray(L)){M.write(r.Array),M.write(o(L.length));for(const S of L)a(M,S)}else{const S=P.VSBuffer.fromString(JSON.stringify(L));M.write(r.Object),M.write(o(S.byteLength)),M.write(S)}}function n(M){switch(M.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return M.read(i(M)).toString();case l.Buffer:return M.read(i(M)).buffer;case l.VSBuffer:return M.read(i(M));case l.Array:{const S=i(M),R=[];for(let N=0;N<S;N++)R.push(n(M));return R}case l.Object:return JSON.parse(M.read(i(M)).toString())}}class f{constructor(L,S,R=null,N=1e3){this.protocol=L,this.ctx=S,this.logger=R,this.timeoutDelay=N,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(U=>this.onRawMessage(U)),this.sendResponse({type:200})}registerChannel(L,S){this.channels.set(L,S),setTimeout(()=>this.flushPendingRequests(L),0)}sendResponse(L){switch(L.type){case 200:{const S=this.send([L.type]);this.logger&&this.logger.logOutgoing(S,0,1,y(L.type));return}case 201:case 202:case 204:case 203:{const S=this.send([L.type,L.id],L.data);this.logger&&this.logger.logOutgoing(S,L.id,1,y(L.type),L.data);return}}}send(L,S=void 0){const R=new w;return a(R,L),a(R,S),this.sendBuffer(R.buffer)}sendBuffer(L){try{return this.protocol.send(L),L.byteLength}catch(S){return 0}}onRawMessage(L){const S=new p(L),R=n(S),N=n(S),U=R[0];switch(U){case 100:return this.logger&&this.logger.logIncoming(L.byteLength,R[1],1,`${m(U)}: ${R[2]}.${R[3]}`,N),this.onPromise({type:U,id:R[1],channelName:R[2],name:R[3],arg:N});case 102:return this.logger&&this.logger.logIncoming(L.byteLength,R[1],1,`${m(U)}: ${R[2]}.${R[3]}`,N),this.onEventListen({type:U,id:R[1],channelName:R[2],name:R[3],arg:N});case 101:return this.logger&&this.logger.logIncoming(L.byteLength,R[1],1,`${m(U)}`),this.disposeActiveRequest({type:U,id:R[1]});case 103:return this.logger&&this.logger.logIncoming(L.byteLength,R[1],1,`${m(U)}`),this.disposeActiveRequest({type:U,id:R[1]})}}onPromise(L){const S=this.channels.get(L.channelName);if(!S){this.collectPendingRequest(L);return}const R=new _.CancellationTokenSource;let N;try{N=S.call(this.ctx,L.name,L.arg,R.token)}catch(K){N=Promise.reject(K)}const U=L.id;N.then(K=>{this.sendResponse({id:U,data:K,type:201}),this.activeRequests.delete(L.id)},K=>{K instanceof Error?this.sendResponse({id:U,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.sendResponse({id:U,data:K,type:203}),this.activeRequests.delete(L.id)});const $=D.toDisposable(()=>R.cancel());this.activeRequests.set(L.id,$)}onEventListen(L){const S=this.channels.get(L.channelName);if(!S){this.collectPendingRequest(L);return}const R=L.id,U=S.listen(this.ctx,L.name,L.arg)($=>this.sendResponse({id:R,data:$,type:204}));this.activeRequests.set(L.id,U)}disposeActiveRequest(L){const S=this.activeRequests.get(L.id);S&&(S.dispose(),this.activeRequests.delete(L.id))}collectPendingRequest(L){let S=this.pendingRequests.get(L.channelName);S||(S=[],this.pendingRequests.set(L.channelName,S));const R=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.sendResponse({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);S.push({request:L,timeoutTimer:R})}flushPendingRequests(L){const S=this.pendingRequests.get(L);if(S){for(const R of S)switch(clearTimeout(R.timeoutTimer),R.request.type){case 100:this.onPromise(R.request);break;case 102:this.onEventListen(R.request);break}this.pendingRequests.delete(L)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(L=>L.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var C;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(C=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(L,S=null){this.protocol=L,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(R=>this.onBuffer(R)),this.logger=S}getChannel(L){const S=this;return{call(R,N,U){return S.isDisposed?Promise.reject(k.canceled()):S.requestPromise(L,R,N,U)},listen(R,N){return S.isDisposed?Promise.reject(k.canceled()):S.requestEvent(L,R,N)}}}requestPromise(L,S,R,N=_.CancellationToken.None){const U=this.lastRequestId++,K={id:U,type:100,channelName:L,name:S,arg:R};if(N.isCancellationRequested)return Promise.reject(k.canceled());let Y;return new Promise((se,oe)=>{if(N.isCancellationRequested)return oe(k.canceled());const ce=()=>{const Re=Ae=>{switch(Ae.type){case 201:this.handlers.delete(U),se(Ae.data);break;case 202:this.handlers.delete(U);const Se=new Error(Ae.data.message);Se.stack=Ae.data.stack,Se.name=Ae.data.name,oe(Se);break;case 203:this.handlers.delete(U),oe(Ae.data);break}};this.handlers.set(U,Re),this.sendRequest(K)};let he=null;this.state===b.Idle?ce():(he=T.createCancelablePromise(Re=>this.whenInitialized()),he.then(()=>{he=null,ce()}));const _e=()=>{he?(he.cancel(),he=null):this.sendRequest({id:U,type:101}),oe(k.canceled())},Pe=N.onCancellationRequested(_e);Y=D.combinedDisposable(D.toDisposable(_e),Pe),this.activeRequests.add(Y)}).finally(()=>{this.activeRequests.delete(Y)})}requestEvent(L,S,R){const N=this.lastRequestId++,$={id:N,type:102,channelName:L,name:S,arg:R};let K=null;const Y=new h.Emitter({onFirstListenerAdd:()=>{K=T.createCancelablePromise(se=>this.whenInitialized()),K.then(()=>{K=null,this.activeRequests.add(Y),this.sendRequest($)})},onLastListenerRemove:()=>{K?(K.cancel(),K=null):(this.activeRequests.delete(Y),this.sendRequest({id:N,type:103}))}}),Q=se=>Y.fire(se.data);return this.handlers.set(N,Q),Y.event}sendRequest(L){switch(L.type){case 100:case 102:{const S=this.send([L.type,L.id,L.channelName,L.name],L.arg);this.logger&&this.logger.logOutgoing(S,L.id,0,`${m(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const S=this.send([L.type,L.id]);this.logger&&this.logger.logOutgoing(S,L.id,0,m(L.type));return}}}send(L,S=void 0){const R=new w;return a(R,L),a(R,S),this.sendBuffer(R.buffer)}sendBuffer(L){try{return this.protocol.send(L),L.byteLength}catch(S){return 0}}onBuffer(L){const S=new p(L),R=n(S),N=n(S),U=R[0];switch(U){case 200:return this.logger&&this.logger.logIncoming(L.byteLength,0,0,y(U)),this.onResponse({type:R[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(L.byteLength,R[1],0,y(U),N),this.onResponse({type:R[0],id:R[1],data:N})}}onResponse(L){if(L.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const S=this.handlers.get(L.id);S&&S(L)}whenInitialized(){return this.state===b.Idle?Promise.resolve():h.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(L=>L.dispose()),this.activeRequests.clear()}}e.ChannelClient=A;class O{constructor(L){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,L(({protocol:S,onDidClientDisconnect:R})=>{h.Event.once(S.onMessage)(U=>{const $=new p(U),K=n($),Y=new f(S,K),Q=new A(S);this.channels.forEach((oe,ce)=>Y.registerChannel(ce,oe));const se={channelServer:Y,channelClient:Q,ctx:K};this._connections.add(se),this._onDidAddConnection.fire(se),R(()=>{Y.dispose(),Q.dispose(),this._connections.delete(se),this._onDidRemoveConnection.fire(se)})})})}get connections(){const L=[];return this._connections.forEach(S=>L.push(S)),L}getChannel(L,S){const R=this;return{call(N,U,$){let K;if(g.isFunction(S)){let Q=u.getRandomElement(R.connections.filter(S));K=Q?Promise.resolve(Q):h.Event.toPromise(h.Event.filter(R.onDidAddConnection,S))}else K=S.routeCall(R,N,U);const Y=K.then(Q=>Q.channelClient.getChannel(L));return F(Y).call(N,U,$)},listen(N,U){if(g.isFunction(S))return R.getMulticastEvent(L,S,N,U);const $=S.routeEvent(R,N,U).then(K=>K.channelClient.getChannel(L));return F($).listen(N,U)}}}getMulticastEvent(L,S,R,N){const U=this;let $=new D.DisposableStore;const K=new h.Emitter({onFirstListenerAdd:()=>{$=new D.DisposableStore;const Y=new h.EventMultiplexer,Q=new Map,se=ce=>{const _e=ce.channelClient.getChannel(L).listen(R,N),Pe=Y.add(_e);Q.set(ce,Pe)},oe=ce=>{const he=Q.get(ce);!he||(he.dispose(),Q.delete(ce))};U.connections.filter(S).forEach(se),h.Event.filter(U.onDidAddConnection,S)(se,void 0,$),U.onDidRemoveConnection(oe,void 0,$),Y.event(K.fire,K,$),$.add(Y)},onLastListenerRemove:()=>{$.dispose()}});return K.event}registerChannel(L,S){this.channels.set(L,S),this._connections.forEach(R=>{R.channelServer.registerChannel(L,S)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=O;class E{constructor(L,S,R=null){const N=new w;a(N,S),L.send(N.buffer),this.channelClient=new A(L,R),this.channelServer=new f(L,S,R)}getChannel(L){return this.channelClient.getChannel(L)}registerChannel(L,S){this.channelServer.registerChannel(L,S)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=E;function F(M){return{call(L,S,R){return M.then(N=>N.call(L,S,R))},listen(L,S){const R=new h.Relay;return M.then(N=>R.input=N.listen(L,S)),R.event}}}e.getDelayedChannel=F;function j(M){let L=!1;return{call(S,R,N){return L?M.call(S,R,N):T.timeout(0).then(()=>L=!0).then(()=>M.call(S,R,N))},listen(S,R){if(L)return M.listen(S,R);const N=new h.Relay;return T.timeout(0).then(()=>L=!0).then(()=>N.input=M.listen(S,R)),N.event}}}e.getNextTickChannel=j;class G{constructor(L){this.fn=L}routeCall(L){return this.route(L)}routeEvent(L){return this.route(L)}async route(L){for(const S of L.connections)if(await Promise.resolve(this.fn(S.ctx)))return Promise.resolve(S);return await h.Event.toPromise(L.onDidAddConnection),await this.route(L)}}e.StaticRouter=G;var z;(function(M){function L(N,U){const $=N,K=U&&U.disableMarshalling,Y=new Map;for(const Q in $)R(Q)&&Y.set(Q,h.Event.buffer($[Q],!0));return new class{listen(Q,se){const oe=Y.get(se);if(oe)return oe;throw new Error(`Event not found: ${se}`)}call(Q,se,oe){const ce=$[se];if(typeof ce=="function"){if(!K&&Array.isArray(oe))for(let he=0;he<oe.length;he++)oe[he]=I.revive(oe[he]);return ce.apply($,oe)}throw new Error(`Method not found: ${se}`)}}}M.fromService=L;function S(N,U){const $=U&&U.disableMarshalling;return new Proxy({},{get(K,Y){var Q;if(typeof Y=="string")return((Q=U==null?void 0:U.properties)===null||Q===void 0?void 0:Q.has(Y))?U.properties.get(Y):R(Y)?N.listen(Y):async function(...se){let oe;U&&!g.isUndefinedOrNull(U.context)?oe=[U.context,...se]:oe=se;const ce=await N.call(Y,oe);return $?ce:I.revive(ce)};throw new Error(`Property not found: ${String(Y)}`)}})}M.toService=S;function R(N){return N[0]==="o"&&N[1]==="n"&&d.isUpperAsciiLetter(N.charCodeAt(2))}})(z=e.ProxyChannel||(e.ProxyChannel={}));const W=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function q(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let L=M.toString();if(L!=="[object Object]")return L}return M}function ee(M){return Array.isArray(M)?M.map(q):q(M)}function te(M,L,S,R,N,U,$){$=ee($);const K=W[N],Y=K[R%K.length];let Q=[`%c[${M}]%c[${String(L).padStart(7," ")}]%c[len: ${String(S).padStart(5," ")}]%c${String(R).padStart(5," ")} - ${U}`,"color: darkgreen","color: grey","color: grey",`color: ${Y}`];/\($/.test(U)?(Q=Q.concat($),Q.push(")")):Q.push($),console.log.apply(console,Q)}e.logWithColors=te;class B{constructor(L,S){this._outgoingPrefix=L,this._incomingPrefix=S,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(L,S,R,N,U){this._totalOutgoing+=L,te(this._outgoingPrefix,this._totalOutgoing,L,S,R,N,U)}logIncoming(L,S,R,N,U){this._totalIncoming+=L,te(this._incomingPrefix,this._totalIncoming,L,S,R,N,U)}}e.IPCLogger=B}),define(J[65],Z([0,1,5,36,2,16,4,33]),function(H,e,h,D,T,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let u=null;function g(){return u||(u=_.VSBuffer.alloc(0)),u}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,a){if(s===0)return g();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const A=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=s),A}if(this._chunks[0].byteLength>s){const A=this._chunks[0].slice(0,s);return a&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),A}let n=_.VSBuffer.alloc(s),f=0,C=0;for(;s>0;){const A=this._chunks[C];if(A.byteLength>s){const O=A.slice(0,s);n.set(O,f),f+=s,a&&(this._chunks[C]=A.slice(s),this._totalLength-=s),s-=s}else n.set(A,f),f+=A.byteLength,a?(this._chunks.shift(),this._totalLength-=A.byteLength):C++,s-=A.byteLength}return n}}e.ChunkStream=I;var d;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(d||(d={}));var v;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class m{constructor(s,a,n,f){this.type=s,this.id=a,this.ack=n,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends T.Disposable{constructor(s){super();this._onMessage=this._register(new h.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const n=this._state.messageType,f=this._state.id,C=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new m(n,f,C,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class y{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(!this._isDisposed){s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=_.VSBuffer.alloc(13);a.writeUInt8(s.type,0),a.writeUInt32BE(s.id,1),a.writeUInt32BE(s.ack,5),a.writeUInt32BE(s.data.byteLength,9),this._writeSoon(a,s.data)}}_bufferAdd(s,a){const n=this._totalLength===0;return this._data.push(s,a),this._totalLength+=s.byteLength+a.byteLength,n}_bufferTake(){const s=_.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,a){this._bufferAdd(s,a)&&k.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class b extends T.Disposable{constructor(s){super();this._onMessage=new h.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new h.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new y(this._socket)),this._socketReader=this._register(new c(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new m(1,0,0,s))}}e.Protocol=b;class p extends D.IPCClient{constructor(s,a,n=null){super(s,a,n);this.protocol=s}static fromSocket(s,a){return new p(new b(s),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=p;class w{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new h.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=w;class l{constructor(s){this.data=s,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],a=0,n=this._first;for(;n;)s[a++]=n.data,n=n.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const a=new l(s);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class i{constructor(){this.lastRuns=[];const s=Date.now();for(let a=0;a<i._HISTORY_LENGTH;a++)this.lastRuns[a]=s-1e3*a;setInterval(()=>{for(let a=i._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return i._INSTANCE||(i._INSTANCE=new i),i._INSTANCE}load(){const s=Date.now(),a=(1+i._HISTORY_LENGTH)*1e3;let n=0;for(let f=0;f<i._HISTORY_LENGTH;f++)s-this.lastRuns[f]<=a&&n++;return 1-n/i._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}i._HISTORY_LENGTH=10,i._INSTANCE=null;class t{constructor(s,a=null){this._loadEstimator=i.getInstance(),this._onControlMessage=new w,this.onControlMessage=this._onControlMessage.event,this._onMessage=new w,this.onMessage=this._onMessage.event,this._onDidDispose=new w,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new w,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new w,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new c(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(n=>this._receiveMessage(n))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=T.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new m(5,0,0,g());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const a=new m(4,0,0,g());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,a){this._isReconnecting=!0,this._socketDisposables=T.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new c(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(n=>this._receiveMessage(n))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let a=0,n=s.length;a<n;a++)this._socketWriter.write(s[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new m(6,0,0,g())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const a=this._outgoingUnackMsg.toArray();for(let n=0,f=a.length;n<f;n++)this._socketWriter.write(a[n]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const n=new m(1,a,this._incomingAckId,s);this._outgoingUnackMsg.push(n),this._isReconnecting||(this._socketWriter.write(n),this._recvAckCheck())}sendControl(s){const a=new m(2,0,0,s);this._socketWriter.write(a)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const s=this._outgoingUnackMsg.peek(),a=Date.now()-s.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const s=new m(3,0,this._incomingAckId,g());this._socketWriter.write(s)}}}e.PersistentProtocol=t}),define(J[106],Z([0,1,2,5,12,10]),function(H,e,h,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var k;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));var P;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(P||(P={}));class u extends h.Disposable{constructor(d,v=Object.create(null)){super();this.database=d,this.options=v,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=P.None,this.cache=new Map,this.flushDelayer=new T.ThrottledDelayer(u.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){var v,m;(v=d.changed)===null||v===void 0||v.forEach((c,y)=>this.accept(y,c)),(m=d.deleted)===null||m===void 0||m.forEach(c=>this.accept(c,void 0))}accept(d,v){if(this.state!==P.Closed){let m=!1;_.isUndefinedOrNull(v)?m=this.cache.delete(d):this.cache.get(d)!==v&&(this.cache.set(d,v),m=!0),m&&this._onDidChangeStorage.fire(d)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===P.None&&(this.state=P.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,v){const m=this.cache.get(d);return _.isUndefinedOrNull(m)?v:m}getBoolean(d,v){const m=this.get(d);return _.isUndefinedOrNull(m)?v:m==="true"}getNumber(d,v){const m=this.get(d);return _.isUndefinedOrNull(m)?v:parseInt(m,10)}async set(d,v){if(this.state!==P.Closed){if(_.isUndefinedOrNull(v))return this.delete(d);const m=String(v);if(this.cache.get(d)!==m)return this.cache.set(d,m),this.pendingInserts.set(d,m),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(d){if(this.state!==P.Closed&&!!this.cache.delete(d))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=P.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(d){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{var v;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(v=this.whenFlushedCallbacks.pop())===null||v===void 0||v()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=u,u.DEFAULT_FLUSH_DELAY=100;class g{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((v,m)=>this.items.set(m,v)),d.delete&&d.delete.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=g}),define(J[107],Z([8,9]),function(H,e){return H.create("vs/base/common/actions",e)}),define(J[108],Z([0,1,107,2,5]),function(H,e,h,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class _ extends D.Disposable{constructor(v,m="",c="",y=!0,b){super();this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._checked=!1,this._id=v,this._label=m,this._cssClass=c,this._enabled=y,this._actionCallback=b}get id(){return this._id}get label(){return this._label}set label(v){this._setLabel(v)}_setLabel(v){this._label!==v&&(this._label=v,this._onDidChange.fire({label:v}))}get tooltip(){return this._tooltip||""}set tooltip(v){this._setTooltip(v)}_setTooltip(v){this._tooltip!==v&&(this._tooltip=v,this._onDidChange.fire({tooltip:v}))}get class(){return this._cssClass}set class(v){this._setClass(v)}_setClass(v){this._cssClass!==v&&(this._cssClass=v,this._onDidChange.fire({class:v}))}get enabled(){return this._enabled}set enabled(v){this._setEnabled(v)}_setEnabled(v){this._enabled!==v&&(this._enabled=v,this._onDidChange.fire({enabled:v}))}get checked(){return this._checked}set checked(v){this._setChecked(v)}_setChecked(v){this._checked!==v&&(this._checked=v,this._onDidChange.fire({checked:v}))}run(v,m){return this._actionCallback?this._actionCallback(v):Promise.resolve(!0)}}e.Action=_;class k extends D.Disposable{constructor(){super(...arguments);this._onBeforeRun=this._register(new T.Emitter),this.onBeforeRun=this._onBeforeRun.event,this._onDidRun=this._register(new T.Emitter),this.onDidRun=this._onDidRun.event}async run(v,m){if(!v.enabled)return Promise.resolve(null);this._onBeforeRun.fire({action:v});try{const c=await this.runAction(v,m);this._onDidRun.fire({action:v,result:c})}catch(c){this._onDidRun.fire({action:v,error:c})}}runAction(v,m){const c=m?v.run(m):v.run();return Promise.resolve(c)}}e.ActionRunner=k;class P extends _{constructor(v){super(P.ID,v,v?"separator text":"separator");this.checked=!1,this.enabled=!1}}e.Separator=P,P.ID="vs.actions.separator";class u{constructor(v,m,c,y){this.tooltip="",this.enabled=!0,this.checked=!1,this.id=v,this.label=m,this.class=y,this._actions=c}dispose(){}get actions(){return this._actions}async run(){}}e.SubmenuAction=u;class g extends _{constructor(){super(g.ID,h.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=g,g.ID="vs.actions.empty";function I(d){var v,m;return{id:d.id,label:d.label,class:void 0,enabled:(v=d.enabled)!==null&&v!==void 0?v:!0,checked:(m=d.checked)!==null&&m!==void 0?m:!1,run:async()=>d.run(),tooltip:d.label,dispose:()=>{}}}e.toAction=I}),define(J[109],Z([8,9]),function(H,e){return H.create("vs/base/common/date",e)}),define(J[110],Z([0,1,109]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const D=60,T=D*60,_=T*24,k=_*7,P=_*30,u=_*365;function g(d,v){typeof d!="number"&&(d=d.getTime());const m=Math.round((new Date().getTime()-d)/1e3);if(m<-30)return h.localize(0,null,g(new Date().getTime()+m*1e3,!1));if(m<30)return h.localize(1,null);let c;return m<D?(c=m,v?c===1?h.localize(2,null,c):h.localize(3,null,c):c===1?h.localize(4,null,c):h.localize(5,null,c)):m<T?(c=Math.floor(m/D),v?c===1?h.localize(6,null,c):h.localize(7,null,c):c===1?h.localize(8,null,c):h.localize(9,null,c)):m<_?(c=Math.floor(m/T),v?c===1?h.localize(10,null,c):h.localize(11,null,c):c===1?h.localize(12,null,c):h.localize(13,null,c)):m<k?(c=Math.floor(m/_),v?c===1?h.localize(14,null,c):h.localize(15,null,c):c===1?h.localize(16,null,c):h.localize(17,null,c)):m<P?(c=Math.floor(m/k),v?c===1?h.localize(18,null,c):h.localize(19,null,c):c===1?h.localize(20,null,c):h.localize(21,null,c)):m<u?(c=Math.floor(m/P),v?c===1?h.localize(22,null,c):h.localize(23,null,c):c===1?h.localize(24,null,c):h.localize(25,null,c)):(c=Math.floor(m/u),v?c===1?h.localize(26,null,c):h.localize(27,null,c):c===1?h.localize(28,null,c):h.localize(29,null,c))}e.fromNow=g;function I(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(J[111],Z([8,9]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(J[38],Z([0,1,111,10,22]),function(H,e,h,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function _(g,I){return I&&(g.stack||g.stacktrace)?h.localize(0,null,P(g),k(g.stack)||k(g.stacktrace)):P(g)}function k(g){return Array.isArray(g)?g.join(`
`):g}function P(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?h.localize(1,null,g.message):g.message||h.localize(2,null)}function u(g=null,I=!1){if(!g)return h.localize(3,null);if(Array.isArray(g)){const d=T.coalesce(g),v=u(d[0],I);return d.length>1?h.localize(4,null,v,d.length):v}if(D.isString(g))return g;if(g.detail){const d=g.detail;if(d.error)return _(d.error,I);if(d.exception)return _(d.exception,I)}return g.stack?_(g,I):g.message?g.message:h.localize(5,null)}e.toErrorMessage=u}),define(J[112],Z([8,9]),function(H,e){return H.create("vs/base/common/jsonErrorMessages",e)}),define(J[113],Z([0,1,112]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function D(T){switch(T){case 1:return h.localize(0,null);case 2:return h.localize(1,null);case 3:return h.localize(2,null);case 4:return h.localize(3,null);case 5:return h.localize(4,null);case 6:return h.localize(5,null);case 7:return h.localize(6,null);case 8:return h.localize(7,null);case 9:return h.localize(8,null);default:return""}}e.getParseErrorMessage=D}),define(J[114],Z([8,9]),function(H,e){return H.create("vs/base/node/processes",e)}),define(J[66],Z([0,1,3,15,17,39,114,10,20,34,4,64,11]),function(H,e,h,D,T,_,k,P,u,g,I,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function m(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(o,i){if(I.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};i&&(t.cwd=i);const r=_.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(s=>{r.once("error",a=>{s({success:!1,error:a})}),r.once("exit",(a,n)=>{s(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?m(t.status):1})}else if(I.isLinux||I.isMacintosh)try{const t=v.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",H).fsPath;return new Promise(r=>{_.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(s,a,n)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function y(o=process.env){return o.comspec||"cmd.exe"}e.getWindowsShell=y;class b{constructor(i,t,r,s){if(t!==void 0&&r!==void 0&&s!==void 0)this.cmd=i,this.args=t,this.shell=r,this.options=s;else{const a=i;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(process.env).forEach(n=>{a[n]=process.env[n]}),Object.keys(this.options.env).forEach(n=>{a[n]=this.options.env[n]}),this.options.env=a}}getSanitizedCommand(){let i=this.cmd.toLowerCase();const t=i.lastIndexOf(h.sep);return t!==-1&&(i=i.substring(t+1)),b.WellKnowCommands[i]?i:"other"}start(i){return I.isWindows&&(this.options&&this.options.cwd&&g.isUNC(this.options.cwd)||!this.options&&g.isUNC(process.cwd()))?Promise.reject(new Error(k.localize(0,null))):this.useExec().then(t=>{let r,s;const a=new Promise((n,f)=>{r=n,s=f});if(t){let n=this.cmd;this.args&&(n=n+" "+this.args.join(" ")),this.childProcess=_.exec(n,this.options,(f,C,A)=>{this.childProcess=null;const O=f;O&&O.killed?s({killed:this.terminateRequested,stdout:C.toString(),stderr:A.toString()}):this.handleExec(r,i,f,C,A)})}else{let n=null;const f=C=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(C,r,i,s);const A={terminated:this.terminateRequested};P.isNumber(C)&&(A.cmdCode=C),r(A)};if(this.shell&&I.isWindows){const C=u.deepClone(this.options);C.windowsVerbatimArguments=!0,C.detached=!1;let A=!1,O=!1;const E=[];let F=this.ensureQuotes(this.cmd);E.push(F.value),A=F.quoted,this.args&&this.args.forEach(G=>{F=this.ensureQuotes(G),E.push(F.value),O=O&&F.quoted});const j=["/s","/c"];A?O?j.push('"'+E.join(" ")+'"'):E.length>1?j.push('"'+E[0]+'" '+E.slice(1).join(" ")):j.push('"'+E[0]+'"'):j.push(E.join(" ")),n=_.spawn(y(),j,C)}else this.cmd&&(n=_.spawn(this.cmd,this.args,this.options));n&&(this.childProcess=n,this.childProcessPromise=Promise.resolve(n),this.pidResolve&&(this.pidResolve(P.isNumber(n.pid)?n.pid:-1),this.pidResolve=void 0),n.on("error",C=>{this.childProcess=null,s({terminated:this.terminateRequested,error:C})}),n.pid&&(this.childProcess.on("close",f),this.handleSpawn(n,r,i,s,!0)))}return a})}handleClose(i,t,r,s){}ensureQuotes(i){return b.regexp.test(i)?{value:'"'+i+'"',quoted:!0}:{value:i,quoted:i.length>0&&i[0]==='"'&&i[i.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(i=>i.pid,i=>-1):new Promise(i=>{this.pidResolve=i})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(i=>(this.terminateRequested=!0,c(i,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),i=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(i=>{if(!this.shell||!I.isWindows)return i(!1);const t=_.spawn(y(),["/s","/c"]);t.on("error",r=>i(!0)),t.on("exit",r=>i(!1))})}}e.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class p extends b{constructor(i,t,r,s){super(i,t,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(i,t,r,s,a){[s,a].forEach((n,f)=>{const C=new d.LineDecoder;C.write(n).forEach(E=>{t({line:E,source:f===0?0:1})});const O=C.end();O&&t({line:O,source:f===0?0:1})}),i({terminated:this.terminateRequested,error:r})}handleSpawn(i,t,r,s,a){const n=new d.LineDecoder,f=new d.LineDecoder;i.stdout.on("data",C=>{n.write(C).forEach(O=>r({line:O,source:0}))}),i.stderr.on("data",C=>{f.write(C).forEach(O=>r({line:O,source:1}))}),this.stdoutLineDecoder=n,this.stderrLineDecoder=f}handleClose(i,t,r,s){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&r({line:a,source:0});const n=this.stderrLineDecoder?this.stderrLineDecoder.end():null;n&&r({line:n,source:1})}}e.LineProcess=p;function w(o){let i=[],t=!1;const r=function(s){if(t){i.push(s);return}(!o.send(s,n=>{if(n&&console.error(n),t=!1,i.length>0){const f=i.slice(0);i=[],f.forEach(C=>r(C))}})||I.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=w;var l;(function(o){async function i(t,r,s){if(h.isAbsolute(t))return t;if(r===void 0&&(r=process.cwd()),h.dirname(t)!=="."||(s===void 0&&P.isString(process.env.PATH)&&(s=process.env.PATH.split(h.delimiter)),s===void 0||s.length===0))return h.join(r,t);async function n(f){return await T.exists(f)?!(await D.promises.stat(f)).isDirectory():!1}for(let f of s){let C;if(h.isAbsolute(f)?C=h.join(f,t):C=h.join(r,f,t),await n(C))return C;let A=C+".com";if(await n(A)||(A=C+".exe",await n(A)))return A}return h.join(r,t)}o.findExecutable=i})(l=e.win32||(e.win32={}))}),define(J[115],Z([0,1,21,4,102,66]),function(H,e,h,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(m,c=process.env){return m===3?D.isWindows?d():_.getWindowsShell(c):g(m,c)}e.getSystemShell=k;function P(m,c=process.env){return m===3?D.isWindows?v(c):_.getWindowsShell(c):g(m,c)}e.getSystemShellSync=P;let u=null;function g(m,c){if(D.isLinux&&m===1||D.isMacintosh&&m===2)return"/bin/bash";if(!u){let y;if(D.isWindows)y="/bin/bash";else{if(y=c.SHELL,!y)try{y=h.userInfo().shell}catch(b){}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}u=y}return u}let I=null;async function d(){return I||(I=(await T.getFirstAvailablePowerShellInstallation()).exePath),I}function v(m){if(I)return I;const c=D.isWindows&&parseFloat(h.release())>=10,y=m.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${m.windir}\\${y?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return c?b:_.getWindowsShell(m)}}),define(J[67],Z([0,1,39,2,12,20,5,66,36,94,25,14,16,4]),function(H,e,h,D,T,_,k,P,u,g,I,d,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class c extends u.ChannelServer{constructor(p){super({send:w=>{try{process.send&&process.send(w.buffer.toString("base64"))}catch(l){}},onMessage:k.Event.fromNodeEventEmitter(process,"message",w=>v.VSBuffer.wrap(Buffer.from(w,"base64")))},p);process.once("disconnect",()=>this.dispose())}}e.Server=c;class y{constructor(p,w){this.modulePath=p,this.options=w,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new k.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const l=w&&w.timeout?w.timeout:6e4;this.disposeDelayer=new T.Delayer(l),this.child=null,this._client=null}getChannel(p){const w=this;return{call(l,o,i){return w.requestPromise(p,l,o,i)},listen(l,o){return w.requestEvent(p,l,o)}}}requestPromise(p,w,l,o=I.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(d.canceled());this.disposeDelayer.cancel();const i=this.getCachedChannel(p),t=T.createCancelablePromise(a=>i.call(w,l,a)),r=o.onCancellationRequested(()=>t.cancel()),s=D.toDisposable(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{r.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(p,w,l){if(!this.disposeDelayer)return k.Event.None;this.disposeDelayer.cancel();let o;const i=new k.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(p).listen(w,l)(i.fire,i),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return i.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],w=Object.create(null);w.env=Object.assign(Object.assign({},_.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(w.env=Object.assign(Object.assign({},w.env),this.options.env)),this.options&&this.options.freshExecArgv&&(w.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),m.isMacintosh&&w.env&&delete w.env.DYLD_LIBRARY_PATH,this.child=h.fork(this.modulePath,p,w);const l=new k.Emitter;k.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if(g.isRemoteConsoleLog(n)){g.log(n,`IPC Library: ${this.options.serverName}`);return}l.fire(v.VSBuffer.wrap(Buffer.from(n,"base64")))});const i=this.options.useQueue?P.createQueuedSender(this.child):this.child,t=n=>this.child&&this.child.connected&&i.send(n.buffer.toString("base64")),r=l.event,s={send:t,onMessage:r};this._client=new u.ChannelClient(s);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,f)=>{process.removeListener("exit",a),this.activeRequests.forEach(C=>D.dispose(C)),this.activeRequests.clear(),n!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+f),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:f})})}return this._client}getCachedChannel(p){let w=this.channels.get(p);return w||(w=this.client.getChannel(p),this.channels.set(p,w)),w}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(J[116],Z([8,9]),function(H,e){return H.create("vs/base/node/zip",e)}),define(J[117],Z([8,9]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[118],Z([8,9]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(J[119],Z([8,9]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(J[120],Z([8,9]),function(H,e){return H.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(J[121],Z([8,9]),function(H,e){return H.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(J[122],Z([8,9]),function(H,e){return H.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(J[123],Z([8,9]),function(H,e){return H.create("vs/platform/extensions/common/extensionValidator",e)}),define(J[124],Z([8,9]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(J[125],Z([8,9]),function(H,e){return H.create("vs/platform/files/common/files",e)}),define(J[126],Z([8,9]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(J[127],Z([8,9]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[128],Z([8,9]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(J[129],Z([8,9]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[130],Z([8,9]),function(H,e){return H.create("vs/platform/terminal/node/terminalProcess",e)}),define(J[131],Z([8,9]),function(H,e){return H.create("vs/server/node/marketplace",e)}),define(J[132],Z([8,9]),function(H,e){return H.create("vs/workbench/common/editor",e)}),define(J[133],Z([8,9]),function(H,e){return H.create("vs/workbench/contrib/terminal/common/terminal",e)}),define(J[134],Z([8,9]),function(H,e){return H.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(J[135],Z([8,9]),function(H,e){return H.create("vs/workbench/services/extensions/node/extensionPoints",e)}),define(J[136],Z([0,1,5,2]),function(H,e,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class T{constructor(){this._onCloseEmitter=new h.Emitter,this._onReloadEmitter=new h.Emitter,this._onTerminateEmitter=new h.Emitter,this._onAttachEmitter=new h.Emitter}call(P,u,g){switch(u){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:g[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:g[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:g[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:g[0],port:g[1],subId:g[2]}))}throw new Error("Method not implemented.")}listen(P,u,g){switch(u){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=T,T.ChannelName="extensionhostdebugservice";class _ extends D.Disposable{constructor(P){super();this.channel=P}reload(P){this.channel.call("reload",[P])}get onReload(){return this.channel.listen("reload")}close(P){this.channel.call("close",[P])}get onClose(){return this.channel.listen("close")}attachSession(P,u,g){this.channel.call("attach",[P,u,g])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(P,u){this.channel.call("terminate",[P,u])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(P,u,g){return this.channel.call("openExtensionDevelopmentHostWindow",[P,u,g])}}e.ExtensionHostDebugChannelClient=_}),define(J[137],Z([0,1,5,6,49,20,2]),function(H,e,h,D,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(c,y){return D.URI.revive(y?y.transformIncoming(c):c)}function u(c,y){return y?y.transformOutgoingURI(c):c}function g(c,y){y=y||T.DefaultURITransformer;const b=c.manifest,p=T.transformAndReviveIncomingURIs(Object.assign(Object.assign({},c),{manifest:void 0}),y);return Object.assign(Object.assign({},p),{manifest:b})}function I(c,y){return y?_.cloneAndChange(c,b=>b instanceof D.URI?y.transformOutgoingURI(b):void 0):c}class d{constructor(y,b){this.service=y,this.getUriTransformer=b,this.onInstallExtension=h.Event.buffer(y.onInstallExtension,!0),this.onDidInstallExtension=h.Event.buffer(y.onDidInstallExtension,!0),this.onUninstallExtension=h.Event.buffer(y.onUninstallExtension,!0),this.onDidUninstallExtension=h.Event.buffer(y.onDidUninstallExtension,!0)}listen(y,b){const p=this.getUriTransformer(y);switch(b){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return h.Event.map(this.onDidInstallExtension,w=>Object.assign(Object.assign({},w),{local:w.local?I(w.local,p):w.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(y,b,p){const w=this.getUriTransformer(y);switch(b){case"zip":return this.service.zip(g(p[0],w)).then(l=>u(l,w));case"unzip":return this.service.unzip(P(p[0],w));case"install":return this.service.install(P(p[0],w));case"getManifest":return this.service.getManifest(P(p[0],w));case"canInstall":return this.service.canInstall(p[0]);case"installFromGallery":return this.service.installFromGallery(p[0],p[1]);case"uninstall":return this.service.uninstall(g(p[0],w),p[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(g(p[0],w));case"getInstalled":return this.service.getInstalled(p[0]).then(l=>l.map(o=>I(o,w)));case"updateMetadata":return this.service.updateMetadata(g(p[0],w),p[1]).then(l=>I(l,w));case"updateExtensionScope":return this.service.updateExtensionScope(g(p[0],w),p[1]).then(l=>I(l,w));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class v extends k.Disposable{constructor(y){super();this.channel=y,this._onInstallExtension=this._register(new h.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new h.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new h.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new h.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(b=>this._onInstallExtension.fire(b))),this._register(this.channel.listen("onDidInstallExtension")(b=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},b),{local:b.local?g(b.local,null):b.local})))),this._register(this.channel.listen("onUninstallExtension")(b=>this._onUninstallExtension.fire(b))),this._register(this.channel.listen("onDidUninstallExtension")(b=>this._onDidUninstallExtension.fire(b)))}zip(y){return Promise.resolve(this.channel.call("zip",[y]).then(b=>D.URI.revive(b)))}unzip(y){return Promise.resolve(this.channel.call("unzip",[y]))}install(y){return Promise.resolve(this.channel.call("install",[y])).then(b=>g(b,null))}getManifest(y){return Promise.resolve(this.channel.call("getManifest",[y]))}async canInstall(y){return!0}installFromGallery(y,b){return Promise.resolve(this.channel.call("installFromGallery",[y,b])).then(p=>g(p,null))}uninstall(y,b){return Promise.resolve(this.channel.call("uninstall",[y,b]))}reinstallFromGallery(y){return Promise.resolve(this.channel.call("reinstallFromGallery",[y]))}getInstalled(y=null){return Promise.resolve(this.channel.call("getInstalled",[y])).then(b=>b.map(p=>g(p,null)))}updateMetadata(y,b){return Promise.resolve(this.channel.call("updateMetadata",[y,b])).then(p=>g(p,null))}updateExtensionScope(y,b){return Promise.resolve(this.channel.call("updateExtensionScope",[y,b])).then(p=>g(p,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=v;class m{constructor(y){this.service=y}listen(y,b){throw new Error("Invalid listen")}call(y,b,p){switch(b){case"getConfigBasedTips":return this.service.getConfigBasedTips(D.URI.revive(p[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=m}),define(J[138],Z([0,1,20]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const D=/^%([\w\d.-]+)%$/i;function T(_,k){const P=u=>{if(typeof u=="string"){const g=D.exec(u);if(!!g)return k[g[1]]||u}};return h.cloneAndChange(_,P)}e.localizeManifest=T}),define(J[50],Z([0,1,123]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function T(d){return d=d.trim(),d==="*"||D.test(d)}e.isValidVersionStr=T;function _(d){if(!T(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let v=d.match(D);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=_;function k(d){if(!d)return null;let v=d.majorBase,m=d.majorMustEqual,c=d.minorBase,y=d.minorMustEqual,b=d.patchBase,p=d.patchMustEqual;return d.hasCaret&&(v===0||(y=!1),p=!1),{majorBase:v,majorMustEqual:m,minorBase:c,minorMustEqual:y,patchBase:b,patchMustEqual:p,isMinimum:d.hasGreaterEquals}}e.normalizeVersion=k;function P(d,v){let m;typeof d=="string"?m=k(_(d)):m=d;let c;if(typeof v=="string"?c=k(_(v)):c=v,!m||!c)return!1;let y=m.majorBase,b=m.minorBase,p=m.patchBase,w=c.majorBase,l=c.minorBase,o=c.patchBase,i=c.majorMustEqual,t=c.minorMustEqual,r=c.patchMustEqual;return c.isMinimum?y>w?!0:y<w?!1:b>l?!0:b<l?!1:p>=o:(y===1&&w===0&&(!i||!t||!r)&&(w=1,l=0,o=0,i=!0,t=!1,r=!1),y<w?!1:y>w?!i:b<l?!1:b>l?!t:p<o?!1:p>o?!r:!0)}e.isValidVersion=P;function u(d,v,m){return v.isBuiltin||typeof v.main=="undefined"?!0:I(d,v.engines.vscode,m)}e.isValidExtensionVersion=u;function g(d,v){return d==="*"||I(v,d)}e.isEngineValid=g;function I(d,v,m=[]){let c=k(_(v));if(!c)return m.push(h.localize(0,null,v)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return m.push(h.localize(1,null,v)),!1}else if(!c.majorMustEqual)return m.push(h.localize(2,null,v)),!1;return P(d,c)?!0:(m.push(h.localize(3,null,d,v)),!1)}e.isVersionValid=I}),define(J[139],Z([0,1,36,67,2,11]),function(H,e,h,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends T.Disposable{constructor(u,g,I,d){super();this.folders=u,this.onDidFilesChange=g,this.onLogMessage=I,this.verboseLogging=d,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new D.Client(_.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=h.ProxyChannel.toService(h.getNextTickChannel(u.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.setFolders(this.folders)}setVerboseLogging(u){this.verboseLogging=u,!this.isDisposed&&this.service&&this.service.setVerboseLogging(u)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${u}`})}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(J[140],Z([0,1,36,67,2,11]),function(H,e,h,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends T.Disposable{constructor(u,g,I,d,v={}){super();this.folders=u,this.onDidFilesChange=g,this.onLogMessage=I,this.verboseLogging=d,this.watcherOptions=v,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new D.Client(_.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=h.ProxyChannel.toService(h.getNextTickChannel(u.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.service.setRoots(this.folders)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${u}`})}setVerboseLogging(u){this.verboseLogging=u,this.service&&this.service.setVerboseLogging(u)}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(J[141],Z([0,1,39,64,95,11]),function(H,e,h,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class k{constructor(u,g,I,d,v){this.watchedFolder=u,this.eventCallback=I,this.logCallback=d,this.verboseLogging=v,this.restartCounter=0,Array.isArray(g)?this.ignored=g.map(m=>T.parse(m)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${u}`),this.startWatcher()}startWatcher(){const u=[this.watchedFolder];this.verboseLogging&&u.push("-verbose"),this.handle=h.spawn(_.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",H).fsPath,u);const g=new D.LineDecoder;this.handle.stdout.on("data",I=>{const d=[];g.write(I).forEach(v=>{const m=v.split("|");if(m.length===2){const c=Number(m[0]),y=m[1];if(c>=0&&c<3){if(this.ignored&&this.ignored.some(b=>b(y))){this.verboseLogging&&this.log(y);return}d.push({type:k.changeTypeMap[c],path:y})}else this.log(m[1])}}),d.length>0&&this.eventCallback(d)}),this.handle.on("error",I=>this.onError(I)),this.handle.stderr.on("data",I=>this.onError(I)),this.handle.on("exit",(I,d)=>this.onExit(I,d))}onError(u){this.error("process error: "+u.toString())}onExit(u,g){this.handle&&(this.error(`terminated unexpectedly (code: ${u}, signal: ${g})`),this.restartCounter<=k.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(u){this.logCallback({type:"error",message:`[File Watcher (C#)] ${u}`})}log(u){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${u}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=k,k.MAX_RESTARTS=5,k.changeTypeMap=[0,1,2]}),define(J[142],Z([0,1,141,3,18]),function(H,e,h,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class _{constructor(P,u,g,I){this.onDidFilesChange=u,this.onLogMessage=g,this.verboseLogging=I,this.service=void 0,this.folder=P[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(D.posix.sep)&&(this.folder.path=T.rtrim(this.folder.path,D.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new h.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,P=>this.onFileEvents(P),P=>this.onLogMessage(P),this.verboseLogging)}setVerboseLogging(P){this.verboseLogging=P,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(P){this.isDisposed||P.length>0&&this.onDidFilesChange(P)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=_}),define(J[51],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class h{constructor(_,k=[],P=!1){this.ctor=_,this.staticArguments=k,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=h;const D=(T,..._)=>new h(T,_);e.createSyncDescriptor=D}),define(J[143],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class h{constructor(_){this.incoming=new Map,this.outgoing=new Map,this.data=_}}e.Node=h;class D{constructor(_){this._hashFn=_,this._nodes=new Map}roots(){const _=[];for(let k of this._nodes.values())k.outgoing.size===0&&_.push(k);return _}insertEdge(_,k){const P=this.lookupOrInsertNode(_),u=this.lookupOrInsertNode(k);P.outgoing.set(this._hashFn(k),u),u.incoming.set(this._hashFn(_),P)}removeNode(_){const k=this._hashFn(_);this._nodes.delete(k);for(let P of this._nodes.values())P.outgoing.delete(k),P.incoming.delete(k)}lookupOrInsertNode(_){const k=this._hashFn(_);let P=this._nodes.get(k);return P||(P=new h(_),this._nodes.set(k,P)),P}lookup(_){return this._nodes.get(this._hashFn(_))}isEmpty(){return this._nodes.size===0}toString(){let _=[];for(let[k,P]of this._nodes)_.push(`${k}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return _.join(`
`)}}e.Graph=D}),define(J[7],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.createDecorator=e.IInstantiationService=e._util=void 0;var h;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function P(u){return u[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=P})(h=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function D(k,P,u,g){P[h.DI_TARGET]===P?P[h.DI_DEPENDENCIES].push({id:k,index:u,optional:g}):(P[h.DI_DEPENDENCIES]=[{id:k,index:u,optional:g}],P[h.DI_TARGET]=P)}function T(k){if(h.serviceIds.has(k))return h.serviceIds.get(k);const P=function(u,g,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(P,u,I,!1)};return P.toString=()=>k,h.serviceIds.set(k,P),P}e.createDecorator=T;function _(k){return function(P,u,g){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");D(k,P,g,!0)}}e.optional=_}),define(J[68],Z([0,1,18,7,4]),function(H,e,h,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let _=T.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",T.isMacintosh),k.set("isLinux",T.isLinux),k.set("isWindows",T.isWindows),k.set("isWeb",T.isWeb),k.set("isMacNative",T.isMacintosh&&!T.isWeb),k.set("isEdge",_.indexOf("Edg/")>=0),k.set("isFirefox",_.indexOf("Firefox")>=0),k.set("isChrome",_.indexOf("Chrome")>=0),k.set("isSafari",_.indexOf("Safari")>=0),k.set("isIPad",_.indexOf("iPad")>=0);const P=Object.prototype.hasOwnProperty;var u;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(u=e.ContextKeyExprType||(e.ContextKeyExprType={}));class g{static false(){return d.INSTANCE}static true(){return v.INSTANCE}static has(E){return m.create(E)}static equals(E,F){return c.create(E,F)}static notEquals(E,F){return p.create(E,F)}static regex(E,F){return r.create(E,F)}static in(E,F){return y.create(E,F)}static not(E){return w.create(E)}static and(...E){return a.create(E)}static or(...E){return n.create(E)}static greater(E,F){return l.create(E,F)}static less(E,F){return i.create(E,F)}static deserialize(E,F=!1){if(!!E)return this._deserializeOrExpression(E,F)}static _deserializeOrExpression(E,F){let j=E.split("||");return n.create(j.map(G=>this._deserializeAndExpression(G,F)))}static _deserializeAndExpression(E,F){let j=E.split("&&");return a.create(j.map(G=>this._deserializeOne(G,F)))}static _deserializeOne(E,F){if(E=E.trim(),E.indexOf("!=")>=0){let j=E.split("!=");return p.create(j[0].trim(),this._deserializeValue(j[1],F))}if(E.indexOf("==")>=0){let j=E.split("==");return c.create(j[0].trim(),this._deserializeValue(j[1],F))}if(E.indexOf("=~")>=0){let j=E.split("=~");return r.create(j[0].trim(),this._deserializeRegexValue(j[1],F))}if(E.indexOf(" in ")>=0){let j=E.split(" in ");return y.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(E)){const j=E.split(">=");return o.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(E)){const j=E.split(">");return l.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(E)){const j=E.split("<=");return t.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(E)){const j=E.split("<");return i.create(j[0].trim(),j[1].trim())}return/^\!\s*/.test(E)?w.create(E.substr(1).trim()):m.create(E)}static _deserializeValue(E,F){if(E=E.trim(),E==="true")return!0;if(E==="false")return!1;let j=/^'([^']*)'$/.exec(E);return j?j[1].trim():E}static _deserializeRegexValue(E,F){if(h.isFalsyOrWhitespace(E)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let j=E.indexOf("/"),G=E.lastIndexOf("/");if(j===G||j<0){if(F)throw new Error(`bad regexp-value '${E}', missing /-enclosure`);return console.warn(`bad regexp-value '${E}', missing /-enclosure`),null}let z=E.slice(j+1,G),W=E[G+1]==="i"?"i":"";try{return new RegExp(z,W)}catch(q){if(F)throw new Error(`bad regexp-value '${E}', parse error: ${q}`);return console.warn(`bad regexp-value '${E}', parse error: ${q}`),null}}}e.ContextKeyExpr=g;function I(O,E){return O.cmp(E)}class d{constructor(){this.type=0}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=d,d.INSTANCE=new d;class v{constructor(){this.type=1}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return d.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class m{constructor(E){this.key=E,this.type=2}static create(E){const F=k.get(E);return typeof F=="boolean"?F?v.INSTANCE:d.INSTANCE:new m(E)}cmp(E){return E.type!==this.type?this.type-E.type:C(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return w.create(this.key)}}e.ContextKeyDefinedExpr=m;class c{constructor(E,F){this.key=E,this.value=F,this.type=4}static create(E,F){if(typeof F=="boolean")return F?m.create(E):w.create(E);const j=k.get(E);return typeof j=="boolean"?F===(j?"true":"false")?v.INSTANCE:d.INSTANCE:new c(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:A(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return E.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(E){return E.mapEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeyEqualsExpr=c;class y{constructor(E,F){this.key=E,this.valueKey=F,this.type=10}static create(E,F){return new y(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:A(this.key,this.valueKey,E.key,E.valueKey)}equals(E){return E.type===this.type?this.key===E.key&&this.valueKey===E.valueKey:!1}evaluate(E){const F=E.getValue(this.valueKey),j=E.getValue(this.key);return Array.isArray(F)?F.indexOf(j)>=0:typeof j=="string"&&typeof F=="object"&&F!==null?P.call(F,j):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(E){return E.mapIn(this.key,this.valueKey)}negate(){return b.create(this)}}e.ContextKeyInExpr=y;class b{constructor(E){this._actual=E,this.type=11}static create(E){return new b(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new b(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotInExpr=b;class p{constructor(E,F){this.key=E,this.value=F,this.type=5}static create(E,F){if(typeof F=="boolean")return F?w.create(E):m.create(E);const j=k.get(E);return typeof j=="boolean"?F===(j?"true":"false")?d.INSTANCE:v.INSTANCE:new p(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:A(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return E.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(E){return E.mapNotEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=p;class w{constructor(E){this.key=E,this.type=3}static create(E){const F=k.get(E);return typeof F=="boolean"?F?d.INSTANCE:v.INSTANCE:new w(E)}cmp(E){return E.type!==this.type?this.type-E.type:C(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}evaluate(E){return!E.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(E){return E.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=w;class l{constructor(E,F){this.key=E,this.value=F,this.type=12}static create(E,F){return new l(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:A(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return parseFloat(E.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=l;class o{constructor(E,F){this.key=E,this.value=F,this.type=13}static create(E,F){return new o(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:A(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return parseFloat(E.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreaterEquals(this.key,this.value)}negate(){return i.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=o;class i{constructor(E,F){this.key=E,this.value=F,this.type=14}static create(E,F){return new i(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:A(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return parseFloat(E.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmaller(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeySmallerExpr=i;class t{constructor(E,F){this.key=E,this.value=F,this.type=15}static create(E,F){return new t(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:A(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return parseFloat(E.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmallerEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(E,F){this.key=E,this.regexp=F,this.type=7}static create(E,F){return new r(E,F)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.key<E.key)return-1;if(this.key>E.key)return 1;const F=this.regexp?this.regexp.source:"",j=E.regexp?E.regexp.source:"";return F<j?-1:F>j?1:0}equals(E){if(E.type===this.type){const F=this.regexp?this.regexp.source:"",j=E.regexp?E.regexp.source:"";return this.key===E.key&&F===j}return!1}evaluate(E){let F=E.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const E=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${E}`}keys(){return[this.key]}map(E){return E.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=r;class s{constructor(E){this._actual=E,this.type=8}static create(E){return new s(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new s(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class a{constructor(E){this.expr=E,this.type=6}static create(E){return a._normalizeArr(E)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let F=0,j=this.expr.length;F<j;F++){const G=I(this.expr[F],E.expr[F]);if(G!==0)return G}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let F=0,j=this.expr.length;F<j;F++)if(!this.expr[F].equals(E.expr[F]))return!1;return!0}return!1}evaluate(E){for(let F=0,j=this.expr.length;F<j;F++)if(!this.expr[F].evaluate(E))return!1;return!0}static _normalizeArr(E){const F=[];let j=!1;for(const G of E)if(!!G){if(G.type===1){j=!0;continue}if(G.type===0)return d.INSTANCE;if(G.type===6){F.push(...G.expr);continue}F.push(G)}if(F.length===0&&j)return v.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];for(F.sort(I);F.length>1;){const G=F[F.length-1];if(G.type!==9)break;F.pop();const z=F.pop(),W=n.create(G.expr.map(q=>a.create([q,z])));W&&(F.push(W),F.sort(I))}return F.length===1?F[0]:new a(F)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(let F of this.expr)E.push(...F.keys());return E}map(E){return new a(this.expr.map(F=>F.map(E)))}negate(){let E=[];for(let F of this.expr)E.push(F.negate());return n.create(E)}}e.ContextKeyAndExpr=a;class n{constructor(E){this.expr=E,this.type=9}static create(E){const F=n._normalizeArr(E);if(F.length!==0)return F.length===1?F[0]:new n(F)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let F=0,j=this.expr.length;F<j;F++){const G=I(this.expr[F],E.expr[F]);if(G!==0)return G}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let F=0,j=this.expr.length;F<j;F++)if(!this.expr[F].equals(E.expr[F]))return!1;return!0}return!1}evaluate(E){for(let F=0,j=this.expr.length;F<j;F++)if(this.expr[F].evaluate(E))return!0;return!1}static _normalizeArr(E){let F=[],j=!1;if(E){for(let G=0,z=E.length;G<z;G++){const W=E[G];if(!!W){if(W.type===0){j=!0;continue}if(W.type===1)return[v.INSTANCE];if(W.type===9){F=F.concat(W.expr);continue}F.push(W)}}if(F.length===0&&j)return[d.INSTANCE];F.sort(I)}return F}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(let F of this.expr)E.push(...F.keys());return E}map(E){return new n(this.expr.map(F=>F.map(E)))}negate(){let E=[];for(let j of this.expr)E.push(j.negate());const F=j=>j.type===9?j.expr:[j];for(;E.length>1;){const j=E.shift(),G=E.shift(),z=[];for(const W of F(j))for(const q of F(G))z.push(g.and(W,q));E.unshift(g.or(...z))}return E[0]}}e.ContextKeyOrExpr=n;class f extends m{constructor(E,F,j){super(E);this.key=E,this._defaultValue=F,typeof j=="object"?f._info.push(Object.assign(Object.assign({},j),{key:E})):j!==!0&&f._info.push({key:E,description:j,type:F!=null?typeof F:void 0})}static all(){return f._info.values()}bindTo(E){return E.createKey(this.key,this._defaultValue)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return g.not(this.key)}isEqualTo(E){return g.equals(this.key,E)}notEqualsTo(E){return g.notEquals(this.key,E)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=D.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function C(O,E){return O<E?-1:O>E?1:0}function A(O,E,F,j){return O<F?-1:O>F?1:E<j?-1:E>j?1:0}}),define(J[144],Z([0,1,7]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=h.createDecorator("downloadService")}),define(J[23],Z([0,1,7]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=h.createDecorator("environmentService"),e.INativeEnvironmentService=h.createDecorator("nativeEnvironmentService")});var ve=this&&this.__decorate||function(H,e,h,D){var T=arguments.length,_=T<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,h):D,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(H,e,h,D);else for(var P=H.length-1;P>=0;P--)(k=H[P])&&(_=(T<3?k(_):T>3?k(e,h,_):k(e,h))||_);return T>3&&_&&Object.defineProperty(e,h,_),_},ge=this&&this.__param||function(H,e){return function(h,D){e(h,D,H)}};define(J[145],Z([0,1,23,3,17,14,2,12]),function(H,e,h,D,T,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let u=class extends k.Disposable{constructor(I){super();this.environmentService=I,this.cleanUpOldLogsSoon()}cleanUpOldLogsSoon(){let I=setTimeout(()=>{I=void 0;const d=D.basename(this.environmentService.logsPath),v=D.dirname(this.environmentService.logsPath);T.readdir(v).then(m=>{const y=m.filter(p=>/^\d{8}T\d{6}$/.test(p)).sort().filter((p,w)=>p!==d),b=y.slice(0,Math.max(0,y.length-9));return P.Promises.settled(b.map(p=>T.rimraf(D.join(v,p))))}).then(null,_.onUnexpectedError)},10*1e3);this._register(k.toDisposable(()=>{I&&(clearTimeout(I),I=void 0)}))}};u=ve([ge(0,h.IEnvironmentService)],u),e.LogsDataCleaner=u}),define(J[27],Z([0,1,118,7,11]),function(H,e,h,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function _(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=_;var k;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=5]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var P;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var u;(function(d){d.Uninstall="uninstall"})(u=e.StatisticType||(e.StatisticType={}));var g;(function(d){d[d.None=0]="None",d[d.Install=1]="Install",d[d.Update=2]="Update"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=D.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class I extends Error{constructor(v,m){super(v);this.code=m}}e.ExtensionManagementError=I,e.IExtensionManagementService=D.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=D.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=D.createDecorator("IExtensionTipsService"),e.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",H).toString(!0),e.ExtensionsLabel=h.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=h.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=D.createDecorator("IExtensionManagementCLIService")}),define(J[40],Z([0,1,18,7]),function(H,e,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function T(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var _;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(_=e.ExtensionType||(e.ExtensionType={}));class k{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,d){if(typeof I=="undefined"||I===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof I=="string"||typeof d=="string"){let v=typeof I=="string"?I:I.value,m=typeof d=="string"?d:d.value;return h.equalsIgnoreCase(v,m)}return I._lower===d._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=k;function P(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function u(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=u,e.IBuiltinExtensionsScannerService=D.createDecorator("IBuiltinExtensionsScannerService")}),define(J[31],Z([0,1,18,40]),function(H,e,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function T(m,c){return m.uuid&&c.uuid?m.uuid===c.uuid:m.id===c.id?!0:h.compareIgnoreCase(m.id,c.id)===0}e.areSameExtensions=T;class _{constructor(c,y){this.version=y,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof _?T(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=_;function k(m,c){return`${m}.${c}`}e.getExtensionId=k;function P(m){return m.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function u(m,c){return P(k(m,c))}e.getGalleryExtensionId=u;function g(m,c){const y=[],b=p=>{for(const w of y)if(w.some(l=>T(c(l),c(p))))return w;return null};for(const p of m){const w=b(p);w?w.push(p):y.push([p])}return y}e.groupByExtension=g;function I(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=I;function d(m){return Object.assign({id:m.identifier.id,name:m.name,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0)},m.telemetryData)}e.getGalleryExtensionTelemetryData=d,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function v(m){const c=new Set;for(const y of m)y.malicious&&c.add(y.id.id);return c}e.getMaliciousExtensionsSet=v}),define(J[146],Z([0,1,2,3,40,17]),function(H,e,h,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends h.Disposable{constructor(u,g){super();this.environmentService=u,this.extensionsManifestCache=D.join(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtension(I=>this.onDidInstallExtension(I))),this._register(g.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtension(u){u.error||this.invalidate()}onDidUnInstallExtension(u){u.error||this.invalidate()}invalidate(){_.rimraf(this.extensionsManifestCache,_.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(J[24],Z([0,1,125,3,6,7,18,10,30]),function(H,e,h,D,T,_,k,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.IFileService=void 0,e.IFileService=_.createDecorator("fileService");var g;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(g=e.FileType||(e.FileType={}));var I;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=d;function v(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=v;function m(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function c(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=c;var y;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(y=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(G,z){super(G);this.code=z}}e.FileSystemProviderError=b;function p(j,G){const z=new b(j.toString(),G);return l(z,G),z}e.createFileSystemProviderError=p;function w(j){return j||p(h.localize(0,null),y.Unknown)}e.ensureFileSystemProviderError=w;function l(j,G){return j.name=G?`${G} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=l;function o(j){if(!j)return y.Unknown;if(j instanceof b)return j.code;const G=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!G)return y.Unknown;switch(G[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileExceedsMemoryLimit:return y.FileExceedsMemoryLimit;case y.FileTooLarge:return y.FileTooLarge;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}e.toFileSystemProviderErrorCode=o;function i(j){if(j instanceof f)return j.fileOperationResult;switch(o(j)){case y.FileNotFound:return 1;case y.FileIsADirectory:return 0;case y.FileNotADirectory:return 10;case y.NoPermissions:return 6;case y.FileExists:return 4;case y.FileExceedsMemoryLimit:return 9;case y.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var t;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class r{constructor(G,z,W){this.resource=G,this.operation=z,this.target=W}isOperation(G){return this.operation===G}}e.FileOperationEvent=r;var s;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class a{constructor(G,z){this.ignorePathCasing=z,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=G;for(const W of G)switch(W.type){case 1:this.added||(this.added=u.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(W.resource,W);break;case 0:this.updated||(this.updated=u.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(W.resource,W);break;case 2:this.deleted||(this.deleted=u.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(W.resource,W);break}}contains(G,...z){return this.doContains(G,{includeChildren:!1},...z)}affects(G,...z){return this.doContains(G,{includeChildren:!0},...z)}doContains(G,z,...W){var q,ee,te,B,M,L;if(!G)return!1;const S=W.length>0;return!!((!S||W.includes(1))&&(((q=this.added)===null||q===void 0?void 0:q.get(G))||z.includeChildren&&((ee=this.added)===null||ee===void 0?void 0:ee.findSuperstr(G)))||(!S||W.includes(0))&&(((te=this.updated)===null||te===void 0?void 0:te.get(G))||z.includeChildren&&((B=this.updated)===null||B===void 0?void 0:B.findSuperstr(G)))||(!S||W.includes(2))&&(((M=this.deleted)===null||M===void 0?void 0:M.findSubstr(G))||z.includeChildren&&((L=this.deleted)===null||L===void 0?void 0:L.findSuperstr(G))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(G){const z=[],W=G===1?this.added:G===0?this.updated:this.deleted;if(W)for(const[,q]of W)z.push(q);return z}filter(G){return new a(this.changes.filter(z=>G(z)),this.ignorePathCasing)}}e.FileChangesEvent=a;function n(j,G,z){return!j||!G||j===G||G.length>j.length?!1:(G.charAt(G.length-1)!==D.sep&&(G+=D.sep),z?k.startsWithIgnoreCase(j,G):j.indexOf(G)===0)}e.isParent=n;class f extends Error{constructor(G,z,W){super(G);this.fileOperationResult=z,this.options=W}static isFileOperationError(G){return G instanceof Error&&!P.isUndefinedOrNull(G.fileOperationResult)}}e.FileOperationError=f;var C;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_READ_ONLY=5]="FILE_READ_ONLY",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(C=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=O;async function E(j,G){if(!G.canHandleResource(T.URI.from({scheme:j.scheme})))return new Promise(z=>{const W=G.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===j.scheme&&q.added&&(W.dispose(),z())})})}e.whenProviderRegistered=E,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(G){return P.isNumber(G)||(G=0),G<F.KB?h.localize(1,null,G.toFixed(0)):G<F.MB?h.localize(2,null,(G/F.KB).toFixed(2)):G<F.GB?h.localize(3,null,(G/F.MB).toFixed(2)):G<F.TB?h.localize(4,null,(G/F.GB).toFixed(2)):h.localize(5,null,(G/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB}),define(J[69],Z([0,1,126,16,24,14]),function(H,e,h,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(I,d,v,m,c,y){let b;try{await P(I,d,v,m,c,y)}catch(p){b=p}finally{b&&c.errorTransformer&&(b=c.errorTransformer(b)),v.end(b)}}e.readFileIntoStream=k;async function P(I,d,v,m,c,y){u(y);const b=await I.open(d,{create:!1});try{u(y);let p=0,w=0,l=c&&typeof c.length=="number"?c.length:void 0,o=D.VSBuffer.alloc(Math.min(c.bufferSize,typeof l=="number"?l:c.bufferSize)),i=c&&typeof c.position=="number"?c.position:0,t=0;do w=await I.read(b,i,o.buffer,t,o.byteLength-t),i+=w,t+=w,p+=w,typeof l=="number"&&(l-=w),t===o.byteLength&&(await v.write(m(o)),o=D.VSBuffer.alloc(Math.min(c.bufferSize,typeof l=="number"?l:c.bufferSize)),t=0);while(w>0&&(typeof l!="number"||l>0)&&u(y)&&g(p,c));if(t>0){let r=t;typeof l=="number"&&(r=Math.min(t,l)),v.write(m(o.slice(0,r)))}}catch(p){throw T.ensureFileSystemProviderError(p)}finally{await I.close(b)}}function u(I){if(I.isCancellationRequested)throw _.canceled();return!0}function g(I,d){if(d==null?void 0:d.limits){if(typeof d.limits.memory=="number"&&I>d.limits.memory)throw T.createFileSystemProviderError(h.localize(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof d.limits.size=="number"&&I>d.limits.size)throw T.createFileSystemProviderError(h.localize(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[70],Z([0,1,6,24,4]),function(H,e,h,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function _(u){return u.map(g=>({type:g.type,resource:h.URI.file(g.path)}))}e.toFileChanges=_;function k(u){const g=new P;for(const I of u)g.processEvent(I);return g.normalize()}e.normalizeFileChanges=k;class P{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(g){const I=this.mapPathToChange.get(g.path);if(I){const d=I.type,v=g.type;d===1&&v===2?(this.mapPathToChange.delete(g.path),this.normalized.splice(this.normalized.indexOf(I),1)):d===2&&v===1?I.type=0:d===1&&v===0||(I.type=v)}else this.normalized.push(g),this.mapPathToChange.set(g.path,g)}normalize(){const g=[],I=[];return this.normalized.filter(d=>d.type!==2?(g.push(d),!1):!0).sort((d,v)=>d.path.length-v.path.length).filter(d=>I.some(v=>D.isParent(d.path,v,!T.isLinux))?!1:(I.push(d.path),!0)).concat(g)}}}),define(J[147],Z([0,1,70,2,17,101,105,12,3]),function(H,e,h,D,T,_,k,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class g extends D.Disposable{constructor(d,v,m,c){super();this.path=d,this.onDidFilesChange=v,this.onLogMessage=m,this.verboseLogging=c,this.fileChangesDelayer=this._register(new P.ThrottledDelayer(k.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(d){this.verboseLogging=d}async startWatching(){try{const{stat:d,symbolicLink:v}=await T.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let m=this.path;if(v)try{m=await _.realpath(m)}catch(c){if(this.onError(c),v.dangling)return}d.isDirectory()?this._register(k.watchFolder(m,(c,y)=>{this.onFileChange({type:c==="changed"?0:c==="added"?1:2,path:u.join(this.path,u.basename(y))})},c=>this.onError(c))):this._register(k.watchFile(m,c=>{this.onFileChange({type:c==="changed"?0:2,path:this.path})},c=>this.onError(c)))}catch(d){d.code!=="ENOENT"&&this.onError(d)}}onFileChange(d){this.fileChangesBuffer.push(d),this.verboseLogging&&this.onVerbose(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`),this.fileChangesDelayer.trigger(async()=>{const v=this.fileChangesBuffer;this.fileChangesBuffer=[];const m=h.normalizeFileChanges(v);this.verboseLogging&&m.forEach(c=>{this.onVerbose(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`)}),m.length>0&&this.onDidFilesChange(m)})}onError(d){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${d}`})}onVerbose(d){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=g}),define(J[52],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class h{constructor(...T){this._entries=new Map;for(let[_,k]of T)this.set(_,k)}set(T,_){const k=this._entries.get(T);return this._entries.set(T,_),k}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=h}),define(J[71],Z([0,1,14,143,51,7,52,12]),function(H,e,h,D,T,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const u=!1;class g extends Error{constructor(c){super("cyclic dependency between services");this.message=c.toString()}}class I{constructor(c=new k.ServiceCollection,y=!1,b){this._activeInstantiations=new Set,this._services=c,this._strict=y,this._parent=b,this._services.set(_.IInstantiationService,this)}createChild(c){return new I(c,this._strict,this)}invokeFunction(c,...y){let b=v.traceInvocation(c),p=!1;try{return c({get:(l,o)=>{if(p)throw h.illegalState("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(l,b);if(!i&&o!==_.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return i}},...y)}finally{p=!0,b.stop()}}createInstance(c,...y){let b,p;return c instanceof T.SyncDescriptor?(b=v.traceCreation(c.ctor),p=this._createInstance(c.ctor,c.staticArguments.concat(y),b)):(b=v.traceCreation(c),p=this._createInstance(c,y,b)),b.stop(),p}_createInstance(c,y=[],b){let p=_._util.getServiceDependencies(c).sort((o,i)=>o.index-i.index),w=[];for(const o of p){let i=this._getOrCreateServiceInstance(o.id,b);if(!i&&this._strict&&!o.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${o.id}.`);w.push(i)}let l=p.length>0?p[0].index:y.length;if(y.length!==l){console.warn(`[createInstance] First service dependency of ${c.name} at position ${l+1} conflicts with ${y.length} static arguments`);let o=l-y.length;o>0?y=y.concat(new Array(o)):y=y.slice(0,l)}return new c(...[...y,...w])}_setServiceInstance(c,y){if(this._services.get(c)instanceof T.SyncDescriptor)this._services.set(c,y);else if(this._parent)this._parent._setServiceInstance(c,y);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let y=this._services.get(c);return!y&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):y}_getOrCreateServiceInstance(c,y){let b=this._getServiceInstanceOrDescriptor(c);return b instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,b,y.branch(c,!0)):(y.branch(c,!1),b)}_safeCreateAndCacheServiceInstance(c,y,b){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,y,b)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,y,b){const p=new D.Graph(o=>o.id.toString());let w=0;const l=[{id:c,desc:y,_trace:b}];for(;l.length;){const o=l.pop();if(p.lookupOrInsertNode(o),w++>1e3)throw new g(p);for(let i of _._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(i.id);if(!t&&!i.optional&&console.warn(`[createInstance] ${c} depends on ${i.id} which is NOT registered.`),t instanceof T.SyncDescriptor){const r={id:i.id,desc:t,_trace:o._trace.branch(i.id,!0)};p.insertEdge(o,r),l.push(r)}}}for(;;){const o=p.roots();if(o.length===0){if(!p.isEmpty())throw new g(p);break}for(const{data:i}of o){if(this._getServiceInstanceOrDescriptor(i.id)instanceof T.SyncDescriptor){const r=this._createServiceInstanceWithOwner(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this._setServiceInstance(i.id,r)}p.removeNode(i)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,y,b=[],p,w){if(this._services.get(c)instanceof T.SyncDescriptor)return this._createServiceInstance(y,b,p,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,y,b,p,w);throw new Error(`illegalState - creating UNKNOWN service instance ${y.name}`)}_createServiceInstance(c,y=[],b,p){if(b){const w=new P.IdleValue(()=>this._createInstance(c,y,p));return new Proxy(Object.create(null),{get(l,o){if(o in l)return l[o];let i=w.value,t=i[o];return typeof t!="function"||(t=t.bind(i),l[o]=t),t},set(l,o,i){return w.value[o]=i,!0}})}else return this._createInstance(c,y,p)}}e.InstantiationService=I;var d;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(d||(d={}));class v{constructor(c,y){this.type=c,this.name=y,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return u?new v(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(c){return u?new v(0,c.name):v._None}branch(c,y){let b=new v(2,c.toString());return this._dep.push([c,y,b]),b}stop(){let c=Date.now()-this._start;v._totals+=c;let y=!1;function b(w,l){let o=[],i=new Array(w+1).join("	");for(const[t,r,s]of l._dep)if(r&&s){y=!0,o.push(`${i}CREATES -> ${t}`);let a=b(w+1,s);a&&o.push(a)}else o.push(`${i}uses -> ${t}`);return o.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(c>2||y)&&console.log(p.join(`
`))}}v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(J[148],Z([0,1,7]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=h.createDecorator("labelService")}),define(J[43],Z([0,1,7]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=h.createDecorator("localizationsService");function D(T){if(typeof T.languageId!="string"||!Array.isArray(T.translations)||T.translations.length===0)return!1;for(const _ of T.translations)if(typeof _.id!="string"||typeof _.path!="string")return!1;return!(T.languageName&&typeof T.languageName!="string"||T.localizedLanguageName&&typeof T.localizedLanguageName!="string")}e.isValidLocalization=D}),define(J[149],Z([0,1,119,14,6,44,27,31,40,63,25,11,43]),function(H,e,h,D,T,_,k,P,u,g,I,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=e.getIdAndVersion=void 0;const m=l=>h.localize(0,null,l),c=h.localize(1,null,"ms-dotnettools.csharp");function y(l,o){return o?`${l.publisher}.${l.name}@${l.version}`:`${l.publisher}.${l.name}`}const b=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function p(l){const o=b.exec(l);return o&&o[1]?[P.adoptToGalleryExtensionId(o[1]),o[2]]:[P.adoptToGalleryExtensionId(l),void 0]}e.getIdAndVersion=p;let w=class{constructor(o,i,t){this.extensionManagementService=o,this.extensionGalleryService=i,this.localizationsService=t}get location(){}async listExtensions(o,i,t=console){let r=await this.extensionManagementService.getInstalled(1);const s=u.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(i&&i!==""){if(s.indexOf(i.toLowerCase())<0){t.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}r=r.filter(n=>n.manifest.categories?n.manifest.categories.map(C=>C.toLowerCase()).indexOf(i.toLowerCase())>-1:!1)}else if(i===""){t.log("Possible Categories: "),s.forEach(n=>{t.log(n)});return}this.location&&t.log(h.localize(2,null,this.location)),r=r.sort((n,f)=>n.identifier.id.localeCompare(f.identifier.id));let a;for(let n of r)a!==n.identifier.id&&(a=n.identifier.id,t.log(y(n.manifest,o)))}async installExtensions(o,i,t,r,s=console){const a=[],n=[];o.length&&s.log(this.location?h.localize(3,null,this.location):h.localize(4,null));const f=await this.extensionManagementService.getInstalled(1),C=(E,F)=>{const j=f.find(G=>P.areSameExtensions(G.identifier,{id:E}));if(j){if(!F&&!r)return s.log(h.localize(5,null,E,j.manifest.version,E)),!1;if(F&&j.manifest.version===F)return s.log(h.localize(6,null,`${E}@${F}`)),!1}return!0},A=[],O=[];for(const E of o)if(E instanceof T.URI)A.push(E);else{const[F,j]=p(E);C(F,j)&&O.push({id:F,version:j,installOptions:{isBuiltin:!1,isMachineScoped:t}})}for(const E of i){const[F,j]=p(E);C(F,j)&&O.push({id:F,version:j,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(A.length&&await Promise.all(A.map(async E=>{try{const F=await this.installVSIX(E,r,s);F&&n.push(F)}catch(F){s.error(F.message||F.stack||F),a.push(E.toString())}})),O.length){const E=await this.getGalleryExtensions(O);await Promise.all(O.map(async F=>{const j=E.get(F.id.toLowerCase());if(j)try{const G=await this.installFromGallery(F,j,f,r,s);G&&n.push(G)}catch(G){s.error(G.message||G.stack||G),a.push(F.id)}else s.error(`${m(F.version?`${F.id}@${F.version}`:F.id)}
${c}`),a.push(F.id)}))}if(n.some(E=>u.isLanguagePackExtension(E))&&await this.updateLocalizationsCache(),a.length)throw new Error(h.localize(7,null,a.join(", ")))}async installVSIX(o,i,t){const r=await this.extensionManagementService.getManifest(o);if(!r)throw new Error("Invalid vsix");if(await this.validateVSIX(r,i,t))try{return await this.extensionManagementService.install(o),t.log(h.localize(8,null,g.getBaseLabel(o))),r}catch(a){if(D.isPromiseCanceledError(a))return t.log(h.localize(9,null,g.getBaseLabel(o))),null;throw a}return null}async getGalleryExtensions(o){const i=o.filter(({version:s})=>s===void 0).map(({id:s})=>s),t=o.filter(({version:s})=>s!==void 0),r=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(i,I.CancellationToken.None)).forEach(a=>r.set(a.identifier.id.toLowerCase(),a))})(),Promise.all(t.map(async({id:s,version:a})=>{const n=await this.extensionGalleryService.getCompatibleExtension({id:s},a);n&&r.set(n.identifier.id.toLowerCase(),n)}))]),r}async installFromGallery({id:o,version:i,installOptions:t},r,s,a,n){const f=await this.extensionGalleryService.getManifest(r,I.CancellationToken.None);if(f&&!this.validateExtensionKind(f,n))return null;const C=s.find(A=>P.areSameExtensions(A.identifier,r.identifier));if(C){if(r.version===C.manifest.version)return n.log(h.localize(10,null,i?`${o}@${i}`:o)),null;n.log(h.localize(11,null,o,r.version))}try{return t.isBuiltin?n.log(h.localize(12,null,o,r.version)):n.log(h.localize(13,null,o,r.version)),await this.extensionManagementService.installFromGallery(r,t),n.log(h.localize(14,null,o,r.version)),f}catch(A){if(D.isPromiseCanceledError(A))return n.log(h.localize(15,null,o)),null;throw A}}validateExtensionKind(o,i){return!0}async validateVSIX(o,i,t){const r={id:P.getGalleryExtensionId(o.publisher,o.name)},a=(await this.extensionManagementService.getInstalled(1)).find(n=>P.areSameExtensions(r,n.identifier)&&_.gt(n.manifest.version,o.version));return a&&!i?(t.log(h.localize(16,null,a.identifier.id,a.manifest.version,o.version)),!1):this.validateExtensionKind(o,t)}async uninstallExtensions(o,i,t=console){const r=async a=>{if(a instanceof T.URI){const n=await this.extensionManagementService.getManifest(a);return y(n)}return a},s=[];for(const a of o){const n=await r(a),C=(await this.extensionManagementService.getInstalled()).filter(A=>P.areSameExtensions(A.identifier,{id:n}));if(!C.length)throw new Error(`${this.notInstalled(n)}
${c}`);if(C.some(A=>A.type===0)){t.log(h.localize(17,null,n));return}if(!i&&C.some(A=>A.isBuiltin)){t.log(h.localize(18,null,n));return}t.log(h.localize(19,null,n));for(const A of C)await this.extensionManagementService.uninstall(A),s.push(A);this.location?t.log(h.localize(20,null,n,this.location)):t.log(h.localize(21,null,n))}s.some(a=>u.isLanguagePackExtension(a.manifest))&&await this.updateLocalizationsCache()}async locateExtension(o,i=console){const t=await this.extensionManagementService.getInstalled();o.forEach(r=>{t.forEach(s=>{if(s.identifier.id===r&&s.location.scheme===d.Schemas.file){i.log(s.location.fsPath);return}})})}updateLocalizationsCache(){return this.localizationsService.update()}notInstalled(o){return this.location?h.localize(22,null,o,this.location):h.localize(23,null,o)}};w=ve([ge(0,k.IExtensionManagementService),ge(1,k.IExtensionGalleryService),ge(2,v.ILocalizationsService)],w),e.ExtensionManagementCLIService=w}),define(J[13],Z([0,1,7,2,4,5,38]),function(H,e,h,D,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=h.createDecorator("logService"),e.ILoggerService=h.createDecorator("loggerService");function P(){return new Date().toISOString()}var u;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(u=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=u.Info;class g extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new _.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=g;class I extends g{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...t){this.checkLogLevel(u.Trace)&&this.log(u.Trace,this.format([i,...t]))}debug(i,...t){this.checkLogLevel(u.Debug)&&this.log(u.Debug,this.format([i,...t]))}info(i,...t){this.checkLogLevel(u.Info)&&this.log(u.Info,this.format([i,...t]))}warn(i,...t){this.checkLogLevel(u.Warning)&&this.log(u.Warning,this.format([i,...t]))}error(i,...t){if(this.checkLogLevel(u.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(u.Error,this.format(r))}else this.log(u.Error,this.format([i,...t]))}critical(i,...t){this.checkLogLevel(u.Critical)&&this.log(u.Critical,this.format([i,...t]))}flush(){}format(i){let t="";for(let r=0;r<i.length;r++){let s=i[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch(a){}t+=(r>0?" ":"")+s}return t}}e.AbstractMessageLogger=I;class d extends g{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!T.isWindows}trace(i,...t){this.getLevel()<=u.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...t):console.log(`[main ${P()}]`,i,...t))}debug(i,...t){this.getLevel()<=u.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...t):console.log(`[main ${P()}]`,i,...t))}info(i,...t){this.getLevel()<=u.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...t):console.log(`[main ${P()}]`,i,...t))}warn(i,...t){this.getLevel()<=u.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,i,...t):console.warn(`[main ${P()}]`,i,...t))}error(i,...t){this.getLevel()<=u.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,i,...t):console.error(`[main ${P()}]`,i,...t))}critical(i,...t){this.getLevel()<=u.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,i,...t):console.error(`[main ${P()}]`,i,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class v extends g{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...t){this.getLevel()<=u.Trace&&console.log("%cTRACE","color: #888",i,...t)}debug(i,...t){this.getLevel()<=u.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...t)}info(i,...t){this.getLevel()<=u.Info&&console.log("%c INFO","color: #33f",i,...t)}warn(i,...t){this.getLevel()<=u.Warning&&console.log("%c WARN","color: #993",i,...t)}error(i,...t){this.getLevel()<=u.Error&&console.log("%c  ERR","color: #f33",i,...t)}critical(i,...t){this.getLevel()<=u.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...t)}dispose(){}flush(){}}e.ConsoleLogger=v;class m extends g{constructor(i,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(t)}trace(i,...t){this.getLevel()<=u.Trace&&this.adapter.log(u.Trace,[this.extractMessage(i),...t])}debug(i,...t){this.getLevel()<=u.Debug&&this.adapter.log(u.Debug,[this.extractMessage(i),...t])}info(i,...t){this.getLevel()<=u.Info&&this.adapter.log(u.Info,[this.extractMessage(i),...t])}warn(i,...t){this.getLevel()<=u.Warning&&this.adapter.log(u.Warning,[this.extractMessage(i),...t])}error(i,...t){this.getLevel()<=u.Error&&this.adapter.log(u.Error,[this.extractMessage(i),...t])}critical(i,...t){this.getLevel()<=u.Critical&&this.adapter.log(u.Critical,[this.extractMessage(i),...t])}extractMessage(i){return typeof i=="string"?i:k.toErrorMessage(i,this.getLevel()<=u.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class c extends g{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const t of this.logServices)t.setLevel(i);super.setLevel(i)}trace(i,...t){for(const r of this.logServices)r.trace(i,...t)}debug(i,...t){for(const r of this.logServices)r.debug(i,...t)}info(i,...t){for(const r of this.logServices)r.info(i,...t)}warn(i,...t){for(const r of this.logServices)r.warn(i,...t)}error(i,...t){for(const r of this.logServices)r.error(i,...t)}critical(i,...t){for(const r of this.logServices)r.critical(i,...t)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=c;class y extends D.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...t){this.logger.trace(i,...t)}debug(i,...t){this.logger.debug(i,...t)}info(i,...t){this.logger.info(i,...t)}warn(i,...t){this.logger.warn(i,...t)}error(i,...t){this.logger.error(i,...t)}critical(i,...t){this.logger.critical(i,...t)}flush(){this.logger.flush()}}e.LogService=y;class b{constructor(){this.onDidChangeLogLevel=new _.Emitter().event}setLevel(i){}getLevel(){return u.Info}trace(i,...t){}debug(i,...t){}info(i,...t){}warn(i,...t){}error(i,...t){}critical(i,...t){}dispose(){}flush(){}}e.NullLogService=b;function p(o){if(o.verbose)return u.Trace;if(typeof o.logLevel=="string"){const i=w(o.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function w(o){switch(o){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Critical;case"off":return u.Off}}e.parseLogLevel=w;function l(o){switch(o){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Critical:return"critical";case u.Off:return"off"}}e.LogLevelToString=l}),define(J[150],Z([0,1,15,2,24,27,23,6,19,31,13,26,44,4,12]),function(H,e,h,D,T,_,k,P,u,g,I,d,v,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let b=class extends D.Disposable{constructor(w,l,o,i){super();this.fileService=l,this.extensionGalleryService=o,this.logService=i,this.extensionsDownloadDir=P.URI.file(w.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(w,l){await this.cleanUpPromise;const o=this.getName(w),i=u.joinPath(this.extensionsDownloadDir,o);if(!await this.fileService.exists(i)){const t=u.joinPath(this.extensionsDownloadDir,`.${o}`);await this.fileService.exists(t)||await this.extensionGalleryService.download(w,t,l),await this.rename(t,i,Date.now()+2*60*1e3)}return i}async delete(w){}async rename(w,l,o){try{await h.promises.rename(w.fsPath,l.fsPath)}catch(i){if(m.isWindows&&i&&i.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${w} to ${l} with 'EPERM' error. Trying again...`),this.rename(w,l,o);throw i}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const w=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(w.children){const l=[],o=[];for(const r of w.children){const s=this.parse(r.name);s&&o.push([s,r])}const i=g.groupByExtension(o,([r])=>r),t=[];for(const r of i)r.sort((s,a)=>v.rcompare(s[0].version,a[0].version)),l.push(...r.slice(1).map(s=>s[1].resource)),t.push(r[0][1]);t.sort((r,s)=>r.mtime-s.mtime),l.push(...t.slice(0,Math.max(0,t.length-this.cache)).map(r=>r.resource)),await c.Promises.settled(l.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(w){this.logService.error(w)}}getName(w){return this.cache?new g.ExtensionIdentifierWithVersion(w.identifier,w.version).key().toLowerCase():d.generateUuid()}parse(w){const l=y.exec(w);return l&&l[1]&&l[2]?new g.ExtensionIdentifierWithVersion({id:l[1]},l[2]):null}};b=ve([ge(0,k.INativeEnvironmentService),ge(1,T.IFileService),ge(2,_.IExtensionGalleryService),ge(3,I.ILogService)],b),e.ExtensionsDownloader=b}),define(J[151],Z([0,1,2,13,39,38,3,12,5,11,17,23]),function(H,e,h,D,T,_,k,P,u,g,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=class extends h.Disposable{constructor(c,y){super();this.environmentService=c,this.logService=y,this.processesLimiter=new P.Limiter(5)}async postUninstall(c){const y=this.parseScript(c,"uninstall");return y&&(this.logService.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(y.script,"uninstall",y.args,!0,c).then(()=>this.logService.info(c.identifier.id,c.manifest.version,"Finished running post uninstall script"),b=>this.logService.error(c.identifier.id,c.manifest.version,`Failed to run post uninstall script: ${b}`)))),I.rimraf(this.getExtensionStoragePath(c)).then(void 0,b=>this.logService.error("Error while removing extension storage path",b))}parseScript(c,y){const b=`vscode:${y}`;if(c.location.scheme===g.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[b]=="string"){const p=c.manifest.scripts[b].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(c.identifier.id,c.manifest.version,`${b} should be a node script`),null):{script:k.join(c.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(c,y,b,p,w){return new Promise((l,o)=>{const i=this.start(c,y,b,w);let t;const r=s=>{t&&(clearTimeout(t),t=null),s?o(s):l(void 0)};i.on("error",s=>{r(_.toErrorMessage(s)||"Unknown")}),i.on("exit",(s,a)=>{r(s?`post-${y} process exited with code ${s}`:void 0)}),p&&(t=setTimeout(()=>{t=null,i.kill(),o("timed out")},5e3))})}start(c,y,b,p){const w={silent:!0,execArgv:void 0},l=T.fork(c,[`--type=extension-post-${y}`,...b],w);l.stdout.setEncoding("utf8"),l.stderr.setEncoding("utf8");const o=u.Event.fromNodeEventEmitter(l.stdout,"data"),i=u.Event.fromNodeEventEmitter(l.stderr,"data");o(s=>this.logService.info(p.identifier.id,p.manifest.version,`post-${y}`,s)),i(s=>this.logService.error(p.identifier.id,p.manifest.version,`post-${y}`,s));const t=u.Event.any(u.Event.map(o,s=>({data:`%c${s}`,format:[""]})),u.Event.map(i,s=>({data:`%c${s}`,format:["color: red"]})));return u.Event.debounce(t,(s,a)=>s?{data:s.data+a.data,format:[...s.format,...a.format]}:{data:a.data,format:a.format},100)(s=>{console.group(p.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),l}getExtensionStoragePath(c){return k.join(this.environmentService.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};v=ve([ge(0,d.IEnvironmentService),ge(1,D.ILogService)],v),e.ExtensionsLifecycle=v}),define(J[72],Z([0,1,124,98,2,24,5,19,30,22,13,16,42,12,25,11,69,59]),function(H,e,h,D,T,_,k,P,u,g,I,d,v,m,c,y,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class extends T.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueues=new Map}registerProvider(o,i){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);D.mark(`code/registerFilesystem/${o}`),this.provider.set(o,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:i});const t=new T.DisposableStore;return t.add(i.onDidChangeFile(r=>this._onDidFilesChange.fire(new _.FileChangesEvent(r,!this.isPathCaseSensitive(i))))),t.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:o}))),typeof i.onDidErrorOccur=="function"&&t.add(i.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),T.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:i}),this.provider.delete(o),T.dispose(t)})}async activateProvider(o){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){t&&i.push(t)}}),!this.provider.has(o)&&await m.Promises.settled(i)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,i){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&i)}listCapabilities(){return p.Iterable.map(this.provider,([o,i])=>({scheme:o,capabilities:i.capabilities}))}async withProvider(o){if(!P.isAbsolutePath(o))throw new _.FileOperationError(h.localize(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const i=this.provider.get(o.scheme);if(!i){const t=new Error;throw t.name="ENOPRO",t.message=h.localize(1,null,o.toString()),t}return i}async withReadProvider(o){const i=await this.withProvider(o);if(_.hasOpenReadWriteCloseCapability(i)||_.hasReadWriteCapability(i)||_.hasFileReadStreamCapability(i))return i;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const i=await this.withProvider(o);if(_.hasOpenReadWriteCloseCapability(i)||_.hasReadWriteCapability(i))return i;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,i){try{return await this.doResolveFile(o,i)}catch(t){throw _.toFileSystemProviderErrorCode(t)===_.FileSystemProviderErrorCode.FileNotFound?new _.FileOperationError(h.localize(2,null,this.resourceForError(o)),1):_.ensureFileSystemProviderError(t)}}async doResolveFile(o,i){const t=await this.withProvider(o),r=this.isPathCaseSensitive(t),s=i==null?void 0:i.resolveTo,a=i==null?void 0:i.resolveSingleChildDescendants,n=i==null?void 0:i.resolveMetadata,f=await t.stat(o);let C;return this.toFileStat(t,o,f,void 0,!!n,(A,O)=>(C||(C=u.TernarySearchTree.forUris(()=>!r),C.set(o,!0),g.isNonEmptyArray(s)&&s.forEach(E=>C.set(E,!0))),Boolean(C.findSuperstr(A.resource)||C.get(A.resource))?!0:A.isDirectory&&a?O===1:!1))}async toFileStat(o,i,t,r,s,a){const{providerExtUri:n}=this.getExtUri(o),f={resource:i,name:n.basename(i),isFile:(t.type&_.FileType.File)!=0,isDirectory:(t.type&_.FileType.Directory)!=0,isSymbolicLink:(t.type&_.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:_.etag({mtime:t.mtime,size:t.size})};if(f.isDirectory&&a(f,r)){try{const C=await o.readdir(i),A=await m.Promises.settled(C.map(async([O,E])=>{try{const F=n.joinPath(i,O),j=s?await o.stat(F):{type:E};return await this.toFileStat(o,F,j,C.length,s,a)}catch(F){return this.logService.trace(F),null}}));f.children=g.coalesce(A)}catch(C){this.logService.trace(C),f.children=[]}return f}return f}async resolveAll(o){return m.Promises.settled(o.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const i=await this.withProvider(o);try{return!!await i.stat(o)}catch(t){return!1}}async canCreateFile(o,i){try{await this.doValidateCreateFile(o,i)}catch(t){return t}return!0}async doValidateCreateFile(o,i){if(!(i==null?void 0:i.overwrite)&&await this.exists(o))throw new _.FileOperationError(h.localize(3,null,this.resourceForError(o)),3,i)}async createFile(o,i=d.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const r=await this.writeFile(o,i);return this._onDidRunOperation.fire(new _.FileOperationEvent(o,0,r)),r}async writeFile(o,i,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:s}=this.getExtUri(r);try{await this.validateWriteFile(r,o,t)||await this.mkdirp(r,s.dirname(o));let n;if(_.hasReadWriteCapability(r)&&!(i instanceof d.VSBuffer))if(v.isReadableStream(i)){const f=await v.peekStream(i,3);f.ended?n=d.VSBuffer.concat(f.buffer):n=f}else n=v.peekReadable(i,f=>d.VSBuffer.concat(f),3);else n=i;!_.hasOpenReadWriteCloseCapability(r)||_.hasReadWriteCapability(r)&&n instanceof d.VSBuffer?await this.doWriteUnbuffered(r,o,n):await this.doWriteBuffered(r,o,n instanceof d.VSBuffer?d.bufferToReadable(n):n)}catch(a){throw new _.FileOperationError(h.localize(4,null,this.resourceForError(o),_.ensureFileSystemProviderError(a).toString()),_.toFileOperationResult(a),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,i,t){let r;try{r=await o.stat(i)}catch(s){return}if((r.type&_.FileType.Directory)!=0)throw new _.FileOperationError(h.localize(5,null,this.resourceForError(i)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==_.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==_.etag({mtime:t.mtime,size:r.size}))throw new _.FileOperationError(h.localize(6,null),3,t);return r}async readFile(o,i){const t=await this.withReadProvider(o),r=await this.doReadAsFileStream(t,o,Object.assign(Object.assign({},i),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await d.streamToBuffer(r.value)})}async readFileStream(o,i){const t=await this.withReadProvider(o);return this.doReadAsFileStream(t,o,i)}async doReadAsFileStream(o,i,t){const r=new c.CancellationTokenSource,s=this.validateReadFile(i,t).then(n=>n,n=>{throw r.cancel(),n});let a;try{t&&typeof t.etag=="string"&&t.etag!==_.ETAG_DISABLED&&await s,!(_.hasOpenReadWriteCloseCapability(o)||_.hasFileReadStreamCapability(o))||_.hasReadWriteCapability(o)&&(t==null?void 0:t.preferUnbuffered)?a=this.readFileUnbuffered(o,i,t):_.hasFileReadStreamCapability(o)?a=this.readFileStreamed(o,i,r.token,t):a=this.readFileBuffered(o,i,r.token,t);const n=await s;return Object.assign(Object.assign({},n),{value:a})}catch(n){throw a&&await v.consumeStream(a),new _.FileOperationError(h.localize(7,null,this.resourceForError(i),_.ensureFileSystemProviderError(n).toString()),_.toFileOperationResult(n),t)}}readFileStreamed(o,i,t,r=Object.create(null)){const s=o.readFileStream(i,r,t);return v.transform(s,{data:a=>a instanceof d.VSBuffer?a:d.VSBuffer.wrap(a),error:a=>new _.FileOperationError(h.localize(8,null,this.resourceForError(i),_.ensureFileSystemProviderError(a).toString()),_.toFileOperationResult(a),r)},a=>d.VSBuffer.concat(a))}readFileBuffered(o,i,t,r=Object.create(null)){const s=d.newWriteableBufferStream();return b.readFileIntoStream(o,i,s,a=>a,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new _.FileOperationError(h.localize(9,null,this.resourceForError(i),_.ensureFileSystemProviderError(a).toString()),_.toFileOperationResult(a),r)}),t),s}readFileUnbuffered(o,i,t){const r=v.newWriteableStream(s=>d.VSBuffer.concat(s));return(async()=>{try{let s=await o.readFile(i);t&&typeof t.position=="number"&&(s=s.slice(t.position)),t&&typeof t.length=="number"&&(s=s.slice(0,t.length)),this.validateReadFileLimits(i,s.byteLength,t),r.end(d.VSBuffer.wrap(s))}catch(s){r.error(s),r.end()}})(),r}async validateReadFile(o,i){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new _.FileOperationError(h.localize(10,null,this.resourceForError(o)),0,i);if(i&&typeof i.etag=="string"&&i.etag!==_.ETAG_DISABLED&&i.etag===t.etag)throw new _.FileOperationError(h.localize(11,null),2,i);return this.validateReadFileLimits(o,t.size,i),t}validateReadFileLimits(o,i,t){if(t==null?void 0:t.limits){let r;if(typeof t.limits.memory=="number"&&i>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&i>t.limits.size&&(r=7),typeof r=="number")throw new _.FileOperationError(h.localize(12,null,this.resourceForError(o)),r)}}async canMove(o,i,t){return this.doCanMoveCopy(o,i,"move",t)}async canCopy(o,i,t){return this.doCanMoveCopy(o,i,"copy",t)}async doCanMoveCopy(o,i,t,r){if(o.toString()!==i.toString())try{const s=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(s,o,a,i,t,r)}catch(s){return s}return!0}async move(o,i,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),a=await this.doMoveCopy(r,o,s,i,"move",!!t),n=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new _.FileOperationEvent(o,a==="move"?2:3,n)),n}async copy(o,i,t){const r=await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),a=await this.doMoveCopy(r,o,s,i,"copy",!!t),n=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new _.FileOperationEvent(o,a==="copy"?3:2,n)),n}async doMoveCopy(o,i,t,r,s,a){if(i.toString()===r.toString())return s;const{exists:n,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(o,i,t,r,s,a);if(n&&!f&&a&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),s==="copy"){if(o===t&&_.hasFileFolderCopyCapability(o))await o.copy(i,r,{overwrite:a});else{const C=await this.resolve(i);C.isDirectory?await this.doCopyFolder(o,C,t,r):await this.doCopyFile(o,i,t,r)}return s}else return o===t?(await o.rename(i,r,{overwrite:a}),s):(await this.doMoveCopy(o,i,t,r,"copy",a),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(o,i,t,r){if(_.hasOpenReadWriteCloseCapability(o)&&_.hasOpenReadWriteCloseCapability(t))return this.doPipeBuffered(o,i,t,r);if(_.hasOpenReadWriteCloseCapability(o)&&_.hasReadWriteCapability(t))return this.doPipeBufferedToUnbuffered(o,i,t,r);if(_.hasReadWriteCapability(o)&&_.hasOpenReadWriteCloseCapability(t))return this.doPipeUnbufferedToBuffered(o,i,t,r);if(_.hasReadWriteCapability(o)&&_.hasReadWriteCapability(t))return this.doPipeUnbuffered(o,i,t,r)}async doCopyFolder(o,i,t,r){await t.mkdir(r),Array.isArray(i.children)&&await m.Promises.settled(i.children.map(async s=>{const a=this.getExtUri(t).providerExtUri.joinPath(r,s.name);return s.isDirectory?this.doCopyFolder(o,await this.resolve(s.resource),t,a):this.doCopyFile(o,s.resource,t,a)}))}async doValidateMoveCopy(o,i,t,r,s,a){let n=!1;if(o===t){const{providerExtUri:C,isPathCaseSensitive:A}=this.getExtUri(o);if(A||(n=C.isEqual(i,r)),n&&s==="copy")throw new Error(h.localize(13,null,this.resourceForError(i),this.resourceForError(r)));if(!n&&C.isEqualOrParent(r,i))throw new Error(h.localize(14,null,this.resourceForError(i),this.resourceForError(r)))}const f=await this.exists(r);if(f&&!n){if(!a)throw new _.FileOperationError(h.localize(15,null,this.resourceForError(i),this.resourceForError(r)),4);if(o===t){const{providerExtUri:C}=this.getExtUri(o);if(C.isEqualOrParent(i,r))throw new Error(h.localize(16,null,this.resourceForError(i),this.resourceForError(r)))}}return{exists:f,isSameResourceWithDifferentPathCase:n}}getExtUri(o){const i=this.isPathCaseSensitive(o);return{providerExtUri:i?P.extUri:P.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(i,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new _.FileOperationEvent(o,0,t)),t}async mkdirp(o,i){const t=[],{providerExtUri:r}=this.getExtUri(o);for(;!r.isEqual(i,r.dirname(i));)try{if(((await o.stat(i)).type&_.FileType.Directory)==0)throw new Error(h.localize(17,null,this.resourceForError(i)));break}catch(s){if(_.toFileSystemProviderErrorCode(s)!==_.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(r.basename(i)),i=r.dirname(i)}for(let s=t.length-1;s>=0;s--){i=r.joinPath(i,t[s]);try{await o.mkdir(i)}catch(a){if(_.toFileSystemProviderErrorCode(a)!==_.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,i){try{await this.doValidateDelete(o,i)}catch(t){return t}return!0}async doValidateDelete(o,i){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!(i==null?void 0:i.useTrash)&&!(t.capabilities&4096))throw new Error(h.localize(18,null,this.resourceForError(o)));const s=await this.exists(o);if(!s)throw new _.FileOperationError(h.localize(19,null,this.resourceForError(o)),1);if(!!!(i==null?void 0:i.recursive)&&s){const n=await this.resolve(o);if(n.isDirectory&&Array.isArray(n.children)&&n.children.length>0)throw new Error(h.localize(20,null,this.resourceForError(o)))}return t}async del(o,i){const t=await this.doValidateDelete(o,i),r=!!(i==null?void 0:i.useTrash),s=!!(i==null?void 0:i.recursive);await t.delete(o,{recursive:s,useTrash:r}),this._onDidRunOperation.fire(new _.FileOperationEvent(o,1))}watch(o,i={recursive:!1,excludes:[]}){let t=!1,r=()=>{t=!0};return this.doWatch(o,i).then(s=>{t?T.dispose(s):r=()=>T.dispose(s)},s=>this.logService.error(s)),T.toDisposable(()=>r())}async doWatch(o,i){const t=await this.withProvider(o),r=this.toWatchKey(t,o,i),s=this.activeWatchers.get(r)||{count:0,disposable:t.watch(o,i)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,s),s.count+=1,T.toDisposable(()=>{s.count--,s.count===0&&(T.dispose(s.disposable),this.activeWatchers.delete(r))})}toWatchKey(o,i,t){const{providerExtUri:r}=this.getExtUri(o);return[r.getComparisonKey(i),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>T.dispose(o.disposable)),this.activeWatchers.clear()}ensureWriteQueue(o,i){const{providerExtUri:t}=this.getExtUri(o),r=t.getComparisonKey(i);let s=this.writeQueues.get(r);return s||(s=new m.Queue,this.writeQueues.set(r,s),k.Event.once(s.onFinished)(()=>{this.writeQueues.delete(r),T.dispose(s)})),s}async doWriteBuffered(o,i,t){return this.ensureWriteQueue(o,i).queue(async()=>{const r=await o.open(i,{create:!0});try{v.isReadableStream(t)||v.isReadableBufferedStream(t)?await this.doWriteStreamBufferedQueued(o,r,t):await this.doWriteReadableBufferedQueued(o,r,t)}catch(s){throw _.ensureFileSystemProviderError(s)}finally{await o.close(r)}})}async doWriteStreamBufferedQueued(o,i,t){let r=0,s;if(v.isReadableBufferedStream(t)){if(t.buffer.length>0){const a=d.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,i,a,a.byteLength,r,0),r+=a.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise(async(a,n)=>{v.listenStream(s,{onData:async f=>{s.pause();try{await this.doWriteBuffer(o,i,f,f.byteLength,r,0)}catch(C){return n(C)}r+=f.byteLength,setTimeout(()=>s.resume())},onError:f=>n(f),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(o,i,t){let r=0,s;for(;(s=t.read())!==null;)await this.doWriteBuffer(o,i,s,s.byteLength,r,0),r+=s.byteLength}async doWriteBuffer(o,i,t,r,s,a){let n=0;for(;n<r;)n+=await o.write(i,s+n,t.buffer,a+n,r-n)}async doWriteUnbuffered(o,i,t){return this.ensureWriteQueue(o,i).queue(()=>this.doWriteUnbufferedQueued(o,i,t))}async doWriteUnbufferedQueued(o,i,t){let r;t instanceof d.VSBuffer?r=t:v.isReadableStream(t)?r=await d.streamToBuffer(t):v.isReadableBufferedStream(t)?r=await d.bufferedStreamToBuffer(t):r=d.readableToBuffer(t),await o.writeFile(i,r.buffer,{create:!0,overwrite:!0})}async doPipeBuffered(o,i,t,r){return this.ensureWriteQueue(t,r).queue(()=>this.doPipeBufferedQueued(o,i,t,r))}async doPipeBufferedQueued(o,i,t,r){let s,a;try{s=await o.open(i,{create:!1}),a=await t.open(r,{create:!0});const n=d.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,C=0,A=0;do A=await o.read(s,f,n.buffer,C,n.byteLength-C),await this.doWriteBuffer(t,a,n,A,f,C),f+=A,C+=A,C===n.byteLength&&(C=0);while(A>0)}catch(n){throw _.ensureFileSystemProviderError(n)}finally{await m.Promises.settled([typeof s=="number"?o.close(s):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async doPipeUnbuffered(o,i,t,r){return this.ensureWriteQueue(t,r).queue(()=>this.doPipeUnbufferedQueued(o,i,t,r))}async doPipeUnbufferedQueued(o,i,t,r){return t.writeFile(r,await o.readFile(i),{create:!0,overwrite:!0})}async doPipeUnbufferedToBuffered(o,i,t,r){return this.ensureWriteQueue(t,r).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,i,t,r))}async doPipeUnbufferedToBufferedQueued(o,i,t,r){const s=await t.open(r,{create:!0});try{const a=await o.readFile(i);await this.doWriteBuffer(t,s,d.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw _.ensureFileSystemProviderError(a)}finally{await t.close(s)}}async doPipeBufferedToUnbuffered(o,i,t,r){const s=await d.streamToBuffer(this.readFileBuffered(o,i,c.CancellationToken.None));await this.doWriteUnbuffered(t,r,s)}throwIfFileSystemIsReadonly(o,i){if(o.capabilities&2048)throw new _.FileOperationError(h.localize(21,null,this.resourceForError(i)),6);return o}resourceForError(o){return o.scheme===y.Schemas.file?o.fsPath:o.toString(!0)}};w=ve([ge(0,I.ILogService)],w),e.FileService=w}),define(J[53],Z([0,1,15,73,2,24,5,4,17,3,19,34,12,13,127,70,140,142,139,147,42,69,22,16]),function(H,e,h,D,T,_,k,P,u,g,I,d,v,m,c,y,b,p,w,l,o,i,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class s extends T.Disposable{constructor(n,f){var C;super();this.logService=n,this.options=f,this.BUFFER_SIZE=((C=this.options)===null||C===void 0?void 0:C.bufferSize)||64*1024,this.onDidChangeCapabilities=k.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Set,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new v.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8,P.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:f,symbolicLink:C}=await u.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(f,C),ctime:f.birthtime.getTime(),mtime:f.mtime.getTime(),size:f.size}}catch(f){throw this.toFileSystemProviderError(f)}}async readdir(n){try{const f=await u.readdir(this.toFilePath(n),{withFileTypes:!0}),C=[];return await Promise.all(f.map(async A=>{try{let O;A.isSymbolicLink()?O=(await this.stat(I.joinPath(n,A.name))).type:O=this.toType(A),C.push([A.name,O])}catch(O){this.logService.trace(O)}})),C}catch(f){throw this.toFileSystemProviderError(f)}}toType(n,f){let C;return(f==null?void 0:f.dangling)?C=_.FileType.Unknown:n.isFile()?C=_.FileType.File:n.isDirectory()?C=_.FileType.Directory:C=_.FileType.Unknown,f&&(C|=_.FileType.SymbolicLink),C}async readFile(n){try{const f=this.toFilePath(n);return await h.promises.readFile(f)}catch(f){throw this.toFileSystemProviderError(f)}}readFileStream(n,f,C){const A=o.newWriteableStream(O=>r.VSBuffer.concat(O.map(E=>r.VSBuffer.wrap(E))).buffer);return i.readFileIntoStream(this,n,A,O=>O.buffer,Object.assign(Object.assign({},f),{bufferSize:this.BUFFER_SIZE}),C),A}async writeFile(n,f,C){let A;try{const O=this.toFilePath(n);if(!C.create||!C.overwrite){if(await u.exists(O)){if(!C.overwrite)throw _.createFileSystemProviderError(c.localize(0,null),_.FileSystemProviderErrorCode.FileExists)}else if(!C.create)throw _.createFileSystemProviderError(c.localize(1,null),_.FileSystemProviderErrorCode.FileNotFound)}A=await this.open(n,{create:!0}),await this.write(A,0,f,0,f.byteLength)}catch(O){throw this.toFileSystemProviderError(O)}finally{typeof A=="number"&&await this.close(A)}}async open(n,f){try{const C=this.toFilePath(n);let A;if(f.create){if(P.isWindows)try{await h.promises.truncate(C,0),A="r+"}catch(E){E.code!=="ENOENT"&&this.logService.trace(E)}A||(A="w")}else A="r";const O=await D.promisify(h.open)(C,A);return this.mapHandleToPos.set(O,0),f.create&&this.writeHandles.add(O),O}catch(C){throw this.toFileSystemProviderError(C)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await D.promisify(h.fdatasync)(n)}catch(f){this.canFlush=!1,this.logService.error(f)}return await D.promisify(h.close)(n)}catch(f){throw this.toFileSystemProviderError(f)}}async read(n,f,C,A,O){const E=this.normalizePos(n,f);let F=null;try{const j=await D.promisify(h.read)(n,C,A,O,E);return typeof j=="number"?F=j:F=j.bytesRead,F}catch(j){throw this.toFileSystemProviderError(j)}finally{this.updatePos(n,E,F)}}normalizePos(n,f){return f===this.mapHandleToPos.get(n)?null:f}updatePos(n,f,C){const A=this.mapHandleToPos.get(n);typeof A=="number"&&(typeof f=="number"||(typeof C=="number"?this.mapHandleToPos.set(n,A+C):this.mapHandleToPos.delete(n)))}async write(n,f,C,A,O){return v.retry(()=>this.doWrite(n,f,C,A,O),100,3)}async doWrite(n,f,C,A,O){const E=this.normalizePos(n,f);let F=null;try{const j=await D.promisify(h.write)(n,C,A,O,E);return typeof j=="number"?F=j:F=j.bytesWritten,F}catch(j){throw this.toFileSystemProviderError(j)}finally{this.updatePos(n,E,F)}}async mkdir(n){try{await h.promises.mkdir(this.toFilePath(n))}catch(f){throw this.toFileSystemProviderError(f)}}async delete(n,f){try{const C=this.toFilePath(n);await this.doDelete(C,f)}catch(C){throw this.toFileSystemProviderError(C)}}async doDelete(n,f){f.recursive?await u.rimraf(n,u.RimRafMode.MOVE):await h.promises.unlink(n)}async rename(n,f,C){const A=this.toFilePath(n),O=this.toFilePath(f);if(A!==O)try{await this.validateTargetDeleted(n,f,"move",C.overwrite),await u.move(A,O)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error(c.localize(2,null,g.basename(A),g.basename(g.dirname(O)),E.toString()))),this.toFileSystemProviderError(E)}}async copy(n,f,C){const A=this.toFilePath(n),O=this.toFilePath(f);if(A!==O)try{await this.validateTargetDeleted(n,f,"copy",C.overwrite),await u.copy(A,O,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error(c.localize(3,null,g.basename(A),g.basename(g.dirname(O)),E.toString()))),this.toFileSystemProviderError(E)}}async validateTargetDeleted(n,f,C,A){const O=this.toFilePath(n),E=this.toFilePath(f);let F=!1;if(!!(this.capabilities&1024)||(F=d.isEqual(O,E,!0)),F&&C==="copy")throw _.createFileSystemProviderError(c.localize(4,null),_.FileSystemProviderErrorCode.FileExists);if(!F&&await u.exists(E)){if(!A)throw _.createFileSystemProviderError(c.localize(5,null),_.FileSystemProviderErrorCode.FileExists);await this.delete(f,{recursive:!0,useTrash:!1})}}watch(n,f){return f.recursive?this.watchRecursive(n,f.excludes):this.watchNonRecursive(n)}watchRecursive(n,f){const C={path:this.toFilePath(n),excludes:f},A=t.insert(this.recursiveFoldersToWatch,C);return this.refreshRecursiveWatchers(),T.toDisposable(()=>{A(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var n,f,C;if(this.recursiveWatcher instanceof w.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(T.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let A,O;((f=(n=this.options)===null||n===void 0?void 0:n.watcher)===null||f===void 0?void 0:f.usePolling)?(A=b.FileWatcher,O=(C=this.options)===null||C===void 0?void 0:C.watcher):this.recursiveFoldersToWatch.length===1?P.isWindows?A=p.FileWatcher:A=b.FileWatcher:A=w.FileWatcher,this.recursiveWatcher=new A(this.recursiveFoldersToWatch,E=>this._onDidChangeFile.fire(y.toFileChanges(E)),E=>{E.type==="error"&&this._onDidWatchErrorOccur.fire(E.message),this.logService[E.type](E.message)},this.logService.getLevel()===m.LogLevel.Trace,O),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))}}watchNonRecursive(n){const f=new l.FileWatcher(this.toFilePath(n),A=>this._onDidChangeFile.fire(y.toFileChanges(A)),A=>{A.type==="error"&&this._onDidWatchErrorOccur.fire(A.message),this.logService[A.type](A.message)},this.logService.getLevel()===m.LogLevel.Trace),C=this.logService.onDidChangeLogLevel(()=>{f.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)});return T.combinedDisposable(f,C)}toFilePath(n){return g.normalize(n.fsPath)}toFileSystemProviderError(n){if(n instanceof _.FileSystemProviderError)return n;let f;switch(n.code){case"ENOENT":f=_.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":f=_.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":f=_.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":f=_.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":f=_.FileSystemProviderErrorCode.NoPermissions;break;default:f=_.FileSystemProviderErrorCode.Unknown}return _.createFileSystemProviderError(n,f)}dispose(){super.dispose(),T.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,T.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=s}),define(J[74],Z([0,1,17,15,152,27,2,23,12,31,13,43,22,5,11,3]),function(H,e,h,D,T,_,k,P,u,g,I,d,v,m,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let b=class extends k.Disposable{constructor(l,o,i){super();this.extensionManagementService=l,this.logService=i,this._onDidLanguagesChange=this._register(new m.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new p(o,i)),this._register(l.onDidInstallExtension(({local:t})=>this.onDidInstallExtension(t))),this._register(l.onDidUninstallExtension(({identifier:t})=>this.onDidUninstallExtension(t)))}getLanguageIds(){return this.cache.getLanguagePacks().then(l=>{const o=["en",...Object.keys(l)];return v.distinct(o)})}onDidInstallExtension(l){l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",l.identifier.id),this.update().then(o=>{o&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(l){this.cache.getLanguagePacks().then(o=>{Object.keys(o).some(i=>o[i]&&o[i].extensions.some(t=>g.areSameExtensions(t.extensionIdentifier,l)))&&(this.logService.debug("Removing language packs from the extension",l.id),this.update().then(i=>{i&&this._onDidLanguagesChange.fire()}))})}async update(){const[l,o]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),i=await this.cache.update(o);return!v.equals(Object.keys(l),Object.keys(i))}};b=ve([ge(0,_.IExtensionManagementService),ge(1,P.INativeEnvironmentService),ge(2,I.ILogService)],b),e.LocalizationsService=b;let p=class extends k.Disposable{constructor(l,o){super();this.logService=o,this.languagePacks={},this.languagePacksFilePath=y.join(l.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new u.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(l){return this.withLanguagePacks(o=>{Object.keys(o).forEach(i=>delete o[i]),this.createLanguagePacksFromExtensions(o,...l)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(l,...o){for(const i of o)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(l,i);Object.keys(l).forEach(i=>this.updateHash(l[i]))}createLanguagePacksFromExtension(l,o){const i=o.identifier,t=o.manifest.contributes&&o.manifest.contributes.localizations?o.manifest.contributes.localizations:[];for(const r of t)if(o.location.scheme===c.Schemas.file&&d.isValidLocalization(r)){let s=l[r.languageId];s||(s={hash:"",extensions:[],translations:{}},l[r.languageId]=s);let a=s.extensions.filter(n=>g.areSameExtensions(n.extensionIdentifier,i))[0];a?a.version=o.manifest.version:s.extensions.push({extensionIdentifier:i,version:o.manifest.version});for(const n of r.translations)s.translations[n.id]=y.join(o.location.fsPath,n.path)}}updateHash(l){if(l){const o=T.createHash("md5");for(const i of l.extensions)o.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);l.hash=o.digest("hex")}}withLanguagePacks(l=()=>null){return this.languagePacksFileLimiter.queue(()=>{let o=null;return D.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch(t){return{}}}).then(i=>(o=l(i),i)).then(i=>{for(const r of Object.keys(i))i[r]||delete i[r];this.languagePacks=i,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),h.writeFile(this.languagePacksFilePath,t)}).then(()=>o,i=>this.logService.error(i))})}};p=ve([ge(0,P.INativeEnvironmentService),ge(1,I.ILogService)],p)}),define(J[153],Z([0,1,13]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function D(_,k){switch(k){case h.LogLevel.Trace:return _.trace;case h.LogLevel.Debug:return _.debug;case h.LogLevel.Info:return _.info;case h.LogLevel.Warning:return _.warn;case h.LogLevel.Error:return _.error;case h.LogLevel.Critical:return _.critical;default:throw new Error("Invalid log level")}}class T extends h.AbstractLogger{constructor(k=h.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(k),this._register(this.onDidChangeLogLevel(P=>{this._logger&&this._logger.setLevel(P)}))}set logger(k){this._logger=k;for(const{level:P,args:u}of this.buffer)D(k,P).apply(k,u);this.buffer=[]}_log(k,...P){this._logger?D(this._logger,k).apply(this._logger,P):this.getLevel()<=k&&this.buffer.push({level:k,args:P})}trace(k,...P){this._log(h.LogLevel.Trace,k,...P)}debug(k,...P){this._log(h.LogLevel.Debug,k,...P)}info(k,...P){this._log(h.LogLevel.Info,k,...P)}warn(k,...P){this._log(h.LogLevel.Warning,k,...P)}error(k,...P){this._log(h.LogLevel.Error,k,...P)}critical(k,...P){this._log(h.LogLevel.Critical,k,...P)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=T}),define(J[154],Z([0,1,13,24,12,16,19,2,7,153]),function(H,e,h,D,T,_,k,P,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const I=5*D.ByteSize.MB;let d=class extends h.AbstractLogger{constructor(c,y,b,p){super();this.name=c,this.resource=y,this.fileService=p,this.backupIndex=1,this.setLevel(b),this.queue=this._register(new T.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=h.LogLevel.Trace&&this._log(h.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=h.LogLevel.Debug&&this._log(h.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=h.LogLevel.Info&&this._log(h.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=h.LogLevel.Warning&&this._log(h.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=h.LogLevel.Error){const c=arguments[0];if(c instanceof Error){const y=Array.prototype.slice.call(arguments);y[0]=c.stack,this._log(h.LogLevel.Error,this.format(y))}else this._log(h.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=h.LogLevel.Critical&&this._log(h.LogLevel.Critical,this.format(arguments))}flush(){}log(c,y){this._log(c,this.format(y))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(c){if(c.fileOperationResult!==3)throw c}}_log(c,y){this.queue.queue(async()=>{await this.initializePromise;let b=await this.loadContent();b.length>I&&(await this.fileService.writeFile(this.getBackupResource(),_.VSBuffer.fromString(b)),b=""),b+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(c)}] ${y}
`,await this.fileService.writeFile(this.resource,_.VSBuffer.fromString(b))})}getCurrentTimestamp(){const c=p=>p<10?`0${p}`:p,y=p=>p<10?`00${p}`:p<100?`0${p}`:p,b=new Date;return`${b.getFullYear()}-${c(b.getMonth()+1)}-${c(b.getDate())} ${c(b.getHours())}:${c(b.getMinutes())}:${c(b.getSeconds())}.${y(b.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,k.joinPath(k.dirname(this.resource),`${k.basename(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(c){return""}}stringifyLogLevel(c){switch(c){case h.LogLevel.Critical:return"critical";case h.LogLevel.Debug:return"debug";case h.LogLevel.Error:return"error";case h.LogLevel.Info:return"info";case h.LogLevel.Trace:return"trace";case h.LogLevel.Warning:return"warning"}return""}format(c){let y="";for(let b=0;b<c.length;b++){let p=c[b];if(typeof p=="object")try{p=JSON.stringify(p)}catch(w){}y+=(b>0?" ":"")+p}return y}};d=ve([ge(3,D.IFileService)],d),e.FileLogger=d;let v=class extends P.Disposable{constructor(c,y,b){super();this.logService=c,this.instantiationService=y,this.fileService=b,this.loggers=new Map,this._register(c.onDidChangeLogLevel(p=>this.loggers.forEach(w=>w.setLevel(p))))}createLogger(c){let y=this.loggers.get(c.toString());return y||(y=new g.BufferLogService(this.logService.getLevel()),this.loggers.set(c.toString(),y),D.whenProviderRegistered(c,this.fileService).then(()=>y.logger=this.instantiationService.createInstance(d,k.basename(c),c,this.logService.getLevel()))),y}dispose(){this.loggers.forEach(c=>c.dispose()),this.loggers.clear(),super.dispose()}};v=ve([ge(0,h.ILogService),ge(1,u.IInstantiationService),ge(2,D.IFileService)],v),e.FileLoggerService=v}),define(J[155],Z([0,1,13,5,6]),function(H,e,h,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class _{constructor(v){this.service=v,this.onDidChangeLogLevel=D.Event.buffer(v.onDidChangeLogLevel,!0)}listen(v,m){switch(m){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${m}`)}async call(v,m,c){switch(m){case"setLevel":return this.service.setLevel(c)}throw new Error(`Call not found: ${m}`)}}e.LogLevelChannel=_;class k{constructor(v){this.channel=v}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(v){k.setLevel(this.channel,v)}static setLevel(v,m){return v.call("setLevel",m)}}e.LogLevelChannelClient=k;class P{constructor(v){this.loggerService=v,this.loggers=new Map}listen(v,m){throw new Error(`Event not found: ${m}`)}async call(v,m,c){switch(m){case"createLogger":this.createLogger(T.URI.revive(c[0]),c[1]);return;case"log":return this.log(T.URI.revive(c[0]),c[1]);case"consoleLog":return this.consoleLog(c[0],c[1])}throw new Error(`Call not found: ${m}`)}createLogger(v,m){this.loggers.set(v.toString(),this.loggerService.createLogger(v,m))}consoleLog(v,m){let c=console.log;switch(v){case h.LogLevel.Error:c=console.error;break;case h.LogLevel.Warning:c=console.warn;break;case h.LogLevel.Info:c=console.info;break}c.call(console,...m)}log(v,m){const c=this.loggers.get(v.toString());if(!c)throw new Error("Create the logger before logging");for(const[y,b]of m)switch(y){case h.LogLevel.Trace:c.trace(b);break;case h.LogLevel.Debug:c.debug(b);break;case h.LogLevel.Info:c.info(b);break;case h.LogLevel.Warning:c.warn(b);break;case h.LogLevel.Error:c.error(b);break;case h.LogLevel.Critical:c.critical(b);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class u{constructor(v){this.channel=v}createConsoleMainLogger(){return new h.AdapterLogger({log:(v,m)=>{this.channel.call("consoleLog",[v,m])}})}createLogger(v,m){return new g(this.channel,v,m)}}e.LoggerChannelClient=u;class g extends h.AbstractMessageLogger{constructor(v,m,c){super(c==null?void 0:c.always);this.channel=v,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.channel.call("createLogger",[m,c]).then(()=>{this._log(this.buffer),this.isLoggerCreated=!0})}log(v,m){this._log([[v,m]])}_log(v){this.isLoggerCreated?this.channel.call("log",[this.file,v]):this.buffer.push(...v)}}class I extends h.LogService{constructor(v,m){super(m);this.parent=v,this._register(v.onDidChangeLogLevel(c=>m.setLevel(c)))}setLevel(v){super.setLevel(v),this.parent.setLevel(v)}}e.FollowerLogService=I}),define(J[54],Z([0,1,13,24]),function(H,e,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function T(u,g,I,d){try{const v=await new Promise((m,c)=>{H(["spdlog"],m,c)});return v.setAsyncMode(8192,500),v.createRotatingLoggerAsync(u,g,I,d)}catch(v){console.error(v)}return null}function _(u,g,I,d){return H.__$__nodeRequire("spdlog").createRotatingLogger(u,g,I,d)}e.createRotatingLogger=_;function k(u,g,I){switch(g){case h.LogLevel.Trace:u.trace(I);break;case h.LogLevel.Debug:u.debug(I);break;case h.LogLevel.Info:u.info(I);break;case h.LogLevel.Warning:u.warn(I);break;case h.LogLevel.Error:u.error(I);break;case h.LogLevel.Critical:u.critical(I);break;default:throw new Error("Invalid log level")}}class P extends h.AbstractMessageLogger{constructor(g,I,d,v){super();this.name=g,this.filepath=I,this.rotating=d,this.buffer=[],this.setLevel(v),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const g=this.rotating?6:1,I=30/g*D.ByteSize.MB;return T(this.name,this.filepath,I,g).then(d=>{if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:v,message:m}of this.buffer)k(this._logger,v,m);this.buffer=[]}})}log(g,I){this._logger?k(this._logger,g,I):this.getLevel()<=g&&this.buffer.push({level:g,message:I})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(J[156],Z([0,1,13,2,19,11,154,54,24,26]),function(H,e,h,D,T,_,k,P,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let I=class extends D.Disposable{constructor(v,m){super();this.logService=v,this.fileService=m,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(v.onDidChangeLogLevel(c=>this.logLevelChangeableLoggers.forEach(y=>y.setLevel(c))))}createLogger(v,m){var c;let y=this.loggers.get(v.toString());return y||(v.scheme===_.Schemas.file?(y=new P.SpdLogLogger((m==null?void 0:m.name)||g.generateUuid(),v.fsPath,!(m==null?void 0:m.donotRotate),this.logService.getLevel()),(m==null?void 0:m.donotUseFormatters)&&y.clearFormatters()):y=new k.FileLogger((c=m==null?void 0:m.name)!==null&&c!==void 0?c:T.basename(v),v,this.logService.getLevel(),this.fileService),this.loggers.set(v.toString(),y),(m==null?void 0:m.always)?y.setLevel(h.LogLevel.Trace):this.logLevelChangeableLoggers.push(y)),y}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(v=>v.dispose()),this.loggers.clear(),super.dispose()}};I=ve([ge(0,h.ILogService),ge(1,u.IFileService)],I),e.LoggerService=I}),define(J[157],Z([0,1,92,7,5]),function(H,e,h,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=h.default,e.INotificationService=D.createDecorator("notificationService");var _;(function(g){g[g.WORKSPACE=0]="WORKSPACE",g[g.GLOBAL=1]="GLOBAL"})(_=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(g){g[g.OFF=0]="OFF",g[g.SILENT=1]="SILENT",g[g.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new u,this.onDidClose=T.Event.None,this.onDidChangeVisibility=T.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.NoOpNotification=P;class u{infinite(){}done(){}total(I){}worked(I){}}e.NoOpProgress=u}),define(J[28],Z([0,1,4,33,11,19]),function(H,e,h,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(h.isWeb||typeof H=="undefined"||typeof H.__$__nodeRequire!="function"){k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.54.0-dev",nameShort:h.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:h.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser"]});const P=document.getElementById("vscode-remote-product-configuration"),u=P&&P.getAttribute("data-settings");u&&Object.assign(k,JSON.parse(u))}else{const P=_.dirname(T.FileAccess.asFileUri("",H));k=H.__$__nodeRequire(_.joinPath(P,"product.json").fsPath);const u=H.__$__nodeRequire(_.joinPath(P,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:u.version})}e.default=k}),define(J[75],Z([0,1,21,28,104,3,19,89,110,11,6]),function(H,e,h,D,T,_,k,P,u,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataDir=e.parsePathArg=e.parseSearchPort=e.parseExtensionHostPort=e.NativeEnvironmentService=void 0;class d{constructor(w){if(this._args=w,!w.logsPath){const l=u.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");w.logsPath=_.join(this.userDataPath,"logs",l)}this.logsPath=w.logsPath}get args(){return this._args}get appRoot(){return _.dirname(g.FileAccess.asFileUri("",H).fsPath)}get userHome(){return I.URI.file(h.homedir())}get userDataPath(){const w=process.env.VSCODE_PORTABLE;return w?_.join(w,"user-data"):b(this._args,process)}get appSettingsHome(){return I.URI.file(_.join(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(h.tmpdir())}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return k.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return k.joinPath(this.userRoamingDataHome,"sync")}get userDataSyncLogResource(){return I.URI.file(_.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return k.joinPath(I.URI.file(_.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return I.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return I.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return k.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return k.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=process.env.VSCODE_PORTABLE;return w?I.URI.file(_.join(w,"argv.json")):k.joinPath(this.userHome,D.default.dataFolderName,"argv.json")}get snippetsHome(){return k.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this._args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file(_.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return _.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const w=y(this._args["builtin-extensions-dir"],process);return w||_.normalize(_.join(g.FileAccess.asFileUri("",H).fsPath,"..","extensions"))}get extensionsDownloadPath(){const w=y(this._args["extensions-download-dir"],process);return w||_.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const w=y(this._args["extensions-dir"],process);if(w)return w;const l=process.env.VSCODE_EXTENSIONS;if(l)return l;const o=process.env.VSCODE_PORTABLE;return o?_.join(o,"extensions"):k.joinPath(this.userHome,D.default.dataFolderName,"extensions").fsPath}get extraExtensionPaths(){return(this._args["extra-extensions-dir"]||[]).map(w=>y(w,process))}get extraBuiltinExtensionPaths(){return(this._args["extra-builtin-extensions-dir"]||[]).map(w=>y(w,process))}get extensionDevelopmentLocationURI(){const w=this._args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(l=>/^[^:/?#]+?:\/\//.test(l)?I.URI.parse(l):I.URI.file(_.normalize(l)))}get extensionTestsLocationURI(){const w=this._args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?I.URI.parse(w):I.URI.file(_.normalize(w))}get disableExtensions(){if(this._args["disable-extensions"])return!0;const w=this._args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return v(this._args,this.isBuilt)}get debugRenderer(){return!!this._args.debugRenderer}get isBuilt(){return!process.env.VSCODE_DEV}get verbose(){return!!this._args.verbose}get logLevel(){return this._args.log}get serviceMachineIdResource(){return k.joinPath(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this._args["crash-reporter-id"]}get crashReporterDirectory(){return this._args["crash-reporter-directory"]}get driverHandle(){return this._args.driver}get telemetryLogResource(){return I.URI.file(_.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this._args["disable-telemetry"]}}ve([P.memoize],d.prototype,"appRoot",null),ve([P.memoize],d.prototype,"userHome",null),ve([P.memoize],d.prototype,"userDataPath",null),ve([P.memoize],d.prototype,"appSettingsHome",null),ve([P.memoize],d.prototype,"tmpDir",null),ve([P.memoize],d.prototype,"userRoamingDataHome",null),ve([P.memoize],d.prototype,"settingsResource",null),ve([P.memoize],d.prototype,"userDataSyncHome",null),ve([P.memoize],d.prototype,"userDataSyncLogResource",null),ve([P.memoize],d.prototype,"sync",null),ve([P.memoize],d.prototype,"machineSettingsResource",null),ve([P.memoize],d.prototype,"globalStorageHome",null),ve([P.memoize],d.prototype,"workspaceStorageHome",null),ve([P.memoize],d.prototype,"keybindingsResource",null),ve([P.memoize],d.prototype,"keyboardLayoutResource",null),ve([P.memoize],d.prototype,"argvResource",null),ve([P.memoize],d.prototype,"snippetsHome",null),ve([P.memoize],d.prototype,"isExtensionDevelopment",null),ve([P.memoize],d.prototype,"untitledWorkspacesHome",null),ve([P.memoize],d.prototype,"installSourcePath",null),ve([P.memoize],d.prototype,"builtinExtensionsPath",null),ve([P.memoize],d.prototype,"extensionsPath",null),ve([P.memoize],d.prototype,"extraExtensionPaths",null),ve([P.memoize],d.prototype,"extraBuiltinExtensionPaths",null),ve([P.memoize],d.prototype,"extensionDevelopmentLocationURI",null),ve([P.memoize],d.prototype,"extensionTestsLocationURI",null),ve([P.memoize],d.prototype,"debugExtensionHost",null),ve([P.memoize],d.prototype,"serviceMachineIdResource",null),ve([P.memoize],d.prototype,"telemetryLogResource",null),e.NativeEnvironmentService=d;function v(p,w){return c(p["inspect-extensions"],p["inspect-brk-extensions"],5870,w,p.debugId)}e.parseExtensionHostPort=v;function m(p,w){return c(p["inspect-search"],p["inspect-brk-search"],5876,w)}e.parseSearchPort=m;function c(p,w,l,o,i){const r=Number(w||p)||(o?null:l),s=r?Boolean(!!w):!1;return{port:r,break:s,debugId:i}}function y(p,w){if(!!p){const l=_.resolve(p);return _.normalize(p)===l?l:_.resolve(w.env.VSCODE_CWD||w.cwd(),p)}}e.parsePathArg=y;function b(p,w){return y(p["user-data-dir"],w)||_.resolve(T.getDefaultUserDataPath())}e.parseUserDataDir=b}),define(J[45],Z([0,1,7]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=h.createDecorator("productService")}),define(J[29],Z([0,1,10,88]),function(H,e,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(k,P){D.ok(h.isString(k)),D.ok(h.isObject(P)),D.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,P)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new T}),define(J[158],Z([0,1,29,5]),function(H,e,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class _{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,g){this.schemasById[T(u)]=g,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new _;h.Registry.add(e.Extensions.JSONContribution,k)}),define(J[41],Z([0,1,117,5,29,10,158]),function(H,e,h,D,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const u=T.Registry.as(k.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:h.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},u.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(p,w=!0){this.registerConfigurations([p],w)}registerConfigurations(p,w=!0){const l=[];p.forEach(o=>{l.push(...this.validateAndRegisterProperties(o,w)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),u.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterConfigurations(p){const w=[],l=o=>{if(o.properties)for(const i in o.properties)w.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,o.properties[i]);o.allOf&&o.allOf.forEach(i=>l(i))};for(const o of p){l(o);const i=this.configurationContributors.indexOf(o);i!==-1&&this.configurationContributors.splice(i,1)}u.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}registerDefaultConfigurations(p){const w=[],l=[];for(const o of p)for(const i in o)if(w.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]=Object.assign(Object.assign({},this.defaultValues[i]||{}),o[i]);const t={type:"object",default:this.defaultValues[i],description:h.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};l.push(d(i)),this.configurationProperties[i]=t,this.defaultLanguageConfigurationOverridesNode.properties[i]=t}else{this.defaultValues[i]=o[i];const t=this.configurationProperties[i];t&&(this.updatePropertyDefaultValue(i,t),this.updateSchema(i,t))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}deregisterDefaultConfigurations(p){const w=[];for(const l of p)for(const o in l)if(w.push(o),delete this.defaultValues[o],e.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const i=this.configurationProperties[o];i&&(this.updatePropertyDefaultValue(o,i),this.updateSchema(o,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}notifyConfigurationSchemaUpdated(...p){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(p){for(const w of p)this.overrideIdentifiers.add(w);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(p,w=!0,l=3){l=_.isUndefinedOrNull(p.scope)?l:p.scope;let o=[],i=p.properties;if(i)for(let r in i){if(w&&c(r)){delete i[r];continue}const s=i[r];if(this.updatePropertyDefaultValue(r,s),e.OVERRIDE_PROPERTY_PATTERN.test(r)?s.scope=void 0:s.scope=_.isUndefinedOrNull(s.scope)?l:s.scope,i[r].hasOwnProperty("included")&&!i[r].included){this.excludedConfigurationProperties[r]=i[r],delete i[r];continue}else this.configurationProperties[r]=i[r];!i[r].deprecationMessage&&i[r].markdownDeprecationMessage&&(i[r].deprecationMessage=i[r].markdownDeprecationMessage),o.push(r)}let t=p.allOf;if(t)for(let r of t)o.push(...this.validateAndRegisterProperties(r,w,l));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(p){const w=l=>{let o=l.properties;if(o)for(const t in o)this.updateSchema(t,o[t]);let i=l.allOf;i&&i.forEach(w)};w(p)}updateSchema(p,w){switch(e.allSettings.properties[p]=w,w.scope){case 1:e.applicationSettings.properties[p]=w;break;case 2:e.machineSettings.properties[p]=w;break;case 6:e.machineOverridableSettings.properties[p]=w;break;case 3:e.windowSettings.properties[p]=w;break;case 4:e.resourceSettings.properties[p]=w;break;case 5:e.resourceSettings.properties[p]=w,this.resourceLanguageSettingsSchema.properties[p]=w;break}}removeFromSchema(p,w){switch(delete e.allSettings.properties[p],w.scope){case 1:delete e.applicationSettings.properties[p];break;case 2:delete e.machineSettings.properties[p];break;case 6:delete e.machineOverridableSettings.properties[p];break;case 3:delete e.windowSettings.properties[p];break;case 4:case 5:delete e.resourceSettings.properties[p];break}}updateOverridePropertyPatternKey(){for(const p of this.overrideIdentifiers.values()){const w=`[${p}]`,l={type:"object",description:h.localize(2,null),errorMessage:h.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(w,l),e.allSettings.properties[w]=l,e.applicationSettings.properties[w]=l,e.machineSettings.properties[w]=l,e.machineOverridableSettings.properties[w]=l,e.windowSettings.properties[w]=l,e.resourceSettings.properties[w]=l}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(p,w){let l=this.defaultValues[p];_.isUndefined(l)&&(l=w.default),_.isUndefined(l)&&(l=v(w.type)),w.default=l}}const I="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(I);function d(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=d;function v(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const m=new g;T.Registry.add(e.Extensions.Configuration,m);function c(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?h.localize(5,null,b):m.getConfigurationProperties()[b]!==void 0?h.localize(6,null,b):null:h.localize(4,null)}e.validateProperty=c;function y(){const b=[],p=m.getConfigurationProperties();for(const w of Object.keys(p))b.push([w,p[w].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=y}),define(J[32],Z([0,1,20,10,6,29,7,41]),function(H,e,h,D,T,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=k.createDecorator("configurationService");function u(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof T.URI)}e.isConfigurationOverrides=u;var g;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(g=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=I;function d(r,s){const a=s?r?s.keys.filter(F=>r.keys.indexOf(F)===-1):[...s.keys]:[],n=r?s?r.keys.filter(F=>s.keys.indexOf(F)===-1):[...r.keys]:[],f=[];if(s&&r){for(const F of r.keys)if(s.keys.indexOf(F)!==-1){const j=p(r.contents,F),G=p(s.contents,F);h.equals(j,G)||f.push(F)}}const C=[],A=F=>{const j={};for(const G of F)for(const z of G.identifiers)j[i(z)]=G;return j},O=s?A(s.overrides):{},E=r?A(r.overrides):{};if(Object.keys(O).length)for(const F of a){const j=O[F];j&&C.push([P.overrideIdentifierFromKey(F),j.keys])}if(Object.keys(E).length)for(const F of n){const j=E[F];j&&C.push([P.overrideIdentifierFromKey(F),j.keys])}if(Object.keys(O).length&&Object.keys(E).length)for(const F of f){const j=E[F],G=O[F];if(j&&G){const z=d({contents:j.contents,keys:j.keys,overrides:[]},{contents:G.contents,keys:G.keys,overrides:[]});C.push([P.overrideIdentifierFromKey(F),[...z.added,...z.removed,...z.updated]])}}return{added:a,removed:n,updated:f,overrides:C}}e.compare=d;function v(r,s){const a=[];for(const n of Object.keys(r))if(P.OVERRIDE_PROPERTY_PATTERN.test(n)){const f={};for(const C in r[n])f[C]=r[n][C];a.push({identifiers:[P.overrideIdentifierFromKey(n).trim()],keys:Object.keys(f),contents:m(f,s)})}return a}e.toOverrides=v;function m(r,s){const a=Object.create(null);for(let n in r)c(a,n,r[n],s);return a}e.toValuesTree=m;function c(r,s,a,n){const f=s.split("."),C=f.pop();let A=r;for(let O=0;O<f.length;O++){let E=f[O],F=A[E];switch(typeof F){case"undefined":F=A[E]=Object.create(null);break;case"object":break;default:n(`Ignoring ${s} as ${f.slice(0,O+1).join(".")} is ${JSON.stringify(F)}`);return}A=F}if(typeof A=="object"&&A!==null)try{A[C]=a}catch(O){n(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(A)}`)}else n(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(A)}`)}e.addToValueTree=c;function y(r,s){const a=s.split(".");b(r,a)}e.removeFromValueTree=y;function b(r,s){const a=s.shift();if(s.length===0){delete r[a];return}if(Object.keys(r).indexOf(a)!==-1){const n=r[a];typeof n=="object"&&!Array.isArray(n)&&(b(n,s),Object.keys(n).length===0&&delete r[a])}}function p(r,s,a){function n(A,O){let E=A;for(const F of O){if(typeof E!="object"||E===null)return;E=E[F]}return E}const f=s.split("."),C=n(r,f);return typeof C=="undefined"?a:C}e.getConfigurationValue=p;function w(r,s,a){Object.keys(s).forEach(n=>{n!=="__proto__"&&(n in r?D.isObject(r[n])&&D.isObject(s[n])?w(r[n],s[n],a):a&&(r[n]=s[n]):r[n]=s[n])})}e.merge=w;function l(){const r=_.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=l;function o(){const r=Object.create(null),s=_.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let a in s){let n=s[a].default;c(r,a,n,f=>console.error(`Conflict in default settings: ${f}`))}return r}e.getDefaultValues=o;function i(r){return`[${r}]`}e.keyFromOverrideIdentifier=i;function t(r,s,a){const n=r.inspect(s),f=r.inspect(a);return typeof n.userValue!="undefined"||typeof n.workspaceValue!="undefined"||typeof n.workspaceFolderValue!="undefined"?n.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:n.defaultValue}e.getMigratedSettingValue=t}),define(J[159],Z([0,1,60,30,22,10,20,6,41,32,29,2,5]),function(H,e,h,D,T,_,k,P,u,g,I,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?g.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?g.getConfigurationValue(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const a of T.distinct([...Object.keys(this.contents),...Object.keys(r)])){let n=this.contents[a],f=r[a];f&&(typeof n=="object"&&typeof f=="object"?(n=k.deepClone(n),this.mergeContents(n,f)):n=f),s[a]=n}return new m(s,this.keys,this.overrides)}merge(...t){const r=k.deepClone(this.contents),s=k.deepClone(this.overrides),a=[...this.keys];for(const n of t){this.mergeContents(r,n.contents);for(const f of n.overrides){const[C]=s.filter(A=>T.equals(A.identifiers,f.identifiers));C?this.mergeContents(C.contents,f.contents):s.push(k.deepClone(f))}for(const f of n.keys)a.indexOf(f)===-1&&a.push(f)}return new m(r,a,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&_.isObject(t[s])&&_.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=k.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?k.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),g.addToValueTree(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&g.removeFromValueTree(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=m;class c extends m{constructor(){const t=g.getDefaultValues(),r=g.getConfigurationKeys(),s=[];for(const a of Object.keys(t))u.OVERRIDE_PROPERTY_PATTERN.test(a)&&s.push({identifiers:[u.overrideIdentifierFromKey(a).trim()],keys:Object.keys(t[a]),contents:g.toValuesTree(t[a],n=>console.error(`Conflict in default settings file: ${n}`))});super(t,r,s)}}e.DefaultConfigurationModel=c;class y{constructor(t,r){this._name=t,this._scopes=r,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get errors(){return this._parseErrors}parseContent(t){if(!_.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r)}}parseRaw(t){this._raw=t;const r=this.doParseRaw(t);this._configurationModel=new m(r.contents,r.keys,r.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let r={},s=null,a=[],n=[],f=[];function C(O){Array.isArray(a)?a.push(O):s&&(a[s]=O)}let A={onObjectBegin:()=>{let O={};C(O),n.push(a),a=O,s=null},onObjectProperty:O=>{s=O},onObjectEnd:()=>{a=n.pop()},onArrayBegin:()=>{let O=[];C(O),n.push(a),a=O,s=null},onArrayEnd:()=>{a=n.pop()},onLiteralValue:C,onError:(O,E,F)=>{f.push({error:O,offset:E,length:F})}};if(t)try{h.visit(t,A),r=a[0]||{}}catch(O){console.error(`Error while parsing settings file ${this._name}: ${O}`),this._parseErrors=[O]}return r}doParseRaw(t){if(this._scopes){const n=I.Registry.as(u.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,n,!0,this._scopes)}const r=g.toValuesTree(t,n=>console.error(`Conflict in settings file ${this._name}: ${n}`)),s=Object.keys(t),a=g.toOverrides(t,n=>console.error(`Conflict in settings file ${this._name}: ${n}`));return{contents:r,keys:s,overrides:a}}filterByScope(t,r,s,a){const n={};for(let f in t)if(u.OVERRIDE_PROPERTY_PATTERN.test(f)&&s)n[f]=this.filterByScope(t[f],r,!1,a);else{const C=this.getScope(f,r);(C===void 0||a.indexOf(C)!==-1)&&(n[f]=t[f])}return n}getScope(t,r){const s=r[t];return s?typeof s.scope!="undefined"?s.scope:3:void 0}}e.ConfigurationModelParser=y;class b extends d.Disposable{constructor(t,r,s,a){super();this.userSettingsResource=t,this.scopes=r,this.fileService=a,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(v.Event.filter(this.fileService.onDidFilesChange,n=>n.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new m}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=b;class p{constructor(t,r,s=new m,a=new m,n=new D.ResourceMap,f=new m,C=new D.ResourceMap,A=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=n,this._memoryConfiguration=f,this._memoryConfigurationByResource=C,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let a;s.resource?(a=this._memoryConfigurationByResource.get(s.resource),a||(a=new m,this._memoryConfigurationByResource.set(s.resource,a))):a=this._memoryConfiguration,r===void 0?a.removeValue(t):a.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const a=this.getConsolidateConfigurationModel(r,s),n=this.getFolderConfigurationModelForResource(r.resource,s),f=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,C=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),A=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),O=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),E=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),F=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,j=n?r.overrideIdentifier?n.freeze().override(r.overrideIdentifier).getValue(t):n.freeze().getValue(t):void 0,G=r.overrideIdentifier?f.override(r.overrideIdentifier).getValue(t):f.getValue(t),z=a.getValue(t),W=T.distinct(T.flatten(a.overrides.map(q=>q.identifiers))).filter(q=>a.getOverrideValue(t,q)!==void 0);return{defaultValue:C,userValue:A,userLocalValue:O,userRemoteValue:E,workspaceValue:F,workspaceFolderValue:j,memoryValue:G,value:z,default:C!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:O!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:E!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:j!==void 0?{value:n==null?void 0:n.freeze().getValue(t),override:r.overrideIdentifier?n==null?void 0:n.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:G!==void 0?{value:f.getValue(t),override:r.overrideIdentifier?f.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(a=>u.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const n=u.overrideIdentifierFromKey(a),f=this._defaultConfiguration.getKeysForOverrideIdentifier(n),C=t.getKeysForOverrideIdentifier(n),A=[...C.filter(O=>f.indexOf(O)===-1),...f.filter(O=>C.indexOf(O)===-1),...f.filter(O=>!k.equals(this._defaultConfiguration.override(n).getValue(O),t.override(n).getValue(O)))];return[n,A]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:a,overrides:n}=g.compare(this.localUserConfiguration,t),f=[...r,...s,...a];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:n}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:a,overrides:n}=g.compare(this.remoteUserConfiguration,t);let f=[...r,...s,...a];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:n}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:a,overrides:n}=g.compare(this.workspaceConfiguration,t);let f=[...r,...s,...a];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:n}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:a,updated:n,removed:f,overrides:C}=g.compare(s,r);let A=[...a,...n,...f];return(A.length||!s)&&this.updateFolderConfiguration(t,r),{keys:A,overrides:C}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:a,removed:n,overrides:f}=g.compare(r,void 0);return{keys:[...s,...a,...n],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const a=r.getFolder(t);a&&(s=this.getFolderConsolidatedConfiguration(a.uri)||s);const n=this._memoryConfigurationByResource.get(t);n&&(s=s.merge(n))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(r=s.merge(a),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:a,keys:n}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:a,keys:n}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),n=t.folders.reduce((f,C)=>(f.set(P.URI.revive(C[0]),this.parseConfigurationModel(C[1])),f),new D.ResourceMap);return new p(r,s,new m,a,n,new m,new D.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=p;function w(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const t=new Set,r=new Map;for(const a of i)a.keys.forEach(n=>t.add(n)),a.overrides.forEach(([n,f])=>{const C=D.getOrSet(r,n,new Set);f.forEach(A=>C.add(A))});const s=[];return r.forEach((a,n)=>s.push([n,[...a.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=w;class l{constructor(t,r,s,a){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=a,this._previousConfiguration=void 0;const n=new Set;t.keys.forEach(C=>n.add(C)),t.overrides.forEach(([,C])=>C.forEach(A=>n.add(A))),this.affectedKeys=[...n.values()];const f=new m;this.affectedKeys.forEach(C=>f.setValue(C,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,n=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!k.equals(a,n)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=g.toValuesTree({[r]:!0},()=>{}),a;for(;typeof s=="object"&&(a=Object.keys(s)[0]);){if(t=t[a],!t)return!1;s=s[a]}return!0}}e.ConfigurationChangeEvent=l;class o extends l{constructor(t,r,s,a){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=o}),define(J[76],Z([0,1,29,41,2,32,159,5,12,19]),function(H,e,h,D,T,_,k,P,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends T.Disposable{constructor(v,m){super();this.settingsResource=v,this._onDidChangeConfiguration=this._register(new P.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new k.UserSettings(this.settingsResource,void 0,g.extUriBiasedIgnorePathCase,m)),this.configuration=new k.Configuration(new k.DefaultConfigurationModel,new k.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new u.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(h.Registry.as(D.Extensions.Configuration).onDidUpdateConfiguration(c=>this.onDidDefaultConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const v=await this.userConfiguration.loadConfiguration();this.configuration=new k.Configuration(new k.DefaultConfigurationModel,v)}getConfigurationData(){return this.configuration.toData()}getValue(v,m){const c=typeof v=="string"?v:void 0,y=_.isConfigurationOverrides(v)?v:_.isConfigurationOverrides(m)?m:{};return this.configuration.getValue(c,y,void 0)}updateValue(v,m,c,y){return Promise.reject(new Error("not supported"))}inspect(v){return this.configuration.inspect(v,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const m=this.configuration.toData(),c=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(c,m,1)}onDidDefaultConfigurationChange(v){const m=this.configuration.toData(),c=this.configuration.compareAndUpdateDefaultConfiguration(new k.DefaultConfigurationModel,v);this.trigger(c,m,6)}trigger(v,m,c){const y=new k.ConfigurationChangeEvent(v,{data:m},this.configuration);y.source=c,y.sourceConfig=this.getTargetConfiguration(c),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(v){switch(v){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(J[160],Z([0,1,7]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=h.createDecorator("remoteAuthorityResolverService");var D;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(k,P=D.Unknown,u){super(k);this._message=k,this._code=P,this._detail=u,this.isHandled=P===D.NotAvailable&&u===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(k){return k instanceof T&&k._code===D.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof T&&k._code===D.NoResolverFound}static isHandled(k){return k instanceof T&&k.isHandled}}e.RemoteAuthorityResolverError=T}),define(J[55],Z([0,1,128,7,41,29,16]),function(H,e,h,D,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=D.createDecorator("requestService");function P(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=P;function u(d){return d.res.statusCode===204}async function g(d){if(!P(d))throw new Error("Server returned "+d.res.statusCode);return u(d)?null:(await k.streamToBuffer(d.stream)).toString()}e.asText=g;async function I(d){if(!P(d))throw new Error("Server returned "+d.res.statusCode);if(u(d))return null;const m=(await k.streamToBuffer(d.stream)).toString();try{return JSON.parse(m)}catch(c){throw c.message+=`:
`+m,c}}e.asJson=I,_.Registry.as(T.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:h.localize(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:h.localize(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:h.localize(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:h.localize(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[h.localize(4,null),h.localize(5,null),h.localize(6,null)],default:"override",description:h.localize(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:h.localize(8,null)}}})}),define(J[161],Z([0,1,25,16]),function(H,e,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class T{constructor(P){this.service=P}listen(P,u){throw new Error("Invalid listen")}call(P,u,g){switch(u){case"request":return this.service.request(g[0],h.CancellationToken.None).then(async({res:I,stream:d})=>{const v=await D.streamToBuffer(d);return[{statusCode:I.statusCode,headers:I.headers},v]})}throw new Error("Invalid call")}}e.RequestChannel=T;class _{constructor(P){this.channel=P}async request(P,u){return _.request(this.channel,P,u)}static async request(P,u,g){const[I,d]=await P.call("request",[u]);return{res:I,stream:D.bufferToStream(d)}}}e.RequestChannelClient=_}),define(J[162],Z([0,1,163,10]),function(H,e,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function T(k){return k.protocol==="http:"?process.env.HTTP_PROXY||process.env.http_proxy||null:k.protocol==="https:"&&(process.env.HTTPS_PROXY||process.env.https_proxy||process.env.HTTP_PROXY||process.env.http_proxy)||null}async function _(k,P={}){const u=h.parse(k),g=P.proxyUrl||T(u);if(!g)return null;const I=h.parse(g);if(!/^https?:$/.test(I.protocol||""))return null;const d={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:D.isBoolean(P.strictSSL)?P.strictSSL:!0};return u.protocol==="http:"?new(await new Promise((v,m)=>{H(["http-proxy-agent"],v,m)}))(d):new(await new Promise((v,m)=>{H(["https-proxy-agent"],v,m)}))(d)}e.getProxyAgent=_}),define(J[164],Z([0,1,26,16]),function(H,e,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function T(_,k,P){let u=P&&P.get("storage.serviceMachineId",0)||null;if(u)return u;try{const I=(await k.readFile(_.serviceMachineIdResource)).value.toString();u=h.isUUID(I)?I:null}catch(g){u=null}if(!u){u=h.generateUuid();try{await k.writeFile(_.serviceMachineIdResource,D.VSBuffer.fromString(u))}catch(g){}}return P&&P.store("storage.serviceMachineId",u,0,1),u}e.getServiceMachineId=T}),define(J[165],Z([0,1,7]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=h.createDecorator("stateService")}),define(J[166],Z([0,1,3,15,23,17,10,13]),function(H,e,h,D,T,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class u{constructor(d,v){this.dbPath=d,this.onError=v,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(!this._database){const d=await this.loadAsync();this._database||(this._database=d)}}loadSync(){try{return this.lastFlushedSerializedDatabase=D.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(d){return d.code!=="ENOENT"&&this.onError(d),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await D.promises.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(d){return d.code!=="ENOENT"&&this.onError(d),{}}}getItem(d,v){const m=this.database[d];return k.isUndefinedOrNull(m)?v:m}setItem(d,v){if(k.isUndefinedOrNull(v))return this.removeItem(d);(typeof v=="string"||typeof v=="number"||typeof v=="boolean")&&this.database[d]===v||(this.database[d]=v,this.saveSync())}removeItem(d){k.isUndefined(this.database[d])||(this.database[d]=void 0,this.saveSync())}saveSync(){const d=JSON.stringify(this.database,null,4);if(d!==this.lastFlushedSerializedDatabase)try{_.writeFileSync(this.dbPath,d),this.lastFlushedSerializedDatabase=d}catch(v){this.onError(v)}}}e.FileStorage=u;let g=class Ke{constructor(d,v){this.fileStorage=new u(h.join(d.userDataPath,Ke.STATE_FILE),m=>v.error(m))}init(){return this.fileStorage.init()}getItem(d,v){return this.fileStorage.getItem(d,v)}setItem(d,v){this.fileStorage.setItem(d,v)}removeItem(d){this.fileStorage.removeItem(d)}};g.STATE_FILE="storage.json",g=ve([ge(0,T.INativeEnvironmentService),ge(1,P.ILogService)],g),e.StateService=g}),define(J[167],Z([0,1,7,5,2,10,106,12]),function(H,e,h,D,T,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const u="__$__targetStorageMarker";e.IStorageService=h.createDecorator("storageService");var g;(function(y){y[y.NONE=0]="NONE",y[y.SHUTDOWN=1]="SHUTDOWN"})(g=e.WillSaveStateReason||(e.WillSaveStateReason={}));var I;(function(y){y[y.GLOBAL=0]="GLOBAL",y[y.WORKSPACE=1]="WORKSPACE"})(I=e.StorageScope||(e.StorageScope={}));var d;(function(y){y[y.USER=0]="USER",y[y.MACHINE=1]="MACHINE"})(d=e.StorageTarget||(e.StorageTarget={}));class v extends T.Disposable{constructor(b={flushInterval:v.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new D.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new P.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new T.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=P.runWhenIdle(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){T.dispose([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,p){p===u?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:p,target:this.getKeyTargets(b)[p]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,p,w){var l;return(l=this.getStorage(p))===null||l===void 0?void 0:l.get(b,w)}getBoolean(b,p,w){var l;return(l=this.getStorage(p))===null||l===void 0?void 0:l.getBoolean(b,w)}getNumber(b,p,w){var l;return(l=this.getStorage(p))===null||l===void 0?void 0:l.getNumber(b,w)}store(b,p,w,l){if(_.isUndefinedOrNull(p)){this.remove(b,w);return}this.withPausedEmitters(()=>{var o;this.updateKeyTarget(b,w,l),(o=this.getStorage(w))===null||o===void 0||o.set(b,p)})}remove(b,p){this.withPausedEmitters(()=>{var w;this.updateKeyTarget(b,p,void 0),(w=this.getStorage(p))===null||w===void 0||w.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,p){const w=[],l=this.getKeyTargets(b);for(const o of Object.keys(l))l[o]===p&&w.push(o);return w}updateKeyTarget(b,p,w){var l,o;const i=this.getKeyTargets(p);typeof w=="number"?i[b]!==w&&(i[b]=w,(l=this.getStorage(p))===null||l===void 0||l.set(u,JSON.stringify(i))):typeof i[b]=="number"&&(delete i[b],(o=this.getStorage(p))===null||o===void 0||o.set(u,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const p=this.get(u,b);if(p)try{return JSON.parse(p)}catch(w){}return Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(){var b,p,w,l;this._onWillSaveState.fire({reason:g.NONE}),await P.Promises.settled([(p=(b=this.getStorage(0))===null||b===void 0?void 0:b.whenFlushed())!==null&&p!==void 0?p:Promise.resolve(),(l=(w=this.getStorage(1))===null||w===void 0?void 0:w.whenFlushed())!==null&&l!==void 0?l:Promise.resolve()])}async logStorage(){var b,p,w,l,o,i;const t=(p=(b=this.getStorage(0))===null||b===void 0?void 0:b.items)!==null&&p!==void 0?p:new Map,r=(l=(w=this.getStorage(1))===null||w===void 0?void 0:w.items)!==null&&l!==void 0?l:new Map;return c(t,r,(o=this.getLogDetails(0))!==null&&o!==void 0?o:"",(i=this.getLogDetails(1))!==null&&i!==void 0?i:"")}}e.AbstractStorageService=v,v.DEFAULT_FLUSH_INTERVAL=60*1e3;class m extends v{constructor(){super();this.globalStorage=new k.Storage(new k.InMemoryStorageDatabase),this.workspaceStorage=new k.Storage(new k.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}e.InMemoryStorageService=m;async function c(y,b,p,w){const l=n=>{try{return JSON.parse(n)}catch(f){return n}},o=new Map,i=new Map;y.forEach((n,f)=>{o.set(f,n),i.set(f,l(n))});const t=new Map,r=new Map;b.forEach((n,f)=>{t.set(f,n),r.set(f,l(n))}),console.group(`Storage: Global (path: ${p})`);let s=[];o.forEach((n,f)=>{s.push({key:f,value:n})}),console.table(s),console.groupEnd(),console.log(i),console.group(`Storage: Workspace (path: ${w})`);let a=[];t.forEach((n,f)=>{a.push({key:f,value:n})}),console.table(a),console.groupEnd(),console.log(r)}e.logStorage=c}),define(J[77],Z([0,1,4,33,26,6]),function(H,e,h,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;async function k(u,g,I,d,v,m,c,y,b){const p=Object.create(null);p["common.machineId"]=m,p.sessionID=T.generateUuid()+Date.now(),p.commitHash=d,p.version=v,p["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=h.PlatformToString(h.platform),p["common.nodePlatform"]=D.platform,p["common.nodeArch"]=I,p["common.product"]=b||"desktop";const w=P(c||[]);w&&(p["common.msftInternal"]=w);let l=0;const o=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),h.isLinuxSnap&&(p["common.snap"]="true");try{const i=await u.readFile(_.URI.file(y));p["common.source"]=i.value.toString().slice(0,30)}catch(i){}return p}e.resolveCommonProperties=k;function P(u){const g=D.env.USERDNSDOMAIN;if(!g)return!1;const I=g.toLowerCase();return u.some(d=>I===d)}}),define(J[168],Z([0,1,22,14,2,20]),function(H,e,h,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var k;(function(u){function g(I,d){return I.callstack<d.callstack?-1:I.callstack>d.callstack?1:0}u.compare=g})(k=e.ErrorEvent||(e.ErrorEvent={}));class P{constructor(g,I=P.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new T.DisposableStore,this._telemetryService=g,this._flushDelay=I;const d=D.errorHandler.addListener(v=>this._onErrorEvent(v));this._disposables.add(T.toDisposable(d)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(g){if(!!g){g.detail&&g.detail.stack&&(g=g.detail);let I=Array.isArray(g.stack)?g.stack.join(`
`):g.stack,d=g.message?g.message:_.safeStringify(g);!I||this._enqueue({msg:d,callstack:I})}}_enqueue(g){const I=h.binarySearch(this._buffer,g,k.compare);I<0?(g.count=1,this._buffer.splice(~I,0,g)):(this._buffer[I].count||(this._buffer[I].count=0),this._buffer[I].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let g of this._buffer)this._telemetryService.publicLogError2("UnhandledError",g);this._buffer.length=0}}e.default=P,P.ERROR_FLUSH_TIMEOUT=5*1e3}),define(J[169],Z([0,1,2,4,168]),function(H,e,h,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class _ extends T.default{installErrorListeners(){let P,u=this;typeof D.globals.onerror=="function"&&(P=D.globals.onerror),D.globals.onerror=function(g,I,d,v,m){u._onUncaughtError(g,I,d,v,m),P&&P.apply(this,arguments)},this._disposables.add(h.toDisposable(()=>{P&&(D.globals.onerror=P)}))}_onUncaughtError(P,u,g,I,d){let v={callstack:P,msg:P,file:u,line:g,column:I};if(d){let{name:m,message:c,stack:y}=d;v.uncaught_error_name=m,c&&(v.uncaught_error_msg=c),y&&(v.callstack=Array.isArray(d.stack)?d.stack=d.stack.join(`
`):d.stack)}this._enqueue(v)}}e.default=_}),define(J[46],Z([0,1,7]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ITelemetryService=void 0,e.ITelemetryService=h.createDecorator("telemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(J[78],Z([0,1,14,27,31,20,46,55,50,23,25,13,24,6,45,167,164,7,19]),function(H,e,h,D,T,_,k,P,u,g,I,d,v,m,c,y,b,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var l;(function(L){L[L.None=0]="None",L[L.IncludeVersions=1]="IncludeVersions",L[L.IncludeFiles=2]="IncludeFiles",L[L.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",L[L.IncludeSharedAccounts=8]="IncludeSharedAccounts",L[L.IncludeVersionProperties=16]="IncludeVersionProperties",L[L.ExcludeNonValidated=32]="ExcludeNonValidated",L[L.IncludeInstallationTargets=64]="IncludeInstallationTargets",L[L.IncludeAssetUri=128]="IncludeAssetUri",L[L.IncludeStatistics=256]="IncludeStatistics",L[L.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",L[L.Unpublished=4096]="Unpublished"})(l||(l={}));function o(...L){return String(L.reduce((S,R)=>S|R,0))}var i;(function(L){L[L.Tag=1]="Tag",L[L.ExtensionId=4]="ExtensionId",L[L.Category=5]="Category",L[L.ExtensionName=7]="ExtensionName",L[L.Target=8]="Target",L[L.Featured=9]="Featured",L[L.SearchText=10]="SearchText",L[L.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:l.None,criteria:[],assetTypes:[]};class n{constructor(S=a){this.state=S}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(S,R=this.state.pageSize){return new n(Object.assign(Object.assign({},this.state),{pageNumber:S,pageSize:R}))}withFilter(S,...R){const N=[...this.state.criteria,...R.length?R.map(U=>({filterType:S,value:U})):[{filterType:S}]];return new n(Object.assign(Object.assign({},this.state),{criteria:N}))}withSortBy(S){return new n(Object.assign(Object.assign({},this.state),{sortBy:S}))}withSortOrder(S){return new n(Object.assign(Object.assign({},this.state),{sortOrder:S}))}withFlags(...S){return new n(Object.assign(Object.assign({},this.state),{flags:S.reduce((R,N)=>R|N,0)}))}withAssetTypes(...S){return new n(Object.assign(Object.assign({},this.state),{assetTypes:S}))}get raw(){const{criteria:S,pageNumber:R,pageSize:N,sortBy:U,sortOrder:$,flags:K,assetTypes:Y}=this.state;return{filters:[{criteria:S,pageNumber:R,pageSize:N,sortBy:U,sortOrder:$}],assetTypes:Y,flags:K}}get searchText(){const S=this.state.criteria.filter(R=>R.filterType===i.SearchText)[0];return S&&S.value?S.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(S=>String(S.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function f(L,S){const R=(L||[]).filter(N=>N.statisticName===S)[0];return R?R.value:0}function C(L){const S="Microsoft.VisualStudio.Code.Translation.";return L.files.filter(N=>N.assetType.indexOf(S)===0).reduce((N,U)=>{const $=F(L,U.assetType);return $&&N.push([U.assetType.substring(S.length),$]),N},[])}function A(L){if(L.properties){const S=L.properties.filter(U=>U.key===t.Repository),R=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),N=S.filter(U=>R.test(U.value))[0];return N?{uri:N.value,fallbackUri:N.value}:null}return F(L,t.Repository)}function O(L){return{uri:`${L.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${L.fallbackAssetUri}/${t.VSIX}`}}function E(L){const S=F(L,t.Icon);if(S)return S;const R=D.DefaultIconPath;return{uri:R,fallbackUri:R}}function F(L,S){return L.files.filter(N=>N.assetType===S)[0]?{uri:`${L.assetUri}/${S}`,fallbackUri:`${L.fallbackAssetUri}/${S}`}:null}function j(L,S){const R=L.properties?L.properties.filter(U=>U.key===S):[],N=R.length>0&&R[0].value;return N?N.split(",").map(U=>T.adoptToGalleryExtensionId(U)):[]}function G(L){const S=L.properties?L.properties.filter(R=>R.key===r.Engine):[];return S.length>0&&S[0].value||""}function z(L){const S=L.properties?L.properties.filter(N=>N.key===r.LocalizedLanguages):[],R=S.length>0&&S[0].value||"";return R?R.split(","):[]}function W(L){return L.indexOf("preview")!==-1}function q(L){const S=L.properties?L.properties.find(R=>R.key===r.WebExtension):void 0;return!!S&&S.value==="true"}function ee(L){return L.files.some(S=>S.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?w.joinPath(m.URI.parse(L.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function te(L,S,R,N,U){const $={manifest:F(S,t.Manifest),readme:F(S,t.Details),changelog:F(S,t.Changelog),license:F(S,t.License),repository:A(S),download:O(S),icon:E(S),coreTranslations:C(S)};return{identifier:{id:T.getGalleryExtensionId(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},name:L.extensionName,version:S.version,date:S.lastUpdated,displayName:L.displayName,publisherId:L.publisher.publisherId,publisher:L.publisher.publisherName,publisherDisplayName:L.publisher.displayName,description:L.shortDescription||"",installCount:f(L.statistics,"install"),rating:f(L.statistics,"averagerating"),ratingCount:f(L.statistics,"ratingcount"),assetUri:m.URI.parse(S.assetUri),webResource:ee(S),assetTypes:S.files.map(({assetType:K})=>K),assets:$,properties:{dependencies:j(S,r.Dependency),extensionPack:j(S,r.ExtensionPack),engine:G(S),localizedLanguages:z(S),webExtension:q(S)},telemetryData:{index:(N.pageNumber-1)*N.pageSize+R,searchText:N.searchText,querySource:U},preview:W(L.flags)}}let B=class{constructor(S,R,N,U,$,K,Y){this.requestService=S,this.logService=R,this.environmentService=N,this.telemetryService=U,this.fileService=$,this.productService=K;const Q=K.extensionsGallery;this.extensionsGalleryUrl=Q&&Q.serviceUrl,this.extensionsControlUrl=Q&&Q.controlUrl,this.commonHeadersPromise=M(K.version,this.environmentService,this.fileService,Y)}api(S=""){return`${this.extensionsGalleryUrl}${S}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(S,R){const N=[];let{total:U,firstPage:$,getPage:K}=await this.query({names:S,pageSize:S.length},R);N.push(...$);for(let Y=1;N.length<U&&($=await K(Y,R),$.length);Y++)N.push(...$);return N}async getCompatibleExtension(S,R){const N=await this.getCompatibleExtensionByEngine(S,R);return(N==null?void 0:N.properties.webExtension)?N.webResource?N:null:N}async getCompatibleExtensionByEngine(S,R){const N=D.isIExtensionIdentifier(S)?null:S;if(N&&N.properties.engine&&u.isEngineValid(N.properties.engine,this.productService.version))return N;const{id:U,uuid:$}=N?N.identifier:S;let K=new n().withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");$?K=K.withFilter(i.ExtensionId,$):K=K.withFilter(i.ExtensionName,U);const{galleryExtensions:Y}=await this.queryGallery(K,I.CancellationToken.None),[Q]=Y;if(!Q||!Q.versions.length)return null;if(R){const oe=Q.versions.filter(ce=>ce.version===R)[0];if(oe){const ce=te(Q,oe,0,K);if(ce.properties.engine&&u.isEngineValid(ce.properties.engine,this.productService.version))return ce}return null}const se=await this.getLastValidExtensionVersion(Q,Q.versions);return se?te(Q,se,0,K):null}async query(S,R){const N=I.CancellationToken.isCancellationToken(S)?{}:S,U=I.CancellationToken.isCancellationToken(S)?S:R;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let $=N.text||"";const K=_.getOrDefault(N,he=>he.pageSize,50);let Y=new n().withFlags(l.IncludeLatestVersionOnly,l.IncludeAssetUri,l.IncludeStatistics,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,K).withFilter(i.Target,"Microsoft.VisualStudio.Code");$?($=$.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,_e,Pe)=>(Y=Y.withFilter(i.Category,Pe||_e),"")),$=$.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,_e,Pe)=>(Y=Y.withFilter(i.Tag,Pe||_e),"")),$=$.replace(/\bfeatured(\s+|\b|$)/g,()=>(Y=Y.withFilter(i.Featured),"")),$=$.trim(),$&&($=$.length<200?$:$.substring(0,200),Y=Y.withFilter(i.SearchText,$)),Y=Y.withSortBy(0)):N.ids?Y=Y.withFilter(i.ExtensionId,...N.ids):N.names?Y=Y.withFilter(i.ExtensionName,...N.names):Y=Y.withSortBy(4),typeof N.sortBy=="number"&&(Y=Y.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(Y=Y.withSortOrder(N.sortOrder));const{galleryExtensions:Q,total:se}=await this.queryGallery(Y,U),oe=Q.map((he,_e)=>te(he,he.versions[0],_e,Y,N.source)),ce=async(he,_e)=>{if(_e.isCancellationRequested)throw h.canceled();const Pe=Y.withPage(he+1),{galleryExtensions:Re}=await this.queryGallery(Pe,_e);return Re.map((Ae,Se)=>te(Ae,Ae.versions[0],Se,Pe,N.source))};return{firstPage:oe,total:se,pageSize:Y.pageSize,getPage:ce}}async queryGallery(S,R){if(!this.isEnabled())throw new Error("No extension gallery service configured.");S=S.withFlags(S.flags,l.ExcludeNonValidated).withFilter(i.ExcludeWithFlags,o(l.Unpublished));const N=await this.commonHeadersPromise,U=JSON.stringify(S.raw),$=Object.assign(Object.assign({},N),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(U.length)}),K=new Date().getTime();let Y,Q,se=0;try{if(Y=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:U,headers:$},R),Y.res.statusCode&&Y.res.statusCode>=400&&Y.res.statusCode<500)return{galleryExtensions:[],total:se};const oe=await P.asJson(Y);if(oe){const ce=oe.results[0],he=ce.extensions,_e=ce.resultMetadata&&ce.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return se=_e&&_e.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:se}}return{galleryExtensions:[],total:se}}catch(oe){throw Q=oe,oe}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},S.telemetryData),{requestBodySize:String(U.length),duration:new Date().getTime()-K,success:!!Y&&P.isSuccess(Y),responseBodySize:Y==null?void 0:Y.res.headers["Content-Length"],statusCode:Y?String(Y.res.statusCode):void 0,errorCode:Q?h.isPromiseCanceledError(Q)?"canceled":h.getErrorMessage(Q).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(se)}))}}async reportStatistic(S,R,N,U){if(!!this.isEnabled()){const $=await this.commonHeadersPromise,K=Object.assign(Object.assign({},$),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${S}/extensions/${R}/${N}/stats?statType=${U}`),headers:K},I.CancellationToken.None)}catch(Y){}}}async download(S,R,N){this.logService.trace("ExtensionGalleryService#download",S.identifier.id);const U=T.getGalleryExtensionTelemetryData(S),$=new Date().getTime(),K=oe=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},U),{duration:oe})),Y=N===1?"install":N===2?"update":"",Q=Y?{uri:`${S.assets.download.uri}&${Y}=true`,fallbackUri:`${S.assets.download.fallbackUri}?${Y}=true`}:S.assets.download,se=await this.getAsset(Q);await this.fileService.writeFile(R,se.stream),K(new Date().getTime()-$)}async getReadme(S,R){if(S.assets.readme){const N=await this.getAsset(S.assets.readme,{},R);return await P.asText(N)||""}return""}async getManifest(S,R){if(S.assets.manifest){const N=await this.getAsset(S.assets.manifest,{},R),U=await P.asText(N);return U?JSON.parse(U):null}return null}async getCoreTranslation(S,R){const N=S.assets.coreTranslations.filter(U=>U[0]===R.toUpperCase())[0];if(N){const U=await this.getAsset(N[1]),$=await P.asText(U);return $?JSON.parse($):null}return null}async getChangelog(S,R){if(S.assets.changelog){const N=await this.getAsset(S.assets.changelog,{},R);return await P.asText(N)||""}return""}async getAllVersions(S,R){let N=new n().withFlags(l.IncludeVersions,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");S.identifier.uuid?N=N.withFilter(i.ExtensionId,S.identifier.uuid):N=N.withFilter(i.ExtensionName,S.identifier.id);const U=[],{galleryExtensions:$}=await this.queryGallery(N,I.CancellationToken.None);return $.length&&(R?await Promise.all($[0].versions.map(async K=>{let Y;try{Y=await this.getEngine(K)}catch(Q){}Y&&u.isEngineValid(Y,this.productService.version)&&U.push({version:K.version,date:K.lastUpdated})})):U.push(...$[0].versions.map(K=>({version:K.version,date:K.lastUpdated})))),U}async getAsset(S,R={},N=I.CancellationToken.None){const U=await this.commonHeadersPromise,$={type:"GET"},K=Object.assign(Object.assign({},U),R.headers||{});R=Object.assign(Object.assign(Object.assign({},R),$),{headers:K});const Y=S.uri,Q=S.fallbackUri,se=Object.assign(Object.assign({},R),{url:Y});try{const oe=await this.requestService.request(se,N);if(oe.res.statusCode===200)return oe;const ce=await P.asText(oe);throw new Error(`Expected 200, got back ${oe.res.statusCode} instead.

${ce}`)}catch(oe){if(h.isPromiseCanceledError(oe))throw oe;const ce=h.getErrorMessage(oe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Y,message:ce});const he=Object.assign(Object.assign({},R),{url:Q});return this.requestService.request(he,N)}}async getLastValidExtensionVersion(S,R){const N=this.getLastValidExtensionVersionFromProperties(S,R);return N||this.getLastValidExtensionVersionRecursively(S,R)}getLastValidExtensionVersionFromProperties(S,R){for(const N of R){const U=G(N);if(!U)return null;if(u.isEngineValid(U,this.productService.version))return N}return null}async getEngine(S){const R=G(S);if(R)return R;const N=F(S,t.Manifest);if(!N)throw new Error("Manifest was not found");const U={"Accept-Encoding":"gzip"},$=await this.getAsset(N,{headers:U}),K=await P.asJson($);if(K)return K.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(S,R){if(!R.length)return null;const N=R[0],U=await this.getEngine(N);return u.isEngineValid(U,this.productService.version)?(N.properties=N.properties||[],N.properties.push({key:r.Engine,value:U}),N):this.getLastValidExtensionVersionRecursively(S,R.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const S=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},I.CancellationToken.None);if(S.res.statusCode!==200)throw new Error("Could not get extensions report.");const R=await P.asJson(S),N=new Map;if(R)for(const U of R.malicious){const $=N.get(U)||{id:{id:U},malicious:!0,slow:!1};$.malicious=!0,N.set(U,$)}return[...N.values()]}};B=ve([ge(0,P.IRequestService),ge(1,d.ILogService),ge(2,g.IEnvironmentService),ge(3,k.ITelemetryService),ge(4,v.IFileService),ge(5,c.IProductService),ge(6,p.optional(y.IStorageService))],B),e.ExtensionGalleryService=B;async function M(L,S,R,N){const U={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L}`},$=await b.getServiceMachineId(S,R,N);return U["X-Market-User-Id"]=$,U}e.resolveMarketplaceHeaders=M}),define(J[79],Z([0,1,28,129,18,7,32,41,2,20,29]),function(H,e,h,D,T,_,k,P,u,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let d=class{constructor(c,y){this._configurationService=y,this._experimentProperties={},this._disposables=new u.DisposableStore,this._cleanupPatterns=[],this._appender=c.appender,this._commonProperties=c.commonProperties||Promise.resolve({}),this._piiPaths=c.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!c.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let b of this._piiPaths)this._cleanupPatterns.push(new RegExp(T.escapeRegExpCharacters(b),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(b=>{const p=/^[a-f0-9]+$/i.test(b["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!p})}))}setExperimentProperty(c,y){this._experimentProperties[c]=y}setEnabled(c){this._enabled=c}_updateUserOptIn(){var c;const y=(c=this._configurationService)===null||c===void 0?void 0:c.getValue(v);this._userOptIn=y?y.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const c=await this._commonProperties;let y=c.sessionID,b=c["common.instanceId"],p=c["common.machineId"],w=c["common.firstSessionDate"],l=c["common.msftInternal"];return{sessionId:y,instanceId:b,machineId:p,firstSessionDate:w,msftInternal:l}}dispose(){this._disposables.dispose()}publicLog(c,y,b){return this.isOptedIn?this._commonProperties.then(p=>{y=g.mixin(y,p),y=g.mixin(y,this._experimentProperties),y=g.cloneAndChange(y,w=>{if(typeof w=="string")return this._cleanupInfo(w,b)}),this._appender.log(c,y)},p=>{console.error(p)}):Promise.resolve(void 0)}publicLog2(c,y,b){return this.publicLog(c,y,b)}publicLogError(c,y){return this.sendErrorTelemetry?this.publicLog(c,y,!0):Promise.resolve(void 0)}publicLogError2(c,y){return this.publicLogError(c,y)}_cleanupInfo(c,y){let b=c;if(y){const p=[];for(let i of this._cleanupPatterns)for(;;){const t=i.exec(c);if(!t)break;p.push([t.index,i.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(b="";;){const i=l.exec(c);if(!i)break;!w.test(i[0])&&p.every(([t,r])=>i.index<t||i.index>=r)&&(b+=c.substring(o,i.index)+"<REDACTED: user-file-path>",o=l.lastIndex)}o<c.length&&(b+=c.substr(o))}for(let p of this._cleanupPatterns)b=b.replace(p,"");return b}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=ve([ge(1,_.optional(k.IConfigurationService))],d),e.TelemetryService=d;const v="telemetry";I.Registry.as(P.Extensions.Configuration).registerConfiguration({id:v,order:110,type:"object",title:D.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:h.default.privacyStatementUrl?D.localize(2,null,h.default.privacyStatementUrl):D.localize(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(J[47],Z([0,1,32,20,10,12]),function(H,e,h,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(m,c){return Promise.resolve(void 0)}publicLog2(m,c){return this.publicLog(m,c)}publicLogError(m,c){return Promise.resolve(void 0)}publicLogError2(m,c){return this.publicLogError(m,c)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};function k(...m){return{log:(c,y)=>m.forEach(b=>b.log(c,y)),flush:()=>_.Promises.settled(m.map(c=>c.flush()))}}e.combinedAppender=k,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(m,c){return c.onDidChangeConfiguration(y=>{y.source!==6&&m.publicLog2("updateConfiguration",{configurationSource:h.ConfigurationTargetToString(y.source),configurationKeys:d(y.sourceConfig)})})}e.configurationTelemetry=P;function u(m){const c=Object.create(null),y=Object.create(null),b=Object.create(null);I(m,b);for(let p in b){p=p.length>150?p.substr(p.length-149):p;const w=b[p];typeof w=="number"?y[p]=w:typeof w=="boolean"?y[p]=w?1:0:typeof w=="string"?c[p]=w.substring(0,1023):typeof w!="undefined"&&w!==null&&(c[p]=w)}return{properties:c,measurements:y}}e.validateTelemetryData=u;function g(m){if(!m)return"none";let c="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(b=>{m.indexOf(`${b}+`)===0&&(c=b)}),c}e.cleanRemoteAuthority=g;function I(m,c,y=0,b){if(!!m)for(let p of Object.getOwnPropertyNames(m)){const w=m[p],l=b?b+p:p;Array.isArray(w)?c[l]=D.safeStringify(w):w instanceof Date?c[l]=w.toISOString():T.isObject(w)?y<2?I(w,c,y+1,l+"."):c[l]=D.safeStringify(w):c[l]=w}}function d(m){if(!m)return[];const c=[];return v(c,"",m),c}function v(m,c,y){y&&typeof y=="object"&&!Array.isArray(y)?Object.keys(y).forEach(b=>v(m,c?`${c}.${b}`:b,y[b])):m.push(c)}}),define(J[170],Z([0,1,2,23,13,47]),function(H,e,h,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let k=class extends h.Disposable{constructor(u,g){super();this.logger=this._register(u.createLogger(g.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(u,g){this.logger.trace(`telemetry/${u}`,_.validateTelemetryData(g))}};k=ve([ge(0,T.ILoggerService),ge(1,D.IEnvironmentService)],k),e.TelemetryLogAppender=k}),define(J[80],Z([0,1,14,20,47]),function(H,e,h,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function _(P){const u=await new Promise((I,d)=>{H(["applicationinsights"],I,d)});let g;return u.defaultClient?(g=new u.TelemetryClient(P),g.channel.setUseDiskRetryCaching(!0)):(u.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),g=u.defaultClient),P.indexOf("AIF-")===0&&(g.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),g}class k{constructor(u,g,I){this._eventPrefix=u,this._defaultData=g,this._defaultData||(this._defaultData=Object.create(null)),typeof I=="function"?this._aiClient=I():this._aiClient=I,this._asyncAIClient=null}_withAIClient(u){if(!!this._aiClient){if(typeof this._aiClient!="string"){u(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=_(this._aiClient)),this._asyncAIClient.then(g=>{u(g)},g=>{h.onUnexpectedError(g),console.error(g)})}}log(u,g){!this._aiClient||(g=D.mixin(g,this._defaultData),g=T.validateTelemetryData(g),this._withAIClient(I=>I.trackEvent({name:this._eventPrefix+"/"+u,properties:g.properties,measurements:g.measurements})))}flush(){return this._aiClient?new Promise(u=>{this._withAIClient(g=>{g.flush({callback:()=>{this._aiClient=void 0,u(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=k}),define(J[171],Z([0,1,17,15,3]),function(H,e,h,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;function _(k,P){const u=Object.create(null),g=(d,v)=>{const m=JSON.parse(d);u[v]=m};if(P){const d=h.readdirSync(P).filter(m=>{try{return D.statSync(T.join(P,m)).isDirectory()}catch(c){return!1}}),v=[];d.forEach(m=>{h.readdirSync(T.join(P,m)).filter(y=>y==="telemetry.json").length===1&&v.push(m)}),v.forEach(m=>{const c=D.readFileSync(T.join(P,m,"telemetry.json")).toString();g(c,m)})}let I=D.readFileSync(T.join(k,"telemetry-core.json")).toString();return g(I,"vscode-core"),I=D.readFileSync(T.join(k,"telemetry-extensions.json")).toString(),g(I,"vscode-extensions"),JSON.stringify(u,null,4)}e.buildTelemetryMessage=_}),define(J[172],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class h{constructor(T){this._callback=T,this._terminalBufferMap=new Map}dispose(){for(const T of this._terminalBufferMap.values())T.dispose()}startBuffering(T,_,k=5){let P;return P=_(u=>{const g=typeof u=="string"?u:u.data;let I=this._terminalBufferMap.get(T);if(I){I.data.push(g);return}const d=setTimeout(()=>this._flushBuffer(T),k);I={data:[g],timeoutId:d,dispose:()=>{clearTimeout(d),this._flushBuffer(T),P.dispose()}},this._terminalBufferMap.set(T,I)}),P}stopBuffering(T){const _=this._terminalBufferMap.get(T);_&&_.dispose()}_flushBuffer(T){const _=this._terminalBufferMap.get(T);_&&(this._terminalBufferMap.delete(T),this._callback(T,_.data.join("")))}}e.TerminalDataBufferer=h}),define(J[173],Z([0,1,21,3,17,10,20,4]),function(H,e,h,D,T,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function u(){const I=/(\d+)\.(\d+)\.(\d+)/g.exec(h.release());let d=0;return I&&I.length===4&&(d=parseInt(I[3])),d}e.getWindowsBuildNumber=u;async function g(I,d,v,m=process.env){if(D.isAbsolute(I))return await T.exists(I)?I:void 0;if(d===void 0&&(d=process.cwd()),D.dirname(I)!=="."){const p=D.join(d,I);return await T.exists(p)?p:void 0}const y=k.getCaseInsensitive(m,"PATH");if(v===void 0&&_.isString(y)&&(v=y.split(D.delimiter)),v===void 0||v.length===0){const p=D.join(d,I);return await T.exists(p)?p:void 0}for(let p of v){let w;if(D.isAbsolute(p)?w=D.join(p,I):w=D.join(d,p,I),await T.exists(w))return w;if(P.isWindows){let l=w+".com";if(await T.exists(l)||(l=w+".exe",await T.exists(l)))return l}}const b=D.join(d,I);return await T.exists(b)?b:void 0}e.findExecutable=g}),define(J[174],Z([0,1,3,4,15,21,5,2,39,13,173,6,130]),function(H,e,h,D,T,_,k,P,u,g,I,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalProcess=void 0;const m=50,c=5;var y;(function(w){w[w.DataFlushTimeout=250]="DataFlushTimeout",w[w.MaximumShutdownTime=5e3]="MaximumShutdownTime"})(y||(y={}));let b=class extends P.Disposable{constructor(l,o,i,t,r,s,a,n){var f;super();this._shellLaunchConfig=l,this._executableEnv=s,this._logService=n,this.id=0,this.shouldPersist=!1,this._currentTitle="",this._isDisposed=!1,this._titleInterval=null,this._writeQueue=[],this._isPtyPaused=!1,this._unacknowledgedCharCount=0,this._onProcessData=this._register(new k.Emitter),this._onProcessExit=this._register(new k.Emitter),this._onProcessReady=this._register(new k.Emitter),this._onProcessTitleChanged=this._register(new k.Emitter);let C;D.isWindows?C=h.basename(this._shellLaunchConfig.executable||""):C="xterm-256color",this._initialCwd=o;const A=a&&process.platform==="win32"&&I.getWindowsBuildNumber()>=18309;this._ptyOptions={name:C,cwd:o,env:r,cols:i,rows:t,useConpty:A,conptyInheritCursor:A&&!!l.initialText},D.isWindows&&A&&i===0&&t===0&&((f=this._shellLaunchConfig.executable)===null||f===void 0?void 0:f.endsWith("Git\\bin\\bash.exe"))&&(this._delayedResizer=new p,this._register(this._delayedResizer.onTrigger(O=>{var E;(E=this._delayedResizer)===null||E===void 0||E.dispose(),this._delayedResizer=void 0,O.cols&&O.rows&&this.resize(O.cols,O.rows)})))}get exitMessage(){return this._exitMessage}get currentTitle(){return this._currentTitle}get onProcessData(){return this._onProcessData.event}get onProcessExit(){return this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}get onProcessTitleChanged(){return this._onProcessTitleChanged.event}async start(){const o=(await Promise.all([this._validateCwd(),this._validateExecutable()])).find(i=>i!==void 0);if(o)return o;try{await this.setupPtyProcess(this._shellLaunchConfig,this._ptyOptions);return}catch(i){return this._logService.trace("IPty#spawn native exception",i),{message:`A native exception occurred during launch (${i.message})`}}}async _validateCwd(){try{if(!(await T.promises.stat(this._initialCwd)).isDirectory())return{message:v.localize(0,null,this._initialCwd.toString())}}catch(l){if((l==null?void 0:l.code)==="ENOENT")return{message:v.localize(1,null,this._initialCwd.toString())}}}async _validateExecutable(){const l=this._shellLaunchConfig;if(!l.executable)throw new Error("IShellLaunchConfig.executable not set");try{const o=await T.promises.stat(l.executable);if(!o.isFile()&&!o.isSymbolicLink())return{message:v.localize(2,null,l.executable)}}catch(o){if((o==null?void 0:o.code)==="ENOENT"){let i=l.cwd instanceof d.URI?l.cwd.path:l.cwd;const t=l.env&&l.env.PATH?l.env.PATH.split(h.delimiter):void 0;if(!await I.findExecutable(l.executable,i,t,this._executableEnv))return{message:v.localize(3,null,l.executable)}}}}async setupPtyProcess(l,o){const i=l.args||[];this._logService.trace("IPty#spawn",l.executable,i,o);const t=(await new Promise((r,s)=>{H(["node-pty"],r,s)})).spawn(l.executable,i,o);this._ptyProcess=t,this._processStartupComplete=new Promise(r=>{this.onProcessReady(()=>r())}),t.onData(r=>{this._shellLaunchConfig.flowControl&&(this._unacknowledgedCharCount+=r.length,!this._isPtyPaused&&this._unacknowledgedCharCount>1e5&&(this._logService.trace(`Flow control: Pause (${this._unacknowledgedCharCount} > ${1e5})`),this._isPtyPaused=!0,t.pause())),this._onProcessData.fire(r),this._closeTimeout&&(clearTimeout(this._closeTimeout),this._queueProcessExit())}),t.onExit(r=>{this._exitCode=r.exitCode,this._queueProcessExit()}),this._setupTitlePolling(t),this._sendProcessId(t.pid)}dispose(){this._isDisposed=!0,this._titleInterval&&clearInterval(this._titleInterval),this._titleInterval=null,this._onProcessData.dispose(),this._onProcessExit.dispose(),this._onProcessReady.dispose(),this._onProcessTitleChanged.dispose(),super.dispose()}_setupTitlePolling(l){setTimeout(()=>this._sendProcessTitle(l),0),D.isWindows||(this._titleInterval=setInterval(()=>{this._currentTitle!==l.process&&this._sendProcessTitle(l)},200))}_queueProcessExit(){this._closeTimeout&&clearTimeout(this._closeTimeout),this._closeTimeout=setTimeout(()=>{this._closeTimeout=void 0,this._kill()},250)}async _kill(){if(await this._processStartupComplete,!this._isDisposed){try{this._ptyProcess&&(this._logService.trace("IPty#kill"),this._ptyProcess.kill())}catch(l){}this._onProcessExit.fire(this._exitCode||0),this.dispose()}}_sendProcessId(l){this._onProcessReady.fire({pid:l,cwd:this._initialCwd})}_sendProcessTitle(l){this._isDisposed||(this._currentTitle=l.process,this._onProcessTitleChanged.fire(this._currentTitle))}async shutdown(l){l?await this._kill():!this._closeTimeout&&!this._isDisposed&&(this._queueProcessExit(),setTimeout(()=>{this._closeTimeout&&!this._isDisposed&&(this._closeTimeout=void 0,this._kill())},5e3))}input(l){if(!(this._isDisposed||!this._ptyProcess)){for(let o=0;o<=Math.floor(l.length/m);o++)this._writeQueue.push(l.substr(o*m,m));this._startWrite()}}_startWrite(){if(!(this._writeTimeout!==void 0||this._writeQueue.length===0)){if(this._doWrite(),this._writeQueue.length===0){this._writeTimeout=void 0;return}this._writeTimeout=setTimeout(()=>{this._writeTimeout=void 0,this._startWrite()},c)}}_doWrite(){const l=this._writeQueue.shift();this._logService.trace("IPty#write",`${l.length} characters`),this._ptyProcess.write(l)}resize(l,o){if(!this._isDisposed&&!(typeof l!="number"||typeof o!="number"||isNaN(l)||isNaN(o))&&this._ptyProcess){if(l=Math.max(l,1),o=Math.max(o,1),this._delayedResizer){this._delayedResizer.cols=l,this._delayedResizer.rows=o;return}this._logService.trace("IPty#resize",l,o);try{this._ptyProcess.resize(l,o)}catch(i){if(this._logService.trace("IPty#resize exception "+i.message),this._exitCode!==void 0&&i.message!=="ioctl(2) failed, EBADF")throw i}}}acknowledgeDataEvent(l){var o;!this._shellLaunchConfig.flowControl||(this._unacknowledgedCharCount=Math.max(this._unacknowledgedCharCount-l,0),this._logService.trace(`Flow control: Ack ${l} chars (unacknowledged: ${this._unacknowledgedCharCount})`),this._isPtyPaused&&this._unacknowledgedCharCount<5e3&&(this._logService.trace(`Flow control: Resume (${this._unacknowledgedCharCount} < ${5e3})`),(o=this._ptyProcess)===null||o===void 0||o.resume(),this._isPtyPaused=!1))}clearUnacknowledgedChars(){var l;!this._shellLaunchConfig.flowControl||(this._unacknowledgedCharCount=0,this._logService.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this._isPtyPaused&&((l=this._ptyProcess)===null||l===void 0||l.resume(),this._isPtyPaused=!1))}getInitialCwd(){return Promise.resolve(this._initialCwd)}getCwd(){if(D.isMacintosh){const l=_.release().split(".");if(l.length>0&&parseInt(l[0])<20)return new Promise(o=>{if(!this._ptyProcess){o(this._initialCwd);return}this._logService.trace("IPty#pid"),u.exec("lsof -OPln -p "+this._ptyProcess.pid+" | grep cwd",(i,t,r)=>{!i&&t!==""?o(t.substring(t.indexOf("/"),t.length-1)):(this._logService.error("lsof did not run successfully, it may not be on the $PATH?",i,t,r),o(this._initialCwd))})})}return D.isLinux?new Promise(l=>{if(!this._ptyProcess){l(this._initialCwd);return}this._logService.trace("IPty#pid"),T.readlink("/proc/"+this._ptyProcess.pid+"/cwd",(o,i)=>{o&&l(this._initialCwd),l(i)})}):new Promise(l=>{l(this._initialCwd)})}getLatency(){return Promise.resolve(0)}};b=ve([ge(7,g.ILogService)],b),e.TerminalProcess=b;class p extends P.Disposable{constructor(){super();this._onTrigger=this._register(new k.Emitter),this._timeout=setTimeout(()=>{this._onTrigger.fire({rows:this.rows,cols:this.cols})},1e3),this._register({dispose:()=>{clearTimeout(this._timeout)}})}get onTrigger(){return this._onTrigger.event}dispose(){super.dispose(),clearTimeout(this._timeout)}}}),define(J[175],Z([0,1,6,19,7,30]),function(H,e,h,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=T.createDecorator("contextService");var k;(function(v){v[v.EMPTY=1]="EMPTY",v[v.FOLDER=2]="FOLDER",v[v.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function P(v){const m=v;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=P;function u(v){const m=v;return!!(m&&typeof m=="object"&&h.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=u;class g{constructor(m,c,y,b){this._id=m,this._configuration=y,this._ignorePathCasing=b,this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=g;class I{constructor(m,c){this.raw=c,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return D.joinPath(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=I;function d(v){return new I({uri:v,index:0,name:D.basenameOrAuthority(v)},{uri:v.toString()})}e.toWorkspaceFolder=d}),define(J[176],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryChannelClient=e.TelemetryChannel=void 0;class h{constructor(_){this.service=_}listen(_,k){throw new Error(`Invalid listen ${k}`)}call(_,k,P){switch(k){case"publicLog":return this.service.publicLog(P[0],P[1],P[2]);case"publicLog2":return this.service.publicLog2(P[0],P[1],P[2]);case"publicLogError":return this.service.publicLogError(P[0],P[1]);case"publicLogError2":return this.service.publicLogError2(P[0],P[1]);case"setEnabled":return Promise.resolve(this.service.setEnabled(P[0]));case"getTelemetryInfo":return this.service.getTelemetryInfo();case"setExperimentProperty":return Promise.resolve(this.service.setExperimentProperty(P[0],P[1]))}throw new Error(`Invalid call ${k}`)}}e.TelemetryChannel=h;class D{constructor(_){this.channel=_,this.isOptedIn=!0,this.sendErrorTelemetry=!0}publicLog(_,k,P){return this.channel.call("publicLog",[_,k,P])}publicLog2(_,k,P){return this.channel.call("publicLog2",[_,k,P])}publicLogError(_,k){return this.channel.call("publicLogError",[_,k])}publicLogError2(_,k){return this.channel.call("publicLogError2",[_,k])}setEnabled(_){this.channel.call("setEnable",[_])}getTelemetryInfo(){return this.channel.call("getTelemetryInfo")}setExperimentProperty(_,k){this.channel.call("setExperimentProperty",[_,k])}}e.TelemetryChannelClient=D}),define(J[177],Z([0,1,203,204,21]),function(H,e,h,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryClient=void 0;class _{get _sender(){throw new Error("unimplemented")}get _buffer(){throw new Error("unimplemented")}setUseDiskRetryCaching(){throw new Error("unimplemented")}send(){throw new Error("unimplemented")}triggerSend(){throw new Error("unimplemented")}}class k{constructor(){this.context=void 0,this.commonProperties=void 0,this.config={},this.channel=new _}addTelemetryProcessor(){throw new Error("unimplemented")}clearTelemetryProcessors(){throw new Error("unimplemented")}runTelemetryProcessors(){throw new Error("unimplemented")}trackTrace(){throw new Error("unimplemented")}trackMetric(){throw new Error("unimplemented")}trackException(){throw new Error("unimplemented")}trackRequest(){throw new Error("unimplemented")}trackDependency(){throw new Error("unimplemented")}track(){throw new Error("unimplemented")}trackNodeHttpRequestSync(){throw new Error("unimplemented")}trackNodeHttpRequest(){throw new Error("unimplemented")}trackNodeHttpDependency(){throw new Error("unimplemented")}trackEvent(u){u.properties||(u.properties={}),u.measurements||(u.measurements={});try{const g=T.cpus();u.measurements.cores=g.length,u.properties["common.cpuModel"]=g[0].model}catch(g){}try{u.measurements.memoryFree=T.freemem(),u.measurements.memoryTotal=T.totalmem()}catch(g){}try{u.properties["common.shell"]=T.userInfo().shell,u.properties["common.release"]=T.release(),u.properties["common.arch"]=T.arch()}catch(g){}try{const g=process.env.TELEMETRY_URL||"https://v1.telemetry.coder.com/track",I=(/^http:/.test(g)?D:h).request(g,{method:"POST",headers:{"Content-Type":"application/json"}});I.on("error",()=>{}),I.write(JSON.stringify(u)),I.end()}catch(g){}}flush(u){u.callback&&u.callback("")}}e.TelemetryClient=k}),define(J[56],Z([0,1,35]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logger=void 0,e.logger=h.logger.named("vscode")}),define(J[57],Z([0,1,15,37,73,93,97,28]),function(H,e,h,D,T,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLocaleFromConfig=e.getTranslations=e.getNlsConfiguration=e.isInternalConfiguration=void 0;const u=new Map,g=D.join(_.getPathFromAmdModule(H,""),"nls.metadata.json"),I=b=>b&&!!b._languagePackId;e.isInternalConfiguration=I;const d={locale:"en",availableLanguages:{}},v=async(b,p)=>{const w=`${b}: ${p}`;return u.has(w)||u.set(w,new Promise(async l=>{const o=P.default.commit&&await T.promisify(h.exists)(g)?await k.getNLSConfiguration(P.default.commit,p,g,b):d;e.isInternalConfiguration(o)&&(o._languagePackSupport=!0),o.locale!=="en"&&o.locale!=="en-us"&&Object.keys(o.availableLanguages).length===0&&u.delete(w),l(o)})),u.get(w)};e.getNlsConfiguration=v;const m=async(b,p)=>{const w=await e.getNlsConfiguration(b,p);if(e.isInternalConfiguration(w))try{return JSON.parse(await T.promisify(h.readFile)(w._translationsConfigFile,"utf8"))}catch(l){}return{}};e.getTranslations=m;const c=async b=>{const p=["locale.json","argv.json"];for(let w=0;w<p.length;++w)try{const l=D.join(b,"User",p[w]),o=y(await T.promisify(h.readFile)(l,"utf8"));return JSON.parse(o).locale}catch(l){}return"en"};e.getLocaleFromConfig=c;const y=b=>{const p=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return b.replace(p,(w,l,o,i,t)=>{if(i)return"";if(t){const r=t.length;return r>2&&t[r-1]===`
`?t[r-2]==="\r"?`\r
`:`
`:""}else return w})}}),define(J[81],Z([0,1,49]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodePath=e.getUriTransformer=void 0;const D=_=>new h.URITransformer(_);e.getUriTransformer=D;const T=_=>_.split("/").map(k=>encodeURIComponent(k)).join("/");e.encodePath=T}),define(J[82],Z([0,1,7]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=h.createDecorator("environmentVariableService");var D;(function(T){T[T.Replace=1]="Replace",T[T.Append=2]="Append",T[T.Prepend=3]="Prepend"})(D=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(J[178],Z([0,1,4,82]),function(H,e,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class T{constructor(u){this.map=new Map,u.forEach((g,I)=>{const d=g.map.entries();let v=d.next();for(;!v.done;){const m=v.value[0];let c=this.map.get(m);if(c||(c=[],this.map.set(m,c)),c.length>0&&c[0].type===D.EnvironmentVariableMutatorType.Replace){v=d.next();continue}const y=v.value[1];c.unshift({extensionIdentifier:I,value:y.value,type:y.type}),v=d.next()}})}applyToProcessEnvironment(u,g){let I;h.isWindows&&(I={},Object.keys(u).forEach(d=>I[d.toLowerCase()]=d)),this.map.forEach((d,v)=>{const m=h.isWindows&&I[v.toLowerCase()]||v;d.forEach(c=>{const y=g?g(c.value):c.value;switch(c.type){case D.EnvironmentVariableMutatorType.Append:u[m]=(u[m]||"")+y;break;case D.EnvironmentVariableMutatorType.Prepend:u[m]=y+(u[m]||"");break;case D.EnvironmentVariableMutatorType.Replace:u[m]=y;break}})})}diff(u){const g=new Map,I=new Map,d=new Map;if(u.map.forEach((v,m)=>{const c=this.map.get(m),y=_(v,c);y&&g.set(m,y)}),this.map.forEach((v,m)=>{const c=u.map.get(m),y=_(v,c);y&&d.set(m,y)}),this.map.forEach((v,m)=>{const c=u.map.get(m),y=k(v,c);y&&I.set(m,y)}),!(g.size===0&&I.size===0&&d.size===0))return{added:g,changed:I,removed:d}}}e.MergedEnvironmentVariableCollection=T;function _(P,u){if(!u)return P;const g=new Set;u.forEach(d=>g.add(d.extensionIdentifier));const I=[];return P.forEach(d=>{g.has(d.extensionIdentifier)||I.push(d)}),I.length===0?void 0:I}function k(P,u){if(!!u){const g=new Map;u.forEach(d=>g.set(d.extensionIdentifier,d));const I=[];return P.forEach(d=>{const v=g.get(d.extensionIdentifier);v&&(d.type!==v.type||d.value!==v.value)&&I.push(v)}),I.length===0?void 0:I}}}),define(J[83],Z([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function h(T){return[...T.entries()]}e.serializeEnvironmentVariableCollection=h;function D(T){return new Map(T)}e.deserializeEnvironmentVariableCollection=D}),define(J[179],Z([0,1,133,68]),function(H,e,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.terminalContributionsDescriptor=e.DEFAULT_COMMANDS_TO_SKIP_SHELL=e.TERMINAL_COMMAND_ID=e.TitleEventSource=e.LinuxDistro=e.ProcessState=e.DEFAULT_LOCAL_ECHO_EXCLUDE=e.SUGGESTIONS_FONT_WEIGHT=e.DEFAULT_BOLD_FONT_WEIGHT=e.DEFAULT_FONT_WEIGHT=e.MAXIMUM_FONT_WEIGHT=e.MINIMUM_FONT_WEIGHT=e.DEFAULT_LINE_HEIGHT=e.MINIMUM_LETTER_SPACING=e.DEFAULT_LETTER_SPACING=e.TERMINAL_ACTION_CATEGORY=e.TERMINAL_CONFIG_SECTION=e.TerminalCursorStyle=e.TERMINAL_CREATION_COMMANDS=e.NEVER_MEASURE_RENDER_TIME_STORAGE_KEY=e.IS_WORKSPACE_SHELL_ALLOWED_STORAGE_KEY=e.KEYBINDING_CONTEXT_TERMINAL_PROCESS_SUPPORTED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_NOT_VISIBLE=e.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE=e.KEYBINDING_CONTEXT_TERMINAL_TEXT_NOT_SELECTED=e.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED=e.KEYBINDING_CONTEXT_TERMINAL_A11Y_TREE_FOCUS=e.KEYBINDING_CONTEXT_TERMINAL_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_ALT_BUFFER_ACTIVE=e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE=e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY=e.KEYBINDING_CONTEXT_TERMINAL_FOCUS=e.KEYBINDING_CONTEXT_TERMINAL_IS_OPEN=e.TERMINAL_VIEW_ID=void 0,e.TERMINAL_VIEW_ID="terminal",e.KEYBINDING_CONTEXT_TERMINAL_IS_OPEN=new D.RawContextKey("terminalIsOpen",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_FOCUS=new D.RawContextKey("terminalFocus",!1,h.localize(0,null)),e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY="terminalShellType",e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE=new D.RawContextKey(e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY,void 0,{type:"string",description:h.localize(1,null)}),e.KEYBINDING_CONTEXT_TERMINAL_ALT_BUFFER_ACTIVE=new D.RawContextKey("terminalAltBufferActive",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FOCUS.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_A11Y_TREE_FOCUS=new D.RawContextKey("terminalA11yTreeFocus",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED=new D.RawContextKey("terminalTextSelected",!1,h.localize(2,null)),e.KEYBINDING_CONTEXT_TERMINAL_TEXT_NOT_SELECTED=e.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE=new D.RawContextKey("terminalFindVisible",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_FIND_NOT_VISIBLE=e.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED=new D.RawContextKey("terminalFindInputFocused",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_FIND_FOCUSED=new D.RawContextKey("terminalFindFocused",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_PROCESS_SUPPORTED=new D.RawContextKey("terminalProcessSupported",!1,h.localize(3,null)),e.IS_WORKSPACE_SHELL_ALLOWED_STORAGE_KEY="terminal.integrated.isWorkspaceShellAllowed",e.NEVER_MEASURE_RENDER_TIME_STORAGE_KEY="terminal.integrated.neverMeasureRenderTime",e.TERMINAL_CREATION_COMMANDS=["workbench.action.terminal.toggleTerminal","workbench.action.terminal.new","workbench.action.togglePanel","workbench.action.terminal.focus"],e.TerminalCursorStyle={BLOCK:"block",LINE:"line",UNDERLINE:"underline"},e.TERMINAL_CONFIG_SECTION="terminal.integrated",e.TERMINAL_ACTION_CATEGORY=h.localize(4,null),e.DEFAULT_LETTER_SPACING=0,e.MINIMUM_LETTER_SPACING=-5,e.DEFAULT_LINE_HEIGHT=1,e.MINIMUM_FONT_WEIGHT=1,e.MAXIMUM_FONT_WEIGHT=1e3,e.DEFAULT_FONT_WEIGHT="normal",e.DEFAULT_BOLD_FONT_WEIGHT="bold",e.SUGGESTIONS_FONT_WEIGHT=["normal","bold","100","200","300","400","500","600","700","800","900"],e.DEFAULT_LOCAL_ECHO_EXCLUDE=["vim","vi","nano","tmux"];var T;(function(u){u[u.UNINITIALIZED=0]="UNINITIALIZED",u[u.LAUNCHING=1]="LAUNCHING",u[u.RUNNING=2]="RUNNING",u[u.KILLED_DURING_LAUNCH=3]="KILLED_DURING_LAUNCH",u[u.KILLED_BY_USER=4]="KILLED_BY_USER",u[u.KILLED_BY_PROCESS=5]="KILLED_BY_PROCESS"})(T=e.ProcessState||(e.ProcessState={}));var _;(function(u){u[u.Fedora=0]="Fedora",u[u.Ubuntu=1]="Ubuntu",u[u.Unknown=2]="Unknown"})(_=e.LinuxDistro||(e.LinuxDistro={}));var k;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence"})(k=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(u){u.FIND_NEXT="workbench.action.terminal.findNext",u.FIND_PREVIOUS="workbench.action.terminal.findPrevious",u.TOGGLE="workbench.action.terminal.toggleTerminal",u.KILL="workbench.action.terminal.kill",u.QUICK_KILL="workbench.action.terminal.quickKill",u.CONFIGURE_TERMINAL_SETTINGS="workbench.action.terminal.openSettings",u.COPY_SELECTION="workbench.action.terminal.copySelection",u.SELECT_ALL="workbench.action.terminal.selectAll",u.DELETE_WORD_LEFT="workbench.action.terminal.deleteWordLeft",u.DELETE_WORD_RIGHT="workbench.action.terminal.deleteWordRight",u.DELETE_TO_LINE_START="workbench.action.terminal.deleteToLineStart",u.MOVE_TO_LINE_START="workbench.action.terminal.moveToLineStart",u.MOVE_TO_LINE_END="workbench.action.terminal.moveToLineEnd",u.NEW="workbench.action.terminal.new",u.NEW_WITH_CWD="workbench.action.terminal.newWithCwd",u.NEW_LOCAL="workbench.action.terminal.newLocal",u.NEW_IN_ACTIVE_WORKSPACE="workbench.action.terminal.newInActiveWorkspace",u.SPLIT="workbench.action.terminal.split",u.SPLIT_IN_ACTIVE_WORKSPACE="workbench.action.terminal.splitInActiveWorkspace",u.RELAUNCH="workbench.action.terminal.relaunch",u.FOCUS_PREVIOUS_PANE="workbench.action.terminal.focusPreviousPane",u.FOCUS_NEXT_PANE="workbench.action.terminal.focusNextPane",u.RESIZE_PANE_LEFT="workbench.action.terminal.resizePaneLeft",u.RESIZE_PANE_RIGHT="workbench.action.terminal.resizePaneRight",u.RESIZE_PANE_UP="workbench.action.terminal.resizePaneUp",u.RESIZE_PANE_DOWN="workbench.action.terminal.resizePaneDown",u.FOCUS="workbench.action.terminal.focus",u.FOCUS_NEXT="workbench.action.terminal.focusNext",u.FOCUS_PREVIOUS="workbench.action.terminal.focusPrevious",u.PASTE="workbench.action.terminal.paste",u.SELECT_DEFAULT_SHELL="workbench.action.terminal.selectDefaultShell",u.RUN_SELECTED_TEXT="workbench.action.terminal.runSelectedText",u.RUN_ACTIVE_FILE="workbench.action.terminal.runActiveFile",u.SWITCH_TERMINAL="workbench.action.terminal.switchTerminal",u.SCROLL_DOWN_LINE="workbench.action.terminal.scrollDown",u.SCROLL_DOWN_PAGE="workbench.action.terminal.scrollDownPage",u.SCROLL_TO_BOTTOM="workbench.action.terminal.scrollToBottom",u.SCROLL_UP_LINE="workbench.action.terminal.scrollUp",u.SCROLL_UP_PAGE="workbench.action.terminal.scrollUpPage",u.SCROLL_TO_TOP="workbench.action.terminal.scrollToTop",u.CLEAR="workbench.action.terminal.clear",u.CLEAR_SELECTION="workbench.action.terminal.clearSelection",u.MANAGE_WORKSPACE_SHELL_PERMISSIONS="workbench.action.terminal.manageWorkspaceShellPermissions",u.RENAME="workbench.action.terminal.rename",u.RENAME_WITH_ARG="workbench.action.terminal.renameWithArg",u.FIND_FOCUS="workbench.action.terminal.focusFind",u.FIND_HIDE="workbench.action.terminal.hideFind",u.QUICK_OPEN_TERM="workbench.action.quickOpenTerm",u.SCROLL_TO_PREVIOUS_COMMAND="workbench.action.terminal.scrollToPreviousCommand",u.SCROLL_TO_NEXT_COMMAND="workbench.action.terminal.scrollToNextCommand",u.SELECT_TO_PREVIOUS_COMMAND="workbench.action.terminal.selectToPreviousCommand",u.SELECT_TO_NEXT_COMMAND="workbench.action.terminal.selectToNextCommand",u.SELECT_TO_PREVIOUS_LINE="workbench.action.terminal.selectToPreviousLine",u.SELECT_TO_NEXT_LINE="workbench.action.terminal.selectToNextLine",u.TOGGLE_ESCAPE_SEQUENCE_LOGGING="toggleEscapeSequenceLogging",u.SEND_SEQUENCE="workbench.action.terminal.sendSequence",u.TOGGLE_FIND_REGEX="workbench.action.terminal.toggleFindRegex",u.TOGGLE_FIND_WHOLE_WORD="workbench.action.terminal.toggleFindWholeWord",u.TOGGLE_FIND_CASE_SENSITIVE="workbench.action.terminal.toggleFindCaseSensitive",u.NAVIGATION_MODE_EXIT="workbench.action.terminal.navigationModeExit",u.NAVIGATION_MODE_FOCUS_NEXT="workbench.action.terminal.navigationModeFocusNext",u.NAVIGATION_MODE_FOCUS_PREVIOUS="workbench.action.terminal.navigationModeFocusPrevious",u.SHOW_ENVIRONMENT_INFORMATION="workbench.action.terminal.showEnvironmentInformation",u.SEARCH_WORKSPACE="workbench.action.terminal.searchWorkspace",u.ATTACH_TO_REMOTE_TERMINAL="workbench.action.terminal.attachToSession"})(P=e.TERMINAL_COMMAND_ID||(e.TERMINAL_COMMAND_ID={})),e.DEFAULT_COMMANDS_TO_SKIP_SHELL=["workbench.action.terminal.clearSelection","workbench.action.terminal.clear","workbench.action.terminal.copySelection","workbench.action.terminal.deleteToLineStart","workbench.action.terminal.deleteWordLeft","workbench.action.terminal.deleteWordRight","workbench.action.terminal.focusFind","workbench.action.terminal.hideFind","workbench.action.terminal.findNext","workbench.action.terminal.findPrevious","workbench.action.terminal.toggleFindRegex","workbench.action.terminal.toggleFindWholeWord","workbench.action.terminal.toggleFindCaseSensitive","workbench.action.terminal.focusNextPane","workbench.action.terminal.focusNext","workbench.action.terminal.focusPreviousPane","workbench.action.terminal.focusPrevious","workbench.action.terminal.focus","workbench.action.terminal.kill","workbench.action.terminal.moveToLineEnd","workbench.action.terminal.moveToLineStart","workbench.action.terminal.newInActiveWorkspace","workbench.action.terminal.new","workbench.action.terminal.paste","workbench.action.terminal.resizePaneDown","workbench.action.terminal.resizePaneLeft","workbench.action.terminal.resizePaneRight","workbench.action.terminal.resizePaneUp","workbench.action.terminal.runActiveFile","workbench.action.terminal.runSelectedText","workbench.action.terminal.scrollDown","workbench.action.terminal.scrollDownPage","workbench.action.terminal.scrollToBottom","workbench.action.terminal.scrollToNextCommand","workbench.action.terminal.scrollToPreviousCommand","workbench.action.terminal.scrollToTop","workbench.action.terminal.scrollUp","workbench.action.terminal.scrollUpPage","workbench.action.terminal.sendSequence","workbench.action.terminal.selectAll","workbench.action.terminal.selectToNextCommand","workbench.action.terminal.selectToNextLine","workbench.action.terminal.selectToPreviousCommand","workbench.action.terminal.selectToPreviousLine","workbench.action.terminal.splitInActiveWorkspace","workbench.action.terminal.split","workbench.action.terminal.toggleTerminal","workbench.action.terminal.navigationModeExit","workbench.action.terminal.navigationModeFocusNext","workbench.action.terminal.navigationModeFocusPrevious","editor.action.toggleTabFocusMode","workbench.action.quickOpen","workbench.action.quickOpenPreviousEditor","workbench.action.showCommands","workbench.action.tasks.build","workbench.action.tasks.restartTask","workbench.action.tasks.runTask","workbench.action.tasks.reRunTask","workbench.action.tasks.showLog","workbench.action.tasks.showTasks","workbench.action.tasks.terminate","workbench.action.tasks.test","workbench.action.toggleFullScreen","workbench.action.terminal.focusAtIndex1","workbench.action.terminal.focusAtIndex2","workbench.action.terminal.focusAtIndex3","workbench.action.terminal.focusAtIndex4","workbench.action.terminal.focusAtIndex5","workbench.action.terminal.focusAtIndex6","workbench.action.terminal.focusAtIndex7","workbench.action.terminal.focusAtIndex8","workbench.action.terminal.focusAtIndex9","workbench.action.focusSecondEditorGroup","workbench.action.focusThirdEditorGroup","workbench.action.focusFourthEditorGroup","workbench.action.focusFifthEditorGroup","workbench.action.focusSixthEditorGroup","workbench.action.focusSeventhEditorGroup","workbench.action.focusEighthEditorGroup","workbench.action.focusNextPart","workbench.action.focusPreviousPart","workbench.action.nextPanelView","workbench.action.previousPanelView","workbench.action.nextSideBarView","workbench.action.previousSideBarView","workbench.action.debug.start","workbench.action.debug.stop","workbench.action.debug.run","workbench.action.debug.restart","workbench.action.debug.continue","workbench.action.debug.pause","workbench.action.debug.stepInto","workbench.action.debug.stepOut","workbench.action.debug.stepOver","workbench.action.nextEditor","workbench.action.previousEditor","workbench.action.nextEditorInGroup","workbench.action.previousEditorInGroup","workbench.action.openNextRecentlyUsedEditor","workbench.action.openPreviousRecentlyUsedEditor","workbench.action.openNextRecentlyUsedEditorInGroup","workbench.action.openPreviousRecentlyUsedEditorInGroup","workbench.action.quickOpenPreviousRecentlyUsedEditor","workbench.action.quickOpenLeastRecentlyUsedEditor","workbench.action.quickOpenPreviousRecentlyUsedEditorInGroup","workbench.action.quickOpenLeastRecentlyUsedEditorInGroup","workbench.action.focusActiveEditorGroup","workbench.action.focusFirstEditorGroup","workbench.action.focusLastEditorGroup","workbench.action.firstEditorInGroup","workbench.action.lastEditorInGroup","workbench.action.navigateUp","workbench.action.navigateDown","workbench.action.navigateRight","workbench.action.navigateLeft","workbench.action.togglePanel","workbench.action.quickOpenView","workbench.action.toggleMaximizedPanel"],e.terminalContributionsDescriptor={extensionPoint:"terminal",defaultExtensionKind:"workspace",jsonSchema:{description:h.localize(5,null),type:"object",properties:{types:{type:"array",description:h.localize(6,null),items:{type:"object",required:["command","title"],properties:{command:{description:h.localize(7,null),type:"string"},title:{description:h.localize(8,null),type:"string"}}}}}}}}),define(J[180],Z([0,1,3,4,90]),function(H,e,h,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function _(i,t){if(!!t)if(D.isWindows)for(const r in t){let s=r;for(const n in i)if(r.toLowerCase()===n.toLowerCase()){s=n;break}const a=t[r];k(i,s,a)}else Object.keys(t).forEach(r=>{const s=t[r];k(i,r,s)})}e.mergeEnvironments=_;function k(i,t,r){typeof r=="string"?i[t]=r:delete i[t]}function P(i,t,r,s){i.TERM_PROGRAM="vscode",t&&(i.TERM_PROGRAM_VERSION=t),I(i,s)&&(i.LANG=d(r)),i.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=P;function u(i,t){if(!!t)for(const r of Object.keys(t)){const s=t[r];s&&(i[r]=s)}}function g(i,t){return Object.keys(t).forEach(r=>{const s=t[r];if(typeof s=="string")try{t[r]=i(s)}catch(a){t[r]=s}}),t}function I(i,t){if(t==="on")return!0;if(t==="auto"){const r=i.LANG;return!r||r.search(/\.UTF\-8$/)===-1&&r.search(/\.utf8$/)===-1&&r.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=I;function d(i){const t=i?i.split("-"):[],r=t.length;if(r===0)return"en_US.UTF-8";if(r===1){const s={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in s&&t.push(s[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.getLangEnvVariable=d;function v(i,t,r,s,a,n){if(i.cwd){const C=typeof i.cwd=="object"?i.cwd.fsPath:i.cwd,A=m(C,r);return c(A||C)}let f;return!i.ignoreConfigurationCwd&&a&&(r&&(a=m(a,r,n)),a&&(h.isAbsolute(a)?f=a:s&&(f=h.join(s.fsPath,a)))),f||(f=s?s.fsPath:t||""),c(f)}e.getCwd=v;function m(i,t,r){if(t)try{return t(i)}catch(s){r==null||r.error("Could not resolve terminal cwd",s);return}return i}function c(i){return D.platform===3&&i&&i[1]===":"?i[0].toUpperCase()+i.substr(1):i}function y(i){let t=i;t.indexOf("\\")!==0&&(t=t.replace(/\\/g,"\\\\")),t.indexOf(" ")!==-1&&(t=t.replace(/ /g,"\\ "));const r=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return t=t.replace(r,""),`'${t}'`}e.escapeNonWindowsPath=y;function b(i,t){if(!!t)return r=>t.resolve(i,r)}e.createVariableResolver=b;function p(i,t,r,s,a,n,f,C,A=D.platform){let O=null;C&&(O=l(i,t,"automationShell",A)),O||(O=l(i,t,"shell",A));let E=O||r;if(A===3&&!s&&a){const F=h.join(a,"Sysnative").replace(/\//g,"\\").toLowerCase();E&&E.toLowerCase().indexOf(F)===0&&(E=h.join(a,"System32",E.substr(F.length+1)))}if(E&&A===3&&(E=E.replace(/\//g,"\\")),n)try{E=n(E)}catch(F){f.error("Could not resolve shell",F)}return E}e.getDefaultShell=p;function w(i,t,r,s,a,n=D.platform){if(r&&l(i,t,"automationShell",n))return[];const f=n===3?"windows":n===1?"osx":"linux",C=i(`terminal.integrated.shellArgs.${f}`);let A=(t?C.value:C.userValue)||C.defaultValue;if(!A)return[];if(typeof A=="string"&&n===3)return s?s(A):A;if(s){const O=[];for(const E of A)try{O.push(s(E))}catch(F){a.error(`Could not resolve terminal.integrated.shellArgs.${f}`,F),O.push(E)}A=O}return A}e.getDefaultShellArgs=w;function l(i,t,r,s=D.platform){const n=i(`terminal.integrated.${r}.${s===3?"windows":s===1?"osx":"linux"}`);return(t?n.value:n.userValue)||n.defaultValue}function o(i,t,r,s,a,n,f){let C={};if(i.strictEnv)u(C,i.env);else{u(C,f);const A=Object.assign({},s?t.value:t.userValue);r&&(A&&g(r,A),i.env&&g(r,i.env)),T.sanitizeProcessEnvironment(C,"VSCODE_IPC_HOOK_CLI"),_(C,A),_(C,i.env),P(C,a,D.locale,n)}return C}e.createTerminalEnvironment=o}),define(J[181],Z([0,1,15,3,4]),function(H,e,h,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMainProcessParentEnv=void 0;let _;async function k(P=process.env){if(_)return _;if(T.isLinux){const u=process.ppid,g=D.basename(process.argv[0]);let I=0,d=u,v=g;do I=d,(await h.promises.readFile(`/proc/${I}/status`,"utf8")).split(`
`).forEach(p=>{p.indexOf("Name:")===0&&(v=p.replace(/^Name:\s+/,"")),p.indexOf("PPid:")===0&&(d=parseInt(p.replace(/^PPid:\s+/,"")))});while(v===g);const m=await h.promises.readFile(`/proc/${I}/environ`,"utf8"),c={};m.split("\0").forEach(y=>{const b=y.indexOf("=");c[y.substr(0,b)]=y.substr(b+1)}),_=c}return T.isMacintosh&&(_={},["SHELL","SSH_AUTH_SOCK","Apple_PubSub_Socket_Render","XPC_FLAGS","XPC_SERVICE_NAME","HOME","LOGNAME","TMPDIR"].forEach(g=>{P[g]&&(_[g]=P[g])})),T.isWindows&&(_=P),_}e.getMainProcessParentEnv=k}),define(J[182],Z([0,1,7]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.LOCAL_MACHINE_SCOPES=[1,3,4,5],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=h.createDecorator("configurationService"),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(J[183],Z([0,1,7]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=h.createDecorator("configurationResolverService")}),define(J[184],Z([0,1,3,33,10,20,4,63,134]),function(H,e,h,D,T,_,k,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class g{constructor(d,v,m){if(this._contributedVariables=new Map,this._context=d,this._labelService=v,m)if(k.isWindows){const c=Object.create(null);this._envVariables=c,Object.keys(m).forEach(y=>{c[y.toLowerCase()]=m[y]})}else this._envVariables=m}resolve(d,v){return this.recursiveResolve(d?d.uri:void 0,v)}resolveAnyBase(d,v,m,c){const y=_.deepClone(v);return k.isWindows&&y.windows?Object.keys(y.windows).forEach(b=>y[b]=y.windows[b]):k.isMacintosh&&y.osx?Object.keys(y.osx).forEach(b=>y[b]=y.osx[b]):k.isLinux&&y.linux&&Object.keys(y.linux).forEach(b=>y[b]=y.linux[b]),delete y.windows,delete y.osx,delete y.linux,this.recursiveResolve(d?d.uri:void 0,y,m,c)}resolveAny(d,v,m){return this.resolveAnyBase(d,v,m)}resolveAnyMap(d,v,m){const c=new Map;return{newConfig:this.resolveAnyBase(d,v,m,c),resolvedVariables:c}}resolveWithInteractionReplace(d,v,m,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(d,v,m,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(d,v){if(this._contributedVariables.has(d))throw new Error("Variable "+d+" is contributed twice.");this._contributedVariables.set(d,v)}recursiveResolve(d,v,m,c){if(T.isString(v))return this.resolveString(d,v,m,c);if(T.isArray(v))return v.map(y=>this.recursiveResolve(d,y,m,c));if(T.isObject(v)){let y=Object.create(null);return Object.keys(v).forEach(b=>{const p=this.resolveString(d,b,m,c);y[p]=this.recursiveResolve(d,v[b],m,c)}),y}return v}resolveString(d,v,m,c){return v.replace(g.VARIABLE_REGEXP,(b,p)=>{if(p.includes(g.VARIABLE_LHS))return b;let w=this.evaluateSingleVariable(b,p,d,m);return c&&c.set(p,w),w})}fsPath(d){return this._labelService?this._labelService.getUriLabel(d,{noPrefix:!0}):d.fsPath}evaluateSingleVariable(d,v,m,c){let y;const b=v.split(":");b.length>1&&(v=b[0],y=b[1]);const p=()=>{const o=this._context.getFilePath();if(o)return o;throw new Error(u.localize(0,null,d))},w=()=>{const o=p();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error(u.localize(1,null,d,h.basename(o)))},l=()=>{if(y){const o=this._context.getFolderUri(y);if(o)return o;throw new Error(u.localize(2,null,d,y))}if(m)return m;throw this._context.getWorkspaceFolderCount()>1?new Error(u.localize(3,null,d)):new Error(u.localize(4,null,d))};switch(v){case"env":if(y){if(this._envVariables){const o=this._envVariables[k.isWindows?y.toLowerCase():y];if(T.isString(o))return o}return""}throw new Error(u.localize(5,null,d));case"config":if(y){const o=this._context.getConfigurationValue(m,y);if(T.isUndefinedOrNull(o))throw new Error(u.localize(6,null,d,y));if(T.isObject(o))throw new Error(u.localize(7,null,d,y));return o}throw new Error(u.localize(8,null,d));case"command":return this.resolveFromMap(d,y,c,"command");case"input":return this.resolveFromMap(d,y,c,"input");default:switch(v){case"workspaceRoot":case"workspaceFolder":return P.normalizeDriveLetter(this.fsPath(l()));case"cwd":return m||y?P.normalizeDriveLetter(this.fsPath(l())):D.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return h.basename(this.fsPath(l()));case"lineNumber":const o=this._context.getLineNumber();if(o)return o;throw new Error(u.localize(9,null,d));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error(u.localize(10,null,d));case"file":return p();case"fileWorkspaceFolder":return w();case"relativeFile":return m||y?h.relative(this.fsPath(l()),p()):p();case"relativeFileDirname":const t=h.dirname(p());if(m||y){const n=h.relative(this.fsPath(l()),t);return n.length===0?".":n}return t;case"fileDirname":return h.dirname(p());case"fileExtname":return h.extname(p());case"fileBasename":return h.basename(p());case"fileBasenameNoExtension":const r=h.basename(p());return r.slice(0,r.length-h.extname(r).length);case"fileDirnameBasename":return h.basename(h.dirname(p()));case"execPath":const s=this._context.getExecPath();return s||d;case"execInstallFolder":const a=this._context.getAppRoot();return a||d;case"pathSeparator":return h.sep;default:try{const n=y?`${v}:${y}`:v;return this.resolveFromMap(d,n,c,void 0)}catch(n){return d}}}}resolveFromMap(d,v,m,c){if(v&&m){const y=c===void 0?m[v]:m[c+":"+v];if(typeof y=="string")return y;throw new Error(u.localize(11,null,d))}return d}}e.AbstractVariableResolverService=g,g.VARIABLE_LHS="${",g.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(J[84],Z([0,1,7]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=h.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(J[185],Z([0,1,132,5,10,6,2,7,68,29,108,22,84]),function(H,e,h,D,T,_,k,P,u,g,I,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.editorGroupToViewColumn=e.viewColumnToEditorGroup=e.computeEditorAriaLabel=e.EditorsOrder=e.pathsToEditors=e.Extensions=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCommandsContextActionRunner=e.TextEditorOptions=e.EditorOptions=e.isEditorInputWithOptions=e.EditorModel=e.SideBySideEditorInput=e.isEditorInputWithPreferredResource=e.EncodingMode=e.EditorInput=e.SaveReason=e.Verbosity=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=void 0,e.ActiveEditorDirtyContext=new u.RawContextKey("activeEditorIsDirty",!1,h.localize(0,null)),e.ActiveEditorPinnedContext=new u.RawContextKey("activeEditorIsNotPreview",!1,h.localize(1,null)),e.ActiveEditorStickyContext=new u.RawContextKey("activeEditorIsPinned",!1,h.localize(2,null)),e.ActiveEditorReadonlyContext=new u.RawContextKey("activeEditorIsReadonly",!1,h.localize(3,null)),e.ActiveEditorContext=new u.RawContextKey("activeEditor",null,{type:"string",description:h.localize(4,null)}),e.ActiveEditorAvailableEditorIdsContext=new u.RawContextKey("activeEditorAvailableEditorIds","",h.localize(5,null)),e.TextCompareEditorVisibleContext=new u.RawContextKey("textCompareEditorVisible",!1,h.localize(6,null)),e.TextCompareEditorActiveContext=new u.RawContextKey("textCompareEditorActive",!1,h.localize(7,null)),e.EditorGroupEditorsCountContext=new u.RawContextKey("groupEditorsCount",0,h.localize(8,null)),e.ActiveEditorGroupEmptyContext=new u.RawContextKey("activeEditorGroupEmpty",!1,h.localize(9,null)),e.ActiveEditorGroupIndexContext=new u.RawContextKey("activeEditorGroupIndex",0,h.localize(10,null)),e.ActiveEditorGroupLastContext=new u.RawContextKey("activeEditorGroupLast",!1,h.localize(11,null)),e.MultipleEditorGroupsContext=new u.RawContextKey("multipleEditorGroups",!1,h.localize(12,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new u.RawContextKey("editorIsOpen",!1,h.localize(13,null)),e.InEditorZenModeContext=new u.RawContextKey("inZenMode",!1,h.localize(14,null)),e.IsCenteredLayoutContext=new u.RawContextKey("isCenteredLayout",!1,h.localize(15,null)),e.SplitEditorsVertically=new u.RawContextKey("splitEditorsVertically",!1,h.localize(16,null)),e.EditorAreaVisibleContext=new u.RawContextKey("editorAreaVisible",!0,h.localize(17,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function m(G){const z=G;return typeof(z==null?void 0:z.getViewState)=="function"}e.isTextEditorPane=m;var c;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(c=e.Verbosity||(e.Verbosity={}));var y;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(y=e.SaveReason||(e.SaveReason={}));class b extends k.Disposable{constructor(){super(...arguments);this._onDidChangeDirty=this._register(new D.Emitter),this.onDidChangeDirty=this._onDidChangeDirty.event,this._onDidChangeLabel=this._register(new D.Emitter),this.onDidChangeLabel=this._onDidChangeLabel.event,this._onDispose=this._register(new D.Emitter),this.onDispose=this._onDispose.event,this.disposed=!1}getName(){return`Editor ${this.getTypeId()}`}getDescription(z){}getTitle(z){return this.getName()}getAriaLabel(){return this.getTitle(0)}getPreferredEditorId(z){return d.firstOrDefault(z)}getTelemetryDescriptor(){return{typeId:this.getTypeId()}}isReadonly(){return!0}isUntitled(){return!1}isDirty(){return!1}isSaving(){return!1}async resolve(){return null}async save(z,W){return this}async saveAs(z,W){return this}async revert(z,W){}rename(z,W){}supportsSplitEditor(){return!0}matches(z){return this===z}isDisposed(){return this.disposed}dispose(){this.disposed||(this.disposed=!0,this._onDispose.fire()),super.dispose()}}e.EditorInput=b;var p;(function(G){G[G.Encode=0]="Encode",G[G.Decode=1]="Decode"})(p=e.EncodingMode||(e.EncodingMode={}));function w(G){const z=G;return z&&!!z.preferredResource}e.isEditorInputWithPreferredResource=w;class l extends b{constructor(z,W,q,ee){super();this.name=z,this.description=W,this._secondary=q,this._primary=ee,this.registerListeners()}registerListeners(){const z=D.Event.once(this.secondary.onDispose);this._register(z(()=>{this.isDisposed()||this.dispose()}));const W=D.Event.once(this.primary.onDispose);this._register(W(()=>{this.isDisposed()||this.dispose()})),this._register(this.primary.onDidChangeDirty(()=>this._onDidChangeDirty.fire())),this._register(this.primary.onDidChangeLabel(()=>this._onDidChangeLabel.fire()))}get resource(){}get primary(){return this._primary}get secondary(){return this._secondary}getTypeId(){return l.ID}getName(){return this.name?this.name:h.localize(18,null,this._secondary.getName(),this._primary.getName())}getDescription(){return this.description}isReadonly(){return this.primary.isReadonly()}isUntitled(){return this.primary.isUntitled()}isDirty(){return this.primary.isDirty()}isSaving(){return this.primary.isSaving()}save(z,W){return this.primary.save(z,W)}saveAs(z,W){return this.primary.saveAs(z,W)}revert(z,W){return this.primary.revert(z,W)}getTelemetryDescriptor(){const z=this.primary.getTelemetryDescriptor();return Object.assign(z,super.getTelemetryDescriptor())}matches(z){return z===this?!0:z instanceof l?this.primary.matches(z.primary)&&this.secondary.matches(z.secondary):!1}}e.SideBySideEditorInput=l,l.ID="workbench.editorinputs.sidebysideEditorInput";class o extends k.Disposable{constructor(){super(...arguments);this._onDispose=this._register(new D.Emitter),this.onDispose=this._onDispose.event,this.disposed=!1}async load(){return this}isResolved(){return!0}isDisposed(){return this.disposed}dispose(){this.disposed=!0,this._onDispose.fire(),super.dispose()}}e.EditorModel=o;function i(G){const z=G;return!!z&&!!z.editor}e.isEditorInputWithOptions=i;class t{static create(z){const W=new t;return W.overwrite(z),W}overwrite(z){return typeof z.forceReload=="boolean"&&(this.forceReload=z.forceReload),typeof z.revealIfVisible=="boolean"&&(this.revealIfVisible=z.revealIfVisible),typeof z.revealIfOpened=="boolean"&&(this.revealIfOpened=z.revealIfOpened),typeof z.preserveFocus=="boolean"&&(this.preserveFocus=z.preserveFocus),typeof z.activation=="number"&&(this.activation=z.activation),typeof z.pinned=="boolean"&&(this.pinned=z.pinned),typeof z.sticky=="boolean"&&(this.sticky=z.sticky),typeof z.inactive=="boolean"&&(this.inactive=z.inactive),typeof z.ignoreError=="boolean"&&(this.ignoreError=z.ignoreError),typeof z.index=="number"&&(this.index=z.index),z.override!==void 0&&(this.override=z.override),typeof z.context=="number"&&(this.context=z.context),this}}e.EditorOptions=t;class r extends t{static from(z){if(!!(z==null?void 0:z.options))return r.create(z.options)}static create(z=Object.create(null)){const W=new r;return W.overwrite(z),W}overwrite(z){var W,q;return super.overwrite(z),z.selection&&(this.selection={startLineNumber:z.selection.startLineNumber,startColumn:z.selection.startColumn,endLineNumber:(W=z.selection.endLineNumber)!==null&&W!==void 0?W:z.selection.startLineNumber,endColumn:(q=z.selection.endColumn)!==null&&q!==void 0?q:z.selection.startColumn}),z.viewState&&(this.editorViewState=z.viewState),typeof z.selectionRevealType!="undefined"&&(this.selectionRevealType=z.selectionRevealType),this}hasOptionsDefined(){return!!this.editorViewState||!!this.selectionRevealType||!!this.selection}static fromEditor(z,W){const q=r.create(W);return q.editorViewState=T.withNullAsUndefined(z.saveViewState()),q}apply(z,W){var q,ee;let te=!1;if(this.editorViewState)z.restoreViewState(this.editorViewState),te=!0;else if(this.selection){const B={startLineNumber:this.selection.startLineNumber,startColumn:this.selection.startColumn,endLineNumber:(q=this.selection.endLineNumber)!==null&&q!==void 0?q:this.selection.startLineNumber,endColumn:(ee=this.selection.endColumn)!==null&&ee!==void 0?ee:this.selection.startColumn};z.setSelection(B),this.selectionRevealType===2?z.revealRangeNearTop(B,W):this.selectionRevealType===3?z.revealRangeNearTopIfOutsideViewport(B,W):this.selectionRevealType===1?z.revealRangeInCenterIfOutsideViewport(B,W):z.revealRangeInCenter(B,W),te=!0}return te}}e.TextEditorOptions=r;class s extends I.ActionRunner{constructor(z){super();this.context=z}run(z){return super.run(z,this.context)}}e.EditorCommandsContextActionRunner=s;var a;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH"})(a=e.SideBySideEditor||(e.SideBySideEditor={}));class n{getOriginalUri(z,W){if(!!z){if((W==null?void 0:W.supportSideBySide)&&z instanceof l){if((W==null?void 0:W.supportSideBySide)===a.BOTH)return{primary:this.getOriginalUri(z.primary,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(z.secondary,{filterByScheme:W.filterByScheme})};z=W.supportSideBySide===a.PRIMARY?z.primary:z.secondary}const q=w(z)?z.preferredResource:z.resource;return!q||!W||!W.filterByScheme?q:this.filterUri(q,W.filterByScheme)}}getCanonicalUri(z,W){if(!!z){if((W==null?void 0:W.supportSideBySide)&&z instanceof l){if((W==null?void 0:W.supportSideBySide)===a.BOTH)return{primary:this.getCanonicalUri(z.primary,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(z.secondary,{filterByScheme:W.filterByScheme})};z=W.supportSideBySide===a.PRIMARY?z.primary:z.secondary}const q=z.resource;return!q||!W||!W.filterByScheme?q:this.filterUri(q,W.filterByScheme)}}filterUri(z,W){if(Array.isArray(W)){if(W.some(q=>z.scheme===q))return z}else if(W===z.scheme)return z}}e.EditorResourceAccessor=new n;var f;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(f=e.CloseDirection||(e.CloseDirection={}));class C{constructor(){this.editorInputFactoryConstructors=new Map,this.editorInputFactoryInstances=new Map,this.customEditorInputFactoryInstances=new Map}start(z){const W=this.instantiationService=z.get(P.IInstantiationService);this.editorInputFactoryConstructors.forEach((q,ee)=>{this.createEditorInputFactory(ee,q,W)}),this.editorInputFactoryConstructors.clear()}createEditorInputFactory(z,W,q){const ee=q.createInstance(W);this.editorInputFactoryInstances.set(z,ee)}registerFileEditorInputFactory(z){this.fileEditorInputFactory=z}getFileEditorInputFactory(){return T.assertIsDefined(this.fileEditorInputFactory)}registerCustomEditorInputFactory(z,W){this.customEditorInputFactoryInstances.set(z,W)}getCustomEditorInputFactory(z){return this.customEditorInputFactoryInstances.get(z)}registerEditorInputFactory(z,W){return this.instantiationService?this.createEditorInputFactory(z,W,this.instantiationService):this.editorInputFactoryConstructors.set(z,W),k.toDisposable(()=>{this.editorInputFactoryConstructors.delete(z),this.editorInputFactoryInstances.delete(z)})}getEditorInputFactory(z){return this.editorInputFactoryInstances.get(z)}}e.Extensions={EditorInputFactories:"workbench.contributions.editor.inputFactories"},g.Registry.add(e.Extensions.EditorInputFactories,new C);async function A(G,z){if(!G||!G.length)return[];const W=await Promise.all(G.map(async q=>{const ee=_.URI.revive(q.fileUri);if(!(!ee||!z.canHandleResource(ee))){const te=typeof q.exists=="boolean"?q.exists:await z.exists(ee);if(!(!te&&q.openOnlyIfExists)){const B=te&&typeof q.lineNumber=="number"?{selection:{startLineNumber:q.lineNumber,startColumn:q.columnNumber||1},pinned:!0,override:q.editorOverrideId}:{pinned:!0,override:q.editorOverrideId};let M;return te?M={resource:ee,options:B,forceFile:!0}:M={resource:ee,options:B,forceUntitled:!0},M}}}));return d.coalesce(W)}e.pathsToEditors=A;var O;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})(O=e.EditorsOrder||(e.EditorsOrder={}));function E(G,z,W,q){let ee=G.getAriaLabel();return W&&!W.isPinned(G)&&(ee=h.localize(19,null,ee)),(W==null?void 0:W.isSticky(z!=null?z:G))&&(ee=h.localize(20,null,ee)),W&&q>1&&(ee=`${ee}, ${W.ariaLabel}`),ee}e.computeEditorAriaLabel=E;function F(G,z){if(typeof z!="number"||z===v.ACTIVE_GROUP)return v.ACTIVE_GROUP;const W=G.getGroups(2);let q=W[z];if(q)return q.id;let ee=W[0];return W.length===1&&ee.count===0?ee.id:v.SIDE_GROUP}e.viewColumnToEditorGroup=F;function j(G,z){let W=typeof z=="number"?G.getGroup(z):z;return W=W!=null?W:G.activeGroup,G.getGroups(2).indexOf(W)}e.editorGroupToViewColumn=j}),define(J[186],Z([0,1,10,182,13,160,175,83,183,185,84,11,148,82,179]),function(H,e,h,D,T,_,k,P,u,g,I,d,v,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let y=class{constructor(p,w,l,o,i,t,r,s,a,n){this._remoteAuthority=p,this._channel=w,this._configurationService=l,this._workspaceContextService=o,this._resolverService=i,this._environmentVariableService=t,this._remoteAuthorityResolverService=r,this._logService=s,this._editorService=a,this._labelService=n}_readSingleTerminalConfiguration(p){const w=this._configurationService.inspect(p);return{userValue:w.userValue,value:w.value,defaultValue:w.defaultValue}}async createTerminalProcess(p,w,l,o,i,t){await this._configurationService.whenRemoteConfigurationLoaded();const r=this._configurationService.getValue(c.TERMINAL_CONFIG_SECTION),s={"terminal.integrated.automationShell.windows":this._readSingleTerminalConfiguration("terminal.integrated.automationShell.windows"),"terminal.integrated.automationShell.osx":this._readSingleTerminalConfiguration("terminal.integrated.automationShell.osx"),"terminal.integrated.automationShell.linux":this._readSingleTerminalConfiguration("terminal.integrated.automationShell.linux"),"terminal.integrated.shell.windows":this._readSingleTerminalConfiguration("terminal.integrated.shell.windows"),"terminal.integrated.shell.osx":this._readSingleTerminalConfiguration("terminal.integrated.shell.osx"),"terminal.integrated.shell.linux":this._readSingleTerminalConfiguration("terminal.integrated.shell.linux"),"terminal.integrated.shellArgs.windows":this._readSingleTerminalConfiguration("terminal.integrated.shellArgs.windows"),"terminal.integrated.shellArgs.osx":this._readSingleTerminalConfiguration("terminal.integrated.shellArgs.osx"),"terminal.integrated.shellArgs.linux":this._readSingleTerminalConfiguration("terminal.integrated.shellArgs.linux"),"terminal.integrated.env.windows":this._readSingleTerminalConfiguration("terminal.integrated.env.windows"),"terminal.integrated.env.osx":this._readSingleTerminalConfiguration("terminal.integrated.env.osx"),"terminal.integrated.env.linux":this._readSingleTerminalConfiguration("terminal.integrated.env.linux"),"terminal.integrated.inheritEnv":r.inheritEnv,"terminal.integrated.cwd":r.cwd,"terminal.integrated.detectLocale":r.detectLocale,"terminal.flowControl":r.flowControl},a=Object.create(null),n=w?h.withNullAsUndefined(this._workspaceContextService.getWorkspaceFolder(w)):void 0;let f;try{f=await this._resolverService.resolveWithInteraction(n,{shellLaunchConfig:p,configuration:s})}catch(W){this._logService.error(W)}if(f)for(const[W,q]of f.entries())(/^config:/.test(W)||W==="selectedText"||W==="lineNumber")&&(a[W]=q);const C=[];for(const[W,q]of this._environmentVariableService.collections.entries())C.push([W,P.serializeEnvironmentVariableCollection(q.map)]);const A=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),O=A.options&&A.options.extensionHostEnv,E=this._workspaceContextService.getWorkspace(),F=E.folders,j=w?this._workspaceContextService.getWorkspaceFolder(w):null,G=g.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:g.SideBySideEditor.PRIMARY,filterByScheme:[d.Schemas.file,d.Schemas.userData,d.Schemas.vscodeRemote]}),z={configuration:s,resolvedVariables:a,envVariableCollections:C,shellLaunchConfig:p,workspaceId:E.id,workspaceName:this._labelService.getWorkspaceLabel(E),workspaceFolders:F,activeWorkspaceFolder:j,activeFileResource:G,shouldPersistTerminal:l,cols:o,rows:i,isWorkspaceShellAllowed:t,resolverEnv:O};return await this._channel.call("$createTerminalProcess",z)}async startTerminalProcess(p){const w={id:p};return this._channel.call("$startTerminalProcess",w)}onTerminalProcessEvent(p){const w={id:p};return this._channel.listen("$onTerminalProcessEvent",w)}sendInputToTerminalProcess(p,w){const l={id:p,data:w};return this._channel.call("$sendInputToTerminalProcess",l)}sendCharCountToTerminalProcess(p,w){const l={id:p,charCount:w};return this._channel.call("$sendCharCountToTerminalProcess",l)}shutdownTerminalProcess(p,w){const l={id:p,immediate:w};return this._channel.call("$shutdownTerminalProcess",l)}resizeTerminalProcess(p,w,l){const o={id:p,cols:w,rows:l};return this._channel.call("$resizeTerminalProcess",o)}getTerminalInitialCwd(p){const w={id:p};return this._channel.call("$getTerminalInitialCwd",w)}getTerminalCwd(p){const w={id:p};return this._channel.call("$getTerminalCwd",w)}sendCommandResultToTerminalProcess(p,w,l,o){const i={id:p,reqId:w,isError:l,payload:o};return this._channel.call("$sendCommandResultToTerminalProcess",i)}orphanQuestionReply(p){const w={id:p};return this._channel.call("$orphanQuestionReply",w)}listTerminals(p){const w={isInitialization:p};return this._channel.call("$listTerminals",w)}setTerminalLayoutInfo(p){const l={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:p.tabs};return this._channel.call("$setTerminalLayoutInfo",l)}getTerminalLayoutInfo(){const w={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",w)}};y=ve([ge(2,D.IWorkbenchConfigurationService),ge(3,k.IWorkspaceContextService),ge(4,u.IConfigurationResolverService),ge(5,m.IEnvironmentVariableService),ge(6,_.IRemoteAuthorityResolverService),ge(7,T.ILogService),ge(8,I.IEditorService),ge(9,v.ILabelService)],y),e.RemoteTerminalChannelClient=y}),define(J[187],Z([0,1,157]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Logger=e.Translations=void 0;var D;(function(_){function k(P,u){if(P===u)return!0;let g=Object.keys(P),I=new Set;for(let d of Object.keys(u))I.add(d);if(g.length!==I.size)return!1;for(let d of g){if(P[d]!==u[d])return!1;I.delete(d)}return I.size===0}_.equals=k})(D=e.Translations||(e.Translations={}));class T{constructor(k){this._messageHandler=k}error(k,P){this._messageHandler(h.Severity.Error,k,P)}warn(k,P){this._messageHandler(h.Severity.Warning,k,P)}info(k,P){this._messageHandler(h.Severity.Info,k,P)}}e.Logger=T}),define(J[188],Z([0,1,15,135,3,44,60,22,113,10,6,17,31,50,40,187]),function(H,e,h,D,T,_,k,P,u,g,I,d,v,m,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionScanner=e.ExtensionScannerInput=void 0;const b="package.json";class p{constructor(a,n,f,C,A){this._ourVersion=a,this._log=n,this._absoluteFolderPath=f,this._isBuiltin=C,this._isUnderDevelopment=A,this._absoluteManifestPath=T.join(f,b)}}class w extends p{static _fastParseJSON(a,n){try{return JSON.parse(a)}catch(f){return k.parse(a,n)}}parse(){return h.promises.readFile(this._absoluteManifestPath).then(a=>{var n;const f=[],C=w._fastParseJSON(a.toString(),f);if(k.getNodeType(C)!=="object")this._log.error(this._absoluteFolderPath,D.localize(0,null,this._absoluteManifestPath));else{if(f.length===0)return C.__metadata&&(C.uuid=C.__metadata.id),C.isUserBuiltin=!!((n=C.__metadata)===null||n===void 0?void 0:n.isBuiltin),delete C.__metadata,C;f.forEach(A=>{this._log.error(this._absoluteFolderPath,D.localize(1,null,this._absoluteManifestPath,A.offset,A.length,u.getParseErrorMessage(A.error)))})}return null},a=>(a.code==="ENOENT"||this._log.error(this._absoluteFolderPath,D.localize(2,null,this._absoluteManifestPath,a.message)),null))}}class l extends p{constructor(a,n,f,C,A,O){super(a,n,f,C,A);this._nlsConfig=O}replaceNLS(a){const n=(j,G)=>{G.forEach(z=>{this._log.error(this._absoluteFolderPath,D.localize(3,null,j,u.getParseErrorMessage(z.error)))})},f=j=>{this._log.error(this._absoluteFolderPath,D.localize(4,null,j))};let C=T.extname(this._absoluteManifestPath),A=this._absoluteManifestPath.substr(0,this._absoluteManifestPath.length-C.length);const O=`${a.publisher}.${a.name}`;let E=this._nlsConfig.translations[O],F;return E?F=h.promises.readFile(E,"utf8").then(j=>{let G=[],z=k.parse(j,G);return G.length>0?(n(E,G),{values:void 0,default:`${A}.nls.json`}):k.getNodeType(z)!=="object"?(f(E),{values:void 0,default:`${A}.nls.json`}):{values:z.contents?z.contents.package:void 0,default:`${A}.nls.json`}},j=>({values:void 0,default:`${A}.nls.json`})):F=d.SymlinkSupport.existsFile(A+".nls"+C).then(j=>{if(!!j)return l.findMessageBundles(this._nlsConfig,A).then(G=>G.localized?h.promises.readFile(G.localized,"utf8").then(z=>{let W=[],q=k.parse(z,W);return W.length>0?(n(G.localized,W),{values:void 0,default:G.original}):k.getNodeType(q)!=="object"?(f(G.localized),{values:void 0,default:G.original}):{values:q,default:G.original}},z=>({values:void 0,default:G.original})):{values:void 0,default:G.original},G=>{})}),F.then(j=>{if(j===void 0)return a;let G=[];return l.resolveOriginalMessageBundle(j.default,G).then(z=>{if(G.length>0)return n(j.default,G),a;if(k.getNodeType(j)!=="object")return f(j.default),a;const W=j.values||Object.create(null);return l._replaceNLStrings(this._nlsConfig,a,W,z,this._log,this._absoluteFolderPath),a})},j=>a)}static resolveOriginalMessageBundle(a,n){return new Promise((f,C)=>{a?h.promises.readFile(a).then(A=>{f(k.parse(A.toString(),n))},A=>{f(null)}):f(null)})}static findMessageBundles(a,n){return new Promise((f,C)=>{function A(O,E){let F=`${O}.nls.${E}.json`;d.SymlinkSupport.existsFile(F).then(j=>{j&&f({localized:F,original:`${O}.nls.json`});let G=E.lastIndexOf("-");G===-1?f({localized:`${O}.nls.json`,original:null}):(E=E.substring(0,G),A(O,E))})}if(a.devMode||a.pseudo||!a.locale)return f({localized:n+".nls.json",original:null});A(n,a.locale)})}static _replaceNLStrings(a,n,f,C,A,O){function E(F,j,G){let z=F[j];if(g.isString(z)){let W=z,q=W.length;if(q>1&&W[0]==="%"&&W[q-1]==="%"){let ee=W.substr(1,q-2),te=f[ee];te===void 0&&C&&(te=C[ee]),te?(a.pseudo&&(te="\uFF3B"+te.replace(/[aouei]/g,"$&$&")+"\uFF3D"),F[j]=G&&(j==="title"||j==="category")&&C?{value:te,original:C[ee]}:te):A.warn(O,D.localize(5,null,ee))}}else if(g.isObject(z))for(let W in z)z.hasOwnProperty(W)&&(W==="commands"?E(z,W,!0):E(z,W,G));else if(g.isArray(z))for(let W=0;W<z.length;W++)E(z,W,G)}for(let F in n)n.hasOwnProperty(F)&&E(n,F)}}class o extends p{validate(a){let n=a;n.isBuiltin=this._isBuiltin,n.isUserBuiltin=!this._isBuiltin&&!!n.isUserBuiltin,n.isUnderDevelopment=this._isUnderDevelopment;let f=[];return o.isValidExtensionDescription(this._ourVersion,this._absoluteFolderPath,n,f)?(f.forEach(C=>{this._log.warn(this._absoluteFolderPath,C)}),n.publisher||(n.publisher="undefined_publisher"),n.id=v.getExtensionId(n.publisher,n.name),n.identifier=new c.ExtensionIdentifier(n.id),n.extensionLocation=I.URI.file(this._absoluteFolderPath),n):(f.forEach(C=>{this._log.error(this._absoluteFolderPath,C)}),null)}static isValidExtensionDescription(a,n,f,C){return o.baseIsValidExtensionDescription(n,f,C)?_.valid(f.version)?m.isValidExtensionVersion(a,f,C):(C.push(D.localize(6,null)),!1):!1}static baseIsValidExtensionDescription(a,n,f){if(!n)return f.push(D.localize(7,null)),!1;if(typeof n.publisher!="undefined"&&typeof n.publisher!="string")return f.push(D.localize(8,null)),!1;if(typeof n.name!="string")return f.push(D.localize(9,null,"name")),!1;if(typeof n.version!="string")return f.push(D.localize(10,null,"version")),!1;if(!n.engines)return f.push(D.localize(11,null,"engines")),!1;if(typeof n.engines.vscode!="string")return f.push(D.localize(12,null,"engines.vscode")),!1;if(typeof n.extensionDependencies!="undefined"&&!o._isStringArray(n.extensionDependencies))return f.push(D.localize(13,null,"extensionDependencies")),!1;if(typeof n.activationEvents!="undefined"){if(!o._isStringArray(n.activationEvents))return f.push(D.localize(14,null,"activationEvents")),!1;if(typeof n.main=="undefined"&&typeof n.browser=="undefined")return f.push(D.localize(15,null,"activationEvents","main")),!1}if(typeof n.main!="undefined"){if(typeof n.main!="string")return f.push(D.localize(16,null,"main")),!1;{const C=T.join(a,n.main);C.startsWith(a)||f.push(D.localize(17,null,C,a))}if(typeof n.activationEvents=="undefined")return f.push(D.localize(18,null,"activationEvents","main")),!1}if(typeof n.browser!="undefined"){if(typeof n.browser!="string")return f.push(D.localize(19,null,"browser")),!1;{const C=T.join(a,n.browser);C.startsWith(a)||f.push(D.localize(20,null,C,a))}if(typeof n.activationEvents=="undefined")return f.push(D.localize(21,null,"activationEvents","browser")),!1}return!0}static _isStringArray(a){if(!Array.isArray(a))return!1;for(let n=0,f=a.length;n<f;n++)if(typeof a[n]!="string")return!1;return!0}}class i{constructor(a,n,f,C,A,O,E,F){this.ourVersion=a,this.commit=n,this.locale=f,this.devMode=C,this.absoluteFolderPath=A,this.isBuiltin=O,this.isUnderDevelopment=E,this.translations=F}static createNLSConfig(a){return{devMode:a.devMode,locale:a.locale,pseudo:a.locale==="pseudo",translations:a.translations}}static equals(a,n){return a.ourVersion===n.ourVersion&&a.commit===n.commit&&a.locale===n.locale&&a.devMode===n.devMode&&a.absoluteFolderPath===n.absoluteFolderPath&&a.isBuiltin===n.isBuiltin&&a.isUnderDevelopment===n.isUnderDevelopment&&a.mtime===n.mtime&&y.Translations.equals(a.translations,n.translations)}}e.ExtensionScannerInput=i;class t{constructor(a){this.root=a}resolveExtensions(){return d.readDirsInDir(this.root).then(a=>a.map(n=>({name:n,path:T.join(this.root,n)})))}}class r{static scanExtension(a,n,f,C,A,O){return f=T.normalize(f),new w(a,n,f,C,A).parse().then(F=>F===null?null:new l(a,n,f,C,A,O).replaceNLS(F)).then(F=>F===null?null:new o(a,n,f,C,A).validate(F))}static async scanExtensions(a,n,f=null){const C=a.absoluteFolderPath,A=a.isBuiltin,O=a.isUnderDevelopment;f||(f=new t(C));try{let E={};if(!A)try{const W=await h.promises.readFile(T.join(C,".obsolete"),"utf8");E=JSON.parse(W)}catch(W){}let F=await f.resolveExtensions();F.sort((W,q)=>W.name<q.name?-1:1),A||(F=F.filter(W=>W.name.indexOf(".")!==0));const j=i.createNLSConfig(a);let G=await Promise.all(F.map(W=>this.scanExtension(a.ourVersion,n,W.path,A,O,j))),z=P.coalesce(G);return z=z.filter(W=>W!==null&&!E[new v.ExtensionIdentifierWithVersion({id:v.getGalleryExtensionId(W.publisher,W.name)},W.version).key()]),A||(z=v.groupByExtension(z,q=>({id:q.identifier.value,uuid:q.uuid})).map(q=>q.sort((ee,te)=>_.rcompare(ee.version,te.version))[0])),z.sort((W,q)=>W.extensionLocation.fsPath<q.extensionLocation.fsPath?-1:1),z}catch(E){return n.error(C,E),[]}}static scanOneOrMultipleExtensions(a,n){const f=a.absoluteFolderPath,C=a.isBuiltin,A=a.isUnderDevelopment;return d.SymlinkSupport.existsFile(T.join(f,b)).then(O=>{if(O){const E=i.createNLSConfig(a);return this.scanExtension(a.ourVersion,n,f,C,A,E).then(F=>F===null?[]:[F])}return this.scanExtensions(a,n)},O=>(n.error(f,O),[]))}static scanSingleExtension(a,n){const f=a.absoluteFolderPath,C=a.isBuiltin,A=a.isUnderDevelopment,O=i.createNLSConfig(a);return this.scanExtension(a.ourVersion,n,f,C,A,O)}static mergeBuiltinExtensions(a,n){return Promise.all([a,n]).then(([f,C])=>{let A=Object.create(null);for(let E=0,F=f.length;E<F;E++)A[c.ExtensionIdentifier.toKey(f[E].identifier)]=f[E];for(let E=0,F=C.length;E<F;E++)A[c.ExtensionIdentifier.toKey(C[E].identifier)]=C[E];let O=Object.keys(A).map(E=>A[E]);return O.sort((E,F)=>{const j=T.basename(E.extensionLocation.fsPath),G=T.basename(F.extensionLocation.fsPath);return j<G?-1:j>G?1:0}),O})}}e.ExtensionScanner=r}),define(J[189],Z([0,1,35,21,37,16,25,5,4,19,6,49,115,40,53,28,57,81,178,83,172,180,181,174,184,188]),function(H,e,h,D,T,_,k,P,u,g,I,d,v,m,c,y,b,p,w,l,o,i,t,r,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalProviderChannel=e.ExtensionEnvironmentChannel=e.FileProviderChannel=void 0;class n extends c.DiskFileSystemProvider{constructor(){super(...arguments);this.watches=new Map}dispose(){this.watches.forEach(z=>z.dispose()),this.watches.clear(),super.dispose()}_watch(z,W,q){this.watches.set(z,this.watch(W,q))}unwatch(z){this.watches.get(z).dispose(),this.watches.delete(z)}}class f{constructor(z,W){this.environmentService=z,this.logService=W,this.watchers=new Map,this.provider=new c.DiskFileSystemProvider(this.logService)}listen(z,W,q){switch(W){case"filechange":return this.filechange(z,q[0]);case"readFileStream":return this.readFileStream(q[0],q[1])}throw new Error(`Invalid listen '${W}'`)}filechange(z,W){const q=new P.Emitter({onFirstListenerAdd:()=>{const ee=new n(this.logService);this.watchers.set(W,ee);const te=p.getUriTransformer(z.remoteAuthority);ee.onDidChangeFile(B=>{q.fire(B.map(M=>Object.assign(Object.assign({},M),{resource:te.transformOutgoing(M.resource)})))}),ee.onDidErrorOccur(B=>this.logService.error(B))},onLastListenerRemove:()=>{this.watchers.get(W).dispose(),this.watchers.delete(W)}});return q.event}readFileStream(z,W){const q=new k.CancellationTokenSource,ee=this.provider.readFileStream(this.transform(z),W,q.token),te=new P.Emitter({onFirstListenerAdd:()=>{ee.on("data",B=>te.fire(_.VSBuffer.wrap(B))),ee.on("error",B=>te.fire(B)),ee.on("end",()=>te.fire("end"))},onLastListenerRemove:()=>q.cancel()});return te.event}call(z,W,q){switch(W){case"stat":return this.stat(q[0]);case"open":return this.open(q[0],q[1]);case"close":return this.close(q[0]);case"read":return this.read(q[0],q[1],q[2]);case"readFile":return this.readFile(q[0]);case"write":return this.write(q[0],q[1],q[2],q[3],q[4]);case"writeFile":return this.writeFile(q[0],q[1],q[2]);case"delete":return this.delete(q[0],q[1]);case"mkdir":return this.mkdir(q[0]);case"readdir":return this.readdir(q[0]);case"rename":return this.rename(q[0],q[1],q[2]);case"copy":return this.copy(q[0],q[1],q[2]);case"watch":return this.watch(q[0],q[1],q[2],q[3]);case"unwatch":return this.unwatch(q[0],q[1])}throw new Error(`Invalid call '${W}'`)}dispose(){this.watchers.forEach(z=>z.dispose()),this.watchers.clear()}async stat(z){return this.provider.stat(this.transform(z))}async open(z,W){return this.provider.open(this.transform(z),W)}async close(z){return this.provider.close(z)}async read(z,W,q){const ee=_.VSBuffer.alloc(q),te=await this.provider.read(z,W,ee.buffer,0,q);return[ee,te]}async readFile(z){return _.VSBuffer.wrap(await this.provider.readFile(this.transform(z)))}write(z,W,q,ee,te){return this.provider.write(z,W,q.buffer,ee,te)}writeFile(z,W,q){return this.provider.writeFile(this.transform(z),W.buffer,q)}async delete(z,W){return this.provider.delete(this.transform(z),W)}async mkdir(z){return this.provider.mkdir(this.transform(z))}async readdir(z){return this.provider.readdir(this.transform(z))}async rename(z,W,q){return this.provider.rename(this.transform(z),I.URI.from(W),q)}copy(z,W,q){return this.provider.copy(this.transform(z),I.URI.from(W),q)}async watch(z,W,q,ee){this.watchers.get(z)._watch(W,this.transform(q),ee)}async unwatch(z,W){this.watchers.get(z).unwatch(W)}transform(z){if(/^\/static[^/]*\//.test(z.path))return I.URI.file(this.environmentService.appRoot+z.path.replace(/^\/static[^/]*\//,"/"));if(z.path==="/vscode-resource"&&z.query)try{const W=JSON.parse(z.query);if(W.requestResourcePath)return I.URI.file(W.requestResourcePath)}catch(W){}return I.URI.from(z)}}e.FileProviderChannel=f;class C{constructor(z,W,q,ee){this.environment=z,this.log=W,this.telemetry=q,this.connectionToken=ee}listen(z,W){throw new Error(`Invalid listen '${W}'`)}async call(z,W,q){switch(W){case"getEnvironmentData":return d.transformOutgoingURIs(await this.getEnvironmentData(),p.getUriTransformer(z.remoteAuthority));case"scanExtensions":return d.transformOutgoingURIs(await this.scanExtensions(q.language),p.getUriTransformer(z.remoteAuthority));case"getDiagnosticInfo":return this.getDiagnosticInfo();case"disableTelemetry":return this.disableTelemetry();case"logTelemetry":return this.logTelemetry(q[0],q[1]);case"flushTelemetry":return this.flushTelemetry()}throw new Error(`Invalid call '${W}'`)}async getEnvironmentData(){return{pid:process.pid,connectionToken:this.connectionToken,appRoot:I.URI.file(this.environment.appRoot),settingsPath:this.environment.settingsResource,logsPath:I.URI.file(this.environment.logsPath),extensionsPath:I.URI.file(this.environment.extensionsPath),extensionHostLogsPath:I.URI.file(T.join(this.environment.logsPath,"extension-host")),globalStorageHome:this.environment.globalStorageHome,workspaceStorageHome:this.environment.workspaceStorageHome,userHome:this.environment.userHome,os:u.OS,marks:[]}}async scanExtensions(z){const W=await b.getTranslations(z,this.environment.userDataPath),q=(B,M,L)=>Promise.all(L.map(S=>a.ExtensionScanner.scanExtensions(new a.ExtensionScannerInput(y.default.version,y.default.commit,z,!!process.env.VSCODE_DEV,S,B,M,W),this.log))),ee=async()=>q(!0,!1,[this.environment.builtinExtensionsPath,...this.environment.extraBuiltinExtensionPaths]),te=async()=>q(!1,!0,[this.environment.extensionsPath,...this.environment.extraExtensionPaths]);return Promise.all([ee(),te()]).then(B=>{const M=new Map;return B.forEach(L=>{L.forEach(S=>{S.forEach(R=>{const N=m.ExtensionIdentifier.toKey(R.identifier);if(M.has(N)){const U=M.get(N).extensionLocation.fsPath,$=R.extensionLocation.fsPath;this.log.warn(`${U} has been overridden ${$}`)}M.set(N,R)})})}),Array.from(M.values())})}getDiagnosticInfo(){throw new Error("not implemented")}async disableTelemetry(){this.telemetry.setEnabled(!1)}async logTelemetry(z,W){this.telemetry.publicLog(z,W)}async flushTelemetry(){}}e.ExtensionEnvironmentChannel=C;class A extends s.AbstractVariableResolverService{constructor(z,W,q){super({getFolderUri:ee=>{const te=W.workspaceFolders.find(B=>B.name===ee);return te&&I.URI.revive(te.uri)},getWorkspaceFolderCount:()=>W.workspaceFolders.length,getConfigurationValue:(ee,te)=>W.resolvedVariables[`config:${te}`],getAppRoot:()=>W.resolverEnv&&W.resolverEnv.VSCODE_CWD||q.VSCODE_CWD||process.cwd(),getExecPath:()=>W.resolverEnv&&W.resolverEnv.VSCODE_EXEC_PATH||q.VSCODE_EXEC_PATH,getFilePath:()=>{const ee=F(z,W.activeFileResource);if(!!ee)return ee.scheme==="file"?ee.fsPath:ee.path},getSelectedText:()=>W.resolvedVariables.selectedText,getLineNumber:()=>W.resolvedVariables.selectedText},void 0,q)}}class O{constructor(z,W,q,ee,te){this.id=z,this._pid=-1,this._title="",this._onDispose=new P.Emitter,this._isOrphan=!0,this.replayData=[],this.maxReplayData=1e4,this.totalReplayData=0,this.disposeDelay=48*60*60*1e3,this.buffering=!1,this._onEvent=new P.Emitter({onFirstListenerAdd:()=>{h.logger.debug("Terminal bound",h.field("id",this.id)),this._isOrphan=!1,this.buffering||(this.buffering=!0,this.bufferer.startBuffering(this.id,this.process.onProcessData))},onFirstListenerDidAdd:()=>{typeof this.disposeTimeout=="undefined"&&(clearTimeout(this.disposeTimeout),this.disposeTimeout=void 0,h.logger.debug("Terminal replaying",h.field("id",this.id)),this._onEvent.fire({type:"replay",events:[{cols:this.cols,rows:this.rows,data:this.replayData.join("")}]}))},onLastListenerRemove:()=>{h.logger.debug("Terminal unbound",h.field("id",this.id)),this._isOrphan=!0,this.persist?this.disposeTimeout=setTimeout(()=>{this.dispose()},this.disposeDelay):this.dispose()}}),this.bufferer=new o.TerminalDataBufferer((B,M)=>{if(this._onEvent.fire({type:"data",data:M}),!!this.persist){this.replayData.push(M),this.totalReplayData+=M.length;let L=this.totalReplayData-this.maxReplayData;if(!(L<=0)){let S=0;for(;S<this.replayData.length&&this.replayData[S].length<=L;++S)L-=this.replayData[S].length;S>0&&this.replayData.splice(0,S),L>0&&this.replayData.length>0&&(this.replayData[0]=this.replayData[0].substring(L)),this.totalReplayData=this.replayData.reduce((R,N)=>R+N.length,0)}}}),this.workspaceId=q.workspaceId,this.workspaceName=q.workspaceName,this.cols=q.cols,this.rows=q.rows,this.persist=!1,this.process=new r.TerminalProcess(W,W.cwd,this.cols,this.rows,ee,process.env,!1,te),this.process.onProcessReady(B=>{this._pid=B.pid,this._onEvent.fire({type:"ready",pid:B.pid,cwd:B.cwd})}),this.process.onProcessTitleChanged(B=>{this._title=B,this._onEvent.fire({type:"titleChanged",title:B})}),this.process.onProcessExit(B=>{h.logger.debug("Terminal exited",h.field("id",this.id),h.field("code",B)),this._onEvent.fire({type:"exit",exitCode:B}),this.dispose()})}get onDispose(){return this._onDispose.event}get isOrphan(){return this._isOrphan}get onEvent(){return this._onEvent.event}get pid(){return this._pid}get title(){return this._title}async dispose(){h.logger.debug("Terminal disposing",h.field("id",this.id)),this._onEvent.dispose(),this.bufferer.dispose(),await this.process.shutdown(!0),this.process.dispose(),this._onDispose.fire(),this._onDispose.dispose()}shutdown(z){return this.process.shutdown(z)}getCwd(){return this.process.getCwd()}getInitialCwd(){return this.process.getInitialCwd()}start(){return this.process.start()}input(z){return this.process.input(z)}acknowledgeDataEvent(z){return this.process.acknowledgeDataEvent(z)}resize(z,W){return this.cols=z,this.rows=W,this.process.resize(z,W)}async description(z){const W=await this.getCwd();return{id:z,pid:this.pid,title:this.title,cwd:W,workspaceId:this.workspaceId,workspaceName:this.workspaceName,isOrphan:this.isOrphan}}}class E{constructor(z){this.logService=z,this.terminals=new Map,this.id=0,this.layouts=new Map}listen(z,W,q){switch(W){case"$onTerminalProcessEvent":return this.onTerminalProcessEvent(q)}throw new Error(`Invalid listen '${W}'`)}onTerminalProcessEvent(z){return this.getTerminal(z.id).onEvent}call(z,W,q){switch(W){case"$createTerminalProcess":return this.createTerminalProcess(z.remoteAuthority,q);case"$startTerminalProcess":return this.startTerminalProcess(q);case"$sendInputToTerminalProcess":return this.sendInputToTerminalProcess(q);case"$sendCharCountToTerminalProcess":return this.sendCharCountToTerminalProcess(q);case"$shutdownTerminalProcess":return this.shutdownTerminalProcess(q);case"$resizeTerminalProcess":return this.resizeTerminalProcess(q);case"$getTerminalInitialCwd":return this.getTerminalInitialCwd(q);case"$getTerminalCwd":return this.getTerminalCwd(q);case"$sendCommandResultToTerminalProcess":return this.sendCommandResultToTerminalProcess(q);case"$orphanQuestionReply":return this.orphanQuestionReply(q[0]);case"$listTerminals":return this.listTerminals(q[0]);case"$setTerminalLayoutInfo":return this.setTerminalLayoutInfo(q);case"$getTerminalLayoutInfo":return this.getTerminalLayoutInfo(q)}throw new Error(`Invalid call '${W}'`)}dispose(){this.terminals.forEach(z=>z.dispose())}async createTerminalProcess(z,W){var q;const ee=this.id++;h.logger.debug("Creating terminal",h.field("id",ee),h.field("terminals",this.terminals.size));const te={name:W.shellLaunchConfig.name,executable:W.shellLaunchConfig.executable,args:W.shellLaunchConfig.args,cwd:typeof W.shellLaunchConfig.cwd!="string"?F(z,W.shellLaunchConfig.cwd):W.shellLaunchConfig.cwd,env:W.shellLaunchConfig.env},B=F(z,(q=W.activeWorkspaceFolder)===null||q===void 0?void 0:q.uri),M=B&&W.activeWorkspaceFolder?Object.assign(Object.assign({},W.activeWorkspaceFolder),{uri:B,toResource:se=>g.joinPath(B,se)}):void 0,L=new A(z,W,process.env),S=i.createVariableResolver(M,L),R=async()=>{if(te.executable){const ce=L.resolve(M,te.executable);let he=[];if(te.args&&Array.isArray(te.args))for(const _e of te.args)he.push(L.resolve(M,_e));else te.args&&(he=L.resolve(M,te.args));return{executable:ce,args:he}}const se=i.getDefaultShell(ce=>W.configuration[ce],W.isWorkspaceShellAllowed,await v.getSystemShell(u.platform),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,S,this.logService,!1),oe=i.getDefaultShellArgs(ce=>W.configuration[ce],W.isWorkspaceShellAllowed,!1,S,this.logService);return{executable:se,args:oe}},N=()=>i.getCwd(te,D.homedir(),S,B,W.configuration["terminal.integrated.cwd"],this.logService),U=Object.assign(Object.assign(Object.assign({},te),await R()),{cwd:N()});h.logger.debug("Resolved shell launch configuration",h.field("id",ee));const $=()=>u.isWindows?W.configuration["terminal.integrated.env.windows"]:u.isMacintosh?W.configuration["terminal.integrated.env.osx"]:W.configuration["terminal.integrated.env.linux"],K=async()=>{const se=await t.getMainProcessParentEnv();return se.VSCODE_IPC_HOOK_CLI=process.env.VSCODE_IPC_HOOK_CLI,se},Y=i.createTerminalEnvironment(te,$(),S,W.isWorkspaceShellAllowed,y.default.version,W.configuration["terminal.integrated.detectLocale"],W.configuration["terminal.integrated.inheritEnv"]!==!1?process.env:await K());if(!te.strictEnv){const se=new Map;for(const[ce,he]of W.envVariableCollections)se.set(ce,{map:l.deserializeEnvironmentVariableCollection(he)});new w.MergedEnvironmentVariableCollection(se).applyToProcessEnvironment(Y)}h.logger.debug("Resolved terminal environment",h.field("id",ee));const Q=new O(ee,U,W,Y,this.logService);return this.terminals.set(ee,Q),h.logger.debug("Created terminal",h.field("id",ee)),Q.onDispose(()=>this.terminals.delete(ee)),{terminalId:ee,resolvedShellLaunchConfig:U}}getTerminal(z){const W=this.terminals.get(z);if(!W)throw new Error(`terminal with id ${z} does not exist`);return W}async startTerminalProcess(z){return this.getTerminal(z.id).start()}async sendInputToTerminalProcess(z){return this.getTerminal(z.id).input(z.data)}async sendCharCountToTerminalProcess(z){return this.getTerminal(z.id).acknowledgeDataEvent(z.charCount)}async shutdownTerminalProcess(z){return this.getTerminal(z.id).shutdown(z.immediate)}async resizeTerminalProcess(z){return this.getTerminal(z.id).resize(z.cols,z.rows)}async getTerminalInitialCwd(z){return this.getTerminal(z.id).getInitialCwd()}async getTerminalCwd(z){return this.getTerminal(z.id).getCwd()}async sendCommandResultToTerminalProcess(z){throw new Error("not implemented")}async orphanQuestionReply(z){throw new Error("not implemented")}async listTerminals(z){return(await Promise.all(Array.from(this.terminals).map(async([q,ee])=>ee.description(q)))).filter(q=>q.isOrphan)}async setTerminalLayoutInfo(z){this.layouts.set(z.workspaceId,z)}async getTerminalLayoutInfo(z){const W=this.layouts.get(z.workspaceId);if(!!W)return{tabs:await Promise.all(W.tabs.map(async ee=>{const te=await Promise.all(ee.terminals.map(async B=>{const M=this.terminals.get(B.terminal);if(!!M)return Object.assign(Object.assign({},B),{terminal:await M.description(B.terminal)})}));return Object.assign(Object.assign({},ee),{terminals:te.filter(j)})}))}}}e.TerminalProviderChannel=E;function F(G,z){const W=p.getUriTransformer(G);return z&&I.URI.revive(W.transformIncoming(z))}function j(G){return typeof G!="undefined"}}),define(J[190],Z([0,1,5,2,6,26,16,42,14,38]),function(H,e,h,D,T,_,k,P,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProvider=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remotefilesystem";class I extends D.Disposable{constructor(v){super();this.session=_.generateUuid(),this._onDidChange=this._register(new h.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchErrorOccur=this._register(new h.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeCapabilities=this._register(new h.Emitter),this.onDidChangeCapabilities=this._onDidChangeCapabilities.event;const m=v.getConnection();this.channel=m.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),this.setCaseSensitive(!0),(async()=>{const c=await v.getEnvironment();this.setCaseSensitive((c==null?void 0:c.os)===3)})(),this.registerListeners()}get capabilities(){return this._capabilities}registerListeners(){this._register(this.channel.listen("filechange",[this.session])(v=>{if(Array.isArray(v)){const m=v;this._onDidChange.fire(m.map(c=>({resource:T.URI.revive(c.resource),type:c.type})))}else{const m=v;this._onDidWatchErrorOccur.fire(m)}}))}setCaseSensitive(v){let m=2|4|16|8;v&&(m|=1024),this._capabilities=m,this._onDidChangeCapabilities.fire(void 0)}stat(v){return this.channel.call("stat",[v])}open(v,m){return this.channel.call("open",[v,m])}close(v){return this.channel.call("close",[v])}async read(v,m,c,y,b){const[p,w]=await this.channel.call("read",[v,m,b]);return c.set(p.buffer.slice(0,w),y),w}async readFile(v){return(await this.channel.call("readFile",[v])).buffer}readFileStream(v,m,c){const y=P.newWriteableStream(p=>k.VSBuffer.concat(p.map(w=>k.VSBuffer.wrap(w))).buffer),b=this.channel.listen("readFileStream",[v,m])(p=>{if(p instanceof k.VSBuffer)y.write(p.buffer);else{if(p==="end")y.end();else{let w=p;w instanceof Error||(w=new Error(g.toErrorMessage(w))),y.end(w)}b.dispose()}});return c.onCancellationRequested(()=>{y.end(u.canceled()),b.dispose()}),y}write(v,m,c,y,b){return this.channel.call("write",[v,m,k.VSBuffer.wrap(c),y,b])}writeFile(v,m,c){return this.channel.call("writeFile",[v,k.VSBuffer.wrap(m),c])}delete(v,m){return this.channel.call("delete",[v,m])}mkdir(v){return this.channel.call("mkdir",[v])}readdir(v){return this.channel.call("readdir",[v])}rename(v,m,c){return this.channel.call("rename",[v,m,c])}copy(v,m,c){return this.channel.call("copy",[v,m,c])}watch(v,m){const c=Math.random();return this.channel.call("watch",[this.session,c,v,m]),D.toDisposable(()=>this.channel.call("unwatch",[this.session,c]))}}e.RemoteFileSystemProvider=I}),define(J[191],Z([0,1,7]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=h.createDecorator("remoteAgentService")}),define(J[48],Z([0,1,116,3,15,12,17,205,206,10]),function(H,e,h,D,T,_,k,P,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(t,r){let s=r.message;switch(t){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s);this.type=t,this.cause=r}}e.ExtractError=I;function d(i){const t=i.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,s)=>r+s,t&61440)}function v(i){if(i instanceof I)return i;let t;return/end of central directory record signature not found/.test(i.message)&&(t="CorruptZip"),new I(t,i)}function m(i,t,r,s,a,n){const f=D.dirname(t),C=D.join(s,f);if(!C.startsWith(s))return Promise.reject(new Error(h.localize(0,null,t)));const A=D.join(s,t);let O;return n.onCancellationRequested(()=>{O&&O.destroy()}),Promise.resolve(T.promises.mkdir(C,{recursive:!0})).then(()=>new Promise((E,F)=>{if(!n.isCancellationRequested)try{O=T.createWriteStream(A,{mode:r}),O.once("close",()=>E()),O.once("error",F),i.once("error",F),i.pipe(O)}catch(j){F(j)}}))}function c(i,t,r,s){let a=_.createCancelablePromise(()=>Promise.resolve()),n=0;return s.onCancellationRequested(()=>{a.cancel(),i.close()}),new Promise((f,C)=>{const A=new _.Sequencer,O=E=>{E.isCancellationRequested||(n++,i.readEntry())};i.once("error",C),i.once("close",()=>a.then(()=>{s.isCancellationRequested||i.entryCount===n?f():C(new I("Incomplete",new Error(h.localize(1,null,n,i.entryCount))))},C)),i.readEntry(),i.on("entry",E=>{if(!s.isCancellationRequested){if(!r.sourcePathRegex.test(E.fileName)){O(s);return}const F=E.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(F)){const z=D.join(t,F);a=_.createCancelablePromise(W=>T.promises.mkdir(z,{recursive:!0}).then(()=>O(W)).then(void 0,C));return}const j=b(i,E),G=d(E);a=_.createCancelablePromise(z=>A.queue(()=>j.then(W=>m(W,F,G,t,r,z).then(()=>O(z)))).then(null,C))}})})}function y(i,t=!1){return new Promise((r,s)=>{P.open(i,t?{lazyEntries:!0}:void 0,(a,n)=>{a?s(v(a)):r(g.assertIsDefined(n))})})}function b(i,t){return new Promise((r,s)=>{i.openReadStream(t,(a,n)=>{a?s(v(a)):r(g.assertIsDefined(n))})})}function p(i,t){return new Promise((r,s)=>{const a=new u.ZipFile;t.forEach(f=>{f.contents?a.addBuffer(typeof f.contents=="string"?Buffer.from(f.contents,"utf8"):f.contents,f.path):f.localPath&&a.addFile(f.localPath,f.path)}),a.end();const n=T.createWriteStream(i);a.outputStream.pipe(n),a.outputStream.once("error",s),n.once("error",s),n.once("finish",()=>r(i))})}e.zip=p;function w(i,t,r={},s){const a=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let n=y(i,!0);return r.overwrite&&(n=n.then(f=>k.rimraf(t).then(()=>f))),n.then(f=>c(f,t,{sourcePathRegex:a},s))}e.extract=w;function l(i,t){return y(i).then(r=>new Promise((s,a)=>{r.on("entry",n=>{n.fileName===t&&b(r,n).then(f=>s(f),f=>a(f))}),r.once("close",()=>a(new Error(h.localize(2,null,t))))}))}function o(i,t){return l(i,t).then(r=>new Promise((s,a)=>{const n=[];r.once("error",a),r.on("data",f=>n.push(f)),r.on("end",()=>s(Buffer.concat(n)))}))}e.buffer=o}),define(J[192],Z([0,1,48,121]),function(H,e,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function T(_){return h.buffer(_,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch(P){throw new Error(D.localize(0,null))}})}e.getManifest=T}),define(J[193],Z([0,1,15,44,2,17,3,13,27,31,12,6,23,138,122,45,48,4,22,11]),function(H,e,h,D,T,_,k,P,u,g,I,d,v,m,c,y,b,p,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const o="scanningSystem",i="scanningUser",t="extracting",r="deleting",s="renaming";let a=class extends T.Disposable{constructor(f,C,A,O){super();this.beforeRemovingExtension=f,this.logService=C,this.environmentService=A,this.productService=O,this._devSystemExtensionsPath=null,this.systemExtensionsPath=A.builtinExtensionsPath,this.extensionsPath=A.extensionsPath,this.uninstalledPath=k.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new I.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(f){const C=[];(f===null||f===0)&&C.push(this.scanSystemExtensions().then(null,A=>Promise.reject(new u.ExtensionManagementError(this.joinErrors(A).message,o)))),(f===null||f===1)&&C.push(this.scanUserExtensions(!0).then(null,A=>Promise.reject(new u.ExtensionManagementError(this.joinErrors(A).message,i))));try{const A=await Promise.all(C);return w.flatten(A)}catch(A){throw this.joinErrors(A)}}async scanUserExtensions(f){this.logService.trace("Started scanning user extensions");let[C,A]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return A=A.filter(O=>!C[new g.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]),f&&(A=g.groupByExtension(A,E=>E.identifier).map(E=>E.sort((F,j)=>D.rcompare(F.manifest.version,j.manifest.version))[0])),this.logService.trace("Scanned user extensions:",A.length),A}async scanAllUserExtensions(){return this.scanExtensionsInDirs(this.extensionsPath,this.environmentService.extraExtensionPaths,1)}async extractUserExtension(f,C,A){const O=f.key(),E=k.join(this.extensionsPath,`.${O}`),F=k.join(this.extensionsPath,O);try{await _.rimraf(F)}catch(G){try{await _.rimraf(F)}catch(z){}throw new u.ExtensionManagementError(c.localize(0,null,F,f.id),r)}await this.extractAtLocation(f,C,E,A);try{await this.rename(f,E,F,Date.now()+2*60*1e3),this.logService.info("Renamed to",F)}catch(G){this.logService.info("Rename failed. Deleting from extracted location",E);try{_.rimraf(E)}catch(z){}throw G}let j=null;try{j=await this.scanExtension(O,this.extensionsPath,1)}catch(G){}if(j)return j;throw new Error(c.localize(1,null,this.extensionsPath))}async saveMetadataForLocalExtension(f,C){this.setMetadata(f,C),C.isMachineScoped=C.isMachineScoped||void 0,C.isBuiltin=C.isBuiltin||void 0;const A=k.join(f.location.fsPath,"package.json"),O=await h.promises.readFile(A,"utf8"),{manifest:E}=await this.parseManifest(O);return E.__metadata=C,await _.writeFile(A,JSON.stringify(E,null,"	")),f}getUninstalledExtensions(){return this.withUninstalledExtensions(f=>f)}async withUninstalledExtensions(f){return this.uninstalledFileLimiter.queue(async()=>{let C;try{C=await h.promises.readFile(this.uninstalledPath,"utf8")}catch(E){if(E.code!=="ENOENT")throw E}let A={};if(C)try{A=JSON.parse(C)}catch(E){}const O=f(A);return Object.keys(A).length?await _.writeFile(this.uninstalledPath,JSON.stringify(A)):await _.rimraf(this.uninstalledPath),O})}async removeExtension(f,C){this.logService.trace(`Deleting ${C} extension from disk`,f.identifier.id,f.location.fsPath),await _.rimraf(f.location.fsPath),this.logService.info("Deleted from disk",f.identifier.id,f.location.fsPath)}async removeUninstalledExtension(f){await this.removeExtension(f,"uninstalled"),await this.withUninstalledExtensions(C=>delete C[new g.ExtensionIdentifierWithVersion(f.identifier,f.manifest.version).key()])}async extractAtLocation(f,C,A,O){this.logService.trace(`Started extracting the extension from ${C} to ${A}`);try{await _.rimraf(A)}catch(E){throw new u.ExtensionManagementError(this.joinErrors(E).message,r)}try{await b.extract(C,A,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${A}:`,f.id)}catch(E){try{await _.rimraf(A)}catch(F){}throw new u.ExtensionManagementError(E.message,E instanceof b.ExtractError&&E.type?E.type:t)}}async rename(f,C,A,O){try{await h.promises.rename(C,A)}catch(E){if(p.isWindows&&E&&E.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${C} to ${A} with 'EPERM' error. Trying again...`,f.id),this.rename(f,C,A,O);throw new u.ExtensionManagementError(E.message||c.localize(2,null,C,A),E.code||s)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const f=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return f;const C=this.scanDevSystemExtensions(),[A,O]=await Promise.all([f,C]);return[...A,...O]}async scanExtensionsInDir(f,C){const A=new I.Limiter(10),O=await _.readdir(f).catch(F=>{if(F.code!=="ENOENT")throw F;return[]});return(await Promise.all(O.map(F=>A.queue(()=>this.scanExtension(F,f,C))))).filter(F=>F&&F.identifier)}async scanExtension(f,C,A){if(A===1&&f.indexOf(".")===0)return null;const O=k.join(C,f);try{const E=await _.readdir(O),{manifest:F,metadata:j}=await this.readManifest(O),G=E.filter(B=>/^readme(\.txt|\.md|)$/i.test(B))[0],z=G?d.URI.file(k.join(O,G)):void 0,W=E.filter(B=>/^changelog(\.txt|\.md|)$/i.test(B))[0],q=W?d.URI.file(k.join(O,W)):void 0,ee={id:g.getGalleryExtensionId(F.publisher,F.name)},te={type:A,identifier:ee,manifest:F,location:d.URI.file(O),readmeUrl:z,changelogUrl:q,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:A===0};return j&&this.setMetadata(te,j),te}catch(E){return this.logService.trace(E),null}}async scanDefaultSystemExtensions(){const f=await this.scanExtensionsInDirs(this.systemExtensionsPath,this.environmentService.extraBuiltinExtensionPaths,0);return this.logService.trace("Scanned system extensions:",f.length),f}async scanDevSystemExtensions(){const f=this.getDevSystemExtensionsList();if(f.length){const C=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",C.length),C.filter(A=>f.some(O=>g.areSameExtensions(A.identifier,{id:O})))}else return[]}setMetadata(f,C){f.publisherDisplayName=C.publisherDisplayName||null,f.publisherId=C.publisherId||null,f.identifier.uuid=C.id,f.isMachineScoped=!!C.isMachineScoped,f.isBuiltin=f.type===0||!!C.isBuiltin}async removeUninstalledExtensions(){const f=await this.getUninstalledExtensions(),C=await this.scanAllUserExtensions(),A=new Set;for(const F of C)f[new g.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).key()]||A.add(F.identifier.id.toLowerCase());const O=g.groupByExtension(C,F=>F.identifier);await I.Promises.settled(O.map(async F=>{const j=F.sort((G,z)=>D.rcompare(G.manifest.version,z.manifest.version))[0];A.has(j.identifier.id.toLowerCase())||await this.beforeRemovingExtension(j)}));const E=C.filter(F=>f[new g.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).key()]);await I.Promises.settled(E.map(F=>this.removeUninstalledExtension(F)))}async removeOutdatedExtensions(){const f=await this.scanAllUserExtensions(),C=[],A=g.groupByExtension(f,O=>O.identifier);C.push(...w.flatten(A.map(O=>O.sort((E,F)=>D.rcompare(E.manifest.version,F.manifest.version)).slice(1)))),await I.Promises.settled(C.map(O=>this.removeExtension(O,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(f=>f.name)}joinErrors(f){const C=Array.isArray(f)?f:[f];return C.length===1?C[0]instanceof Error?C[0]:new Error(C[0]):C.reduce((A,O)=>new Error(`${A.message}${A.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=k.normalize(k.join(l.FileAccess.asFileUri("",H).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(f){const C=[h.promises.readFile(k.join(f,"package.json"),"utf8").then(F=>this.parseManifest(F)),h.promises.readFile(k.join(f,"package.nls.json"),"utf8").then(void 0,F=>F.code!=="ENOENT"?Promise.reject(F):"{}").then(F=>JSON.parse(F))],[{manifest:A,metadata:O},E]=await Promise.all(C);return{manifest:m.localizeManifest(A,E),metadata:O}}parseManifest(f){return new Promise((C,A)=>{try{const O=JSON.parse(f),E=O.__metadata||null;C({manifest:O,metadata:E})}catch(O){A(new Error(c.localize(3,null)))}})}async scanExtensionsInDirs(f,C,A){return(await Promise.all([f,...C].map(E=>this.scanExtensionsInDir(E,A)))).reduce((E,F)=>E.concat(F),[])}};a=ve([ge(1,P.ILogService),ge(2,v.INativeEnvironmentService),ge(3,y.IProductService)],a),e.ExtensionsScanner=a}),define(J[85],Z([0,1,15,120,3,17,2,22,48,27,31,23,12,5,44,6,28,4,13,146,38,46,50,19,26,144,7,11,25,192,150,193,151]),function(H,e,h,D,T,_,k,P,u,g,I,d,v,m,c,y,b,p,w,l,o,i,t,r,s,a,n,f,C,A,O,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const j="unsetUninstalled",G="downloading",z="validating",W="local",q="unknown";let ee=class extends k.Disposable{constructor(B,M,L,S,R,N){super();this.environmentService=B,this.galleryService=M,this.logService=L,this.downloadService=S,this.telemetryService=R,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new m.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new m.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new m.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new m.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const U=this._register(N.createInstance(F.ExtensionsLifecycle));this.extensionsScanner=this._register(N.createInstance(E.ExtensionsScanner,$=>U.postUninstall($))),this.manifestCache=this._register(new l.ExtensionsManifestCache(B,this)),this.extensionsDownloader=this._register(N.createInstance(O.ExtensionsDownloader)),this._register(k.toDisposable(()=>{this.installingExtensions.forEach($=>$.cancel()),this.uninstallingExtensions.forEach($=>$.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(B){this.logService.trace("ExtensionManagementService#zip",B.identifier.id);const M=await this.collectFiles(B),L=await u.zip(r.joinPath(this.environmentService.tmpDir,s.generateUuid()).fsPath,M);return y.URI.file(L)}async unzip(B){return this.logService.trace("ExtensionManagementService#unzip",B.toString()),(await this.install(B)).identifier}async getManifest(B){const M=await this.downloadVsix(B),L=T.resolve(M.fsPath);return A.getManifest(L)}async collectFiles(B){const M=async S=>{let R=await _.readdir(S);R=R.map($=>T.join(S,$));const N=await Promise.all(R.map($=>h.promises.stat($)));let U=Promise.resolve([]);return N.forEach(($,K)=>{const Y=R[K];$.isFile()&&(U=U.then(Q=>[...Q,Y])),$.isDirectory()&&(U=U.then(Q=>M(Y).then(se=>[...Q,...se])))}),U};return(await M(B.location.fsPath)).map(S=>({path:`extension/${T.relative(B.location.fsPath,S)}`,localPath:S}))}async install(B,M={}){return this.logService.trace("ExtensionManagementService#install",B.toString()),v.createCancelablePromise(async L=>{const S=await this.downloadVsix(B),R=T.resolve(S.fsPath),N=await A.getManifest(R),U={id:I.getGalleryExtensionId(N.publisher,N.name)};let $=1;if(N.engines&&N.engines.vscode&&!t.isEngineValid(N.engines.vscode,b.default.version))throw new Error(D.localize(0,null,U.id,b.default.version));const K=new I.ExtensionIdentifierWithVersion(U,N.version),Q=(await this.getInstalled(1)).find(oe=>I.areSameExtensions(U,oe.identifier));if(Q)if(M.isMachineScoped=M.isMachineScoped||Q.isMachineScoped,M.isBuiltin=M.isBuiltin||Q.isBuiltin,$=2,K.equals(new I.ExtensionIdentifierWithVersion(Q.identifier,Q.manifest.version)))try{await this.extensionsScanner.removeExtension(Q,"existing")}catch(oe){throw new Error(D.localize(1,null,N.displayName||N.name))}else c.gt(Q.manifest.version,N.version)&&await this.uninstallExtension(Q);else{const oe=await this.unsetUninstalledAndGetLocal(K);if(oe)try{await this.extensionsScanner.removeExtension(oe,"existing")}catch(ce){throw new Error(D.localize(2,null,N.displayName||N.name))}}this.logService.info("Installing the extension:",U.id),this._onInstallExtension.fire({identifier:U,zipPath:R});let se;try{se=await this.getGalleryMetadata(I.getGalleryExtensionId(N.publisher,N.name))}catch(oe){}try{const oe=await this.installFromZipPath(K,R,Object.assign(Object.assign({},se||{}),M),M,$,L);return this.logService.info("Successfully installed the extension:",U.id),oe}catch(oe){throw this.logService.error("Failed to install the extension:",U.id,oe.message),oe}})}async downloadVsix(B){if(B.scheme===f.Schemas.file)return B;if(!this.downloadService)throw new Error("Download service is not available");const M=r.joinPath(this.environmentService.tmpDir,s.generateUuid());return await this.downloadService.download(B,M),M}async installFromZipPath(B,M,L,S,R,N){try{const U=await this.installExtension({zipPath:M,identifierWithVersion:B,metadata:L},N);try{await this.installDependenciesAndPackExtensions(U,void 0,S)}catch($){P.isNonEmptyArray(U.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",U.identifier.id,$.message),P.isNonEmptyArray(U.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",U.identifier.id,$.message)}return this._onDidInstallExtension.fire({identifier:B,zipPath:M,local:U,operation:R}),U}catch(U){throw this._onDidInstallExtension.fire({identifier:B,zipPath:M,operation:R,error:U}),U}}async canInstall(B){return!0}async installFromGallery(B,M={}){if(!this.galleryService.isEnabled())throw new Error(D.localize(3,null));try{B=await this.checkAndGetCompatibleVersion(B)}catch(R){const N=R&&R.code?R.code:q;throw this.logService.error("Failed to install extension:",B.identifier.id,R?R.message:N),this.reportTelemetry(this.getTelemetryEvent(1),I.getGalleryExtensionTelemetryData(B),void 0,R),R instanceof Error&&(R.name=N),R}const L=new I.ExtensionIdentifierWithVersion(B.identifier,B.version).key();let S=this.installingExtensions.get(L);return S||(S=v.createCancelablePromise(R=>this.doInstallFromGallery(B,M,R)),this.installingExtensions.set(L,S),S.finally(()=>this.installingExtensions.delete(L))),S}async doInstallFromGallery(B,M,L){const S=new Date().getTime();let R=1;this.logService.info("Installing extension:",B.identifier.id),this._onInstallExtension.fire({identifier:B.identifier,gallery:B});try{const U=(await this.getInstalled(1)).find(Y=>I.areSameExtensions(Y.identifier,B.identifier));U&&(R=2);const $=await this.downloadInstallableExtension(B,R);$.metadata.isMachineScoped=M.isMachineScoped||(U==null?void 0:U.isMachineScoped),$.metadata.isBuiltin=M.isBuiltin||(U==null?void 0:U.isBuiltin);const K=await this.installExtension($,L);try{await this.extensionsDownloader.delete(y.URI.file($.zipPath))}catch(Y){}if(!M.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(K,U,M)}catch(Y){try{await this.uninstall(K)}catch(Q){}throw Y}return U&&c.neq(U.manifest.version,B.version)&&await this.setUninstalled(U),this.logService.info("Extensions installed successfully:",B.identifier.id),this._onDidInstallExtension.fire({identifier:B.identifier,gallery:B,local:K,operation:R}),this.reportTelemetry(this.getTelemetryEvent(R),I.getGalleryExtensionTelemetryData(B),new Date().getTime()-S,void 0),K}catch(N){const U=N&&N.code?N.code:q;throw this.logService.error("Failed to install extension:",B.identifier.id,N?N.message:U),this._onDidInstallExtension.fire({identifier:B.identifier,gallery:B,operation:R,error:U}),this.reportTelemetry(this.getTelemetryEvent(R),I.getGalleryExtensionTelemetryData(B),new Date().getTime()-S,N),N instanceof Error&&(N.name=U),N}}async checkAndGetCompatibleVersion(B){if(await this.isMalicious(B))throw new g.ExtensionManagementError(D.localize(4,null),g.INSTALL_ERROR_MALICIOUS);const M=await this.galleryService.getCompatibleExtension(B);if(!M)throw new g.ExtensionManagementError(D.localize(5,null,B.identifier.id,b.default.version),g.INSTALL_ERROR_INCOMPATIBLE);return M}async reinstallFromGallery(B){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",B.identifier.id),!this.galleryService.isEnabled())throw new Error(D.localize(6,null));const M=await this.findGalleryExtension(B);if(!M)throw new Error(D.localize(7,null));await this.setUninstalled(B);try{await this.extensionsScanner.removeUninstalledExtension(B)}catch(L){throw new Error(D.localize(8,null,o.toErrorMessage(L)))}await this.installFromGallery(M)}getTelemetryEvent(B){return B===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(B){const M=await this.getExtensionsReport();return I.getMaliciousExtensionsSet(M).has(B.identifier.id)}async downloadInstallableExtension(B,M){const L={id:B.identifier.uuid,publisherId:B.publisherId,publisherDisplayName:B.publisherDisplayName};let S;try{this.logService.trace("Started downloading extension:",B.identifier.id);const R=await this.extensionsDownloader.downloadExtension(B,M);this.logService.info("Downloaded extension:",B.identifier.id,S),S=R.fsPath}catch(R){throw new g.ExtensionManagementError(this.joinErrors(R).message,G)}try{const R=await A.getManifest(S);return{zipPath:S,identifierWithVersion:new I.ExtensionIdentifierWithVersion(B.identifier,R.version),metadata:L}}catch(R){throw new g.ExtensionManagementError(this.joinErrors(R).message,z)}}async installExtension(B,M){try{const L=await this.unsetUninstalledAndGetLocal(B.identifierWithVersion);if(L)return B.metadata?this.extensionsScanner.saveMetadataForLocalExtension(L,B.metadata):L}catch(L){throw p.isMacintosh?new g.ExtensionManagementError(D.localize(9,null),j):new g.ExtensionManagementError(D.localize(10,null),j)}return this.extractAndInstall(B,M)}async unsetUninstalledAndGetLocal(B){return await this.isUninstalled(B)?(this.logService.trace("Removing the extension from uninstalled list:",B.id),await this.unsetUninstalled(B),this.logService.info("Removed the extension from uninstalled list:",B.id),(await this.getInstalled(1)).find(S=>new I.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).equals(B))||null):null}async extractAndInstall({zipPath:B,identifierWithVersion:M,metadata:L},S){let R=await this.extensionsScanner.extractUserExtension(M,B,S);return this.logService.info("Installation completed.",M.id),L&&(R=await this.extensionsScanner.saveMetadataForLocalExtension(R,L)),R}async installDependenciesAndPackExtensions(B,M,L){if(!!this.galleryService.isEnabled()){const S=B.manifest.extensionDependencies||[];if(B.manifest.extensionPack)for(const R of B.manifest.extensionPack)M&&M.manifest.extensionPack&&M.manifest.extensionPack.some(N=>I.areSameExtensions({id:N},{id:R}))||S.every(N=>!I.areSameExtensions({id:N},{id:R}))&&S.push(R);if(S.length){const R=await this.getInstalled(),N=S.filter(U=>R.every(({identifier:$})=>!I.areSameExtensions($,{id:U})));if(N.length){const $=(await this.galleryService.query({names:N,pageSize:S.length},C.CancellationToken.None)).firstPage;try{await v.Promises.settled($.map(K=>this.installFromGallery(K,L)))}catch(K){try{await this.rollback($)}catch(Y){}throw K}}}}}async rollback(B){const L=(await this.getInstalled(1)).filter(S=>B.some(R=>new I.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).equals(new I.ExtensionIdentifierWithVersion(R.identifier,R.version))));await v.Promises.settled(L.map(S=>this.uninstall(S)))}async uninstall(B,M={}){this.logService.trace("ExtensionManagementService#uninstall",B.identifier.id);const L=await this.getInstalled(1),S=L.find(R=>I.areSameExtensions(R.identifier,B.identifier));if(!S)throw new Error(D.localize(11,null,B.manifest.displayName||B.manifest.name));try{await this.checkForDependenciesAndUninstall(S,L,M)}catch(R){throw this.joinErrors(R)}}async updateMetadata(B,M){return this.logService.trace("ExtensionManagementService#updateMetadata",B.identifier.id),B=await this.extensionsScanner.saveMetadataForLocalExtension(B,Object.assign(Object.assign({},B.manifest.__metadata||{}),M)),this.manifestCache.invalidate(),B}async updateExtensionScope(B,M){return this.logService.trace("ExtensionManagementService#updateExtensionScope",B.identifier.id),B=await this.extensionsScanner.saveMetadataForLocalExtension(B,Object.assign(Object.assign({},B.manifest.__metadata||{}),{isMachineScoped:M})),this.manifestCache.invalidate(),B}async getGalleryMetadata(B){const M=await this.findGalleryExtensionByName(B);return M?{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId}:void 0}async findGalleryExtension(B){if(B.identifier.uuid){const M=await this.findGalleryExtensionById(B.identifier.uuid);return M||this.findGalleryExtensionByName(B.identifier.id)}return this.findGalleryExtensionByName(B.identifier.id)}async findGalleryExtensionById(B){return(await this.galleryService.query({ids:[B],pageSize:1},C.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(B){return(await this.galleryService.query({names:[B],pageSize:1},C.CancellationToken.None)).firstPage[0]}joinErrors(B){const M=Array.isArray(B)?B:[B];return M.length===1?M[0]instanceof Error?M[0]:new Error(M[0]):M.reduce((L,S)=>new Error(`${L.message}${L.message?",":""}${S instanceof Error?S.message:S}`),new Error(""))}async checkForDependenciesAndUninstall(B,M,L){try{await this.preUninstallExtension(B);const S=L.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(B,M);await this.uninstallExtensions(B,S,M,L)}catch(S){throw await this.postUninstallExtension(B,new g.ExtensionManagementError(S instanceof Error?S.message:S,W)),S}await this.postUninstallExtension(B)}async uninstallExtensions(B,M,L,S){const R=[B,...M];if(!S.donotCheckDependents)for(const N of R)this.checkForDependents(N,R,L,B);await v.Promises.settled([this.uninstallExtension(B),...M.map(N=>this.doUninstall(N))])}checkForDependents(B,M,L,S){const R=this.getDependents(B,L);if(R.length){const N=R.filter(U=>M.indexOf(U)===-1);if(N.length)throw new Error(this.getDependentsErrorMessage(B,N,S))}}getDependentsErrorMessage(B,M,L){return L===B?M.length===1?D.localize(12,null,L.manifest.displayName||L.manifest.name,M[0].manifest.displayName||M[0].manifest.name):M.length===2?D.localize(13,null,L.manifest.displayName||L.manifest.name,M[0].manifest.displayName||M[0].manifest.name,M[1].manifest.displayName||M[1].manifest.name):D.localize(14,null,L.manifest.displayName||L.manifest.name,M[0].manifest.displayName||M[0].manifest.name,M[1].manifest.displayName||M[1].manifest.name):M.length===1?D.localize(15,null,L.manifest.displayName||L.manifest.name,B.manifest.displayName||B.manifest.name,M[0].manifest.displayName||M[0].manifest.name):M.length===2?D.localize(16,null,L.manifest.displayName||L.manifest.name,B.manifest.displayName||B.manifest.name,M[0].manifest.displayName||M[0].manifest.name,M[1].manifest.displayName||M[1].manifest.name):D.localize(17,null,L.manifest.displayName||L.manifest.name,B.manifest.displayName||B.manifest.name,M[0].manifest.displayName||M[0].manifest.name,M[1].manifest.displayName||M[1].manifest.name)}getAllPackExtensionsToUninstall(B,M,L=[]){if(L.indexOf(B)!==-1)return[];L.push(B);const S=B.manifest.extensionPack?B.manifest.extensionPack:[];if(S.length){const R=M.filter(U=>!U.isBuiltin&&S.some($=>I.areSameExtensions({id:$},U.identifier))),N=[];for(const U of R)N.push(...this.getAllPackExtensionsToUninstall(U,M,L));return[...R,...N]}return[]}getDependents(B,M){return M.filter(L=>L.manifest.extensionDependencies&&L.manifest.extensionDependencies.some(S=>I.areSameExtensions({id:S},B.identifier)))}async doUninstall(B){try{await this.preUninstallExtension(B),await this.uninstallExtension(B)}catch(M){throw await this.postUninstallExtension(B,new g.ExtensionManagementError(M instanceof Error?M.message:M,W)),M}await this.postUninstallExtension(B)}async preUninstallExtension(B){if(!await _.exists(B.location.fsPath))throw new Error(D.localize(18,null));this.logService.info("Uninstalling extension:",B.identifier.id),this._onUninstallExtension.fire(B.identifier)}async uninstallExtension(B){let M=this.uninstallingExtensions.get(B.identifier.id);return M||(M=v.createCancelablePromise(async()=>{const L=await this.extensionsScanner.scanUserExtensions(!1);await this.setUninstalled(...L.filter(S=>I.areSameExtensions(S.identifier,B.identifier)))}),this.uninstallingExtensions.set(B.identifier.id,M),M.finally(()=>this.uninstallingExtensions.delete(B.identifier.id))),M}async postUninstallExtension(B,M){if(M)this.logService.error("Failed to uninstall extension:",B.identifier.id,M.message);else if(this.logService.info("Successfully uninstalled extension:",B.identifier.id),B.identifier.uuid)try{await this.galleryService.reportStatistic(B.manifest.publisher,B.manifest.name,B.manifest.version,"uninstall")}catch(S){}this.reportTelemetry("extensionGallery:uninstall",I.getLocalExtensionTelemetryData(B),void 0,M);const L=M?M instanceof g.ExtensionManagementError?M.code:q:void 0;this._onDidUninstallExtension.fire({identifier:B.identifier,error:L})}getInstalled(B=null){return this.extensionsScanner.scanExtensions(B)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(B){return(await this.filterUninstalled(B)).length===1}filterUninstalled(...B){return this.extensionsScanner.withUninstalledExtensions(M=>{const L=[];for(const S of B)M[S.key()]&&L.push(S.key());return L})}setUninstalled(...B){const M=B.map(L=>new I.ExtensionIdentifierWithVersion(L.identifier,L.manifest.version));return this.extensionsScanner.withUninstalledExtensions(L=>(M.forEach(S=>L[S.key()]=!0),L))}unsetUninstalled(B){return this.extensionsScanner.withUninstalledExtensions(M=>delete M[B.key()])}getExtensionsReport(){const B=new Date().getTime();return(!this.reportedExtensions||B-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=B),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const B=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${B.length} reported extensions from service`),B}catch(B){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(B,M,L,S){const R=S?S instanceof g.ExtensionManagementError?S.code:q:void 0;this.telemetryService.publicLogError(B,Object.assign(Object.assign({},M),{success:!S,duration:L,errorcode:R}))}};ee=ve([ge(0,d.INativeEnvironmentService),ge(1,g.IExtensionGalleryService),ge(2,w.ILogService),ge(3,n.optional(a.IDownloadService)),ge(4,i.ITelemetryService),ge(5,n.IInstantiationService)],ee),e.ExtensionManagementService=ee}),define(J[194],Z([0,1,15,37,207,73,48,131,28]),function(H,e,h,D,T,_,k,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.enableCustomMarketplace=e.buffer=e.extract=e.tar=void 0;const g=k.extract,I=k.buffer,d=async(w,l)=>{const o=T.pack(),i=[],t=new Promise(r=>{o.on("end",()=>r(Buffer.concat(i)))});o.on("data",r=>i.push(r));for(let r=0;r<l.length;r++){const s=l[r];o.entry({name:s.path},s.contents)}return o.finalize(),await _.promisify(h.writeFile)(w,await t),w};e.tar=d;const v=async(w,l,o={},i)=>{try{await b(w,l,o,i)}catch(t){t.toString().includes("Invalid tar header")&&await g(w,l,o,i)}};e.extract=v;const m=(w,l)=>new Promise(async(o,i)=>{try{let t=!1;if(await c(w,new RegExp(l),(r,s)=>{D.normalize(r)===D.normalize(l)&&(t=!0,o(s))}),!t)throw new Error("couldn't find asset "+l)}catch(t){t.toString().includes("Invalid tar header")?I(w,l).then(o).catch(i):i(t)}});e.buffer=m;const c=async(w,l,o)=>new Promise((i,t)=>{const r=T.extract(),s=a=>{r.destroy(),t(a)};r.once("error",s),r.on("entry",async(a,n,f)=>{const C=a.name;l.test(C)?y(n).then(A=>{o(C,A),f()}).catch(s):(n.on("end",()=>f()),n.resume())}),r.on("finish",i),h.createReadStream(w).pipe(r)}),y=w=>new Promise((l,o)=>{const i=[];w.on("error",o),w.on("end",()=>l(Buffer.concat(i))),w.on("data",t=>i.push(t))}),b=async(w,l,o={},i)=>new Promise((t,r)=>{const s=new RegExp(o.sourcePath?`^${o.sourcePath}`:""),a=T.extract(),n=f=>{a.destroy(),r(f)};a.once("error",n),a.on("entry",async(f,C,A)=>{const O=()=>{C.on("end",()=>A()),C.resume()},E=D.normalize(f.name);if(i.isCancellationRequested||!s.test(E))return O();const F=E.replace(s,""),j=D.join(l,F);if(/\/$/.test(F))return h.promises.mkdir(j,{recursive:!0}).then(O);const G=D.dirname(F),z=D.join(l,G);if(z.indexOf(l)!==0)return n(new Error(P.localize(0,null,F)));await h.promises.mkdir(z,{recursive:!0});const W=h.createWriteStream(j,{mode:f.mode});W.once("close",()=>A()),W.once("error",n),C.pipe(W)}),a.once("finish",t),h.createReadStream(w).pipe(a)}),p=()=>{u.default.extensionsGallery=Object.assign({serviceUrl:process.env.SERVICE_URL||"https://extensions.coder.com/api",itemUrl:process.env.ITEM_URL||"",controlUrl:"",recommendationsUrl:""},u.default.extensionsGallery||{});const w=k;w.zip=e.tar,w.extract=e.extract,w.buffer=e.buffer};e.enableCustomMarketplace=p}),define(J[86],Z([0,1,152,208,195,5,36,3,21,26,2,16,65,14,4]),function(H,e,h,D,T,_,k,P,u,g,I,d,v,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class y{constructor(C){this.socket=C}dispose(){this.socket.destroy()}onData(C){const A=O=>C(d.VSBuffer.wrap(O));return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(C){return this.socket.on("close",C),{dispose:()=>this.socket.off("close",C)}}onEnd(C){return this.socket.on("end",C),{dispose:()=>this.socket.off("end",C)}}write(C){if(!this.socket.destroyed)try{this.socket.write(C.buffer)}catch(A){if(A.code==="EPIPE")return;m.onUnexpectedError(A)}}end(){this.socket.end()}drain(){return new Promise((C,A)=>{if(this.socket.bufferSize===0){C();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),C()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=y;var b;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(b||(b={}));var p;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(p||(p={}));class w extends I.Disposable{constructor(C,A,O,E){super();this._onDidZlibFlush=this._register(new _.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new _.Emitter),this._onClose=this._register(new _.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=C,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=A,this._recordInflateBytes=E,A?(this._zlibInflate=T.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",F=>{console.error(F),m.onUnexpectedError(F),this._onClose.fire()}),this._zlibInflate.on("data",F=>{this._pendingInflateData.push(F)}),O&&(this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=T.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",F=>{console.error(F),m.onUnexpectedError(F),this._onClose.fire()}),this._zlibDeflate.on("data",F=>{this._pendingDeflateData.push(F)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new v.ChunkStream,this._register(this.socket.onData(F=>this._acceptChunk(F))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?d.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):d.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(C){return this._onData.event(C)}onClose(C){return this._onClose.event(C)}onEnd(C){return this.socket.onEnd(C)}write(C){this._totalOutgoingDataBytes+=C.byteLength,this._zlibDeflate?(this._zlibDeflate.write(C.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let A=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,A=A.slice(0,A.length-4),this._isEnded||this._write(d.VSBuffer.wrap(A),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(C,!1)}_write(C,A){let O=2;C.byteLength<126?O+=0:C.byteLength<2**16?O+=2:O+=8;const E=d.VSBuffer.alloc(O);if(A?E.writeUInt8(194,0):E.writeUInt8(130,0),C.byteLength<126)E.writeUInt8(C.byteLength,1);else if(C.byteLength<2**16){E.writeUInt8(126,1);let F=1;E.writeUInt8(C.byteLength>>>8&255,++F),E.writeUInt8(C.byteLength>>>0&255,++F)}else{E.writeUInt8(127,1);let F=1;E.writeUInt8(0,++F),E.writeUInt8(0,++F),E.writeUInt8(0,++F),E.writeUInt8(0,++F),E.writeUInt8(C.byteLength>>>24&255,++F),E.writeUInt8(C.byteLength>>>16&255,++F),E.writeUInt8(C.byteLength>>>8&255,++F),E.writeUInt8(C.byteLength>>>0&255,++F)}this._totalOutgoingWireBytes+=E.byteLength+C.byteLength,this.socket.write(d.VSBuffer.concat([E,C]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(C){if(C.byteLength!==0){for(this._totalIncomingWireBytes+=C.byteLength,this._incomingData.acceptChunk(C);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const A=this._incomingData.peek(this._state.readLen),E=(A.readUInt8(0)&128)>>>7,F=A.readUInt8(1),j=(F&128)>>>7,G=F&127;this._state.state=2,this._state.readLen=2+(j?4:0)+(G===126?2:0)+(G===127?8:0),this._state.fin=E,this._state.mask=0}else if(this._state.state===2){const A=this._incomingData.read(this._state.readLen),O=A.readUInt8(1),E=(O&128)>>>7;let F=O&127,j=1;F===126?F=A.readUInt8(++j)*2**8+A.readUInt8(++j):F===127&&(F=A.readUInt8(++j)*0+A.readUInt8(++j)*0+A.readUInt8(++j)*0+A.readUInt8(++j)*0+A.readUInt8(++j)*2**24+A.readUInt8(++j)*2**16+A.readUInt8(++j)*2**8+A.readUInt8(++j));let G=0;E&&(G=A.readUInt8(++j)*2**24+A.readUInt8(++j)*2**16+A.readUInt8(++j)*2**8+A.readUInt8(++j)),this._state.state=3,this._state.readLen=F,this._state.mask=G}else if(this._state.state===3){const A=this._incomingData.read(this._state.readLen);l(A,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(A.buffer)),this._zlibInflate.write(A.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const O=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=O.length,this._onData.fire(d.VSBuffer.wrap(O))})):(this._totalIncomingDataBytes+=A.byteLength,this._onData.fire(A))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await _.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=w;function l(f,C){if(C!==0){let A=f.byteLength>>>2;for(let z=0;z<A;z++){const W=f.readUInt32BE(z*4);f.writeUInt32BE(W^C,z*4)}let O=A*4,E=f.byteLength-O;const F=C>>>24&255,j=C>>>16&255,G=C>>>8&255;E>=1&&f.writeUInt8(f.readUInt8(O)^F,O),E>=2&&f.writeUInt8(f.readUInt8(O+1)^j,O+1),E>=3&&f.writeUInt8(f.readUInt8(O+2)^G,O+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function i(){const f=g.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let C;return e.XDG_RUNTIME_DIR?C=P.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):C=P.join(u.tmpdir(),`vscode-ipc-${f}.sock`),r(C),C}e.createRandomIPCHandle=i;function t(f,C,A){const O=h.createHash("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${A}-${C}-sock`;let E;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?E=P.join(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${A}-${C}.sock`):E=P.join(f,`${A}-${C}.sock`),r(E),E}e.createStaticIPCHandle=t;function r(f){const C=o[c.platform];typeof C=="number"&&f.length>=C&&console.warn(`WARNING: IPC handle "${f}" is longer than ${C} chars, try a shorter --user-data-dir`)}class s extends k.IPCServer{constructor(C){super(s.toClientConnectionEvent(C));this.server=C}static toClientConnectionEvent(C){const A=_.Event.fromNodeEventEmitter(C,"connection");return _.Event.map(A,O=>({protocol:new v.Protocol(new y(O)),onDidClientDisconnect:_.Event.once(_.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function a(f){return new Promise((C,A)=>{const O=D.createServer();O.on("error",A),O.listen(f,()=>{O.removeListener("error",A),C(new s(O))})})}e.serve=a;function n(f,C){return new Promise((A,O)=>{const E=D.createConnection(f,()=>{E.removeListener("error",O),A(v.Client.fromSocket(new y(E),C))});E.once("error",O)})}e.connect=n}),define(J[87],Z([0,1,195,163,2,10,14,162,32,13,16]),function(H,e,h,D,T,_,k,P,u,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends T.Disposable{constructor(m,c){super();this.logService=c,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,c){this.logService.trace("RequestService#request",m.url);const{proxyUrl:y,strictSSL:b}=this,p=m.agent?m.agent:await P.getProxyAgent(m.url||"",{proxyUrl:y,strictSSL:b});return m.agent=p,m.strictSSL=b,this.authorization&&(m.headers=Object.assign(Object.assign({},m.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(m,c)}async getNodeRequest(m){return(D.parse(m.url).protocol==="https:"?await new Promise((b,p)=>{H(["https"],b,p)}):await new Promise((b,p)=>{H(["http"],b,p)})).request}_request(m,c){return new Promise(async(y,b)=>{let p;const w=D.parse(m.url),l=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),o={hostname:w.hostname,port:w.port?parseInt(w.port):w.protocol==="https:"?443:80,protocol:w.protocol,path:w.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:_.isBoolean(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(o.auth=m.user+":"+m.password),p=l(o,i=>{const t=_.isNumber(m.followRedirects)?m.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&t>0&&i.headers.location)this._request(Object.assign(Object.assign({},m),{url:i.headers.location,followRedirects:t-1}),c).then(y,b);else{let r=i;i.headers["content-encoding"]==="gzip"&&(r=i.pipe(h.createGunzip())),y({res:i,stream:I.streamToBufferReadableStream(r)})}}),p.on("error",b),m.timeout&&p.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&p.write(m.data),p.end(),c.onCancellationRequested(()=>{p.abort(),b(k.canceled())})})}async resolveProxy(m){}};d=ve([ge(0,u.IConfigurationService),ge(1,g.ILogService)],d),e.RequestService=d}),define(J[196],Z([0,1,21,15,209,3,12,28,52,51,71,23,75,27,85,78,46,47,79,77,55,87,32,76,80,165,166,13,11,54,171,72,24,53,2,45,149,6,74,43,14,38,16]),function(H,e,h,D,T,_,k,P,u,g,I,d,v,m,c,y,b,p,w,l,o,i,t,r,s,a,n,f,C,A,O,E,F,j,G,z,W,q,ee,te,B,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class S extends G.Disposable{constructor(U){super();this.argv=U,T.gracefulify(D),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[U,$]=await this.initServices();return U.invokeFunction(async K=>{const Y=K.get(f.ILogService),Q=K.get(F.IFileService),se=K.get(d.INativeEnvironmentService),oe=K.get(m.IExtensionManagementCLIService);return Y.info("CLI main",this.argv),this.registerErrorHandler(Y),await this.doRun(se,oe,Q),k.raceTimeout(p.combinedAppender(...$).flush(),1e3)})}async initServices(){const U=new u.ServiceCollection,$=new v.NativeEnvironmentService(this.argv);U.set(d.IEnvironmentService,$),U.set(d.INativeEnvironmentService,$),await Promise.all([$.appSettingsHome.fsPath,$.extensionsPath].map(we=>we?D.promises.mkdir(we,{recursive:!0}):void 0));const K=f.getLogLevel($),Y=[];Y.push(new A.SpdLogLogger("cli",_.join($.logsPath,"cli.log"),!0,K)),K===f.LogLevel.Trace&&Y.push(new f.ConsoleLogger(K));const Q=this._register(new f.MultiplexLogService(Y));U.set(f.ILogService,Q);const se=this._register(new E.FileService(Q));U.set(F.IFileService,se);const oe=this._register(new j.DiskFileSystemProvider(Q));se.registerProvider(C.Schemas.file,oe);const ce=this._register(new r.ConfigurationService($.settingsResource,se));U.set(t.IConfigurationService,ce),await ce.initialize();const he=new n.StateService($,Q);U.set(a.IStateService,he),U.set(z.IProductService,Object.assign({_serviceBrand:void 0},P.default));const{appRoot:_e,extensionsPath:Pe,extensionDevelopmentLocationURI:Re,isBuilt:Ae,installSourcePath:Se}=$;U.set(o.IRequestService,new g.SyncDescriptor(i.RequestService)),U.set(m.IExtensionManagementService,new g.SyncDescriptor(c.ExtensionManagementService)),U.set(m.IExtensionGalleryService,new g.SyncDescriptor(y.ExtensionGalleryService)),U.set(m.IExtensionManagementCLIService,new g.SyncDescriptor(W.ExtensionManagementCLIService)),U.set(te.ILocalizationsService,new g.SyncDescriptor(ee.LocalizationsService));const de=[];if(Ae&&!Re&&!$.disableTelemetry&&P.default.enableTelemetry){P.default.aiConfig&&P.default.aiConfig.asimovKey&&de.push(new s.AppInsightsAppender("monacoworkbench",null,P.default.aiConfig.asimovKey));const we={appender:p.combinedAppender(...de),sendErrorTelemetry:!1,commonProperties:l.resolveCommonProperties(se,h.release(),process.arch,P.default.commit,P.default.version,he.getItem("telemetry.machineId"),P.default.msftInternalDomains,Se),piiPaths:[_e,Pe]};U.set(b.ITelemetryService,new g.SyncDescriptor(w.TelemetryService,[we]))}else U.set(b.ITelemetryService,p.NullTelemetryService);return[new I.InstantiationService(U),de]}registerErrorHandler(U){B.setUnexpectedErrorHandler($=>{const K=M.toErrorMessage($,!0);!K||U.error(`[uncaught exception in CLI]: ${K}`)})}async doRun(U,$,K){if(this.argv["install-source"])return this.setInstallSource(U,K,this.argv["install-source"]);if(this.argv["list-extensions"])return $.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return $.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return $.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return $.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(O.buildTelemetryMessage(U.appRoot,U.extensionsPath))}asExtensionIdOrVSIX(U){return U.map($=>/\.vsix$/i.test($)?q.URI.file(_.isAbsolute($)?$:_.join(process.cwd(),$)):$)}async setInstallSource(U,$,K){await $.writeFile(q.URI.file(U.installSourcePath),L.VSBuffer.fromString(K.slice(0,30)))}}async function R(N){const U=new S(N);try{await U.run()}finally{U.dispose()}}e.main=R}),define(J[197],Z([0,1,35,39,5,11,86,57]),function(H,e,h,D,T,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.ManagementConnection=e.Connection=void 0;class u{constructor(v,m){this.protocol=v,this.token=m,this._onClose=new T.Emitter,this.onClose=this._onClose.event,this.disposed=!1}get offline(){return this._offline}reconnect(v,m){this._offline=void 0,this.doReconnect(v,m)}dispose(){this.disposed||(this.disposed=!0,this.doDispose(),this._onClose.fire())}setOffline(){this._offline||(this._offline=Date.now())}}e.Connection=u;class g extends u{constructor(v,m){super(v,m);this.protocol=v,v.onDidDispose(()=>this.dispose()),v.onSocketClose(()=>this.setOffline())}doDispose(){this.protocol.sendDisconnect(),this.protocol.dispose(),this.protocol.getUnderlyingSocket().destroy()}doReconnect(v,m){this.protocol.beginAcceptReconnection(v,m),this.protocol.endAcceptReconnection()}}e.ManagementConnection=g;class I extends u{constructor(v,m,c,y,b){super(m,y);this.environment=b,this.logger=h.logger.named("exthost",h.field("token",y)),this.protocol.dispose(),this.spawn(v,c).then(p=>this.process=p),this.protocol.getUnderlyingSocket().pause()}doDispose(){this.process&&this.process.kill(),this.protocol.getUnderlyingSocket().destroy()}doReconnect(v,m){this.protocol.beginAcceptReconnection(v,null),this.protocol.dispose(),this.sendInitMessage(m)}sendInitMessage(v){const m=this.protocol.getUnderlyingSocket();m.pause();const c=this.protocol.getSocket();this.logger.trace("Sending socket"),this.process.send({type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:Buffer.from(v.buffer).toString("base64"),skipWebSocketFrames:!(c instanceof k.WebSocketNodeSocket),permessageDeflate:this.protocol.options.permessageDeflate,inflateBytes:c instanceof k.WebSocketNodeSocket?Buffer.from(c.recordedInflateBytes.buffer).toString("base64"):void 0},m)}async spawn(v,m){this.logger.trace("Getting NLS configuration...");const c=await P.getNlsConfiguration(v,this.environment.userDataPath);this.logger.trace("Spawning extension host...");const y=D.fork(_.FileAccess.asFileUri("bootstrap-fork",H).fsPath,["--type=extensionHost"],{env:Object.assign(Object.assign({},process.env),{VSCODE_AMD_ENTRYPOINT:"vs/workbench/services/extensions/node/extensionHostProcess",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_EXTHOST_WILL_SEND_SOCKET:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_LOG_LEVEL:process.env.LOG_LEVEL,VSCODE_NLS_CONFIG:JSON.stringify(c),VSCODE_PARENT_PID:String(process.pid)}),silent:!0});return y.on("error",b=>{this.logger.error("Exited unexpectedly",h.field("error",b)),this.dispose()}),y.on("exit",b=>{this.logger.trace("Exited",h.field("code",b)),this.dispose()}),y.stdout&&y.stderr&&(y.stdout.setEncoding("utf8").on("data",b=>this.logger.info(b)),y.stderr.setEncoding("utf8").on("data",b=>this.logger.error(b))),y.on("message",b=>{switch(b.type){case"__$console":const p=this.logger[b.severity==="log"?"info":b.severity];p?p.bind(this.logger)("console",h.field("arguments",b.arguments)):this.logger.error("Unexpected severity",h.field("event",b));break;case"VSCODE_EXTHOST_DISCONNECTED":this.logger.trace("Going offline"),this.setOffline();break;case"VSCODE_EXTHOST_IPC_READY":this.logger.trace("Got ready message"),this.sendInitMessage(m);break;default:this.logger.error("Unexpected message",h.field("event",b));break}}),this.logger.trace("Waiting for handshake..."),y}}e.ExtensionHostConnection=I}),define(J[198],Z([0,1,35,16,65,86,56]),function(H,e,h,D,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class P extends T.PersistentProtocol{constructor(g,I){super(I.skipWebSocketFrames?new _.NodeSocket(g):new _.WebSocketNodeSocket(new _.NodeSocket(g),I.permessageDeflate||!1,I.inflateBytes||null,I.recordInflateBytes||!1));this.options=I}getUnderlyingSocket(){const g=this.getSocket();return g instanceof _.NodeSocket?g.socket:g.socket.socket}handshake(){return k.logger.trace("Protocol handshake",h.field("token",this.options.reconnectionToken)),new Promise((g,I)=>{const d=setTimeout(()=>{k.logger.error("Handshake timed out",h.field("token",this.options.reconnectionToken)),I(new Error("timed out"))},1e4),v=this.onControlMessage(m=>{try{const c=m.toString();k.logger.trace("Protocol message",h.field("token",this.options.reconnectionToken),h.field("message",c));const y=JSON.parse(c);switch(y.type){case"auth":return this.authenticate(y);case"connectionType":return v.dispose(),clearTimeout(d),g(y);default:throw new Error("Unrecognized message type")}}catch(c){v.dispose(),clearTimeout(d),I(c)}});this.authenticate()})}authenticate(g){this.sendMessage({type:"sign",data:""})}tunnel(){throw new Error("Tunnel is not implemented yet")}sendMessage(g){this.sendControl(D.VSBuffer.fromString(JSON.stringify(g)))}}e.Protocol=P}),define(J[199],Z([0,1,35,15,21,37,5,11,6,100,36,145,196,32,76,136,23,75,78,27,137,85,24,72,53,51,71,52,43,74,13,155,156,54,28,45,55,161,87,169,77,46,170,79,47,80,176,189,197,177,56,57,198,81,186,190,191]),function(H,e,h,D,T,_,k,P,u,g,I,d,v,m,c,y,b,p,w,l,o,i,t,r,s,a,n,f,C,A,O,E,F,j,G,z,W,q,ee,te,B,M,L,S,R,N,U,$,K,Y,Q,se,oe,ce,he,_e,Pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Vscode=void 0;class Re{constructor(){this._onDidClientConnect=new k.Emitter,this.onDidClientConnect=this._onDidClientConnect.event,this.ipc=new I.IPCServer(this.onDidClientConnect),this.maxExtraOfflineConnections=0,this.connections=new Map,this.services=new f.ServiceCollection}async cli(Se){return v.main(Se)}async initialize(Se){const de=ce.getUriTransformer(Se.remoteAuthority);this.servicesPromise||(this.servicesPromise=this.initializeServices(Se.args)),await this.servicesPromise;const we=this.services.get(b.IEnvironmentService),Ee=Se.startPath,Ie=Ne=>{try{return u.URI.parse(Ne,!0)}catch(Me){return u.URI.from({scheme:P.Schemas.vscodeRemote,authority:Se.remoteAuthority,path:Ne})}};return{workbenchWebConfiguration:{workspaceUri:Ee&&Ee.workspace?Ie(Ee.url):void 0,folderUri:Ee&&!Ee.workspace?Ie(Ee.url):void 0,remoteAuthority:Se.remoteAuthority,logLevel:O.getLogLevel(we),workspaceProvider:{payload:[["userDataPath",we.userDataPath],["enableProposedApi",JSON.stringify(Se.args["enable-proposed-api"]||[])]]}},remoteUserDataUri:de.transformOutgoing(u.URI.file(we.userDataPath)),productConfiguration:G.default,nlsConfiguration:await se.getNlsConfiguration(we.args.locale||await se.getLocaleFromConfig(we.userDataPath),we.userDataPath),commit:G.default.commit||"development"}}async handleWebSocket(Se,de,we){if(!de.reconnectionToken)throw new Error("Reconnection token is missing from query parameters");const Ee=new oe.Protocol(Se,{reconnectionToken:de.reconnectionToken,reconnection:de.reconnection==="true",skipWebSocketFrames:de.skipWebSocketFrames==="true",permessageDeflate:we,recordInflateBytes:we});try{await this.connect(await Ee.handshake(),Ee)}catch(Ie){Ee.sendMessage({type:"error",reason:Ie.message}),Ee.dispose(),Ee.getSocket().dispose()}return!0}async connect(Se,de){switch(G.default.commit&&Se.commit!==G.default.commit&&Q.logger.warn(`Version mismatch (${Se.commit} instead of ${G.default.commit})`),Se.desiredConnectionType){case 2:case 1:this.connections.has(Se.desiredConnectionType)||this.connections.set(Se.desiredConnectionType,new Map);const we=this.connections.get(Se.desiredConnectionType),Ee=async()=>Se.desiredConnectionType===2?{debugPort:await this.getDebugPort()}:{type:"ok"},Ie=de.options.reconnectionToken;if(de.options.reconnection&&we.has(Ie)){de.sendMessage(await Ee());const Me=de.readEntireBuffer();return de.dispose(),we.get(Ie).reconnect(de.getSocket(),Me)}else if(de.options.reconnection||we.has(Ie))throw new Error(de.options.reconnection?"Unrecognized reconnection token":"Duplicate reconnection token");Q.logger.debug("New connection",h.field("token",Ie)),de.sendMessage(await Ee());let Ne;if(Se.desiredConnectionType===1)Ne=new K.ManagementConnection(de,Ie),this._onDidClientConnect.fire({protocol:de,onDidClientDisconnect:Ne.onClose});else{const Me=de.readEntireBuffer();Ne=new K.ExtensionHostConnection(Se.args?Se.args.language:"en",de,Me,Ie,this.services.get(b.IEnvironmentService))}we.set(Ie,Ne),Ne.onClose(()=>{Q.logger.debug("Connection closed",h.field("token",Ie)),we.delete(Ie)}),this.disposeOldOfflineConnections(we);break;case 3:return de.tunnel();default:throw new Error("Unrecognized connection type")}}disposeOldOfflineConnections(Se){const de=Array.from(Se.values()).filter(we=>typeof we.offline!="undefined");for(let we=0,Ee=de.length-this.maxExtraOfflineConnections;we<Ee;++we)Q.logger.debug("Disposing offline connection",h.field("token",de[we].token)),de[we].dispose()}async initializeServices(Se){const de=new p.NativeEnvironmentService(Se);D.mkdirSync(de.globalStorageHome.fsPath,{recursive:!0});const we=new O.MultiplexLogService([new O.ConsoleLogger(O.getLogLevel(de)),new j.SpdLogLogger(Pe.RemoteExtensionLogFileName,_.join(de.logsPath,`${Pe.RemoteExtensionLogFileName}.log`),!1,O.getLogLevel(de))]),Ee=new r.FileService(we);Ee.registerProvider(P.Schemas.file,new s.DiskFileSystemProvider(we));const Ie=new F.LoggerService(we,Ee),Ne=[_.join(de.userDataPath,"clp"),de.appRoot,de.extensionsPath,de.builtinExtensionsPath,...de.extraExtensionPaths,...de.extraBuiltinExtensionPaths];this.ipc.registerChannel("logger",new E.LogLevelChannel(we)),this.ipc.registerChannel(y.ExtensionHostDebugBroadcastChannel.ChannelName,new y.ExtensionHostDebugBroadcastChannel),this.services.set(O.ILogService,we),this.services.set(b.IEnvironmentService,de),this.services.set(b.INativeEnvironmentService,de),this.services.set(O.ILoggerService,Ie);const Me=new c.ConfigurationService(de.settingsResource,Ee);await Me.initialize(),this.services.set(m.IConfigurationService,Me),this.services.set(W.IRequestService,new a.SyncDescriptor(ee.RequestService)),this.services.set(t.IFileService,Ee),this.services.set(z.IProductService,Object.assign({_serviceBrand:void 0},G.default));const Ue=await g.getMachineId();await new Promise(ze=>{const X=new n.InstantiationService(this.services);X.invokeFunction(ie=>{X.createInstance(d.LogsDataCleaner);let ne;de.disableTelemetry?ne=R.NullTelemetryService:ne=new S.TelemetryService({appender:R.combinedAppender(new N.AppInsightsAppender("code-server",null,()=>new Y.TelemetryClient),new L.TelemetryLogAppender(ie.get(O.ILoggerService),de)),sendErrorTelemetry:!0,commonProperties:B.resolveCommonProperties(Ee,T.release(),process.arch,G.default.commit,G.default.version,Ue,[],de.installSourcePath,"code-server"),piiPaths:Ne},Me),this.services.set(M.ITelemetryService,ne),this.services.set(l.IExtensionManagementService,new a.SyncDescriptor(i.ExtensionManagementService)),this.services.set(l.IExtensionGalleryService,new a.SyncDescriptor(w.ExtensionGalleryService)),this.services.set(C.ILocalizationsService,new a.SyncDescriptor(A.LocalizationsService)),this.ipc.registerChannel("extensions",new o.ExtensionManagementChannel(ie.get(l.IExtensionManagementService),fe=>ce.getUriTransformer(fe.remoteAuthority))),this.ipc.registerChannel("remoteextensionsenvironment",new $.ExtensionEnvironmentChannel(de,we,ne,"")),this.ipc.registerChannel("request",new q.RequestChannel(ie.get(W.IRequestService))),this.ipc.registerChannel("telemetry",new U.TelemetryChannel(ne)),this.ipc.registerChannel("localizations",I.ProxyChannel.fromService(ie.get(C.ILocalizationsService))),this.ipc.registerChannel(_e.REMOTE_FILE_SYSTEM_CHANNEL_NAME,new $.FileProviderChannel(de,we)),this.ipc.registerChannel(he.REMOTE_TERMINAL_CHANNEL_NAME,new $.TerminalProviderChannel(we)),ze(new te.default(ne))})})}async getDebugPort(){}}e.Vscode=Re}),define(J[210],Z([0,1,35,14,103,56,194,199]),function(H,e,h,D,T,_,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),D.setUnexpectedErrorHandler(d=>_.logger.warn(d instanceof Error?d.message:d)),k.enableCustomMarketplace(),T.monkeyPatch(!0);const u=process.exit;if(process.exit=function(d){_.logger.warn(`process.exit() was prevented: ${d||"unknown code"}.`)},typeof process.env.CODE_SERVER_PARENT_PID!="undefined"){const d=parseInt(process.env.CODE_SERVER_PARENT_PID,10);setInterval(()=>{try{process.kill(d,0)}catch(v){u()}},5e3)}else _.logger.error("no parent process"),u(1);const g=new P.Vscode,I=d=>{if(!process.send)throw new Error("not spawned with IPC");process.send(d)};process.on("message",async(d,v)=>{switch(_.logger.debug("got message from code-server",h.field("type",d.type)),_.logger.trace("code-server message content",h.field("message",d)),d.type){case"init":try{const m=await g.initialize(d.options);I({type:"options",id:d.id,options:m})}catch(m){_.logger.error(m.message),_.logger.error(m.stack),u(1)}break;case"cli":try{await g.cli(d.args),u(0)}catch(m){_.logger.error(m.message),_.logger.error(m.stack),u(1)}break;case"socket":g.handleWebSocket(v,d.query,d.permessageDeflate);break}}),process.send?I({type:"ready"}):(_.logger.error("not spawned with IPC"),u(1))})}).call(this);

//# sourceMappingURL=entry.js.map
